-- 퀘스트 관련 기능 오픈 처리
-- version("0.64.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    -- 퀘스트 진행 중 오픈 되어야 할 기능들을 여기 추가한다.
    -- 스크립트 사용 시 앞쪽에 UnlockQuestContents()를 넣어줌으로서 앞서 설정한 기능 오픈 상태를 적용할 수 있다.
end

-- 퀘스트 진행 상태 검사
if CheckQuestAppear() then -- 퀘스트 등장 상태 시 실행될 부분
    if OnTownRefresh() then
        -- 등장시킬 캐릭터와 퀘스트 아이콘을 여기 추가한다.
    end
    if OnTownCharacterClick(152) then
        -- 캐릭터를 눌렀을 때 진행할 내용을 여기 추가한다.
    end
elseif CheckQuestRunning() then -- 퀘스트 진행중 상태 시 실행될 부분
    if OnTownRefresh() then
        -- 등장시킬 캐릭터와 퀘스트 아이콘을 여기 추가한다.
    end
    if OnTownCharacterClick(152) then
        -- 캐릭터를 눌렀을 때 진행할 내용을 여기 추가한다.
    end
elseif CheckQuestComplete() then -- 퀘스트 완료 상태 시 실행될 부분
    if OnTownRefresh() then
        -- 등장시킬 캐릭터와 퀘스트 아이콘을 여기 추가한다.
    end
    if OnTownCharacterClick(152) then
        -- 캐릭터를 눌렀을 때 진행할 내용을 여기 추가한다.
    end
end

if OnQuestReplay() then
    -- 퀘스트 다시하기 시 실행될 부분을 여기 추가한다.
end

if OnQuestContinue() then
    -- 퀘스트 도중 이어하기 시 실행될 부분을 여기 추가한다.
end

if OnGameStart() then
    -- 게임 시작 시(로그인 직후) 실행될 부분을 여기 추가한다.
end
