-- 오프닝(810001)
-- version("0.64.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
end


local function ScriptQuestNicknameChange()
    FullLoad()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()
    -- 시나리오 배경음
    SoundPlay(0) --=BGM=Title_UPUP_-14Lufs

    -- 시점을 분수대 근처로
    TownCameraSetPos(TownCharacterGetNPC(0), -3, 33*40-182, 1)

    -- 더미 NPC들 등장
    TownCharacterStandAt(TownCharacterAddNPC(301), -283, 33*40+76)
    TownCharacterStandAt(TownCharacterAddNPC(302), -164, 33*40+17)
    TownCharacterStandAt(TownCharacterAddNPC(303), -214, 33*40-144)
    TownCharacterStandAt(TownCharacterAddNPC(304), -289, 33*40-263)
    TownCharacterStandAt(TownCharacterAddNPC(305), -166, 33*40-342)
    TownCharacterStandAt(TownCharacterAddNPC(306), 180, 33*40+80)
    TownCharacterStandAt(TownCharacterAddNPC(307), 359, 33*40-5)
    TownCharacterStandAt(TownCharacterAddNPC(308), 230, 33*40-90)
    TownCharacterStandAt(TownCharacterAddNPC(309), 316, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(310), 285, 33*40-285)
    TownCharacterStandAt(TownCharacterAddNPC(311), 286, 33*40-356)

    -- 더미 NPC들 NameTag숨김
    TownCharacterHideNameTag(TownCharacterGetNPC(301))
    TownCharacterHideNameTag(TownCharacterGetNPC(302))
    TownCharacterHideNameTag(TownCharacterGetNPC(303))
    TownCharacterHideNameTag(TownCharacterGetNPC(304))
    TownCharacterHideNameTag(TownCharacterGetNPC(305))
    TownCharacterHideNameTag(TownCharacterGetNPC(306))
    TownCharacterHideNameTag(TownCharacterGetNPC(307))
    TownCharacterHideNameTag(TownCharacterGetNPC(308))
    TownCharacterHideNameTag(TownCharacterGetNPC(309))
    TownCharacterHideNameTag(TownCharacterGetNPC(310))
    TownCharacterHideNameTag(TownCharacterGetNPC(311))

    -- 오프닝 추락 애니메이션
    AnimationAdd("opening", "Opening/Event_falling01_01")
    AnimationSetLayer("opening", 1)
    AnimationSetScale("opening", 1)
    AnimationSetFullScreen("opening")
    AnimationPlay("opening")
    Wait(0.5)
    SoundPlayEffect(629072) --FALL_SEQUENCE_HEAD
    Wait(1.25)
    AnimationRemove("opening")

    AnimationAdd("smog", "Opening/Event_falling01_02")
    AnimationSetLayer("smog", 1)
    AnimationSetScale("smog", 1)
    AnimationSetPos("smog", 0, 0)

    AnimationPlay("smog")
    Wait(0.5)

    -- 유저 캐릭터가 등장,
    TownCharacterStandAt(TownCharacterAddNPC(1), -3, 33*40-182)
    TownCharacterSetExpression(TownCharacterGetNPC(1), "BeSurprised")
    TownCharacterActionByID(TownCharacterGetNPC(1), 612852)
    Wait(0.5)
    TownCharacterActionPause(TownCharacterGetNPC(1), 1)
    Wait(0.3)
    TownCharacterActionPause(TownCharacterGetNPC(1), 0)
    Wait(1.1)

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    AnimationRemove("smog")
    Wait(0.5)

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001001))  -- "여... 여긴 어디?"
    Wait(2)
    MonologClose()
    Wait(1)

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001002))  -- "나는... 왜 이런 모습으로…?"
    Wait(2)
    MonologClose()

    -- 더미 NPC들 감추기
    TownCharacterHide(TownCharacterGetNPC(301))
    TownCharacterHide(TownCharacterGetNPC(302))
    TownCharacterHide(TownCharacterGetNPC(303))
    TownCharacterHide(TownCharacterGetNPC(304))
    TownCharacterHide(TownCharacterGetNPC(305))
    TownCharacterHide(TownCharacterGetNPC(306))
    TownCharacterHide(TownCharacterGetNPC(307))
    TownCharacterHide(TownCharacterGetNPC(308))
    TownCharacterHide(TownCharacterGetNPC(309))
    TownCharacterHide(TownCharacterGetNPC(310))
    TownCharacterHide(TownCharacterGetNPC(311))

    -- 유저 캐릭터 줌인
    TownCameraZoomIn(TownCharacterGetNPC(1), 0, 50, 3.7)

    -- 유저 캐릭터 위로 집중선 표시
    AnimationAdd("concent", "Opening/opening_concentline")
    AnimationSetLayer("concent", 2)
    AnimationSetScale("concent", 2)
    AnimationSetFullScreen("concent")
    AnimationRepeat("concent")
    SoundPlayEffect(629074) --MOVIE_U-ARE-NOT-ALONE
    Wait(4)
    AnimationRemove("concent")

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001003))  -- "이... 이상한 곳이다…"
    Wait(2)
    MonologClose()

    -- 더미 NPC들 보이기
    TownCharacterShow(TownCharacterGetNPC(301))
    TownCharacterShow(TownCharacterGetNPC(302))
    TownCharacterShow(TownCharacterGetNPC(303))
    TownCharacterShow(TownCharacterGetNPC(304))
    TownCharacterShow(TownCharacterGetNPC(305))
    TownCharacterShow(TownCharacterGetNPC(306))
    TownCharacterShow(TownCharacterGetNPC(307))
    TownCharacterShow(TownCharacterGetNPC(308))
    TownCharacterShow(TownCharacterGetNPC(309))
    TownCharacterShow(TownCharacterGetNPC(310))
    TownCharacterShow(TownCharacterGetNPC(311))

    Wait(1)

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001004))  -- "여기를 봐도…"
    Wait(2)
    MonologClose()

    -- 왼쪽 줌인
    TownCameraZoomIn(TownCharacterGetNPC(0), -250, 33*40, 1.5)
    Wait(2)

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001005))  -- "저기를 봐도…"
    Wait(2)
    MonologClose()

    -- 오른쪽 줌인
    TownCameraZoomIn(TownCharacterGetNPC(0), 250, 33*40, 1.5)
    Wait(2)

    -- 독백
    MonologOpen(STR_QUEST_TEXT(810001006))  -- "모두 춤을 추고 있어;;;;"
    Wait(2)
    TownCharacterSetExpression(TownCharacterGetNPC(1), "Default")
    MonologClose()

    -- 시점을 분수대 근처로
    TownCameraSetPos(TownCharacterGetNPC(0), 0, 33*40-80, 1)

    -- 더미 NPC들 등장
    TownCharacterStandAt(TownCharacterAddNPC(301), -283, 33*40+76)
    TownCharacterStandAt(TownCharacterAddNPC(302), -164, 33*40+17)
    TownCharacterStandAt(TownCharacterAddNPC(303), -214, 33*40-144)
    TownCharacterStandAt(TownCharacterAddNPC(304), -289, 33*40-263)
    TownCharacterStandAt(TownCharacterAddNPC(305), -166, 33*40-342)
    TownCharacterStandAt(TownCharacterAddNPC(306), 180, 33*40+80)
    TownCharacterStandAt(TownCharacterAddNPC(307), 359, 33*40-5)
    TownCharacterStandAt(TownCharacterAddNPC(308), 230, 33*40-90)
    TownCharacterStandAt(TownCharacterAddNPC(309), 316, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(310), 285, 33*40-285)
    TownCharacterStandAt(TownCharacterAddNPC(311), 286, 33*40-356)

    -- 더미 NPC들 NameTag숨김
    TownCharacterHideNameTag(TownCharacterGetNPC(301))
    TownCharacterHideNameTag(TownCharacterGetNPC(302))
    TownCharacterHideNameTag(TownCharacterGetNPC(303))
    TownCharacterHideNameTag(TownCharacterGetNPC(304))
    TownCharacterHideNameTag(TownCharacterGetNPC(305))
    TownCharacterHideNameTag(TownCharacterGetNPC(306))
    TownCharacterHideNameTag(TownCharacterGetNPC(307))
    TownCharacterHideNameTag(TownCharacterGetNPC(308))
    TownCharacterHideNameTag(TownCharacterGetNPC(309))
    TownCharacterHideNameTag(TownCharacterGetNPC(310))
    TownCharacterHideNameTag(TownCharacterGetNPC(311))

    -- 유저 캐릭터 등장
    TownCharacterStandAt(TownCharacterAddNPC(1), 0, 33*40-182)
    -- 카바 등장
    TownCharacterStandAt(TownCharacterAddNPC(101), 400, 33*40-182)

    -- 유저 캐릭터는 기본동작
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

    -- 5초 대기
    Wait(5)

    -- 더미 NPC들 감추기
    TownCharacterHide(TownCharacterGetNPC(301))
    TownCharacterHide(TownCharacterGetNPC(302))
    TownCharacterHide(TownCharacterGetNPC(303))
    TownCharacterHide(TownCharacterGetNPC(304))
    TownCharacterHide(TownCharacterGetNPC(305))
    TownCharacterHide(TownCharacterGetNPC(306))
    TownCharacterHide(TownCharacterGetNPC(307))
    TownCharacterHide(TownCharacterGetNPC(308))
    TownCharacterHide(TownCharacterGetNPC(309))
    TownCharacterHide(TownCharacterGetNPC(310))
    TownCharacterHide(TownCharacterGetNPC(311))

    -- 유저 캐릭터 줌인
    TownCameraZoomIn(TownCharacterGetNPC(1), 0, 50, 2)
    Wait(1)

    -- 화면 우측 카바 등장, 카메라 줌인
    TownCharacterStandAt(TownCharacterAddNPC(101), 360, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPC(101), -60, 50, 2)
    Wait(1)

    -- 카바가 유저 캐릭터 우측으로 걸어온다
    TownCharacterWalkTo(TownCharacterGetNPC(101), 120, 33*40-182)
    Wait(2)

    -- 카바 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001007))  -- "춤을 추고 있지 않다니, 이 곳에는 처음인가 보군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001008))  -- "여기는 {highlight}{bold}댄스빌{/bold}{/highlight}, 춤으로 소통하는 세계, 리듬이 지배하는 세상."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001009))  -- "그리고 난 댄스빌의 이름난 춤꾼! {highlight}{bold}카바{/bold}{/highlight}라고 한다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001010))  -- "자네의 이름은?"
    MonologOpen(STR_QUEST_TEXT(810001011))  -- "내 이름이… 아, 그래. 생각이 나."
    Wait(2)
    MonologClose()

    -- 퀘스트 더미 진행 중이거나 닉네임을 이미 변경한 경우 스킵
    if (not CheckQuestManagerDummy()) and (not CheckQuestProgress(10101, 1)) then
        -- 닉네임 변경, 닉네임이 변경되면 진행도 10101가 1이 된다.
        RequireChangeNickname()
    end
    SetQuestProgressComplete_Dummy(10101)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001012))  -- "[nickname], 그게 자네의 이름이군. 좋아."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001013))  -- "혹시 이름을 잘못 말했다 싶으면 자네 {highlight}{bold}이름 옆에 있는 작은 버튼{/bold}{/highlight}을 눌러 이름을 바꿀 수 있다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001014))  -- "원래 이름을 바꾸려면 많은 댄소나이트가 필요하지만, 처음 한 번은 무료로 바꿀 수 있으니 참고하게나."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001015))  -- "그나저나... 그렇게 멍하니 서 있어서는 곤란해."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001016))  -- "이곳 댄스빌에서 춤을 추지 않는 것은 곧 숨을 쉬지 않는 것! 자, 내가 말하는 대로 해보게!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001017))  -- "춤을 추려면 먼저 자네의 캐릭터를 터치해 메뉴를 불러와야 해."

    -- 유저 캐릭터 터치 요구조건
    ::jmp_click1::
    RequireSceneTownCharacterClick(TownCharacterGetNPC(1))
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001018))  -- "자네 캐릭터를 터치하면 아주 중요한 메뉴들을 불러올 수 있어."
        goto jmp_click1
    end

    -- 단독 줌인
    ScriptTownZoomInCharacter(TownCharacterGetNPC(1))
    -- 상단 바 가림
    PushPopupTownUserWithoutTopBar(1)
    -- 유저정보 박스 가림
    UIHide("uiProfileBox")
    UIHide("uiBottomButtons")

    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001019))  -- "이제 {highlight}{bold}춤{/bold}{/highlight} 버튼을 한 번 눌러보겠나?"

    ::jmp_btn_info_dance::
    RequireClickWithCCB("UI_common/ui_btn2_003_05", "btn_info_dance")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001020))  -- "{highlight}{bold}춤{/bold}{/highlight} 버튼을 살짝 터치하면 된다네."
        goto jmp_btn_info_dance
    end
end


local function ScriptQuestCreateDance()
    FullLoad()

    UseDummyDanceList("")

    -- 춤 목록 화면으로
    PushSceneDanceList("My")
    -- 카바 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001021))  -- "잘 왔네. 여긴 또 뭐하는 곳인가 싶지?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001022))  -- "이곳은 자네가 만든 춤들을 한 눈에 볼 수 있는 화면이야."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001023))  -- "왜이리 허전하냐고? 자네가 아직 춤을 만들지 않았으니 당연한 것이지!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001024))  -- "그럼 이 허전함을 채울 춤을 하나 만들어 볼까? {highlight}{bold}추가{/bold}{/highlight} 버튼을 눌러보자고."

    ::jmp_btn_add::
    RequireClickWithCCB("UI_common/ui_btn2_004_02", "btn_add")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001025))  -- "괴상한 게 튀어나온다든지 하지 않으니까 걱정말고 {highlight}{bold}추가{/bold}{/highlight} 버튼을 한 번 눌러봐."
        goto jmp_btn_add
    end

    UseDummyDanceList("[612020]")
    SetQuestProgress_Dummy(10103, 1)
    Wait(0.5)
end

local function ScriptQuestDanceMove()
    FullLoad()

    SetInteger("skip_temporary_save", 1)

    -- 춤 편집 화면으로
    PushSceneDanceMove()
    -- 카바 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    -- 튜토리얼에 필요없는 UI감추기
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_backward")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_undo")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_redo")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_tuto_help")

    UIHideWithCCB("UI_dance/ui_dance_01", "minibox")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_play_pause")
    UIHide("uiControlPoints")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_section_repeat")

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")


    -- 이름 편집 커서 안나오게
    UIHide("uiTextInput")

    UIHide("uiFrames")
    UIHideWithCCB("UI_dance/ui_dance_01", "timeline_arrw")
    UIHideWithCCB("UI_dance/ui_btn_dance_frame_edit", "btn_add")
    UIHideWithCCB("UI_dance/ui_btn_dance_frame_edit", "btn_del")
    UIDisableWithCCB("UI_dance/ui_dance_control","btn_control_name")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001026))  -- "잘 했네. {pagebreak} 이 화면에서는 자네가 출 춤을 직접 만들 수 있다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001027))  -- "가운데 보이는 큰 인형을 이용해 춤을 만들 수 있지."

    -- 조절점 UI 표시
    UIShow("uiControlPoints")
    Wait(2)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001028))  -- "움직이고 싶은 부위의 {highlight}{bold}노란 점{/bold}{/highlight}을 손가락으로 살짝 {highlight}{bold}터치{/bold}{/highlight}하면 되는데..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001029))  -- "먼저 오른손을 한 번 선택해볼까?"

    -- 인형의 오른손 조절점 정확한 위치에 유도 신호.
    ::jmp_retry_r_hand::
    x = UIGetX("cpRHand")
    y = UIGetY("cpRHand")
    RequireTouchArea(x-30, x+30, y-30, y+30)
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001030))  -- "오른손을 한 번 선택해볼까?"
        goto jmp_retry_r_hand
    end
    SceneDanceMove_SelectCP("cpRHand")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001031))  -- "그 부분이 선택되지?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810001032))  -- "응? 점이 너무 작아서 정확하게 선택하기가 힘들다고? 그럼 좋은 방법이 있지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001033))  -- "왼손 주위의 빈 공간을 터치해볼까?"

    -- 인형의 왼손 조절점 주변의 빈공간(터치하면 왼손이 선택될 수 있는 빈 공간)에 유도 신호.
    ::jmp_retry_l_hand::
    x = UIGetX("cpLHand")
    y = UIGetY("cpLHand")
    RequireTouchArea(x+100-80, x+100+80, y-80, y+80)
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001033))  -- "왼손 주위의 빈 공간을 터치해볼까?"
        goto jmp_retry_l_hand
    end
    SceneDanceMove_SelectCP("cpLHand")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001034))  -- "왼손 주위의 빈 공간을 터치하니 왼손이 선택되지?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810001035))  -- "이렇게 대충 {highlight}{bold}빈 공간을 터치{/bold}{/highlight}해도 그 주위의 파란 점이 선택된다는 사실!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810001036))  -- "뭐? 점 두 개가 비슷한 위치에 있으면 어쩌냐고? 거 참 빈틈이 없는 사람이구만."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001037))  -- "같은 빈 공간을 연속해서 터치하면 가까운 부위가 차례로 선택되니 걱정할 것 없네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001038))  -- "아까와 같은 곳을 다시 한 번 터치하면 어떻게 되는지 볼까?"

    -- 인형의 왼손 조절점 주변의 빈공간(이전에 유도했던 곳과 같은 곳)에 유도 신호.
    ::jmp_retry_l_hand_2::
    x = UIGetX("cpLHand")
    y = UIGetY("cpLHand")
    RequireTouchArea(x+100-80, x+100+80, y-80, y+80)
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001039))  -- "아까 터치했던 곳과 같은 곳을 한 번 더 터치해볼까?"
        goto jmp_retry_l_hand_2
    end
    SceneDanceMove_SelectCP("cpLArm")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001040))  -- "같은 곳을 터치했는데 다른 부위가 선택되는 것이 보이지?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001041))  -- "이런 방식으로 두 부위가 겹쳤을 때도 원하는 부위를 선택할 수 있는 거야."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001042))  -- "움직일 부위를 선택했으니, 이제 손가락을 {highlight}{bold}화면의 아무 곳{/bold}{/highlight}에나 댄 채로 움직이면!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001043))  -- "그 부위를 움직이고자 하는 방향으로 옮길 수 있어."
    DescriptionBarShow(STR_QUEST_TEXT(810001044))   -- "손가락을 화면에 댄 채로 끌어보세요."

    -- 캐릭터가 없는 빈공간에 안 누른 상태의 손가락 등장,
    -- 누른 상태의 손가락으로 바뀐 후 그 상태에서 아래(손가락 등장 위치에 따라서 방향은 위나 옆으로 바뀌어도 상관없음)로 일정 거리를 이동하는 모습을 반복해서 보여준다.
    -- 유저가 드래그를 하고나면 손가락은 사라짐.>> 빈 공간에서 드래그를 하라는 메시지를 전달하기 위해

    -- 진행조건 : 조절점 드래그
    RequireDragFromTo(200, 0, 350, 0)

    DescriptionBarHide()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001045))  -- "말귀를 잘 알아듣는군. 그런 방식으로 원하는 자세를 만들면 된다네."

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001046))  -- "머리나 몸통의 {highlight}{bold}기울기{/bold}{/highlight}는 {highlight}{bold}파란 점{/bold}{/highlight}을 이용하면 쉽게 조절할 수 있어."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001047))  -- "{highlight}{bold}머리{/bold}{/highlight}를 한번 기울여보면 쉽게 이해가 될 거야."

    ::jmp_cpHead::  --머리 회전조절점 누르도록 유도
    RequireTouchUI("cpHeadRot")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001047))  -- "{highlight}{bold}머리{/bold}{/highlight}를 한번 기울여보면 쉽게 이해가 될 거야."
        goto jmp_cpHead
    end
    SceneDanceMove_SelectCP("cpHeadRot")
    RequireDragFromTo(100, 0, 200, 0)  --머리 옆의 빈공간에서 손가락을 드래그하도록 유도(머리 기울이기 동작 유도)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001048))  -- "역시 쉽게 해내는군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001049))  -- "그렇게 {highlight}{bold}네 개{/bold}{/highlight}의 자세를 정하면 그것들이 연결되어 예술적인 춤이 되는 거지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001050))  -- "{highlight}{bold}아래{/bold}{/highlight}에 있는 네 개의 {highlight}{bold}작은 인형{/bold}{/highlight}들을 터치하면 각각의 자세를 바꿀 수가 있어."

    -- 하단 프레임 목록 표시, 안내신호 표시
    UIShow("uiFrames")
    UIShowWithCCB("UI_dance/ui_dance_01", "timeline_arrw")
    UISignalShow("uiFrames")
    Wait(2)
    UISignalHide()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001051))  -- "그럼 말이 나온 김에 두 번째 자세도 한 번 바꿔볼까?"

    -- 진행조건 : 두번째 프레임 선택
    ::jmp_uiFrame2::
    RequireButton("uiFrame2")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001052))  -- "아래 네 개의 인형 중에 {highlight}{bold}두 번째{/bold}{/highlight} 인형을 터치하면 된다네."
        goto jmp_uiFrame2
    end

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001053))  -- "방금 만든 자세에 이어질 자세를 여기에 만들고."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001054))  -- "이런 식으로 세 번째, 네 번째 자세도 만들면!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001055))  -- "간단히 춤 완성!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001056))  -- "{highlight}{bold}완성된 춤{/bold}{/highlight}을 추는 자네의 모습이 {highlight}{bold}왼쪽{/bold}{/highlight}의 조그만 화면에 보일 걸세"

    -- 미리보기 UI 표시, 안내신호 표시
    UIShowWithCCB("UI_dance/ui_dance_01", "minibox")
    UIShowWithCCB("UI_dance/ui_dance_01", "btn_play_pause")
    UISignalShowWithCCB("UI_dance/ui_dance_01", "btn_change_dancer")
    Wait(2)
    UISignalHide()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810001057))  -- "팔, 다리가 앙상하고 단순해 보여도 무시는 금물!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810001058))  -- "저래 봬도 춤추기에 최적화된 형태라네."

    -- 뒤로가기 버튼 표시
    UIShowWithCCB("UI_dance/ui_dance_01", "btn_backward")
    UISignalShowWithCCB("UI_dance/ui_dance_01", "btn_backward")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001059))  -- "자, 그럼 춤을 완성한 후 {highlight}{bold}[뒤로 가기]{/bold}{/highlight} 버튼을 눌러서 밖으로 나오게."
    UISignalHide()

    DescriptionBarShow(STR_QUEST_TEXT(810001060))   -- "재미있는 자세를 만들어보세요."


    -- 진행조건 : 춤 편집 튜토리얼
    -- 두 개 이상의 프레임을 편집하지 않은 상태에서 뒤로가기를 누르면 첫번째 대사창
    -- 아무 조작 없이 20초가 지나면 두번째 대사창
    -- 완료 후 편집한 춤 저장
    ::jmp_DanceMoveTutorial::
    RequireSceneDanceMoveTutorial()
    if RequireCheckResult("2More") then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001061))  -- "아래 네 개의 자세 중에 {highlight}{bold}두 개{/bold}{/highlight} 정도는 바꿔줘야 춤 같이 보이지 않겠어?"
        goto jmp_DanceMoveTutorial
    elseif RequireCheckResult("TimeOut") then
        UISignalShowWithCCB("UI_dance/ui_dance_01", "btn_backward")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001062))  -- "잊지 말게. 춤을 완성했다 싶으면 {highlight}{bold}[뒤로 가기]{/bold}{/highlight} 버튼을 누르는 거야."
        UISignalHide()
        goto jmp_DanceMoveTutorial
    end

end


local function ScriptQuestComplete()
-- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()
    -- 카바 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    -- 더미 NPC들 등장
    TownCharacterStandAt(TownCharacterAddNPC(301), -283, 33*40+76)
    TownCharacterStandAt(TownCharacterAddNPC(302), -164, 33*40+17)
    TownCharacterStandAt(TownCharacterAddNPC(303), -214, 33*40-144)
    TownCharacterStandAt(TownCharacterAddNPC(304), -289, 33*40-263)
    TownCharacterStandAt(TownCharacterAddNPC(305), -166, 33*40-342)
    TownCharacterStandAt(TownCharacterAddNPC(306), 180, 33*40+80)
    TownCharacterStandAt(TownCharacterAddNPC(307), 359, 33*40-5)
    TownCharacterStandAt(TownCharacterAddNPC(308), 230, 33*40-90)
    TownCharacterStandAt(TownCharacterAddNPC(309), 316, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(310), 285, 33*40-285)
    TownCharacterStandAt(TownCharacterAddNPC(311), 286, 33*40-356)

    -- 더미 NPC 감추기
    TownCharacterHideWithUpdate(TownCharacterGetNPC(301))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(302))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(303))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(304))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(305))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(306))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(307))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(308))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(309))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(310))
    TownCharacterHideWithUpdate(TownCharacterGetNPC(311))

    -- 더미 NPC들 NameTag숨김
    TownCharacterHideNameTag(TownCharacterGetNPC(301))
    TownCharacterHideNameTag(TownCharacterGetNPC(302))
    TownCharacterHideNameTag(TownCharacterGetNPC(303))
    TownCharacterHideNameTag(TownCharacterGetNPC(304))
    TownCharacterHideNameTag(TownCharacterGetNPC(305))
    TownCharacterHideNameTag(TownCharacterGetNPC(306))
    TownCharacterHideNameTag(TownCharacterGetNPC(307))
    TownCharacterHideNameTag(TownCharacterGetNPC(308))
    TownCharacterHideNameTag(TownCharacterGetNPC(309))
    TownCharacterHideNameTag(TownCharacterGetNPC(310))
    TownCharacterHideNameTag(TownCharacterGetNPC(311))

    -- 유저 캐릭터 등장, 춤을 추고있음
    dance_data = GetConfigDataStr("quest/810001/dance_data")
    TownCharacterStandAt(TownCharacterAddNPC(1), 0, 33*40-182)
    TownCharacterActionWithData(TownCharacterGetNPC(1), dance_data)
    -- 화면 우측에 카바 등장
    TownCharacterStandAt(TownCharacterAddNPC(101), 400, 33*40-182)
    -- 카바 줌인
    TownCameraSetPos(TownCharacterGetNPC(101), 0, 50, 2)
    TownCameraZoomIn(TownCharacterGetNPC(101), 0, 50, 2)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001063))  -- "드디어 첫 춤을 만들었군!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001064))  -- "춤을 만드는 데 익숙해지면 더 다양한 춤 만들기 기술을 익힐 수 있다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810001065))  -- "그럼 춤을 한 번 볼까?"

    -- 카바 좌측을 줌인
    TownCameraZoomIn(TownCharacterGetNPC(101), -60, 50, 2)
    -- 유저 캐릭터 우측으로 카바 접근
    TownCharacterWalkTo(TownCharacterGetNPC(101), 120, 33*40-182)
    Wait(1)

    TownCharacterActionWithData(TownCharacterGetNPC(101), dance_data)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810001066))  -- "오오! 저절로 어깨가 들썩일 정도로 흥이 나는 춤이야!"

    -- 카바가 유저의 춤을 따라 춤
    TownCharacterActionWithData(TownCharacterGetNPC(1), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(101), dance_data)

    -- 더미 NPC들이 등장하고 유저의 춤을 따라 춤
    TownCharacterActionWithData(TownCharacterGetNPC(301), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(302), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(303), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(304), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(305), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(306), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(307), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(308), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(309), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(310), dance_data)
    TownCharacterActionWithData(TownCharacterGetNPC(311), dance_data)

    Wait(1)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810001067))  -- "저것 봐! 다른 춤꾼들이 이 춤에 감응하기 시작했어!"

    TownCharacterShow(TownCharacterGetNPC(301))
    TownCharacterShow(TownCharacterGetNPC(302))
    TownCharacterShow(TownCharacterGetNPC(303))
    TownCharacterShow(TownCharacterGetNPC(304))
    TownCharacterShow(TownCharacterGetNPC(305))
    TownCharacterShow(TownCharacterGetNPC(306))
    TownCharacterShow(TownCharacterGetNPC(307))
    TownCharacterShow(TownCharacterGetNPC(308))
    TownCharacterShow(TownCharacterGetNPC(309))
    TownCharacterShow(TownCharacterGetNPC(310))
    TownCharacterShow(TownCharacterGetNPC(311))

    TownCameraZoomIn(TownCharacterGetNPC(0), 0, 33*40-80, 1)

    Wait(4)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810001068))  -- "자네.. 아주 흥미로운 친구로군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001069))  -- "이렇게 만난 것도 인연인데 날 따라오겠나?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001070))  -- "지낼 곳도 마땅찮을 텐데 우리 집으로 함께 가세."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001071))  -- "여기서 조금만 걸으면 보라색으로 아름답고 찬란하게 빛나는 집이 나올 거야. 바로 거기라네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810001072))  -- "그럼 가볼까?"

    -- 카바 줌인
    TownCameraZoomIn(TownCharacterGetNPC(101), 0, 50, 1)

    -- 카바가 집 앞으로 이동
    TownCharacterWalkTo(TownCharacterGetNPC(101), -12*40, 53*40)
    Wait(2)
    -- 유저도 따라서 이동
    TownCharacterWalkTo(TownCharacterGetNPC(1), -12*40, 53*40)
    Wait(3)

    MonologOpen(STR_QUEST_TEXT(810001073))  -- "잠시 후..."
    Wait(2)
    MonologClose()

    -- 더미 캐릭터 감춤
    TownCharacterHide(TownCharacterGetNPC(301))
    TownCharacterHide(TownCharacterGetNPC(302))
    TownCharacterHide(TownCharacterGetNPC(303))
    TownCharacterHide(TownCharacterGetNPC(304))
    TownCharacterHide(TownCharacterGetNPC(305))
    TownCharacterHide(TownCharacterGetNPC(306))
    TownCharacterHide(TownCharacterGetNPC(307))
    TownCharacterHide(TownCharacterGetNPC(308))
    TownCharacterHide(TownCharacterGetNPC(309))
    TownCharacterHide(TownCharacterGetNPC(310))
    TownCharacterHide(TownCharacterGetNPC(311))

    -- 시점을 광장 중앙으로
    TownCameraSetPos(TownCharacterGetNPC(0), 0, 33*40, 1)


    -- 3명 추락 애니메이션 재생
    AnimationAdd("opening2_1", "Opening/Event_falling02_01")
    AnimationSetFullScreen("opening2_1")
    Wait(0.5)
    AnimationPlay("opening2_1")
    Wait(0.45)
    SoundPlayEffect(629072) --FALL_SEQUENCE_HEAD
    Wait(2.6)
    AnimationRemove("opening2_1")

    AnimationAdd("opening2_2", "Opening/Event_falling02_02")
    AnimationSetPos("opening2_2", 80, 100)
    Wait(0.5)

    AnimationPlay("opening2_2")
    Wait(0.1)
    SoundPlayEffect(629073) --FALL_SEQUENCE_TAIL

    Wait(0.5)
    -- 추락하는 3인 케릭터 생성
    AnimationAdd("avatar_dummy", "Opening/Event_falling02_dummy")
    AnimationDisable( "avatar_dummy")

    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(207), AnimationGetSpriteProperty( "avatar_dummy", "dummy1"), 40, 33*40+82)
    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(208), AnimationGetSpriteProperty( "avatar_dummy", "dummy2"), 40, 33*40+82)
    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(209), AnimationGetSpriteProperty( "avatar_dummy", "dummy3"), 40, 33*40+82)

    TownCharacterHideNameTag( TownCharacterGetNPC(207))
    TownCharacterHideNameTag( TownCharacterGetNPC(208))
    TownCharacterHideNameTag( TownCharacterGetNPC(209))

    TownCharacterActionByID(TownCharacterGetNPC(207), 612849)
    TownCharacterActionByID(TownCharacterGetNPC(208), 612850)
    TownCharacterActionByID(TownCharacterGetNPC(209), 612851)

    Wait(0.5)

    TownCharacterActionPause(TownCharacterGetNPC(207), 1)
    TownCharacterActionPause(TownCharacterGetNPC(208), 1)
    TownCharacterActionPause(TownCharacterGetNPC(209), 1)

    AnimationRemove("avatar_dummy")

    Wait(0.4)
    AnimationRemove("opening2_2")

    AnimationAdd("opening2_3", "Opening/Event_falling02_03")
    AnimationSetPos("opening2_3", 80, 100)
    AnimationRepeat("opening2_3")

    TownCharacterActionPause(TownCharacterGetNPC(207), 0)
    TownCharacterActionPause(TownCharacterGetNPC(208), 0)
    TownCharacterActionPause(TownCharacterGetNPC(209), 0)

    Wait(1.0)

    TownCharacterActionPause(TownCharacterGetNPC(207), 1)
    TownCharacterActionPause(TownCharacterGetNPC(208), 1)
    TownCharacterActionPause(TownCharacterGetNPC(209), 1)

    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810001074))  -- "으으…이동할 때마다 충격이 이렇게 커서야... 여긴… 설마…?"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810001075))  -- "결국… 이 곳으로 돌아온 건가…"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810001076))  -- "아직.... 끝나지 않았다…"


    TownCharacterHideAll()
    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(207))
    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(208))
    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(209))

    -- 독백, 퀘스트 종료
    -- MonologOpen("")
    Wait(1)
    ScenarioEndingShow() -- "[오프닝] 스토리 완료"
    Wait(1)

    AnimationStop( "opening2_3")
    AnimationRemove("opening2_3")

    SendSingularLog(1) -- id 1 : tutorial complete

end

local function ScriptOnQuest()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    GoSceneTown()

    if CheckQuestAppear() then
        -- 퀘스트 시작
        QuestStart()
    end

    if CheckQuestRunning() then
        -- 닉네임을 안 바꿨고 춤도 안 만든 상태
        if CheckQuestProgress(10101, 0) and CheckQuestProgress(10103, 0) then
            ScriptQuestNicknameChange()
            ScriptQuestCreateDance()
            ScriptQuestDanceMove()
            ScriptQuestComplete()
        -- 닉네임은 바꿨고 춤은 안 만든 상태
        elseif CheckQuestProgress(10101, 1) and CheckQuestProgress(10103, 0) then
            ScriptQuestNicknameChange()
            ScriptQuestCreateDance()
            ScriptQuestDanceMove()
            ScriptQuestComplete()
        -- 닉네임을 바꿨고 춤도 만든 상태
        elseif CheckQuestProgress(10101, 1) and CheckQuestProgress(10103, 1) then
            ScriptQuestComplete()
        end

        -- 퀘스트 보상
        QuestComplete()
    end

    if CheckQuestComplete() then
        QuestReward()

        -- 이어서 다음 시나리오를 카바가 진행하므로, 카바네 집 앞으로 카메라 이동
        TownMapSetPos(TownCharacterGetNPC(101), 0, 50, 1)

        GoTown()

        if (CheckGuestUser()==false) then
            ShowReviewPopup()
        end
    end
end

if OnQuestReplay() then
    UnlockQuestContents()

    ScriptQuestNicknameChange()
    ScriptQuestCreateDance()
    ScriptQuestDanceMove()
    ScriptQuestComplete()
    GoTown()
end

-- 이 퀘스트는 체험형이므로, 도중에 중단된 경우 게임 시작시 바로 퀘스트로 넘어간다.
if OnGameStart() then
    ScriptOnQuest()
end
