-- 우주의 균형(810003) -- 스토리
-- version("0.31.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end
  
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 팬 되기, 스타/팬 관리 기능을 열어줌
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function textCheckQuestAppear()
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003001))  -- "자네에겐 다른 세계의 기운이 느껴지는군."

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestReplay()
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003001))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
end

local function ScriptOnQuest()
      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(129)
    
	AddQuestSkipButton()
	
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003002))  -- "자네에게서 느껴지는 파동... 우리의 것과는 조금 다르군."

     TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003003))  -- "힘을 간직한 고요함이라. 어떤 수련을 했는지 모르겠지만 아주 드문 기운이야."
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003004))  -- "우주란 말일세. 완벽하게 아귀를 맞춰가며 굴러가는 듯 보이지만 생각보다 허점이 많아."

      --밤하늘에 우주통로가 생기는 이미지 등장
    AnimationAdd("event_memory_04_01", "Characters/event_memory_04_01")
    AnimationSetFullScreen("event_memory_04_01")
	AnimationPlay( "event_memory_04_01")
	SoundPlayEffect(629071) --=SE=Ani_Wormhole
	Wait(3)
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003005))  -- "그 허점은 기운의 불균형을 가져오고, 그 불균형을 해소하기 위해 우주에는 {highlight}{bold}구멍{/bold}{/highlight}이 생긴다네."

    AnimationRemove( "event_memory_04_01")

      --춤요정들이 우주 통로에서 지구로 날아오는 이미지 등장
	AnimationAdd("event_memory_04_02", "Characters/event_memory_04_02")
    AnimationSetFullScreen("event_memory_04_02")
	AnimationPlay( "event_memory_04_02")
	SoundPlayEffect(629062) --=SE=Ani_Angel
    Wait(5)
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003006))  -- "그리고 그 구멍을 통해서 다른 세계의 기운들이 왕래하며 균형을 되찾아가는 것이지."

      --춤요정들이 우주 통로에서 지구로 날아오는 이미지 사라짐
	AnimationRemove( "event_memory_04_02")
	
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003007))  -- "자네는 그 균형추가 되어줄 존재일지도 모르겠군. {highlight}{bold}춤요정{/bold}{/highlight}들이 그랬던 것처럼."
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003008))  -- "자네가 왜 여기 있는지 궁금할 테지? 자네가 누구인지도?"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_exclamation")
    Wait(1.5)
    
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003009))  -- "{highlight}{bold}춤요정{/bold}{/highlight}을 찾아가보게. 그 물음에 대한 단서를 얻을 수 있을 걸세."
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003010))  -- "그들도 자네처럼 {highlight}{bold}우주의 구멍{/bold}{/highlight}을 통과한 {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들이니까 말이야."
    DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003011))  -- "{highlight}{bold}춤요정{/bold}{/highlight}들은 {highlight}{bold}마을{/bold}{/highlight}에 흔하게 돌아다니곤 하니 찾기가 어렵진 않을 걸세."
    Wait(0.5)

    MonologOpen(STR_QUEST_TEXT(810003012))  -- "우주의 구멍... 그리고 춤요정..."
    Wait(2)
    MonologClose()
    Wait(1)
	
    -- 퀘스트 시작/완료/보상
    ScenarioEndingShow()  -- "[우주의 균형] 스토리 완료"

    QuestStart()
    QuestComplete()
    QuestReward()
	GoTown()

end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(129))
        -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(129))
        -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(129))
		-- DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
		textCheckQuestAppear()
        PushPopupTownNpcWithSelectBox(129)
    end
    
	if OnClickQuestTab(TownCharacterGetNPC(129)) then
        --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
		textCheckQuestAppear()
    end
    
	if OnClickQuestStart() then
        ScriptOnQuest()
	elseif CheckQuestRunning() then       
		if OnTownRefresh() then
            TownCharacterRoamInTown(TownCharacterAddNPC(129))
            TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
            TownCharacterSetQuest(TownCharacterGetNPC(129))			
		end
        			
	
		if OnTownCharacterClick(TownCharacterGetNPC(129)) then
			ScriptTownMoveToTownSquare(TownCharacterGetNPC(129))  -- 대사가 없이 바로 이동
              -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(129))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
              -- ScriptTownMoveToSide(TownCharacterGetNPC(129))
            --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
			textCheckQuestAppear()
            PushPopupTownNpcWithSelectBox(129)
        end
        
		if OnClickQuestTab(TownCharacterGetNPC(129)) then
            --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))      -- "자네에겐 다른 세계의 기운이 느껴지는군."
			textCheckQuestAppear()
		end
        
		if OnClickQuestStart() then
            ScriptOnQuest()
        elseif CheckQuestComplete() then
            if OnTownRefresh() then
               TownCharacterRoamInTown(TownCharacterAddNPC(129))
               TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
               TownCharacterSetQuest(TownCharacterGetNPC(129))
            end
        
			if OnTownCharacterClick(TownCharacterGetNPC(129)) then
           
			ScriptTownMoveToTownSquare(TownCharacterGetNPC(129))  -- 대사가 없이 바로 이동
                -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(129))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
                -- ScriptTownMoveToSide(TownCharacterGetNPC(129))
                --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
				textCheckQuestAppear()
                PushPopupTownNpcWithSelectBox(129)
            end
		end
        if OnClickQuestTab(TownCharacterGetNPC(129)) then
            --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003012))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
			textCheckQuestAppear()
        end

        if OnClickQuestStart() then
            ScriptOnQuest()
        end    
	end
end

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(129))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
    TownCharacterSetQuest(TownCharacterGetNPC(129))
    ScriptTownMoveToTownSquare(TownCharacterGetNPC(129))  -- 대사가 없이 바로 이동
    -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(129)) -- 넓은 장소가 필요함으로 무조건 광장으로 이동
    -- ScriptTownMoveToSide(TownCharacterGetNPC(129))
    --DialogOpen(129, STR_NPC(129), "", STR_QUEST_TEXT(810003001))  -- "자네에겐 다른 세계의 기운이 느껴지는군."
    textCheckQuestReplay()
    PushPopupTownNpcWithSelectBox(129)
end
