-- 하늘에서 떨어진 자들(810005) -- 스토리
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 팬 되기, 스타/팬 관리 기능을 열어줌
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005001))  -- "댄스게이트 조사 결과가 궁금하시죠?"
end



if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(111))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
    TownCharacterSetQuest(TownCharacterGetNPC(111))
    ScriptTownMoveToTownSquare(TownCharacterGetNPC(111))  -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(111)) -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(111))
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005001))  -- "댄스게이트 조사 결과가 궁금하시죠?"
    PushPopupTownNpcWithSelectBox(111)
 end

local function ScriptOnQuest()
      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(111)
    
	-- 대사 스킵
	AddQuestSkipButton()
		
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005002))  -- "여기 계셨군요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005003))  -- "오늘은 {highlight}{bold}가디{/bold}{/highlight} 여왕의 부탁을 받고 이렇게 찾아왔어요!"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005004))  -- "{highlight}{bold}댄스게이트 조사 결과{/bold}{/highlight}를 알려드리려구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005005))  -- "제 직업이 바로 댄스게이트 정비공이거든요!"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_exclamation")
    Wait(1.5)
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005006))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}를 살펴보니, {highlight}{bold}우주 통로{/bold}{/highlight}에 정상적으로 연결된 기록 외에 {highlight}{bold}오작동한 흔적{/bold}{/highlight}이 있었어요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005007))  -- "정상적인 작동과 동일한 패턴이었는데도 {highlight}{bold}우주 통로{/bold}{/highlight}와는 연결되지 않았죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005008))  -- "그런데 그런 증상이 있을 때마다 {highlight}{bold}댄스게이트{/bold}{/highlight} 주위 어딘가에 {highlight}{bold}우주 통로{/bold}{/highlight}가 열렸던 모양이에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005009))  -- "그리고 그 때마다 {highlight}{bold}우주 통로{/bold}{/highlight}에서 누군가가 나왔을 가능성이 있으니까..."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005010))  -- "{highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들은 생각보다 많을 수 있는 거죠."

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_shocking")
    Wait(1.5)
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005011))  -- "[유저의 닉네임] 님께는 오히려 희소식일 수도 있어요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005012))  -- "[유저의 닉네임] 님께서 어디에서 왔는지 알면, {highlight}{bold}댄스게이트{/bold}{/highlight}를 통해서 돌아가실 수도 있잖아요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005013))  -- "{highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들 중, [유저의 닉네임] 님과 같은 세계에서 온 사람이 있다면 그 문제는 간단히 해결될 거에요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005014))  -- "그러려면 [유저의 닉네임] 님은 댄스빌에서 {highlight}{bold}유명해질 필요{/bold}{/highlight}가 있구요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005015))  -- "유명해지면 하늘에서 떨어진 자들 중 [유저의 닉네임] 님을 알아보는 사람이 나오기 쉬워지니까 말이죠!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005016))  -- "{highlight}{bold}뮤직비디오{/bold}{/highlight}를 만들어서 {highlight}{bold}댄스비전{/bold}{/highlight}에 꾸준히 올려보세요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005017))  -- "[유저의 닉네임] 님의 춤 실력이라면 금새 유명해질 수 있을 거에요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005018))  -- "게다가 [유저의 닉네임] 님은 아직 춤 실력을 완전히 되찾은 것이 아니니까, 앞으로 더 뛰어난 춤꾼이 되실 거잖아요?"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005019))  -- "아, 그리고 이건 그냥 소문인데요..."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005020))  -- "전에 말씀드렸던 {highlight}{bold}전설춤꾼{/bold}{/highlight}의 실종도 이번 {highlight}{bold}댄스게이트{/bold}{/highlight} 오작동과 관련이 있다는 이야기가 있더라구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005021))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}의 오작동, {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들의 등장, {highlight}{bold}전설춤꾼{/bold}{/highlight}의 실종... "
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005022))  -- "왜인지는 모르겠지만 요즘 특이한 일이 많이 일어나네요. 또 어떤 일이 일어날지 기대되는데요?"
    
    MonologOpen(STR_QUEST_TEXT(810005023))  -- "기대하지마... 그런 거..."
    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow()  -- "[하늘에서 떨어진 자들] 스토리 완료"
    -- 퀘스트 시작/완료/보상

    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()
end


if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(111))
            -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(111))
            -- 넓은 장소가 필요하므로 무조건 광장으로 이동
            -- ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005031))  -- "댄스게이트 조사 결과가 궁금하시죠?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end
	
    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005001))  -- "댄스게이트 조사 결과가 궁금하시죠?"
    end
    if OnClickQuestStart() then
        ScriptOnQuest()
    elseif CheckQuestRunning() then
		if OnTownRefresh() then
            TownCharacterRoamInTown(TownCharacterAddNPC(111))
            TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
            TownCharacterSetQuest(TownCharacterGetNPC(111))
        end
		
        if OnTownCharacterClick(TownCharacterGetNPC(111)) then
            ScriptTownMoveToTownSquare(TownCharacterGetNPC(111))
              -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(111))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
              -- ScriptTownMoveToSide(TownCharacterGetNPC(111))
            --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005031))  -- "댄스게이트 조사 결과가 궁금하시죠?"
            textCheckQuestAll()
			PushPopupTownNpcWithSelectBox(111)
        end
		
        if OnClickQuestTab(TownCharacterGetNPC(111)) then
            --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005031))  -- "댄스게이트 조사 결과가 궁금하시죠?"
			textCheckQuestAll()
		end
			
        if OnClickQuestStart() then
            ScriptOnQuest()
        elseif CheckQuestComplete() then
			if OnTownRefresh() then
				TownCharacterRoamInTown(TownCharacterAddNPC(111))
				TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
				TownCharacterSetQuest(TownCharacterGetNPC(111))
			end
			
			if OnTownCharacterClick(TownCharacterGetNPC(111)) then
				ScriptTownMoveToTownSquare(TownCharacterGetNPC(111))
				-- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(111))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
				-- ScriptTownMoveToSide(TownCharacterGetNPC(111))
				--DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005031))  -- "댄스게이트 조사 결과가 궁금하시죠?"
				textCheckQuestAll()
				PushPopupTownNpcWithSelectBox(111)
			end
		end
		
        if OnClickQuestTab(TownCharacterGetNPC(111)) then
            --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(810005031))  -- "댄스게이트 조사 결과가 궁금하시죠?"
			textCheckQuestAll()
		end
        
		if OnClickQuestStart() then
            ScriptOnQuest()
        end
	end
end
