-- 요원의 각오(810006) -- 스토리 퀘스트
-- version("0.42.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

local function UnlockQuestContents()
    UnlockStartQuestMode()
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006001))  -- "{highlight}{bold}초대 전설춤꾼{/bold}{/highlight}은 {highlight}{bold}부활의 춤{/bold}{/highlight}으로 댄스빌을 구했다고 합니다."
end



local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(110)
    
	-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006002))  -- "아, [유저의 닉네임] 님이십니까."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006003))  -- "저는 이곳에서 하루를 돌아보곤 합니다."

      --반짝이는 동상을 아래에서 올려다보는 듯한 이미지 등장
    AnimationAdd("event_memory_08", "Characters/event_memory_08")
    AnimationSetFullScreen("event_memory_08")
	AnimationPlay( "event_memory_08")
	SoundPlayEffect(629067) --=SE=Ani_LookStatue
    Wait(3)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006004))  -- "여기에 서 계시는 이분처럼 댄스빌의 번영과 평화를 위해 기여했는지를 생각하면서."

      --반짝이는 동상을 아래에서 올려다보는 듯한 이미지 사라짐
	AnimationRemove( "event_memory_08")
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006005))  -- "이분은 댄스빌의 {highlight}{bold}초대 전설춤꾼{/bold}{/highlight}이십니다."
    
      --한 명이 어마어마한 광채 한가운데서 춤을 추고 있고, 다른 사람들이 그것을 지켜보는 이미지 등장
    AnimationAdd("event_memory_06", "Characters/event_memory_06")
    AnimationSetFullScreen("event_memory_06")
	AnimationPlay( "event_memory_06")
	SoundPlayEffect(629065) --=SE=Ani_Light
    Wait(4)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006006))  -- "사람들과 춤요정들이 모두 출구가 보이지 않는 위기에 처해있을 때, 춤 하나로 모두를 구해내셨다고 합니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006007))  -- "사람들은 그 때의 전설적인 춤, 혹은 사건을 {highlight}{bold}부활의 춤{/bold}{/highlight}이라고 부릅니다."

      --한 명이 어마어마한 광채 한가운데서 춤을 추고 있고, 다른 사람들이 그것을 지켜보는 이미지 사라짐
    AnimationRemove( "event_memory_06")
		
		
		
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006008))  -- "춤으로 생명의 부활을 이끈다... 정말 대단하지 않습니까?"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006009))  -- "이 분이야말로 지금의 댄스빌이 있게한 장본인이자, 이곳에서 살아가는 모든 이들의 영웅입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006010))  -- "제가 감히 이 분의 업적에 미치기는 힘들겠지만, 조금이나마 댄스빌에 보탬이 되는 삶을 살고 싶습니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006011))  -- "그래서 전 이곳에 와서 저의 하루를 냉철하게 반성해보는 것입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006012))  -- "요원이란 본래 이리도 고독하고 묵직한 길이 아니겠습니까?"
    
      --요원 캐릭터가 요상한 자세(1)을 취함
    TownCharacterActionByID( TownCharacterGetNPC(110), 612793)
	Wait(0.5)
    TownCharacterActionPause( TownCharacterGetNPC(110), 1)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006013))  -- "어떤 역경이 저를 방해하더라도!"
    
      --요원 캐릭터가 요상한 자세(2)를 취함
    TownCharacterActionPause( TownCharacterGetNPC(110), 0)
    TownCharacterActionByID( TownCharacterGetNPC(110), 612794)
	Wait(0.5)
    TownCharacterActionPause( TownCharacterGetNPC(110), 1)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006014))  -- "댄스빌의 안위와 번영을 위해서라면!"
    
      --요원 캐럭터가 요상한 자세 (3)을 취함
    TownCharacterActionPause( TownCharacterGetNPC(110), 0)
    TownCharacterActionByID( TownCharacterGetNPC(110), 612795)    
	Wait(0.5)
    TownCharacterActionPause( TownCharacterGetNPC(110), 1)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006015))  -- "제가 맡은 일은 무엇이든 해내고야 말 것입니다!"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_sweat")
    Wait(2)

    MonologOpen(STR_QUEST_TEXT(810006016))  -- "생명의 부활을 이끄는 춤이라..."
    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow()  -- "[요원의 각오] 스토리 완료"
    -- 퀘스트 시작/완료/보상

    TownCharacterActionPause( TownCharacterGetNPC(110), 0)
    TownCharacterSetDanceIdle( TownCharacterGetNPC(110), 611110)

    QuestStart()
    QuestComplete()
    QuestReward()

	GoTown()
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    if OnTownRefresh() then
        -- 요원 등장
        TownCharacterStandAt(TownCharacterAddNPC(110), 0*40, 29*40)  -- 광장 가운데 동상 앞에 요원 서있음
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))
    end

      -- 요원을 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        --DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006016))  -- "{highlight}{bold}초대 전설춤꾼{/bold}{/highlight}은 {highlight}{bold}부활의 춤{/bold}{/highlight}으로 댄스빌을 구했다고 합니다."
        textCheckQuestAll()
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        --DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810006016))  -- "{highlight}{bold}초대 전설춤꾼{/bold}{/highlight}은 {highlight}{bold}부활의 춤{/bold}{/highlight}으로 댄스빌을 구했다고 합니다."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end
