 -- 바람과 함께 사라지다.(810008) -- 스토리 퀘스트
-- version("0.36.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end


local function UnlockQuestContents()
    UnlockStartQuestMode()
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
     DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008001))  -- "바람이... 그분을 데려갔...어요..."
end



local function ScriptOnQuest()
      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents()  -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(151)
    
		-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008002))  -- "저... 이 동네 아카데미의 마스터... [유저의 닉네임] 님...이시죠...?"
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008003))  -- "명성은... 많이 들었어요... [유저의 닉네임] 님은... 열정적이고 친절한... 분이시라고..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008004))  -- "아카데미에서... [유저의 닉네임]과 함께... 춤을 추는 크루들은... 행복하겠네요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008005))  -- "전... 어떤 아카데미의 크루으로 있다가... 뛰쳐나왔답니다..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008006))  -- "전... 당시 제 마스터님을 열심히... 도울 준비가 되어...있었지만..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008007))  -- "그분은... 저희 크루들을... 방치...하다시피 했거든요..."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008008))  -- "그런데... 새 아카데미를 찾다가... 전 보고 말았어요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008009))  -- "그분이 사라지는... 장면을요..."
    
      --댄스게이트 앞에서 두 개의 그림자가 서로 마주보고 서있는 이미지 등장
    AnimationAdd("event_memory_07_01", "Characters/event_memory_07_01")
    AnimationSetFullScreen("event_memory_07_01")
	AnimationPlay( "event_memory_07_01")
	Wait(2)

    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008010))  -- "{highlight}댄스게이트{/highlight} 앞이었어요... 그분과... 어떤 남자가... 오랫동안 서로를 바라보고만... 있었죠."
    --마주보고 서있는 이미지에서 바람이 부는 연출 등장
    SoundPlayEffect(629070) --=SE=Ani_wind
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008011))  -- "그리고 한차례 강풍이... 불자... 둘은 격렬하게 춤 대결을... 펼치기 시작했어요..."

    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008012))  -- "마치 그 강풍이... 둘의 대결로 인해... 발생한 것이 아닌가 하는 생각이 들 정도의... 격전이었죠..."
    AnimationRemove( "event_memory_07_01")

    --바람 부는 연출이 등장한 후, 마주보고 서있던 두 사람의 눈이 번쩍이는 연출이 번갈아가면서 등장
    --둘의 눈이 번쩍이는 연출이 등장한 후, 두 그림자가 제각각 고난도의 여러 자세를 취하는 연출이 번갈아가면서 등장
    --(자세를 취하는 연출이 등장하기 시작한 후부터 아래의 대사 등장 가능)
    AnimationAdd("event_memory_07_02", "Characters/event_memory_07_02")
    AnimationSetFullScreen("event_memory_07_02")
    AnimationPlay( "event_memory_07_02")
    SoundPlayEffect(629069) --=SE=Ani_TowShadow
    Wait(7)

      --자세를 취하는 연출이 모두 끝나고 나면 아래의 대사 등장 가능
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008013))  -- "그리고... 그 바람이 점점 더 거세진다는 사실을 깨달은 찰나..."
    
	AnimationRemove( "event_memory_07_02")
      --댄스게이트로부터 밝은 빛이 점점 커져 화면 전체가 하얘졌다가, 다시 (두 그림자가 없어진)원래의 화면으로 서서히 돌아오는 연출 등장
    AnimationAdd("event_memory_07_03", "Characters/event_memory_07_03")
    AnimationSetFullScreen("event_memory_07_03")
	AnimationPlay( "event_memory_07_03")
	SoundPlayEffect(629066) --=SE=Ani_LightOfDS
    Wait(4)
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008014))  -- "주위가... 갑자기 강한 빛으로 둘러싸였고... 빛과 바람이... 잦아들었을 때에는..."
    
      --(두 그림자가 없어진)원래의 화면으로 돌아오는 연출이 끝나고 모든 이미지가 사라진 후에 아래 대사 등장
    AnimationRemove( "event_memory_07_03")

    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008015))  -- "춤 대결을 벌이던 둘도... 사라지고 없었어요... 빛처럼... 바람처럼..."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_shocking")
    Wait(2)
    
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008016))  -- "[유저의 닉네임] 님께서도... 얼마 전에... {highlight}이상한 가면을 쓴... 남자{/highlight}와... 춤 대결을 하셨...죠...?"
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008017))  -- "그자가 바로... 제 마스터님과 춤 대결을 벌였던... 춤꾼이에요."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008018))  -- "그리고... 제 마스터이셨던... 그분은... 사라진 {highlight}전설춤꾼{/highlight}이시구요..."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_exclamation")
    Wait(2)

    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008019))  -- "그 가면 쓴 남자는 나타났는데... 왜 제 마스터님은 나타나지 않는... 걸까요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008020))  -- "그 가면 쓴 남자가... 왜 [유저의 닉네임] 님을 찾아온... 걸까요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008021))  -- "또... {highlight}가디{/highlight} 님은 왜 그날 이후로 {highlight}댄스게이트{/highlight} 앞을 떠나지 않으실까요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008022))  -- "이제 와서... 다시 예전의 아카데미로... 돌아갈... 생각은 없지만..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008023))  -- "적어도... 그분에게... 무슨 일이 있었는지는 알아야... 마음이 편해질 것 같아요..."

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008024))  -- "[유저의 닉네임] 님도... 특별히 아시는 것은 없는... 거군요... 그렇군요..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008025))  -- "언젠가... 인연이 허락한다면... 그분의 사정을 알 게 될 날이... 오겠죠..."
    DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008026))  -- "[유저의 닉네임] 님은... 크루들과... 사이가 멀어지는 일 없이... 행복하시길..."
    
    MonologOpen(STR_QUEST_TEXT(810008027))  -- "가디 여왕이라면 뭔가를 알지도 몰라..."

    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow()  -- "[바람과 함께 사라지다.] 스토리 완료"
      -- 퀘스트 시작/완료/보상
    
    QuestStart()
    QuestComplete()
    QuestReward()
	GoTown()
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(151))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(151))
        TownCharacterSetQuest(TownCharacterGetNPC(151))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(151)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(151))
        -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(151))
        -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(151))
        -- DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(151)
    end
    
	if OnClickQuestTab(TownCharacterGetNPC(151)) then
        -- DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
		textCheckQuestAll()
	end
    
	if OnClickQuestStart() then
        ScriptOnQuest()
    end
    
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(151))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(151))
        TownCharacterSetQuest(TownCharacterGetNPC(151))
    end	

    if OnTownCharacterClick(TownCharacterGetNPC(151)) then
		PreLoad()
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(151))  -- 대사가 없이 바로 이동
        --DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(151)
    end
    
	if OnClickQuestTab(TownCharacterGetNPC(151)) then
		--DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
		textCheckQuestAll()
	end
    
	if OnClickQuestStart() then
        ScriptOnQuest()
	end
	
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(151))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(151))
        TownCharacterSetQuest(TownCharacterGetNPC(151))
    end
    if OnTownCharacterClick(TownCharacterGetNPC(151)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(151))  -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(151))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(151))
        -- DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(151)
    end
    if OnClickQuestTab(TownCharacterGetNPC(151)) then
        -- DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
		textCheckQuestAll()
	end
    if OnClickQuestStart() then
        ScriptOnQuest()
    end
	
    if OnQuestReplay() then
        TownCharacterRoamInTown(TownCharacterAddNPC(151))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(151))
        TownCharacterSetQuest(TownCharacterGetNPC(151))
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(151))  -- 대사가 없이 바로 이동
          -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(151)) -- 넓은 장소가 필요함으로 무조건 광장으로 이동
          -- ScriptTownMoveToSide(TownCharacterGetNPC(151))
        --DialogOpen(151, STR_NPC(151), "Characters/npc_004", STR_QUEST_TEXT(810008028))  -- "바람이... 그분을 데려갔...어요..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(151)
    end
end
