-- 불친절한 아리(810012) -- 진입 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520041) -- 뮤비 편집 기능 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlayBGM(629055) --=BGM=Character_Ari_evil

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012001))  -- "안녕. 그래. 또 왔어."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810012002))  -- "그런 의외라는 표정 짓지 말아줄래? 나도 지금 상황이 아주 내키지 않는다는 말씀이야."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012003))  -- "아빠가 너한테 {highlight}{bold}뮤직비디오 편집{/bold}{/highlight}을 설명하지 않고 그냥 넘어간 게 마음에 걸린다고..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012004))  -- "위대한 춤꾼이신 아빠의 귀한 신경을 이런 데다 쓰게 둘 수는 없으니 온 거야. 알겠어?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012005))  -- "그러니, 지금부터 친절함이라고는 1도 없는 최소한의 설명만 할 테니까 잘 들어."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012006))  -- "{highlight}{bold}뮤직비디오 편집{/bold}{/highlight}의 핵심은 {highlight}{bold}카메라의 움직임{/bold}{/highlight}이야."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012007))  -- "카메라를 {highlight}{bold}이동{/bold}{/highlight}하거나, {highlight}{bold}확대{/bold}{/highlight}하거나, {highlight}{bold}축소{/bold}{/highlight}하거나, {highlight}{bold}회전{/bold}{/highlight}해서 뮤직비디오를 더 보기좋게 만들 수 있어."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012008))  -- "이 정도면 충분하지? 그럼 난 간다."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012009))  -- "뭐? 조작법? 그 정도는 알아서... 그래. 그래. 그 정도의 선심은 써줄게."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012010))  -- "화면을 {highlight}{bold}손가락 하나{/bold}{/highlight}로 터치해서 움직이면 {highlight}{bold}카메라 이동{/bold}{/highlight}을 할 수 있고..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012011))  -- "{highlight}{bold}손가락 두 개{/bold}{/highlight}로 터치해서 움직이면 {highlight}{bold}카메라 확대, 축소, 회전{/bold}{/highlight}을 할 수 있어."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012012))  -- "손가락으로 화면을 움직이기가 어렵거나 귀찮으면 이런 방법도 있지."
    
    UISignalShowWithCCB("UI_common/ui_mv_edit_02", "btn_rotation_area") -- 각도 조정 UI를 빨간 박스로 표시
    Wait(2)
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012013))  -- "여기에 있는 버튼을 터치해서 각도를 10도 단위로 조정하거나"
    UISignalHide()

    UISignalShowWithCCB("UI_common/ui_mv_edit_02", "btn_zoom_area") -- 확대/축소 UI를 빨간 박스로 표시
    Wait(2)
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012014))  -- "여기에 있는 버튼을 터치해서 0.2 단위로 배율을 높이거나 낮출 수 있어."
    UISignalHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012015))  -- "조작법은 이게 전부야."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012016))  -- "{highlight}{bold}뮤직비디오 편집{/bold}{/highlight} 기능은 이 간단한 조작만으로 뮤직비디오의 수준을 엄청나게 높일 수 있어서 아주 유용해."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810012017))  -- "물론 네가 그렇게 할 수 있는지는 다른 이야기지만 말이지. 호호"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810012018))  -- "그럼 난 간다."

    -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)
    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

-- PRELOAD_BEGIN

--유저가 [편집] 버튼을 누르면 뮤직비디오 편집 화면 내부에 진입한 상태로 스크립트 진행
--이 퀘스트를 진행 가능한 상태가 되면, [편집] 버튼에 new 표시(유저 캐릭터 바로 가기 버튼에도 new 표시)
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UnlockQuestContents()
        if CheckMyMVOffAir() then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
            UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        end
    end	

	-- 내 춤꾼 팝업 진입 시, 뮤비리스트	버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") or OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        if CheckMyMVOffAir() then
            UIAddNewIconAt("btn_info_mv", "btn_info_mv/iconNew", 29, 41)
        end
    end
	
    if OnGameAction("OnAfterSceneEntered/SceneMVList") then
        if CheckMyMVOffAir() then
            UIAddNewIconAtWithCCB("UI_common/ui_mv_list_01", "btn_edit", "btn_edit/iconNew", 29, 31)
        end
    end

    -- 편집 버튼 클릭 시, 유저 캐릭터 바로가기 버튼 new 표시 제거, 편집 버튼에 New표시 제거
    if OnGameAction("OnUIClick/SceneMVList/btn_edit") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
        UIRemoveNewIconWithCCB("UI_common/ui_mv_list_01", "btn_edit", "btn_edit/iconNew")
        UIRemoveNewIcon("btn_info_mv", "btn_info_mv/iconNew")
        UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        RefreshNewCount()
    end

    -- 뮤비 편집 화면 진입 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterSceneEntered/SceneMVModify") then
        ScriptOnQuest()
    end
end





-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
