 -- 춤요정들의 여왕(810018) -- 스토리 퀘스트
-- version("0.31.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end
  
local function UnlockQuestContents()
    UnlockStartQuestMode()
end


local function textCheckQuestAppear()
end

local function textCheckQuestRunning()
end

local function textCheckQuestComplete()
end 

local function textCheckQuestAll()
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018001))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용하면 시공간을 넘나들 수 있답니다~"
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function ScriptOnQuestComplete()
    
    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    QuestReward()
    GoTown()
end

local function ScriptOnQuest()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlayBGM(629060) --=BGM=Character_Gadi
    ScenarioIntroShow(121)
    
 
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
  	QuestStart()

 	AddQuestSkipButton()
	  
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_006", STR_QUEST_TEXT(810018002))  -- "안녕하세요, [유저의 닉네임] 님!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018003))  -- "전 {highlight}{bold}춤요정{/bold}{/highlight}들의 여왕, {highlight}{bold}가디{/bold}{/highlight}라고 해요~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810018004))  -- "그런데... 저에게 뭔가 부탁을 하려면 양질의 댄소나이트를 잔뜩 들고 오셔야 된다는 건 알고 계시겠죠?"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_005", STR_QUEST_TEXT(810018005))  -- "...는 농담이구요~ 그렇지 않아도 꼭 한 번 뵙고 싶었어요!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810018006))  -- "유명한 춤꾼이시니 뜯어먹을 것도 많지 않겠어요?"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_silly")
    Wait(1.5)
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_005", STR_QUEST_TEXT(810018007))  -- "...도 농담이랍니다~ 그렇게 표정이 굳으실 것 까지야~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018008))  -- "그럼 인사는 이쯤으로 하고... [유저의 닉네임] 님이 왜 찾아왔는지 제가 맞춰볼까요?"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018009))  -- "[유저의 닉네임]님처럼 {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들에 대해서 궁금하신 거죠? 우리 춤요정들을 포함해서."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_exclamation")
    Wait(1.5)

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018010))  -- "그럼 먼저 {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들을 이곳으로 인도한 {highlight}{bold}하늘의 구멍{/bold}{/highlight}에 대해서 알려드릴 필요가 있겠네요."
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018011))  -- "{highlight}{bold}우주 통로{/bold}{/highlight}는 우주의 시공간을 관통하는 구멍으로, 최초의 춤요정들과 [유저의 닉네임] 님이 이곳으로 올 때 통과했던 구멍이기도 하죠~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018012))  -- "{highlight}{bold}우주 통로{/bold}{/highlight}는 우주의 상태 변화에 따라 생기고 사라지지만, {highlight}{bold}댄스게이트{/bold}{/highlight}를 이용하면 원할 때 만들 수 있어요!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810018013))  -- "제 뒤에 있는 커다란 구조물이 바로 {highlight}{bold}댄스게이트{/bold}{/highlight}랍니다!"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810018014))  -- "따라서, 언제든지 [유저의 닉네임] 님은 돌아가실 수 있는 거에요!"
    
	TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_haha")
	Wait(1.5)
    
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810018015))  -- "...라고 말씀드리고 싶지만 실은 그리 간단한 문제가 아니에요."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810018016))  -- "최초의 춤요정들이나 [유저의 닉네임]님이 통과한 {highlight}{bold}우주 통로{/bold}{/highlight}는 {highlight}{bold}댄스게이트{/bold}{/highlight}로 만들어진 게 아니기 때문이죠."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810018017))  -- "그래서 댄스게이트가 아닌 하늘에서 떨어지신 거구요."
    
	TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_irritation")
	Wait(1.5)
    
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810018018))  -- "너무 실망하지는 마세요. 방법이 없는 것은 아니니까요."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018019))  -- "이 주위에서 우주 통로가 열린 것은 댄스게이트가 여기에 있기 때문일 확률이 크거든요."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018020))  -- "예를 들어 댄스게이트가 주위의 강한 댄스파에 반응을 해서 이상 작동해 시공간을 일그러뜨렸다든지..."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810018021))  -- "댄스게이트의 작동 흔적을 찾아보면 아마 자세한 내용을 알 수 있을 거에요."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810018022))  -- "조사가 끝나면 결과를 [유저의 닉네임]님께 알려드리도록 할 테니 안심하고 기다리시길~"
    
	TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_happy")
	Wait(1.5)

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810018023))  -- "언제라도 댄스게이트에 대해 궁금한 게 있으시면 저를 다시 찾아주세요."

	Wait(0.5)
    
	-- 독백, 퀘스트 완료
	Wait(1)
	ScenarioEndingShow()  -- "[춤요정들의 여왕] 퀘스트 완료"
    
	QuestComplete()
    QuestReward()
    ScriptOnQuestComplete()
	GoTown()
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
	if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)  -- -1520, 1080 (댄스게이트 위치 이동하고 나면 수정 필요)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
		PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004050))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용하면 시공간을 넘나들 수 있답니다~"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(121)
	end
    
    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004050))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용하면 시공간을 넘나들 수 있답니다~"
        textCheckQuestAll()
    end
        
	if OnClickQuestStart() then
        ScriptOnQuest()
    end
end	

    --퀘스트 다시하기
if OnQuestReplay() then
        --TODO
end

