-- 꽃단장(810033) -- 체험형 퀘스트
-- version("0.38.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520031)  -- 미용실 관련 기능을 열어줌
end

local function CheckQuestStartReq()
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(810033001))  -- "샤바 씨가 아~까부터 기다리고 있다구~"
end


local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    if CheckQuestManagerDummy() then
        SetInteger("skip_buy_beauty", 1)
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()

    if CheckQuestProgress(10104, 1) then
        SceneTownSetStateEmpty() 
        QuestComplete()
        return true
    end

    -- 마을 UI 감추기
    --SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(103)


    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(810033002))  -- "어서와~ 샤바 씨가 말하던 귀한 손님이구나~?"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(810033003))  -- "우리 미용실의 신선하고 파격적인 스타일로 흠뻑 적셔줄 테니 기대하라구~"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(810033004))  -- "샤바 씨가 아~까부터 기다리고 있으니까 어서 들어가봐~"

    PushPopupTownBeauty(145)

    ::jmp_btn_shop_hair::
    RequireButtonWithCCB("UI_common/ui_btn2_012_03", "btn_shop_hair")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(810033004))  -- "샤바 씨가 아~까부터 기다리고 있으니까 어서 들어가봐~"
        goto jmp_btn_shop_hair
    end
    
    SoundPlayBGM(629057) --=BGM=Character_Shaba

    -- 미용실
    -- 추천 버튼 가리기
    UIHideWithCCB("UI_common/ui_btn2_009_03", "btn_rcmnd")
    UIRemove("ui_btn_change")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033005))  -- "{highlight}{bold}미용실{/bold}{/highlight}에 오신 걸 환영합니다!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033006))  -- "아, 물론 미용이란 자신의 가치를 높이는 일이니 {highlight}{bold}골드{/bold}{/highlight}나 {highlight}{bold}댄소나이트{/bold}{/highlight}가 필요하겠죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033007))  -- "하지만! 오늘은 특별히 제가 {highlight}{bold}미용비{/bold}{/highlight}를 {highlight}{bold}모두 내드릴게요{/bold}{/highlight}!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033008))  -- "부담스러워할 것 없어요. 쇼핑 메이트에게 이 정도는 당연한 거니까!"

    -- 미용실 진입 시 이미 머리 탭 선택 상태
    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033009))  -- "먼저 여길 보시면 많은 {highlight}{bold}머리 스타일{/bold}{/highlight}이 있죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033010))  -- "원하는 스타일이 뭔지 한 번 잘 살펴보시구요~"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033011))  -- "{highlight}{bold}색 바꾸기{/bold}{/highlight} 버튼으로 머리 색깔을 바꿀 수도 있으니 참고하세요."

    UISignalShow("btn_color")
    Wait(2)
    UISignalHide()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033012))   -- "머리를 새로 할 생각을 하니 신이 나서 절로 춤이 나오지 않아요?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810033013))  -- "음? 신나는 춤을 추기에는 딱히 어울리지 않는 얼굴이군."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(810033014))  -- "머리를 하는 기분 좋은 날에 그런 무미건조한 얼굴이라니 있을 수 없는 일이에요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033015))  -- "지금의 상황에 걸맞는 {highlight}{bold}얼굴{/bold}{/highlight}을 하려면..."

    ::jmp_btnExpression::  --얼굴 탭 클릭
    RequireButton("btnExpression")  --얼굴 탭 클릭
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033016))  -- "춤 출 때 얼굴 생김새가 얼마나 중요한지 잘 아시죠?"
        goto jmp_btnExpression  --얼굴 탭 선택
    end

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033017))  -- "{highlight}{bold}어떤 얼굴{/bold}{/highlight}을 하느냐에 따라 춤의 느낌이 확 바뀔 수도 있으니까 잘 활용해보세요."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033018))  -- "또 놀라운 걸 한 가지 더 알려드릴까요? 여기에서는 {highlight}{bold}피부색{/bold}{/highlight}도 마음대로 바꿀 수 있답니다."

    
    ::jmp_btnSkin::  -- 피부 탭 클릭
    RequireButton("btnSkin")  -- 피부 탭 클릭
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033019))  -- "피부색도 마음대로 바꿀 수 있답니다."
        goto jmp_btnSkin  -- 피부 탭 클릭
    end

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033020))  -- "미용실인데 얼굴이랑 피부색을 어떻게 바꿀 수 있냐구요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033021))  -- "......"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033022))  -- "너무 그렇게 깊이 생각하지 말자구요. 어쨌든 바꿀 수 있으니 좋은 거잖아요? 호호."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033023))  -- "얼굴의 허전함을 없애줄 {highlight}{bold}수염{/bold}{/highlight}도 여러 종류가 있는데 한 번 보실래요?"

    ::jmp_btnMustache::  --수염 탭 선택
    RequireButton("btnMustache")  --수염 탭 선택
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033024))  -- "얼굴의 허전함을 없애줄 수염도 여러 종류가 있는데 한 번 보세요~"
        goto jmp_btnMustache  --수염 탭 선택
    end

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033025))  -- "쭉 훑어보니 어떠세요? 해보고 싶은 스타일이 막 떠오르죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033026))  -- "자! 드디어 본격 자기 발전 시간!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033027))  -- "외모를 원하는 스타일로 가꿔보고 {highlight}{bold}구입{/bold}{/highlight} 버튼을 눌러보아요!"

    DescriptionBarShow(STR_QUEST_TEXT(810033028))  -- "외모를 원하는 스타일로 가꾼 후 [구입] 버튼을 누르세요."

    UIDisableWithCCB( "UI_common/ui_main_top_02", "btn_add_gold")
    UIDisableWithCCB( "UI_common/ui_main_top_02", "btn_add_dsn")

    -- 진행조건 : 구매
    -- 구매액 0에서 뒤로가기를 누르면 1번 대사창
    -- 구매액 0에서 구매를 누르면 2번 대사창

    ::jmp_buy::
    RequireSceneBeautyBuy()
    if RequireCheckResult("Back") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810033029))  -- "그냥 미용실에서 나가다니... 제 성의를 무시하시는 건가요?"
        goto jmp_buy
    elseif RequireCheckResult("NoItem") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810033029))  -- "그냥 미용실에서 나가다니... 제 성의를 무시하시는 건가요?"
        goto jmp_buy
    else
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033030))  -- "오호, 지금 스타일에 대한 확신이 있으시군요!"
    end
    SetQuestProgress_Dummy(10104, 1)

    DescriptionBarHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033031))  -- "그것 봐요! 외모를 좀 가꾸니 얼마나 보기가 좋아요!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810033032))  -- "외모는 춤의 느낌을 좌우하기도 하니까 신경을 써야지. 암."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033033))  -- "자, 여기서 팁 하나 더!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033034))  -- "고민하기 귀찮다, 혹은 뭔가 예상치 못 한 조합을 얻고 싶다 할 땐!"

    -- 원장님의 추천 UI 안내
    UIShowWithCCB("UI_common/ui_btn2_009_03", "btn_rcmnd")
    UISignalShowWithCCB("UI_common/ui_btn2_009_03", "btn_rcmnd")
    Wait(2)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810033035))  -- "{highlight}{bold}원장님의 추천{/bold}{/highlight} 버튼으로 품격 있는 스타일을 만나볼 수 있답니다!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033036))  -- "어때요? 간단하죠?"

    UISignalHide()

    QuestComplete()
    return true
end


local function ScriptOnQuestAppear()
-- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestStart()
    return ScriptOnQuestRunning()
end

local function ScriptOnQuestComplete()

    FullLoad()
    UnlockQuestContents()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();
    -- 시나리오 배경음
    SoundPlay(0) --=BGM=Title_UPUP_-14Lufs

    -- 미용실 정문 앞에 유저 캐릭터, 카바, 샤바가 서있는 화면으로 전환
    TownCharacterStandAt(TownCharacterAddNPC(1), 9*40, 7*40)
    TownCharacterStandAt(TownCharacterAddNPC(101), 12*40, 7*40)
    TownCharacterStandAt(TownCharacterAddNPC(103), 14*40, 7*40)
    TownCameraSetPos(TownCharacterGetNPC(1), 120, 50, 2)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033037))  -- "축하해요! 드디어 쇼핑 할 자격이 생겼네요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810033038))  -- "저와 함께 세상에서 가장 보람찬 시간을 보내봐요!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(810033039))  -- "허허. 잘 부탁하네."

    -- 유저 짜증
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_irritation")
    Wait(2)

    SoundPlayEffect(629075) --ANGRY

    -- 독백, 시나리오 완료
    MonologOpen(STR_QUEST_TEXT(810033040))  -- "누구를 위한 꽃단장인가..."
    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow() -- "[꽃단장] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestComplete()
    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN
-- 가위손 쁘디가 미용실에서 퀘스트 표시 뜬 상태로 대기

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(145), 14*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(145))
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestAppear() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(145), 14*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(145))
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(145), 14*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(145))
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", "샤바 씨가 아~까부터 기다리고 있다구~")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
