  -- 카트라슈의 고민(810044)
-- version("0.37.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810044001))  --수정 예정  -- "아카데미 {highlight}{bold}레벨 [start10001]{/bold}{/highlight}가 되면 다음 이야기를 볼 수 있어요!"

        return false
    end
    
    return true
end

local function textCheckQuestAppear()
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044002))  -- "요즘 카트라슈는 통 기운이 없어요."
end

local function textCheckQuestRunning()
	DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001",  STR_QUEST_TEXT(810044003))  -- "...다시 도전?"
end

local function textCheckQuestComplete()
	DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044002))  -- "요즘 카트라슈는 통 기운이 없어요."       
end 

local function textCheckQuestAll()

end



local function ScriptOnQuestAppear()

    if not CheckQuestStartReq() then
        return false
    end

    FullLoad()
    UnlockQuestContents()

    -- 카바네 집으로
    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)
    -- 시나리오 배경음
    SoundPlayBGM(629085) --=BGM=Character_Catrasche

    ScenarioIntroShow(107)

    -- 탁자 위 카트라슈 등장, 춤을 안추고 기본 자세를 하고있음
    CharacterAdd(107, 0, 20)
    CharacterSetDance(107, "dance_01")
    -- 아리 화면 우측에서 걸어들어옴
    CharacterAdd(102, 1000, -160)
    CharacterWalkTo(102, 360, -160)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_015", STR_QUEST_TEXT(810044004))  -- "카트라..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_016", STR_QUEST_TEXT(810044005))  -- "...슈?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_010", STR_QUEST_TEXT(810044006))  -- "이봐... 카트라슈..."

    -- 아리 걱정되서 카트라슈 옆으로 뛰어감
    CharacterRunTo(102, 120, -160)
    Wait(1)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_003", STR_QUEST_TEXT(810044007))  -- "너... 어째서 춤을 추지 않고 있는 거야?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_003", STR_QUEST_TEXT(810044008))  -- "어디 아파?"

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044009))  -- "......"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044010))  -- "깨개갱..."

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810044011))  -- "개밥을 좀 싼 걸로 바꿨다고 서운해서 그러는 거야?"
    
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_008", STR_QUEST_TEXT(810044012))  -- "왕! 왕!"

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810044013))  -- "호오... 까칠하기까지..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810044014))  -- "카트라슈, 너..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_008", STR_QUEST_TEXT(810044015))  -- "사춘기구나?"

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_008", STR_QUEST_TEXT(810044012))  -- "왕! 왕!"

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810044016))  -- "부끄러워하기는."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_015", STR_QUEST_TEXT(810044017))  -- "괜찮아. 이 누나도 다 겪어봤거든. 막 예민해지고 그렇지?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_015", STR_QUEST_TEXT(810044018))  -- "우리 질풍노도의 카트라슈는 혼자만의 시간이 필요해 보이니까, 이 사려 깊은 누나는 자리를 피해줄게."

    -- 아리 화면 우측 퇴장
    CharacterRunOut(102, 1000, -160)
    Wait(1.5)

    -- 카트라슈 짜증
    CharacterShowEmotion(107, "Characters/Emoticon_irritation")
    Wait(1.5)

    -- 유저 화면 좌측에서 걸어옴
    CharacterAdd(1, -1000, -160)
    CharacterWalkTo(1, -240, -160)
    Wait(2)

    -- 카트라슈 느낌표
    CharacterShowEmotion(107, "Characters/Emoticon_exclamation")
    Wait(1.5)

    -- 카트라슈 탁자 아래로 뛰어내림, 유저 우측으로
    CharacterRunTo(107, 0, -160)
    Wait(1)
    CharacterRunTo(107, -120, -160)
    Wait(1)

    -- 유저 의아함
    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044009))  -- "......"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044019))  -- "......저기... 할 말이..."
    
    -- 유저 놀람
    CharacterShowEmotion(1, "Characters/Emoticon_shocking")
    Wait(1.5)

    MonologOpen(STR_QUEST_TEXT(810044020))  -- "개... 개가 말을?"
    Wait(2.5)
    MonologClose()

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044021))  -- "너무 갑작스러운 건 아는데, 내가 좀 급한 일이 있어서 말이야."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044022))  -- "춤을 상당히 잘 춘다고 하던데, 맞지?"

    CharacterShowEmotion(1, "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044023))  -- "그래서 말인데... 부탁 하나 들어줄 수 있을까?"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044024))  -- "나 대신 누구랑 춤 대결을 좀 해줬으면 해서. 뭐, 꼭 내가 춤을 못 춰서는 아니고..."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_010", STR_QUEST_TEXT(810044025))  -- "뭐, 곤란하면 안 해도… 아니, 뭐 그 까짓 거 그냥 한 번 해주면 될 것 같은데… 안 그래?"
    
    -- 유저 땀
    CharacterShowEmotion(1, "Characters/Emoticon_sweat")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044026))  -- "응? 왜 이런 부탁을 하냐고? 그건..."

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();

    SoundPlayBGM(629085) --=BGM=Character_Catrasche

    -- 시점을 분수대 근처로
    TownCameraSetPos(TownCharacterGetNPC(0), -3, 33*40-182, 1);

    -- 더미 펫들 등장
    local dogs = { }
    for i=1,10,1 do
        dogs[i] = TownCharacterAddNPC(400 + i)
        TownCharacterHideNameTag(dogs[i])
    end

    TownCharacterStandAt(dogs[1], -283, 33*40+76)
    TownCharacterStandAt(dogs[2], -164, 33*40+17)
    TownCharacterStandAt(dogs[3], -214, 33*40-144)
    TownCharacterStandAt(dogs[4], -289, 33*40-263)
    TownCharacterStandAt(dogs[5], -166, 33*40-342)
    TownCharacterStandAt(dogs[6], 180, 33*40+80)
    TownCharacterStandAt(dogs[7], 359, 33*40-5)
    TownCharacterStandAt(dogs[8], 230, 33*40-90)
    TownCharacterStandAt(dogs[9], 316, 33*40-182)
    TownCharacterStandAt(dogs[10], 285, 33*40-285)

    -- 웅디 등장
    TownCharacterStandAt(TownCharacterAddNPC(109), -8*40, 33*40-182)

    -- 카트라슈 등장, 시점이동
    TownCharacterStandAt(TownCharacterAddNPC(107), 11*40, 33*40-182)
    TownCameraSetPos(TownCharacterGetNPC(107), 0, 50, 2)
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044027))  -- "지난 봄, 어느 날이었어."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044028))  -- "햇살은 따사롭고 바람은 포근했지."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044029))  -- "완벽한 날씨에 들뜬 나는, 거기에 한줄기 행복을 더해줄 개껌을 사러 길을 나섰더랬어."

    -- 웅디 광장 중앙으로 이동
    TownCharacterWalkTo(TownCharacterGetNPC(109), 0*40, 33*40-182)
    -- 카트라슈 광장 중앙으로 이동
    TownCharacterWalkTo(TownCharacterGetNPC(107), 4*40, 33*40-182)
    -- 카트라슈 줌인
    TownCameraZoomIn(TownCharacterGetNPC(107), -2*40, 50, 2)
    Wait(2)

    -- 카트라슈 놀람
    TownCharacterSetEmot(TownCharacterGetNPC(107), "Characters/Emoticon_exclamation")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810044030))  -- "길을 가던 중, 나는 그녀를 보고 말았어."
    Wait(0.5)

    -- 카트라슈 컷씬
    AnimationAdd("mentality", "Characters/event_mentality_02")
    AnimationPlay("mentality")
    SoundPlayBGM(629085) --=BGM=Character_Catrasche
    Wait(2.8)
    AnimationRemove("mentality")

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_005", STR_QUEST_TEXT(810044031))  -- "그녀의 이름은 {highlight}{bold}웅디{/bold}{/highlight}. 태어나서 그렇게 아름다운 암컷은 처음이었지."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_006", STR_QUEST_TEXT(810044032))  -- "난 용기를 내어 그녀에게 다가가려고 했어!"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044033))  -- "하지만…"
    
    -- 웅디 좌측 쥬오 등장, 블라인드 처리, 접근
    TownCharacterStandAt(TownCharacterAddNPC(160), -8*40, 33*40-182)
    TownCharacterBlind(TownCharacterGetNPC(160))
    TownCharacterWalkTo(TownCharacterGetNPC(160), -2*40, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPC(109), 0, 50, 2)
    Wait(1)

    -- 웅디 사랑표현
    TownCharacterSetEmot(TownCharacterGetNPC(109), "Characters/Emoticon_heart")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044034))  -- "이미 그녀의 마음 속에는 다른 수컷이 자리하고 있었더랬어…"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(810044035))  -- "{highlight}{bold}쥬오{/bold}{/highlight}라고 얼마 전에 갑자기 나타나, 춤으로 이 일대 개들을 평정한 녀석이야."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_006", STR_QUEST_TEXT(810044036))  -- "그래서 난 결심했어. 그녀의 마음을 얻기 위해 춤으로 {highlight}{bold}쥬오{/bold}{/highlight}를 누르겠다고."

    -- 카바네 집으로
    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)

    -- 쥬오 블라인드 해제
    TownCharacterBlindOff(TownCharacterGetNPC(160))

    -- 유저 등장
    CharacterAdd(1, 60, -160)
    -- 카트라슈 등장
    CharacterAdd(107, -60, -160)
    CharacterSetDance(107, "dance_01")
    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044037))  -- "그런데 그 녀석이 춤을 워낙 잘 춰야지 말이야…"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044038))  -- "내가 아무한테나 막 부탁하는 개가 아닌데 워낙 네 실력이 뛰어나니 믿고 맡기겠다는 거야."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_007", STR_QUEST_TEXT(810044039))  -- "사실 나도 이길 수 있기는 하지만 그래도 좀 더 안전한 길을 찾는 게 좋잖아?"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_010", STR_QUEST_TEXT(810044040))  -- "도와줄 거지? 그렇지?"

    -- 유저 당황
    CharacterShowEmotion(1, "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044041))  -- "그 얼굴은 {highlight}{bold}꼭 내가 하고 싶어!{/bold}{/highlight}라는 뜻이구나? 역시! 네가 좋은 사람이란 걸 첫눈에 알아봤다니까!"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044042))  -- "자, 그럼 이 옷을 입어줘야겠어."

    -- 유저 물음표
    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044043))  -- "특별히 주문 제작한 {highlight}{bold}카트라슈 의상{/bold}{/highlight}이야"
    Wait(0.5)

    -- 화면 어두워지고, 카트라슈 옷,모자 착용
    MonologOpen(STR_QUEST_TEXT(810044000))  -- ""
    Wait(1)
    CharacterWearClothes(1, 201825)
    CharacterWearClothes(1, 202825)
    Wait(1)
    MonologClose()

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044044))  -- "나 대신 춤 대결을 하려면 그게 필요할 거야."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044045))  -- "나의 멋스러움을 고스란히 풍기는 게 아주 마음에 드는군."

    -- 유저 짜증
    CharacterShowEmotion(1, "Characters/Emoticon_irritation")
    Wait(1.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044046))  -- "그럼 바로 출발해볼까?"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810044047))  -- "아, 내가 이야기 안 했구나. 잠시 후에 바로 대결 시작이라 서둘러야 되거든."
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_010", STR_QUEST_TEXT(810044048))  -- "많이 갑작스럽고 황당하겠지만 이해해줄 거지? 그렇지?"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(810044049))  -- "자, 서두르자구."

    -- 마을로
    GoSceneTown()

    SoundPlayBGM(629085) --=BGM=Character_Catrasche

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();

    -- 시점을 분수대 근처로
    TownCameraSetPos(TownCharacterGetNPC(0), -3, 33*40-182, 1);

    -- 더미 펫들 등장
    local dogs = { }
    for i=1,10,1 do
        dogs[i] = TownCharacterAddNPC(400 + i)
        TownCharacterHideNameTag(dogs[i])
    end

    TownCharacterStandAt(dogs[1], -283, 33*40+76)
    TownCharacterStandAt(dogs[2], -164, 33*40+17)
    TownCharacterStandAt(dogs[3], -214, 33*40-144)
    TownCharacterStandAt(dogs[4], -289, 33*40-263)
    TownCharacterStandAt(dogs[5], -166, 33*40-342)
    TownCharacterStandAt(dogs[6], 180, 33*40+80)
    TownCharacterStandAt(dogs[7], 359, 33*40-5)
    TownCharacterStandAt(dogs[8], 230, 33*40-90)
    TownCharacterStandAt(dogs[9], 316, 33*40-182)
    TownCharacterStandAt(dogs[10], 285, 33*40-285)

    -- 웅디 등장
    TownCharacterStandAt(TownCharacterAddNPC(109), -10*40, 33*40-182)
    -- 쥬오 등장
    TownCharacterStandAt(TownCharacterAddNPC(160), -8*40, 33*40-182)
    

    -- 카트라슈, 유저(카트라슈 옷,모자 착용)등장, 시점이동
    TownCharacterStandAt(TownCharacterAddNPC(107), 11*40, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(1), 9*40, 33*40-182)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201825)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202825)
    TownCameraSetPos(TownCharacterGetNPC(1), 0, 50, 2)
    Wait(1)

    -- 쥬오, 웅디 주변에 펫 배치
    -- (씬조작, 마을, 개, 0, 0, 200.0)

    -- 쥬오, 웅디 걸어옴
    TownCharacterWalkTo(TownCharacterGetNPC(160), -2*40, 33*40-182)
    TownCharacterWalkTo(TownCharacterGetNPC(109), -4*40, 33*40-182)

    -- 카트라슈, 유저 걸어옴
    TownCameraZoomIn(TownCharacterGetNPC(1), -2*40, 50, 2)
    TownCharacterWalkTo(TownCharacterGetNPC(1), 2*40, 33*40-182)
    TownCharacterWalkTo(TownCharacterGetNPC(107), 4*40, 33*40-182)
    Wait(2)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_005", STR_QUEST_TEXT(810044050))  -- "저기 {highlight}{bold}웅디{/bold}{/highlight}가 있어! 캬아~ 저 철철 흘러넘치는 고귀함!"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_007", STR_QUEST_TEXT(810044051))  -- "보는 눈이 많으니 이쯤에서 난 빠질게. 잘 해주리라 믿어. 힘 내!"

    -- 화면 우측으로 카트라슈 퇴장
    TownCharacterWalkTo(TownCharacterGetNPC(107), 11*40, 33*40-182)
    Wait(2)

    -- 유저 어이없음
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_silly")
    Wait(1.5)

    -- 유저 걸어감
    TownCharacterWalkTo(TownCharacterGetNPC(1), 0*40, 33*40-182)
    Wait(1)

    -- 쥬오 테마로 배경음악 바뀜
    SoundPlayBGM(629061) --=BGM=Character_Juo

    MonologOpen(STR_QUEST_TEXT(810044052))  -- "쥬오가... 사, 사람?"
    Wait(2.5)
    MonologClose()

    TownCameraZoomIn(TownCharacterGetNPC(1), -2*40, 50, 2)

    DialogOpen(425, STR_NPC(425), "", STR_QUEST_TEXT(810044053))  -- "카트라슈가 진짜로 왔다! 진짜 왔어!"
    DialogOpen(426, STR_NPC(426), "", STR_QUEST_TEXT(810044054))  -- "설마 진짜로 쥬오를 이길 수 있다고 생각하는 건 아니지?"
    DialogOpen(427, STR_NPC(427), "", STR_QUEST_TEXT(810044055))  -- "그러다 상처 받지 말고 포기하는 게 현명한 걸지도 몰라!"

    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_007", STR_QUEST_TEXT(810044056))  -- "어? 정말로 왔네?"
    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_001", STR_QUEST_TEXT(810044057))  -- "카트라슈 너 보기보다 배짱이 좋구나? 다시 봤어."
    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_003", STR_QUEST_TEXT(810044058))  -- "물론 나같은 절세미견의 마음을 빼앗으려면 최고가 되어야 하겠지만."
    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_002", STR_QUEST_TEXT(810044059))  -- "카트라슈가 이렇게 적극적이니 날 잃지 않으려면 분발해야겠어, 쥬오."

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810044060))  -- " ……난 그런거 관심 없…"

    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_008", STR_QUEST_TEXT(810044061))  -- "호호호호, 쥬, 쥬오는 이렇게 무뚝뚝한 얼굴로 농담을 툭툭 던지는 게 매력이란 말이야! 호호호."
    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_001", STR_QUEST_TEXT(810044062))  -- "뭐, 어, 어쨌든! 이 후끈한 분위기가 식기 전에 어서 시작해야지?"

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810044063))  -- "……"
    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_004", STR_QUEST_TEXT(810044064))  -- "흐음…"

    DialogOpen(428, STR_NPC(428), "", STR_QUEST_TEXT(810044065))  -- "나, 나왔다! 극한의 춤을 끌어내기 직전의 저 평온한 표정!"
    DialogOpen(429, STR_NPC(429), "", STR_QUEST_TEXT(810044066))  -- "평온해 보이지만, 영역 표시 직전과도 같은 극도의 긴장감과 쾌감을 느끼는 표정일지도!"
    Wait(2)

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_006", STR_QUEST_TEXT(810044067))  -- "흐읍!"

    TownCharacterAction(TownCharacterGetNPC(160), "shake_01")
    Wait(2)

    MonologOpen(STR_QUEST_TEXT(810044068))  -- "뭐, 뭐지? 머리와 몸을 자유자재로 움직이는 저 기술은?"
    Wait(2.5)
    MonologClose()

    MonologOpen(STR_QUEST_TEXT(810044069))  -- "내가 이길 수 있을까?"
    Wait(2)
    MonologClose()

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_006", STR_QUEST_TEXT(810044070))  -- "...준비는 됐겠지..."
    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_006", STR_QUEST_TEXT(810044071))  -- "간다."
    
    MonologOpen(STR_QUEST_TEXT(810044072))  -- "보인다... 놈이 몸을 기울이는 각도가... 볼 수 있어!"
    Wait(2)
    MonologClose()

    -- 퀘스트 시작
    QuestStart()

    -- 미니게임 스테이지4
    PushSceneMiniGameDance(1200004)
    UIHide("uiScore")
    UIHide("btnBack")
    UIHide("btnLeft")
    UIHide("btnRight")
    -- 미니게임의 유저 캐릭터에게 카트라슈 옷을 입힘!
    SceneMiniGameDanceWearClothes(201825)
    SceneMiniGameDanceWearClothes(202825)

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_004", STR_QUEST_TEXT(810044073))  -- "그럼, 시작."
    UIShow("btnLeft")
    UIShow("btnRight")
    Wait(1)

    -- 진행조건 : 미니게임 성공
    ::jmp_retry::
    RequireSceneMiniGameDanceFinish()
    Wait(2)
    if RequireCheckResult("Fail") then
        DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_004", STR_QUEST_TEXT(810044074))  -- "역시 쥬오가 최고!"
        DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810044009))  -- "......"

        RequireSceneMiniGameDancePopupPass()
        if RequireCheckResult("Pass") then
            QuestProgressBuy()
            SceneMiniGameDanceSuccess()
            Wait(2)
            QuestComplete()
            return true
        end

        RequireSceneMiniGameDancePopupRetry()
        goto jmp_retry
    end

    SoundPlayBGM(629085) --=BGM=Character_Catrasche
    -- 퀘스트 완료
    QuestComplete()
    return true
end

local function ScriptOnQuestRunning()

    if not CheckQuestStartReq() then
        return false
    end

    FullLoad()
    UnlockQuestContents()

    PushSceneMiniGameDance(1200004)
    UIHide("uiScore")
    UIHide("btnBack")
    UIHide("btnLeft")
    UIHide("btnRight")

    -- 미니게임의 유저 캐릭터에게 카트라슈 옷을 입힘!
    SceneMiniGameDanceWearClothes(201825)
    SceneMiniGameDanceWearClothes(202825)

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001",  STR_QUEST_TEXT(810044073))  -- "그럼, 시작."
    UIShow("btnLeft")
    UIShow("btnRight")
    Wait(1)

    -- 진행조건 : 미니게임 성공
    ::jmp_retry::
    RequireSceneMiniGameDanceFinish()
    Wait(2)
    if RequireCheckResult("Fail") then
        DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_004", STR_QUEST_TEXT(810044074))  -- "역시 쥬오가 최고!"
        DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001",  STR_QUEST_TEXT(810044009))  -- "......"

        RequireSceneMiniGameDancePopupPass()
        if RequireCheckResult("Pass") then
            QuestProgressBuy()
            SceneMiniGameDanceSuccess()
            Wait(2)
            QuestComplete()
            return true
        end

        RequireSceneMiniGameDancePopupRetry()
        goto jmp_retry
    end

    SoundPlayBGM(629085) --=BGM=Character_Catrasche

    QuestComplete()
    return true
end

local function ScriptOnQuestComplete()

    FullLoad()
    UnlockQuestContents()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    SoundPlayBGM(629085) --=BGM=Character_Catrasche

    -- 시점을 분수대 근처로
    TownCameraSetPos(TownCharacterGetNPC(0), -3, 33*40-182, 1);
    -- 더미 펫들 등장
    TownCharacterStandAt(TownCharacterAddNPC(401), -283, 33*40+76)
    TownCharacterStandAt(TownCharacterAddNPC(402), -164, 33*40+17)
    TownCharacterStandAt(TownCharacterAddNPC(403), -214, 33*40-144)
    TownCharacterStandAt(TownCharacterAddNPC(404), -289, 33*40-263)
    TownCharacterStandAt(TownCharacterAddNPC(405), -166, 33*40-342)
    TownCharacterStandAt(TownCharacterAddNPC(406), 180, 33*40+80)
    TownCharacterStandAt(TownCharacterAddNPC(407), 359, 33*40-5)
    TownCharacterStandAt(TownCharacterAddNPC(408), 230, 33*40-90)
    TownCharacterStandAt(TownCharacterAddNPC(409), 316, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(410), 285, 33*40-285)
    -- 웅디 등장
    TownCharacterStandAt(TownCharacterAddNPC(109), -4*40, 33*40-182)
    -- 쥬오 등장
    TownCharacterStandAt(TownCharacterAddNPC(160), -0*40, 33*40-182)
    -- 유저 등장
    TownCharacterStandAt(TownCharacterAddNPC(1), 2*40, 33*40-182)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201825)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202825)
    
    DialogOpen(421, STR_NPC(421), "", STR_QUEST_TEXT(810044009))  -- "......"
    DialogOpen(422, STR_NPC(422), "", STR_QUEST_TEXT(810044075))  -- "카… 카트라슈가 이긴 거야?"
    DialogOpen(109, STR_NPC(109), "Characters/npc_woongdy_004", STR_QUEST_TEXT(810044076))  -- "카트라슈… 멋있었어!"

    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810044063))  -- "……"
    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810044077))  -- "…이길 수 없다…..."

    -- 쥬오 쓰러짐
    TownCharacterAction(TownCharacterGetNPC(160), "lie_01")
    Wait(1)

    DialogOpen(423, STR_NPC(423), "", STR_QUEST_TEXT(810044078))  -- "카트라슈가 이겼다!"
    DialogOpen(424, STR_NPC(424), "", STR_QUEST_TEXT(810044079))  -- "댄스빌 개 춤꾼들의 새로운 희망! 카트라슈!"
    DialogOpen(421, STR_NPC(421), "", STR_QUEST_TEXT(810044080))  -- "와아~"

    -- 펫들이 모여듬
    -- (씬조작, 마을, 줌아웃)
    -- (씬조작, 마을, 개, 이동, 30,10,135.0)
    -- (딜레이, 1.5)

    MonologOpen(STR_QUEST_TEXT(810044081))  -- "쥬오가 한 스텝을 일부러 틀려준 듯 한 건 기분 탓이겠지?"
    Wait(3)
    MonologClose()
    
    Wait(2)

    -- 광장 위쪽 카바, 아리 등장, 줌인
    TownCharacterStandAt(TownCharacterAddNPC(101), -60, 33*40+200)
    TownCharacterStandAt(TownCharacterAddNPC(102), 60, 33*40+200)
    TownCameraZoomIn(TownCharacterGetNPC(102), -60, 50, 2)
    Wait(1)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_010", STR_QUEST_TEXT(810044082))  -- "제 말이 맞죠? [유저의 닉네임] 님이 카트라슈와 이야기 하는 걸 똑똑히 봤어요."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810044083))  -- "동물과 대화가 가능하다니… 설마……"

    -- 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[카트라슈의 고민] 스토리 완료"

    -- 퀘스트 보상
    QuestReward()
    RestoreUserConstume()
    GoTown()
end

-- PRELOAD_BEGIN

-- 카바네 집 앞에 샤바 서있음
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(103), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044082))  -- "요즘 카트라슈는 통 기운이 없어요."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044082))  -- "요즘 카트라슈는 통 기운이 없어요."
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestAppear() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then
    -- 댄스게임 도중 실패한 단계에서는 쥬오가 등장
    if OnTownRefresh() then
        -- 쥬오 등장
        TownCharacterStandAt(TownCharacterAddNPC(160), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(160))
        TownCharacterSetQuest(TownCharacterGetNPC(160))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(160)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(160))
        --DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001",  STR_QUEST_TEXT(810044083))  -- "...다시 도전?"
        textCheckQuestRunning()
		PushPopupTownNpcWithSelectBox(160)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
		--DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001",  STR_QUEST_TEXT(810044083))  -- "...다시 도전?"
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end
elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(103), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044082))  -- "요즘 카트라슈는 통 기운이 없어요."
        textCheckQuestComplete()
		PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        --DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810044082))  -- "요즘 카트라슈는 통 기운이 없어요."
		textCheckQuestComplete()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
