-- 음악이 없으면 춤도 없어(820004) -- 체험형 퀘스트
-- version("0.37.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004001))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
end


local function ScriptOnQuestRunning()
    
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    if CheckQuestProgress(10107, 1) then
        SoundPlayWithFirstMusicInvenList()
        return true
    end

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(111)

    if not CheckQuestManagerDummy() then
        LoadQuestMusicID()
    end

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004002))  -- "아, [유저의 닉네임] 님! 먼저 인사해주시다니, 이렇게 영광스러울 수가!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004003))  -- "존경하는 춤꾼과 종종 이렇게 마주 설 수 있다는 건 큰 복이 아닐 수 없죠!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004004))  -- "볼 때마다 느끼는 거지만, [유저의 닉네임] 님의 춤은 정말 더할 나위가 없네요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004005))  -- "아주 민감한 예술 감각을 지닌 저조차도 빠져들게 만들었으니까요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004006))  -- "그런데... 음악이 춤의 개성을 따라가지 못 하는 건 좀 아쉬운 것 같아요."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004007))  -- "예? 아직 음악을 직접 만들어보신 적이 없다구요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004008))  -- "어쩐지. 춤과 음악이 서로 서먹서먹해 보이더라니."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004009))  -- "실이 없으면 바늘이 제 구실을 못 하듯 음악 없이는 춤도 없는 법!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004010))  -- "당장 음악을 만들기는 어려울 테니 제가 만든 걸 하나 드릴게요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004011))  -- "이 춤에 거짓말처럼 잘 어울릴 테니 두고 보세요."

    -- 튜토리얼 음악
    DescriptionBarShow(STR_QUEST_TEXT(820004012))  -- "음악을 불러오는 중..."

    music_id_list = {
        629039,
        629040,
        629041,
        629042,
        629043,
        629044,
        629045,
        629046,
        629047,
        629048,
    }

    inst_dummy = {
                    '{"inst_list":[{"inst_id":630147}, {"inst_id":630156}, {"inst_id":630144}, {"inst_id":630152}, {"inst_id":632115}, {"inst_id":632101}, {"inst_id":632101}]}',
                    '{"inst_list":[{"inst_id":630147}, {"inst_id":630156}, {"inst_id":630146}, {"inst_id":630152}, {"inst_id":632115}, {"inst_id":632174}, {"inst_id":632101}]}',
                    '{"inst_list":[{"inst_id":630149}, {"inst_id":630153}, {"inst_id":630145}, {"inst_id":630152}, {"inst_id":632115}, {"inst_id":632100}, {"inst_id":632103}]}',
                    '{"inst_list":[{"inst_id":630149}, {"inst_id":630153}, {"inst_id":630145}, {"inst_id":630152}, {"inst_id":632123}, {"inst_id":632100}, {"inst_id":632103}]}',
                    '{"inst_list":[{"inst_id":630149}, {"inst_id":630153}, {"inst_id":630145}, {"inst_id":630152}, {"inst_id":632208}, {"inst_id":632196}, {"inst_id":632081}]}',
                    '{"inst_list":[{"inst_id":630149}, {"inst_id":630153}, {"inst_id":630145}, {"inst_id":630152}, {"inst_id":632208}, {"inst_id":632161}, {"inst_id":632081}]}',
                    '{"inst_list":[{"inst_id":630150}, {"inst_id":630153}, {"inst_id":630143}, {"inst_id":630152}, {"inst_id":632078}, {"inst_id":632121}]}',
                    '{"inst_list":[{"inst_id":630150}, {"inst_id":630153}, {"inst_id":630143}, {"inst_id":630152}, {"inst_id":632078}, {"inst_id":632161}]}',
                    '{"inst_list":[{"inst_id":630157}, {"inst_id":630153}, {"inst_id":630140}, {"inst_id":630152}, {"inst_id":632203}, {"inst_id":632161}]}',
                    '{"inst_list":[{"inst_id":630149}, {"inst_id":630154}, {"inst_id":630142}, {"inst_id":630146}, {"inst_id":632080}, {"inst_id":630124}]}',
                }

    if not CheckQuestManagerDummy() then
        music_id = GetQuestMusicID()
        rand_num = 0

        for i = 1,10, 1 do
            if music_id == music_id_list[i] then
                rand_num = i
                break
            end
        end
    else
        rand_num = GetRandMinMax( 1, 10)
    end

    SoundPlayBGM( music_id_list[rand_num])

    Wait(2)
-- 더미 악기 목록 사용
    UseDummyInstruments( inst_dummy[rand_num])
-- 더미 음악 목록 사용
    UseDummyMusicList(inst_dummy[rand_num] )

    DescriptionBarHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004013))  -- "좋아. 좋아. 역시 이 리듬은 최고..."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004014))  -- "응...?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004015))  -- "으응??"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004016))  -- "허전해! 허전해!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004017))  -- "[유저의 닉네임] 님께서도 느껴지시죠? 이 견디기 힘든 소리의 여백이!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004018))  -- "[유저의 닉네임] 님의 탁월한 센스로 음악 수정을 좀 도와주시겠어요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004019))  -- "음악을 수정하려면, 먼저 [유저의 닉네임] 님의 캐릭터를 터치해보세요."

    -- 유저캐릭터 터치
    TownCameraZoomIn(TownCharacterGetNPC(1), 0, 50, 2)
    Wait(1)

    DescriptionBarShow(STR_QUEST_TEXT(820004020))  -- "[유저의 닉네임] 님의 캐릭터를 터치해보세요."

    ::jmp_click1::
    RequireSceneTownCharacterClick(TownCharacterGetNPC(1))
    if RequireCheckResult("OutOfTouch") then
        goto jmp_click1
    end

    -- 줌인
    ScriptTownZoomInCharacter(TownCharacterGetNPC(1))
    PushPopupTownUser(1)

    DescriptionBarHide()

  -- 유저가 본인의 캐릭터를 터치하면 캐릭터가 줌인 되며 하단에 [음악] 버튼이 추가, 등장.
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004021))  -- "{highlight}{bold}음악{/bold}{/highlight} 버튼이 보이죠? 한 번 눌러보세요."

    ::jmp_btn_info_music::
        RequireButtonWithCCB("UI_common/ui_btn2_003_05", "btn_info_music")
        if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004022))  -- "{highlight}{bold}음악{/bold}{/highlight} 버튼을 눌러 [유저의 닉네임] 님의 뛰어난 춤에 어울리는 음악을 만들어보자구요!"
        goto jmp_btn_info_music
    end

    -- 유저가 [음악] 버튼을 누르면 음악 목록 화면이 등장.
    -- 인상 좋은 청년에게 받은 [대충 만든 음악]이 목록에 있다.
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004023))  -- "저기 제가 심혈을 기울여 만든 {highlight}{bold}대충 만든 음악{/bold}{/highlight}이 있네요!"

    ::jmp_btnToggle_modify_info::
        RequireClickWithCCB("UI_common/ui_btn2_004_01", "btnToggle_modify_info")
        if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004024))  -- "음악 수정이 그리 어렵지는 않을 테니 걱정마세요."
        goto jmp_btnToggle_modify_info
    end


    -- [대충 만든 음악] 목록을 누르면 소리 목록(악기 목록) 화면이 등장.
    PushSceneMusicTrackList()

    -- 필요없는 UI 감추기(채널 탭, 편집 탭, 재생 버튼, 하단 패턴 목록, 우측 클립보드 메뉴, 녹음 버튼, 되돌리기 버튼)
    -- DVM이 재생되지 않고 있는 경우 재생시키기
    SoundPlayCurDVM()

    -- [대충 만든 음악] 목록을 누르면 소리 목록(악기 목록) 화면이 등장.
    -- 악기는 큰북, 작은북(연주 안 됨), 열린 하이햇, 닫힌 하이햇 4개 활용

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004025))  -- "화면을 보시면 아시겠지만, 제가 만든 음악은 다양한 소리를 사용하고 있... 앗!!!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004026))  -- "앗! 그랬군! 소리 하나를 사용하지 않고 있었어!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004027))  -- "예민한 감각의 내가 이런 실수를 하다니..."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004028))  -- "저기 두 번째 {highlight}{bold}작은 북 모양의 스네어 드럼{/bold}{/highlight}이 안 움직이는 게 보이시죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004029))  -- "스네어 드럼의 소리를 추가해서 풍부한 음악을 만들어보자구요!"

    ::jmp_btnInst2::
    RequireButton("btnInst2")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004030))  -- "스네어 드럼 소리 외에는 모두 잘 연주되고 있네요."
        goto jmp_btnInst2
    end

      -- 스네어 드럼을 누르면 연주 상태 화면이 등장.
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004031))  -- "여기 보이는 {highlight}{bold}네모난 칸{/bold}{/highlight}들은 각각 {highlight}{bold}한 스텝{/bold}{/highlight}를 의미해요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004032))  -- "{highlight}{bold}빈 칸{/bold}{/highlight}을 {highlight}{bold}터치{/bold}{/highlight}하면 색깔이 바뀌며 여러 표시와 글자가 나타날 거에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004033))  -- "그 칸에서는 해당 악기가 연주되어 소리가 나게 되는 거죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004034))  -- "한 번 더 톡 하고 터치하면 빈 칸으로 돌아가서 소리가 안 나는 거구요. 쉽죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004035))  -- "자, 느껴보세요! 지금 흐르는 음악의 비트를!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004036))  -- "그리고 원하는 칸을 톡 터치해보는 거에요!"

    DescriptionBarShow(STR_QUEST_TEXT(820004037))  -- "소리가 났으면 하는 칸들을 터치하고 [뒤로 가기] 버튼을!"

    drum_note_cnt = GetSceneMusicTrackEditCurrentNoteCount()
    ::jmp_addnote::
    RequireSceneMusicTrackEditAddNote( drum_note_cnt)
    if RequireCheckResult("1More") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004038))  -- "보이는 칸들 중 소리가 났으면 하는 칸을 톡 찍으시면 돼요."
        goto jmp_addnote
    end

    DescriptionBarHide()

      -- [뒤로 가기] 버튼을 누르면 아래의 스크립트 진행
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004039))  -- "바로 이거야! 이제야 알찬 리듬을 갖추게 되었어요! [유저의 닉네임] 님은 쉽게 해내실 거라 믿었어요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004040))  -- "뛰어난 춤꾼이 되기 위해 노력하다 보면 더 많은 소리와 더 많은 기능으로 음악을 만드실 수 있답니다!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004041))  -- "예를 들어서..."

    RequestMusicEditRecordPermission()

    if CheckMusicEditRecordPermission() then

          -- 녹음해서 악기 제작
        PushSceneMusicEditRecord()
        WaitSoundRecordingFinish()

          -- 녹음한 악기 생성
        CreateInstrumentFromRecorded(5)

        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004042))  -- "자 이제 재밌는 걸 들려드릴게요!"
        PopScene()

        AdjustRecordedInstrument(5, 3)

        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004043))  -- "[유저의 닉네임] 님의 목소리가 바로 음악이 되는 기적!"
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004044))  -- "녹음한 소리를 마치 악기처럼 사용할 수 있죠!"
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004045))  -- "혹시 지금의 소리 대신, 더 재미있는 소리를 녹음해서 넣어보고 싶으세요?"

        PopupAskSoundRecordRetry()
        if RequireCheckResult("no") then
            PushSceneMusicEditRecord()
            WaitSoundRecordingFinish()

            PopScene()

            AdjustRecordedInstrument(5, 3)
        else
            goto jmp_finishRecord
        end

        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004046))  -- "혹시 한 번 더 다른 소리로 바꿔보고 싶으신지?"

        PopupAskSoundRecordRetry()
        if RequireCheckResult("no") then
            PushSceneMusicEditRecord()
            WaitSoundRecordingFinish()

            PopScene()

            AdjustRecordedInstrument(5, 3)
        else
            goto jmp_finishRecord
        end

        ::jmp_finishRecord::
    else
        CreateInstrumentFromRecorded(5)
        AdjustRecordedInstrument(5, 3)
    end

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004047))  -- "여기까지만 해도 신기방기하지만, 끝이 아니랍니다."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004048))  -- "소리를 마음대로 조정하는 것도 가능하거든요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004049))  -- "먼저 소리의 {highlight}{bold}높이{/bold}{/highlight}를 슬쩍 바꿔볼까요?"

    UISignalShow("btnMelody")
    Wait(2)
    UISignalHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004050))  -- "{highlight}{bold}음표{/bold}{/highlight} 모양에 불이 켜져 있죠? 이 상태에서 소리가 나는 칸에 손을 대고 움직여 보면..."


    --높낮이를 바꾸는 것과 뒤로 가기를 누르는 것 외의 조작은 막기
    default_node = GetSceneMusicTrackEditMelodyCurrentNote()

    first_note = GetSceneMusicTrackEditMelodyFirstNoteName()
    x = UIGetX( first_note)
    y = UIGetY( first_note)
    RequireDragFromTo(x, y, x+100, y)  --손가락이 등장, 소리가 나는 칸 중 첫번째 칸을 누른 상태에서 오른쪽으로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    Wait(2)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004051))  -- "표시된 계이름이 바뀌면서 소리의 {highlight}{bold}높이{/bold}{/highlight}가 달라지죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004052))  -- "같은 방식으로 음의 {highlight}{bold}길이{/bold}{/highlight}를 바꾸고 싶을 때는..."

    UISignalShow("btnLength")  --음 길이 탭에 빨간 박스
    Wait(2)
    UISignalHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004053))  -- "여기를 누르면 음의 {highlight}{bold}길이{/bold}{/highlight}를 바꾸는 상태가 되고,"

    UISignalShow("btnVol")  --음 크기 탭에 빨간 박스
    Wait(2)
    UISignalHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004054))  -- "여기를 누르면 음의 {highlight}{bold}크기{/bold}{/highlight}를 바꾸는 상태가 돼요. 간단하죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004055))  -- "그리고 언제든 다른 소리로 교체하고 싶을 때는 {highlight}{bold}악기 변경{/bold}{/highlight} 버튼을 누르세요."

    UISignalShow("btnMusicInstList")
    Wait(2)
    UISignalHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004056))  -- "자, 그럼 음악을 좀 더 재미있게 만들고 마무리해볼까요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004057))  -- "여러가지 하기는 귀찮으니, 음의 {highlight}{bold}높이{/bold}{/highlight}만 적당히 좀 바꿔보자구요!"

    ::jmp_melody_change::  --음의 높낮이를 바꿨는지 체크
    RequireSceneMusicTrackEditMelodyChange( default_node)  --음의 높낮이를 바꿨는지 체크
    if RequireCheckResult("2More") then  --음의 높낮이를 2개 이상 바꾸고 뒤로 가기를 눌렀는지 체크
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004058))  --높낮이를 2개 미만으로 바꾸고 뒤로 가기를 눌렀을 때 대사  -- "음의 {highlight}{bold}높이{/bold}{/highlight}를 2개 이상은 바꿔야 좀 차이가 느껴지지 않을까요?"
        DescriptionBarShow(STR_QUEST_TEXT(820004059))  -- "음의 높이를 바꿔 더 매력적인 음악으로!"
        goto jmp_melody_change  --음의 높낮이를 바꿨는지 체크
    end
 
    if not CheckQuestManagerDummy() then
        -- 악기 저장, 다시보기 시 제외
        CreateRealInstrument()

        -- 더미가 아닌 저장된 실 악기 데이터 적용, 다시보기 시 제외
        AdjustRealInstrument(3)

        -- 음악 저장, 다시보기 시 제외
        CreateRealMusic()
    end

    GoSceneTown()  --유저가 음의 높낮이를 바꾼 음악 재생

    return true
end

    DescriptionBarHide()

local function ScriptOnQuestComplete()
    -- 지나가는 남자 둘이 등장해야 하므로 먼저 유저 및, 인상 좋은 청년의 위치 변경
    SceneTownSetStateEmpty()
    TownCharacterStandAt(TownCharacterAddNPC(1), 0, 26*40)
    TownCharacterStandAt(TownCharacterAddNPC(111), 2*40, 26*40)
    TownCameraZoomIn(TownCharacterGetNPC(1), 40, 50, 1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004060))  -- "아, 아닛! 이, 이게 정말 제가 만들던 그 음악이 맞나요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004061))  -- "뭔가... 꽃가루 가득한 봄철의 흐드러진 청춘을 표현한 느낌이랄까...?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004062))  -- "음악의 클래스가 한 단계 높아진 느낌이에요!"
    TownCharacterSetEmot(TownCharacterGetNPC(111), "Characters/Emoticon_exclamation")
    Wait(1.5)
    TownCharacterStandAt(TownCharacterAddNPC(123), -8*40, 26*40)
    TownCharacterWalkTo(TownCharacterGetNPC(123), -2*40, 26*40)
    Wait(2)
    DialogOpen(123, STR_NPC(123), "", STR_QUEST_TEXT(820004063))  -- "음악이 너무 좋아 그냥 지나칠 수 없었어요. 이 곡의 이름은 뭐죠?"
    TownCharacterStandAt(TownCharacterAddNPC(124), 10*40, 26*40)
    TownCharacterWalkTo(TownCharacterGetNPC(124), 4*40, 26*40)
    Wait(2)
    DialogOpen(124, STR_NPC(124), "", STR_QUEST_TEXT(820004064))  -- "오오! 이런 음악을 만들 수 있다면 앞으로 다시는 음악을 만들지 못하더라도 여한이 없겠어!"
    TownCharacterSetEmot(TownCharacterGetNPC(111), "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004065))  -- "음악 제작에도 이런 재능을 감추고 계셨다니!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004066))  -- "앞으로도 [유저의 닉네임] 님의 기똥찬 음악을 기대할게요!"

    SetQuestProgressComplete_Dummy(10107)
    QuestComplete()
    QuestReward()
    ScenarioEndingShow()  -- "[음악이 없으면 춤도 없어] 퀘스트 완료"
    GoTown()
end

local function ScriptOnQuestAppear()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents()  -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestStart()
    return ScriptOnQuestRunning()
end


-- PRELOAD_BEGIN

  -- 인상 좋은 청년의 머리 위에 빨간 느낌표.
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestAppear() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(111), 2*40, 26*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        ScriptTownMoveToLeftSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820004067))  -- "춤꾼이라면 음악에 대해서도 좀 알아야 하지 않겠어요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        QuestReward()
        GoTown()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
