-- 춤으로 소통하는 세계(820011) -- 메인 튜토리얼
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end


local function UnlockQuestContents()
    UnlockStartQuestMode()
--    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 팬 되기, 스타/팬 관리 기능을 열어줌
--    UnlockContents(520018)  -- 자랑하기 기능을 열어줌
end

  --유저가 댄스비전을 터치해 상세보기 화면으로 들어오면 스크립트 시작
  --진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정은 없음

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011001))  -- "댄스빌에서 {highlight}{bold}댄스비전{/bold}{/highlight} 없이는 소통을 논할 수 없습니다."
end



local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(110)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011002))  -- "[유저의 닉네임] 님, 반갑습니다. 춤 실력이 아주 뛰어나시더군요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011003))  -- "우리 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서는 [유저의 닉네임] 님의 등장과 활약에 주목하고 있습니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011004))  -- "가족 관계는 어떻게 되십니까? 어떻게 하늘에서 떨어지게 된 것이지요? 춤은 어디서 배우셨는지?"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011005))  -- "음... 떨어질 때의 충격으로 기억을 잃어버리신 모양이군요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011006))  -- "요즘 세상에 기억상실이라니... 구태의연한 전개로군."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011007))  -- "뭐, 좋습니다. 어찌 됐든 뛰어난 춤꾼이 많아지는 것은 저희 입장에서 반가운 일이니까요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011008))  -- "기억을 찾으실 때까지 지내시는데 어려움이 없도록, 저희 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서 도와드리도록 하죠."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011009))  -- "먼저 이걸 받아주시겠습니까?"
    
    -- 요원 머리 위에 작은 댄스비전 이미지가 등장, 2초 후 화면 우측 상단(현재의 댄스비전 자리)으로 점점 커비며 날아가 고정되는 듯한 연출과 함께 댄스비전 오픈
    -- 이 구간동안 터치를 막음
    BeginTimeTouchLock(6)

    RemoveQuestSkipButton()

    SendProtocolGetDanceVision()
    UIHide("uiDanceVision")
    TownCharacterActionByID( TownCharacterGetNPC(110), 612893)

    UIAddCCB( "dv2", "ui_main_top_dv_ani2")
    UIControlCCB820011( "dv2", 0)
    UILoad( "dv2")
    UIHide( "dv2")

    AnimationAdd("dv1", "UI_common/ui_main_top_dv_ani1")
    AnimationSetPos("dv1", -80, -40)
    Wait(0.5)
    TownCharacterActionByID( TownCharacterGetNPC(110), 611110)

    dv_x = UIGetX( "btnDanceVision")
    dv_y = UIGetY( "btnDanceVision")

    AnimationMove("dv1", dv_x, dv_y - 2, -150, 150, 0, 0)

    Wait(0.1)
--    SceneTownSetStateIdle()
    UIShow( "dv2")
    AnimationRemove( "dv1")
    Wait(0.1)
    UIControlCCB820011( "dv2", 1)
    Wait(0.4)
    SceneTownSetStateIdle()
    UIShow("uiDanceVision")
    Wait(1.0)
    UIRemoveCCB( "dv2")

    -- 터치 잠금 해제
    EndTimeTouchLock()
    Wait(0.5)

    DialogOpenNoOffUI(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011010))  -- "이것은 {highlight}{bold}댄스비전{/bold}{/highlight}이라는 것입니다. 댄스빌의 구성원이라면 누구나 가지고 있는 것으로..."
    DialogOpenNoOffUI(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011011))  -- "댄스빌의 수많은 춤꾼들이 자신의 {highlight}{bold}춤{/bold}{/highlight}과 {highlight}{bold}음악{/bold}{/highlight}으로 만든 {highlight}{bold}뮤직비디오{/bold}{/highlight}를 자랑하는 수단이죠."
    DialogOpenNoOffUI(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011012))  -- "{highlight}{bold}춤으로 소통{/bold}{/highlight}하는 이곳 댄스빌에서 {highlight}{bold}소통의 핵심{/bold}{/highlight}적인 역할을 합니다."
    DialogOpenNoOffUI(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011013))  -- "좀 더 자세히 살펴볼까요?"


    
    -- 댄스비전 중앙에 손가락으로 누르기 유도
    ::jmp_btnDanceVision::
    RequireButton("btnDanceVision")
    if RequireCheckResult("OutOfTouch") then
        DialogOpenNoOffUI(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011014))  -- "{highlight}{bold}댄스비전{/bold}{/highlight}은 댄스빌에서 {highlight}{bold}소통의 가장 중요한 수단{/bold}{/highlight}입니다."
        goto jmp_btnDanceVision
    end

    -- 댄스비전에 해당하는 뮤비가 하나도 없을 때
    if UIExists("itemDanceVision/Other/OnAir") == false then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011015))  -- "{highlight}{bold}댄스비전{/bold}{/highlight}에 {highlight}{bold}뮤직비디오{/bold}{/highlight}가 없다니, 드문 일이군요."
        GoTown()
        return
    end
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011016))  -- "많은 {highlight}{bold}뮤직 비디오{/bold}{/highlight}들이 보일 겁니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011017))  -- "다양한 춤꾼들의 다양한 {highlight}{bold}뮤직비디오{/bold}{/highlight}를 보면 새로운 영감이 떠오르게 마련이지요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011018))  -- "물론 감상 자체만으로도 즐거운 일일 테고 말입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011019))  -- "그리고 뮤직비디오 중 하나를 터치해보면..."
    
    ::jmp_itemDanceVision::
    UIListScrollTo("uiListDanceVision", "itemDanceVision/Other/OnAir")
    RequireButton("itemDanceVision/Other/OnAir")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011020))  -- "뮤직비디오 중 하나를 터치해보면..."
        goto jmp_itemDanceVision
    end

    -- 뮤비 상세화면 진입 실패 시
    if CheckMVDetailError() then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011021))  -- "댄스비전이 오작동 하다니, 무척 드문 일입니다."
        FixMVDetailError()
        GoTown()
        return
    end

    RequireCurrentScene("SceneDanceVisionDetail")

    -- 뮤직비디오 자세히 보기 화면으로 전환.
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011022))  -- "이렇게 춤과 음악, 배경을 모두 갖춘 뮤직비디오를 크게 감상할 수 있습니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011023))  -- "또 중요한 건 이 화면에서 뮤직비디오를 만든 춤꾼과의 소통도 가능하다는 점입니다."
    
    -- [별점] 버튼에 영역/화살표
    UISignalShow("uiRateStar")
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011024))  -- "뮤직비디오를 보고 드는 느낌을 {highlight}{bold}별점{/bold}{/highlight}으로 평가하는 재미도 한 번 느껴보시고."
    UISignalHide()
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011025))  -- "이 뮤직비디오를 만든 사람의 다른 작품들도 내 댄스비전에 자주 나왔으면 좋겠다 싶을 때는..."
    
      -- [팬 되기] 버튼에 영역/화살표
    UISignalShow("btnBeFan")
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011026))  -- "{highlight}{bold}팬 되기{/bold}{/highlight} 버튼을 이용해 그 춤꾼을 나의 스타로 등록해두면 됩니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011027))  -- "그러면 그 춤꾼이 새 뮤직비디오를 만들 때마다 내 댄스비전에 등장하지요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011028))  -- "별점만으로는 [유저의 닉네임] 님의 마음을 다 표현할 수 없다면 이런 것도 있습니다."
    UISignalHide()

    -- 댓글창 열기 버튼에 손가락으로 누르기 유도
    local ccb_name = GetMvDetailLoadedCCBName()

    if ccb_name == "none" then
        -- 만약에 Scene을 찾을 수 없는 상태라면 대사만 처리

        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011029))  -- "{highlight}{bold}별점{/bold}{/highlight}이랑 {highlight}{bold}댓글{/bold}{/highlight}, {highlight}{bold}팬 되기{/bold}{/highlight}는 그 뮤직비디오에 대한 춤꾼들의 관심을 가늠해볼 수 있는 것들이지요."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011030))  -- "그러실리는 없겠지만... 뮤직비디오를 너무 심하게 폄하하거나 욕설을 적거나 한다면 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서 징계를 내리니 조심하시길."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011031))  -- "댄스빌에서 댄스비전은 신분증과도 같습니다. 잃어버리지 말고 항상 지니고 다니면서 살펴보십시오."
    else
        ::jmp_btnMVComment::
        RequireButtonWithCCB( ccb_name, "btnMVComment")
        if RequireCheckResult("OutOfTouch") then
            DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011032))  -- "뮤직비디오에 대해 하고 싶은 말이 있다면..."
            goto jmp_btnMVComment
        end
        UIHide("uiCommentInput")
        
        Wait(2)
    
        -- 댓글창이 열긴 상태에서 아래의 스크립트 진행
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011033))  -- "바로 {highlight}{bold}댓글 창{/bold}{/highlight}입니다."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011029))  -- "{highlight}{bold}별점{/bold}{/highlight}이랑 {highlight}{bold}댓글{/bold}{/highlight}, {highlight}{bold}팬 되기{/bold}{/highlight}는 그 뮤직비디오에 대한 춤꾼들의 관심을 가늠해볼 수 있는 것들이지요."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011030))  -- "그러실리는 없겠지만... 뮤직비디오를 너무 심하게 폄하하거나 욕설을 적거나 한다면 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서 징계를 내리니 조심하시길."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011031))  -- "댄스빌에서 댄스비전은 신분증과도 같습니다. 잃어버리지 말고 항상 지니고 다니면서 살펴보십시오."
    end

    Wait(0.5)

    ScenarioEndingShow()  -- "[춤으로 소통하는 세계] 스토리 완료"
    -- 퀘스트 시작/완료/보상

    QuestComplete()
    QuestReward()

    ButtonClickWithCCB("UI_common/ui_dv_03_mv_03", "btn_backward")
    TownStateRestore()
end

-- 카바네 집 앞에 요원 서있음
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    if OnTownRefresh() then
        -- 요원 등장
        TownCharacterStandAt(TownCharacterAddNPC(110), -12*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))
    end

    -- 요원을 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        --DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011033))  -- "댄스빌에서 {highlight}{bold}댄스비전{/bold}{/highlight} 없이는 소통을 논할 수 없습니다."
        textCheckQuestAll()
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        --DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820011033))  -- "댄스빌에서 {highlight}{bold}댄스비전{/bold}{/highlight} 없이는 소통을 논할 수 없습니다."
        textCheckQuestAll()
    end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end


