-- 신성한 땅(820013) -- 스토리 퀘스트
-- version("0.31.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end


local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520002)  -- 아카데미 관련 기능을 열어줌
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
    UnlockContents(520009)  -- 장애물 제거 관련 기능을 열어줌
end


local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013001))  -- "아카데미... 참 탐나는 땅이란 말이야..."
end




local function ScriptOnQuest()

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(152)

    TownCameraZoomIn(TownCharacterGetNPC(1), -1*40, 50, 2)
	
	-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013002))  -- "아~ 요 아래에 새로 생긴 {highlight}{bold}아카데미의 마스터{/bold}{/highlight}라고?"
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013003))  -- "안 그래도 누가 그 금싸라기 땅을 차지하고 있나 궁금하던 차였어."
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013004))  -- "접근성 좋지,경치 좋지, 개발할 면적 풍부하지, 그런 땅이 또 없다니까."
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013005))  -- "게다가 아카데미 진흥법 때문에 주위를 개간하면 그 땅을 다 아카데미로 쓸 수 있으니 말 다 했지 뭐."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)
    
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013006))  -- "어라… 본인이 차지하고 있는 땅의 가치를 영 모르는 눈치인데?"
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013007))  -- "땅은 자고로 자기를 예뻐해주는 주인을 만나야 제대로 된 빛을 발하는 법!"
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013008))  -- "손해 보는 셈 치고 가격을 제대로 쳐줄테니 그 아카데미 일대 땅을 나에게 팔지 않겠어?"
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013009))  -- "가격은… 눈물을 머금고 {highlight}{bold}1,000,000{/bold}{/highlight} 골드 쳐주지! 어때? 자주 오는 기회가 아니라고!"
    
    RequirePopupSellAcademy(STR_QUEST_TEXT(820013010), 1000000)  -- "아카데미 일대의 땅을 판매하시겠어요?"
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013011))  -- "잠깐!"
    
      -- 화면 좌측 요원 등장, 뛰어옴
    TownCharacterStandAtCharacter(TownCharacterAddNPC(110), TownCharacterGetUser(), -10*40, 0*40)
    TownCharacterRunToCharacter(TownCharacterGetNPC(110),TownCharacterGetNPC( 1), -4*40, 0*40)
    Wait(1)
    
    TownCameraZoomIn(TownCharacterGetNPC(1), -2*40, 50, 2)
    TownCharacterSetEmot(TownCharacterGetNPC(152), "Characters/Emoticon_exclamation")
    Wait(1)
    
	-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013012))  -- "겁도 없이 아카데미의 땅을 거래하려 들다니!"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013013))  -- "춤 부흥 목적의 땅을 개인적으로 거래하는 게 중범죄라는 걸 잘 알 텐데!"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_shocking")
    Wait(1.5)
    
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013014))  -- "요, 요원이 왜 이런 곳에!"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013015))  -- "우리 요원들은 댄스빌의 발전과 정의 실현을 위해서라면 어디든지 나타나는 존재니까!"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013016))  -- "[유저의 닉네임] 님! 저 파렴치한 녀석으로부터 구해드리겠습니다!"
    DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013017))  -- "요원 중에도 상태가 좀 이상한 녀석에게 걸려버렸군. 에잇!"
    
      -- 화면 좌측 으로 땅부자 뛰어 나감
    TownCharacterRunToCharacter(TownCharacterGetNPC(152),TownCharacterGetNPC( 152), 12*40, -4*40)
    Wait(2)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820013018))  -- "거기 서지 못 해!"
    
      -- 요원 땅부자에게로 뛰어 나감
    TownCharacterRunToCharacter(TownCharacterGetNPC(110),TownCharacterGetNPC( 152), 0*40, 0*40)
    Wait(1)
    
      -- 화면 좌측 신입 요원 등장, 걸어옴
    TownCharacterStandAtCharacter(TownCharacterAddNPC(133), TownCharacterGetUser(), -10*40, 0*40)
    TownCharacterRunToCharacter(TownCharacterGetNPC(133),TownCharacterGetNPC( 1), -2*40, 0*40)
    
    Wait(2)
    TownCharacterHide(TownCharacterGetNPC(152))
    TownCharacterHide(TownCharacterGetNPC(110))
    
    TownCameraZoomIn(TownCharacterGetNPC(1), -1*40, 50, 2)
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013019))  -- "많이 놀라셨죠? 요즘 신입 마스터들을 상대로 아카데미 땅을 사려는 사람들이 종종 있어요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013020))  -- "아카데미 들은 워낙 좋은 터에 자리를 잡으니까요. 그런데 아카데미 땅 거래는 불법이거든요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013021))  -- "댄스빌의 근간은 역시 춤이고, 그 춤의 발전에 큰 도움을 줄 신성한 땅이니까요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013022))  -- "뭐, 혹시나 거래를 한다고 하진 않으셨죠? [유저의 닉네임] 님이 그런 실수를 할 리가!"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_sweat")
    Wait(1.5)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013023))  -- "아카데미는 댄스빌을 지탱하는 기반이니까 소중히 써주세요~"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013024))  -- "특히 아카데미 일대의 넓은 땅은, 그것을 어떻게 쓰느냐에 따라 가능성이 무궁무진하답니다~"

    Wait(1)
    ScenarioEndingShow()  -- "[신성한 땅] 스토리 완료"
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()
end

local function ScriptOnQuestRunning()
    -- 퀘스트 시작 조건 검사
    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    ScriptOnQuest()
end

local ScriptOnQuestAppear = ScriptOnQuest

local function ScriptOnQuestComplete()
    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
	
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013023))  -- "아카데미는 댄스빌을 지탱하는 기반이니까 소중히 써주세요~"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820013024))  -- "특히 아카데미 일대의 넓은 땅은, 그것을 어떻게 쓰느냐에 따라 가능성이 무궁무진하답니다~"

    Wait(1)
    ScenarioEndingShow() -- "[신성한 땅] 퀘스트 완료"

    QuestComplete()
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

-- 땅부자 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(152))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(152))
        TownCharacterSetQuest(TownCharacterGetNPC(152))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(152)) then
        PreLoad()

        ScriptTownMoveToTownSquare(TownCharacterGetNPC(152))
        --DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013023))  -- "아카데미... 참 탐나는 땅이란 말이야..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(152)
    end

    if OnClickQuestTab(TownCharacterGetNPC(152)) then
        --DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013023))  -- "아카데미... 참 탐나는 땅이란 말이야..."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning()  then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(152))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(152))
        TownCharacterSetQuest(TownCharacterGetNPC(152))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(152)) then
        PreLoad()

        ScriptTownMoveToTownSquare(TownCharacterGetNPC(152))
        --DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013023))  -- "아카데미... 참 탐나는 땅이란 말이야..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(152)
    end

    if OnClickQuestTab(TownCharacterGetNPC(152)) then
        --DialogOpen(152, STR_NPC(152), "Characters/npc_005", STR_QUEST_TEXT(820013023))  -- "아카데미... 참 탐나는 땅이란 말이야..."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(133), -1*40, 27*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        ScriptTownMoveToTownSquare(TownCharacterGetNPC(133))
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end

-- PRELOAD_END

-- 퀘스트 다시하기
if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(152))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(152))
    TownCharacterSetQuest(TownCharacterGetNPC(152))

    ScriptTownMoveToTownSquare(TownCharacterGetNPC(152))
    PushPopupTownNpcWithSelectBox(152)
end
