-- 너와 나의 시너지(820019)
-- version("0.61.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520013)  -- 군무 제작 기능을 열어줌 : 위치 편집, 인원수/촬영범위 선택/확대 기능 포함
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019001))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
end



local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(111)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019002))  -- "앗! 또 뵙네요! 아무래도 우리는 인연이 깊은 모양이에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019003))  -- "마침 {highlight}{bold}여럿이 추는 춤{/bold}{/highlight}을 처음으로 만들어보려던 차인데 좀 도와주세요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019004))  -- "아, [유저의 닉네임] 님도 아직 혼자 추는 춤 밖에 안 만들어보셨다구요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019005))  -- "그럼 더 잘됐네요! [유저의 닉네임] 님과 처음을 함께 하는 영광을 누릴 수 있게 되다니!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019006))  -- "그럼, 감각적인 작품이 가득한 제 춤 목록 화면으로 한 번 가볼까요?"
    
    PushSceneDanceList("[612147, 612148, 612151]")  --유저의 데이터를 사용하지 않는 인상 좋은 청년의 춤 목록 화면으로 전환, 춤은 저퀄의 혼자 추는 춤 3개
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019007))  -- "어때요? [유저의 닉네임] 님 만큼은 아니지만 동작 하나하나가 느낌 있죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019008))  -- "우리가 함께 만들면 아마 훨씬 더 어마어마한 작품이 나오지 않을까요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019009))  -- "아까운 시간을 낭비하지 말고 어서 {highlight}{bold}군무{/bold}{/highlight}를 만들러 가보자구요!"
    
    ::jmp_btn_add::
    RequireButtonWithCCB("UI_common/ui_btn2_004_02", "btn_add")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019010))  -- "{highlight}{bold}추가{/bold}{/highlight} 버튼을 눌러보시겠어요?"
        goto jmp_btn_add
    end

    -- 춤 제작/잇기 선택
    ::jmp_btnAllowEdit::
    RequireButtonWithCCB("UI_dance/ui_dance_mode_select", "dv_button_make")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnAllowEdit
    end
    
    --인원 설정하는 화면으로
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019011))  -- "음... 여긴 {highlight}{bold}몇 명이 출 건지{/bold}{/highlight} 정하는 화면인가봐요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019012))  -- "여기에서 {highlight}{bold}2명 이상{/bold}{/highlight}을 선택하면 {highlight}{bold}군무{/bold}{/highlight}가 되겠네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019013))  -- "우리 둘 다 군무는 처음이니 먼저 {highlight}{bold}2명{/bold}{/highlight}이서 만드는 춤을 한 번 만들어 볼까요?"
    
    ::jmp_btnCount2::  --2명 선택 유도
    RequireButton("btnCount2")  --2명 선택 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019014))  -- "{highlight}{bold}2명{/bold}{/highlight}이서 추는 {highlight}{bold}군무{/bold}{/highlight}를 한 번 만들어 보자구요."
        goto jmp_btnCount2  --2명 선택 유도
    end
    
    ::jmp_btnCountNext::
    RequireButtonWithCCB("UI_common/ui_btn2_008_01", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019014))  -- "{highlight}{bold}2명{/bold}{/highlight}이서 추는 {highlight}{bold}군무{/bold}{/highlight}를 한 번 만들어 보자구요."
        goto jmp_btnCountNext
    end
    
      --촬영 범위 선택 화면으로
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019015))  -- "이번에는 {highlight}{bold}촬영 범위{/bold}{/highlight}를 설정하는 화면이네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019016))  -- "얼마나 공간을 넓게 쓸 건지를 결정해야겠네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019017))  -- "여럿이서 춤을 추면 많은 자리를 차지하기도 하고, 이동할 공간도 필요할테니까요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019018))  -- "무난하게 보통의 촬영 범위로 선택 할까요?"

    ::jmp_btnCamera2::  --보통 범위 선택 유도
    RequireButton("btnCamera2")  --보통 범위 선택 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019019))  -- "군무에서는 공간을 잘 활용하는 게 중요한가봐요."
        goto jmp_btnCamera2  --보통 범위 선택 유도
    end

    ::jmp_btnCameraNext::
    RequireButtonWithCCB("UI_common/ui_btn2_008_01", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019019))  -- "군무에서는 공간을 잘 활용하는 게 중요한가봐요."
        goto jmp_btnCameraNext
    end
    
      --제목 정하는 화면으로
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019020))  -- "춤의 {highlight}{bold}제목{/bold}{/highlight}을 지을 차례네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019021))  -- "[유저의 닉네임] 님께서 멋진 걸로 하나 지어주세요!"
    OpenKeyboard()

    DescriptionBarShow(STR_QUEST_TEXT(820019022))  -- "제목을 입력하고 [완료] 버튼을 눌러주세요."
    
    UIHide("btnBackScene")  --뒤로 가기 버튼 감추기
    
    --유저가 제목을 입력하고 [완료] 버튼을 누르면 아래의 스크립트 진행
    --동선 그리기, 회전 조절점, 늘이기, 두배, 춤기술 감추기
    RequireSceneDanceNameNext()  -- RequireCreateDance() -- 내춤을 만드는것과는 다름

    UIHideWithCCB("UI_dance/ui_dance_02", "btn_backward")  -- 뒤로가기 감추기
    -- UIHide("btnUndo")
    -- UIHide("btnRedo")
    -- UIHide("btnHelp")
    
    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")

    -- 하단 확장 버튼 보이지 않게
    OffDanceMoveOffExpendButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019023))  -- "이제 본격적으로 춤을 만들 차례예요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019024))  -- "이전과는 다르게 프레임이 두 종류가 있네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019025))  -- "우리에게 익숙한, 인형의 자세를 만들어 넣는 프레임은 아래쪽이군요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019026))  -- "먼저 제가 왼쪽 인형의 자세를 만들어 넣어 볼게요!"

    Wait(1)
      -- SceneDanceFramePaste(붙여넣어질 프레임 번호, 붙여넣을 군무 데이터 번호, 붙여넣을 프레임 번호, 붙여넣을 춤 번호)
    SceneDanceSelectFrame(1, 1)
    Wait(0.5)
    SceneDancePasteFrame(1, 612043, 1, 0)  --네 개의 자세 프레임을 미리 지정해둔 자세들로 채움
    Wait(1)
    SceneDanceSelectFrame(2, 1)
    Wait(0.5)
    SceneDancePasteFrame(2, 612043, 2, 0)  --네 개의 자세 프레임을 미리 지정해둔 자세들로 채움
    Wait(1)
    SceneDanceSelectFrame(3, 1)
    Wait(0.5)
    SceneDancePasteFrame(3, 612043, 3, 0)  --네 개의 자세 프레임을 미리 지정해둔 자세들로 채움
    Wait(1)
    SceneDanceSelectFrame(4, 1)
    Wait(0.5)
    SceneDancePasteFrame(4, 612043, 4, 0)  --네 개의 자세 프레임을 미리 지정해둔 자세들로 채움
    Wait(1)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019027))  -- "어떤 모습일지 {highlight}{bold}▶{/bold}{/highlight}버튼을 눌러볼까요?"
    
      -- 재생 버튼 유도
    ::jmp_btnPlay1::  -- 재생 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause") -- 재생 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019027))  -- "어떤 모습일지 {highlight}{bold}▶{/bold}{/highlight}버튼을 눌러볼까요?"
        goto jmp_btnPlay1  -- 재생 버튼 누르도록 유도
    end
    Wait(3)
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019028))  -- "어때요? 제가 만든 자세들을 보니 막 영감이 떠오르시나요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019029))  -- "그럼 다른 인형의 자세는 [유저의 닉네임] 님께서 한번 만들어보시겠어요?"
    
      -- 일시정지 버튼 유도
    ::jmp_btnStop1::  -- 일시정지 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  -- 일시정지 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019030))  -- "다른 인형의 자세는 [유저의 닉네임] 님께서 한번 만들어보시겠어요?"
        goto jmp_btnStop1  -- 일시정지 버튼 누르도록 유도
    end

    -- 위치편집 첫번째 프레임 버튼 유도
    ::jmp_frmPos1::  -- 위치편집 첫번째 프레임 버튼 누르도록 유도
    RequireButton("frmPos1")  -- 위치편집 첫번째 프레임 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019030))  -- "다른 인형의 자세는 [유저의 닉네임] 님께서 한번 만들어보시겠어요?"
        goto jmp_frmPos1  -- 위치편집 첫번째 프레임 버튼 누르도록 유도
    end

    ::jmp_charPos2::  -- 자세가 초기모습 그대로인 인형 누르도록 유도
    RequireTouchUI("charPos2")  --자세가 초기모습 그대로인 인형 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019030))  -- "다른 인형의 자세는 [유저의 닉네임] 님께서 한번 만들어보시겠어요?"
        goto jmp_charPos2  --자세가 초기모습 그대로인 인형 누르도록 유도
    end

    -- 두번째 춤 선택
    SceneDanceSelectDance(2)

    -- 자세편집 첫번째 프레임 버튼 유도
    ::jmp_frmMotion1::  -- 자세편집 첫번째 프레임 버튼 누르도록 유도
    RequireButton("uiFrame1")  -- 자세편집 첫번째 프레임 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019030))  -- "다른 인형의 자세는 [유저의 닉네임] 님께서 한번 만들어보시겠어요?"
        goto jmp_frmMotion1  -- 자세편집 첫번째 프레임 버튼 누르도록 유도
    end

    DescriptionBarShow(STR_QUEST_TEXT(820019031))  -- "선택한 인형의 자세를 만들고 ▶버튼을 누르세요."
    UISetEnableMotionEditOnly() -- 다른 인형, 위치 프레임은 선택 불가

    SceneDanceMoveMoveCountReset()
    ::jmp_btnPlay2::
    RequireSceneDanceMovePlay(2)
    if RequireCheckResult("LackOfMove") then  --현재 선택한 인형의 자세 프레임 중 2개 이상 자세를 편집하지 않은 상태에서 ▶버튼을 누르면
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019032))  -- "{highlight}{bold}두 개{/bold}{/highlight} 프레임 정도는 자세를 바꿔줘야 춤 같이 보이지 않을까요?"
        goto jmp_btnPlay2
    end
    Wait(3)

    DescriptionBarHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019033))  -- "와, 여러 명이 같이 춤을 춘다는 게 이런 느낌이군요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019034))  -- "우리가 만든 춤이 서로 은근히 어울리는 것 같지 않아요?... 아니면 말구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019035))  -- "그런데 공간이 넓어서 그런지 제자리에 서서 춤을 추는 게 좀 심심해 보이네요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019036))  -- "음.. 위쪽에 있는 프레임을 자세히 보니 춤 추는 {highlight}{bold}인형들의 위치{/bold}{/highlight}가 표시되어 있어요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019037))  -- "이걸 이용해서 {highlight}{bold}동선{/bold}{/highlight}을 만들 수 있지 않을까요?"

    -- 일시정지 버튼 유도
    ::jmp_btnStop2::  -- 일시정지 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  -- 일시정지 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019037))  -- "이걸 이용해서 {highlight}{bold}동선{/bold}{/highlight}을 만들 수 있지 않을까요?"
        goto jmp_btnStop2  -- 일시정지 버튼 누르도록 유도
    end

    UIUnsetEnableMotionEditOnly() -- 다른 인형, 위치 프레임은 선택 불가 해제

    -- 위치 프레임 전체를 감싸는 긴 박스 깜빡임
    -- 하단 프레임 목록 표시, 안내신호 표시
    -- UIShow("uiFrames")
    -- UISignalShow("uiFrames")
    UISignalShowEx("frmPos1", "frmPos4")
    Wait(2)
    UISignalHide()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019038))  -- "각 프레임에 설정한 위치로 인형들이 이동하나봐요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019039))  -- "위치 프레임 중 하나를 선택한 다음에.."
    
    ::jmp_frame2::  --두번째 위치 프레임 선택 유도
    RequireButton("frmPos2")  --두번째 위치 프레임 선택 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019040))  -- "위치 프레임 중 하나를 선택해보시겠어요?"
        goto jmp_frame2  --두번째 위치 프레임 선택 유도
    end
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019041))  -- "인형의 위치를 슬쩍 이동시키고"

    DescriptionBarShow(STR_QUEST_TEXT(820019042))  -- 1001145  -- "손가락을 화면에 댄 채로 끌어보세요."
      -- 진행조건 : 조절점 드래그
    RequireDragFromTo(-200, 0, -350, 0)  --현재 선택되어 있는 인형을 손가락으로 드래그해 위로 옮기도록 유도
    DescriptionBarHide()
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019043))  -- "{highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러보면..."
    
    ::jmp_btnPlay3::  --[플레이] 버튼 누르기 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  --[플레이] 버튼 누르기 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019043))  -- "{highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러보면..."
        goto jmp_btnPlay3  --[플레이] 버튼 누르기 유도
    end
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019044))  -- "오! 지정한 위치로 이동하네요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019045))  -- "이렇게 각각의 인형마다 동선을 만들면 되는 거군요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019046))  -- "다른 크루들과 동작과 동선을 맞춰서 일사분란하게 춤을 출 때의 그 시너지! 상상이 되시죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019047))  -- "그럼 다른 프레임의 인형 위치들도 바꿔볼까요?"

    -- 일시정지 버튼 유도
    ::jmp_btnStop3::  -- 일시정지 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  -- 일시정지 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019047))  -- "그럼 다른 프레임의 인형 위치들도 바꿔볼까요?"
        goto jmp_btnStop3  -- 일시정지 버튼 누르도록 유도
    end

    DescriptionBarShow(STR_QUEST_TEXT(820019048))  -- "인형의 위치를 옮겨 동선을 만들고 [▶] 버튼을!"
    UISetEnablePositionEditOnly() -- 다른 인형, 자세 프레임은 선택 불가

    SceneDanceMoveMoveCountReset()
    ::jmp_btnPlay4::  --위치 이동 튜토리얼
    RequireSceneDanceMovePlay(2)  --위치 이동 튜토리얼
    if RequireCheckResult("LackOfMove") then  --2개의 위치 프레임 이상 인형 위치를 이동하지 않은 상태에서 ▶버튼을 누르면
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019049))  -- "{highlight}{bold}두 개{/bold}{/highlight} 프레임 정도는 위치를 바꿔줘야 동선같아 보이지 않을까요?"
        goto jmp_btnPlay4
    end
    Wait(3)

    DescriptionBarHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019050))  -- "오오 그렇군요! 이런 식으로 움직이니 그냥 제자리에 있을 때와는 확실히 느낌이 다르네요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019051))  -- "이 춤은 우리가 같이 만든 거니까 같이 써야겠죠? [유저의 닉네임] 님의 우편으로 보내드릴게요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019052))  -- "[유저의 닉네임]과 함께 춤을 만들고 공유하다니... 정말 꿈을 꾸는 것 같아요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019053))  -- "이 감동이 사라지기 전에 얼른 다른 군무를 만들어봐야겠어요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019054))  -- "[유저의 닉네임] 님께서 어떤 군무를 만드실지도 무척 기대가 되고 말이죠!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "분명 예술혼을 듬뿍 담은 작품들일 테니 미리 배워갈 준비를 해둘게요."
    
      -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[너와 나의 시너지] 퀘스트 완료"
      -- 퀘스트 시작/완료/보상
      --튜토리얼을 통해 만들어진 춤을 우편함으로 전달
      --춤은 바로 쓸 수 있는 완성된 춤이고, 유저가 수정 가능

    QuestComplete()
    QuestReward()
    
    GoTown()
end

-- PRELOAD_BEGIN

-- 인상 좋은 청년 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()

        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()

        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()

        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019055))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end


-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(111))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
    TownCharacterSetQuest(TownCharacterGetNPC(111))
    ScriptTownMoveToSide(TownCharacterGetNPC(111))
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820019001))  -- "춤은 여럿이 같이 추면 더 멋있답니다."
    PushPopupTownNpcWithSelectBox(111)
end
