-- 친해지면 닮아간다.(820024) -- 일반형 퀘스트
-- version("0.36.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520016) -- NPC호감도 관리 기능을 열어줌
    UnlockContents(520031) -- 미용실 
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024001))  -- "서로 친해져서 나쁠 건 없잖아요?"
end

local function textQuestReplay()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024001))  -- "서로 친해져서 나쁠 건 없잖아요?"
end 

-- PRELOAD_BEGIN


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(111)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024002))  -- "앗 여긴 어쩐 일이세요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024003))  -- "설마 절 만나러 일부러 여기까지? 감동이에요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024004))  -- "...혹시 그냥 지나가다가 마주친 거라도 아무 말씀 말아주세요. 지금 이 감동을 놓치고 싶지 않으니까요."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_sweat")
    Wait(1.5)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024005))  -- "[유저의 닉네임] 님 같은 유명한 춤꾼과 친해진 것 같아 가슴이 벅차요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024006))  -- "댄스빌의 다른 춤꾼들과도 두루두루 친하게 지내세요. 그럼 아주 좋은 점이 있답니다!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024007))  -- "본래 여기 춤꾼들은 개성도 강하고 자존심도 세서 뭔가를 공유하길 꺼려해요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024008))  -- "하지만 자신과 {highlight}{bold}가장 친한 춤꾼{/bold}{/highlight}에게라면 이야기가 달라지죠!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024009))  -- "이를테면 자신만의 {highlight}{bold}헤어 스타일{/bold}{/highlight}이나 {highlight}{bold}패션{/bold}{/highlight}의 비법을 공유하는 거에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024010))  -- "어떤 춤꾼과 아주아주 친해졌다면, {highlight}{bold}미용실{/bold}{/highlight}에 가보세요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024011))  -- "그 춤꾼만의 비법을 활용한 머리 모양을 직접 해볼 수 있을 테니까요."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_haha")
    Wait(1.5)
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024012))  -- "춤꾼들과 어떻게 친해지냐구요?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024013))  -- "간단해요. 뭔가 할 말이 있어보이는 춤꾼이 있으면 말을 걸어보시는 거에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024014))  -- "이를 테면 저한테 이렇게 말을 걸어주셔서 제가 감동을 받은 것처럼 말이죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024015))  -- "전 이미 [유저의 닉네임] 님에게 마음을 활짝 열었으니, 제 비법을 전수해드릴게요."
    
    -- 아래의 팝업창 등장
    -- "[인상 좋은 청년] 춤꾼과 둘도 없는 사이가 되었어요!"
    -- "미용실에서 [인상 좋은 청년] 춤꾼의 비법이 담긴 머리 모양을 이용하실 수 있어요!"
    PushPopupFollowerCommunicateResultMax(111)

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024016))  -- "그럼 미용실에서 직접 한 번 보실까요?"

    -- 미용실 원장 NPC가 화면의 중앙에 오도록 화면 이동
    TownCharacterShow(TownCharacterGetNPC(145))
    TownCameraZoomIn(TownCharacterGetNPC(145), 0, 50, 2)
    Wait(1)

    -- 미용실 원장 NPC에 손가락으로 누르기 유도
    ::jmp_click1::
    RequireSceneTownCharacterClick(TownCharacterGetNPC(145))
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024017))  -- "제가 미용실 원장 님께 제 머리의 비법을 미리 일러놨답니다."
        goto jmp_click1
    end

    ScriptTownMoveToBeauty(TownCharacterGetNPC(145), TownCharacterGetUser())
    PushPopupTownBeauty(145)

    ::jmp_btn_shop_hair::
    RequireButtonWithCCB("UI_common/ui_btn2_012_03", "btn_shop_hair")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024017))  -- "제가 미용실 원장 님께 제 머리의 비법을 미리 일러놨답니다."
        goto jmp_btn_shop_hair
    end

    -- 미용실 화면으로 전환, 인상 좋은 청년의 머리 모양 목록이 중심이 되도록 목록 이동
    SceneShopLikeabilityBeautyAddItem( 111) -- 호감도 아이템 109152

    ::jmp_scene::
    RequireCurrentSceneName("SceneShopBeauty")
    if RequireCheckResult("check_scene") then
        goto jmp_scene
    end
    
    -- 인상 좋은 청년의 머리 모양 목록에 영역/화살표
    UIListScrollTo("uiItemList3", "btnItem109152")
    UISignalShow("btnItem109152")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024018))  -- "제 머리랑 똑같은 스타일의 머리가 보이죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024019))  -- "이제 저처럼 멋들어진 머리를 하실 수 있게 된 거예요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024020))  -- "그리고 [유저의 닉네임]님께 {highlight}{bold}선물{/bold}{/highlight}도 하나 보내놨으니까 {highlight}{bold}우편함{/bold}{/highlight} 꼭 확인해보세요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024021))  -- "[유저의 닉네임] 님을 향한 저의 마음이 아주 잘 드러나는 선물일 거에요!"
    UISignalHide()

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[친해지면 닮아간다.] 퀘스트 완료"

    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()
end


-- 인상 좋은 청년 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(111))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(111))
        TownCharacterSetQuest(TownCharacterGetNPC(111))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(111)) then
        PreLoad()
        UnlockQuestContents()
        ScriptTownMoveToSide(TownCharacterGetNPC(111))
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(111)
    end

    if OnClickQuestTab(TownCharacterGetNPC(111)) then
        --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(111))
    ScriptTownMoveToSide(TownCharacterGetNPC(111))
    --DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820024024))  -- "서로 친해져서 나쁠 건 없잖아요?"
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(111)
end
