-- 카트라슈의 콧수염(820034) -- 진행형 퀘스트
-- version("0.37.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520002)  -- 아카데미 관련 기능을 열어줌
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
    UnlockContents(520009)  -- 장애물 제거 관련 기능을 열어줌
    UnlockContents(520010)  -- 춤/음악 배우기 관련 기능을 열어줌
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520012)  -- 춤꾼 영입 기능을 열어줌
    UnlockContents(520013)  -- 군무 제작 기능을 열어줌
    UnlockContents(520015)  -- 명예 상점 기능을 열어줌
    UnlockContents(520016)  -- NPC호감도 관리 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034001))  -- "카바 씨의 콧수염 한 가닥 한 가닥에 숨은 사연들을 알앙?"
end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034001))  -- "카바 씨의 콧수염 한 가닥 한 가닥에 숨은 사연들을 알앙?"
end 


local function ScriptOnQuestAppear()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(162)

		-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034002))  -- "오홍. 내가 부르는 소리를 들었구낭?"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034003))  -- "난 댄스빌 {highlight}{bold}콧수염 동호회 회장{/bold}{/highlight}이양."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034004))  -- "{highlight}{bold}카바{/bold}{/highlight} 씨가 우리 동호회의 콧수염 마스터 중 한 명이라 [nickname] 씨 이야기를 많이 들었엉."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034005))  -- "{highlight}{bold}카바{/bold}{/highlight} 씨랑 같은 집에 산다궁?"

    TownCharacterActionByID( TownCharacterGetNPC(162), 612893)
    AnimationAdd("som", "Characters/Event_som")
    AnimationSetPosWithTownCharacter("som", TownCharacterGetNPC(162), 0, 50)
    AnimationPlay("som")
    Wait(1)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034006))  -- "그럼 이걸 {highlight}{bold}카바{/bold}{/highlight} 씨에게 좀 전해줄 수 있겠엉?"
    AnimationRemove("som")
    TownCharacterActionByID( TownCharacterGetNPC(162), 612150)

    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034007))  -- "{highlight}{bold}카바{/bold}{/highlight} 씨가 아끼는 {highlight}{bold}보라색 콧수염 모양 조각{/bold}{/highlight}인뎅 여기에 놓고 갔더라궁."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034008))  -- "뭔가 사연이 있는 물건 같아 보였는뎅... 자세한 건 나도 몰랑."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034009))  -- "아항... {highlight}{bold}카바{/bold}{/highlight} 씨의 콧수염은 언제 봐도 아름답지 않앙?"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034010))  -- "어떻게 콧수염 관리를 그리 잘 할 수 있는 걸깡?"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034011))  -- "나중에 {highlight}{bold}카바{/bold}{/highlight} 씨가 콧수염을 어떻게 관리하는지 슬쩍 보고 좀 알려줭. 알겠징?"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034012))  -- "그리고 혹시 우리 동호회에 가입하고 싶으면 언제든지 찾아오라궁."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034013))  -- "단, 콧수염을 기르고 나성! 오호홍."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034014))  -- "그럼 그 물건 잘 좀 부탁할겡. 꼭 {highlight}{bold}카바{/bold}{/highlight} 씨한테 전달해줭."
    Wait(0.5)

    QuestStart()
    GoTown()
end


local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

	-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034015))  -- "아아... 자네구만..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(820034016))  -- "난 이미 틀렸다네... 내 분신과 같은 물건을 잃어버리고 말았어..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(820034017))  -- "나 같이 철저한 사람이 그렇게 소중한 걸 어디다 두고 오거나 할 리는 없고..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(820034018))  -- "누군가 그 아름다운 자태가 탐 나서 도둑질한 게 틀림없어!"

    TownCharacterActionByID( TownCharacterGetUser(), 612893)
    AnimationAdd("som", "Characters/Event_som")
    AnimationSetPosWithTownCharacter("som", TownCharacterGetUser(), 0, 50)
    AnimationPlay("som")
    Wait(1)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(820034019))  -- "아아... 음... 음...? 잠깐 자네 손에 든 그건..."
    AnimationRemove("som")
    TownCharacterActionByID( TownCharacterGetUser(), 612020)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(820034020))  -- "내 {highlight}{bold}콧수염의 혼신{/bold}{/highlight}!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(820034021))  -- "설마... 설마 자네가 내 {highlight}{bold}콧수염의 혼신{/bold}{/highlight}을..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(820034022))  -- "음? 뭐라고? {highlight}{bold}콧수염 동호회 회장{/bold}{/highlight}님이 부탁을...?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(820034023))  -- "하하하. 그럼 그렇지! 자네가 그런 짓을 할 리가 없지! 난 처음부터 굳게 믿고 있었다네!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(820034024))  -- "아까는...음... '설마 자네가 내 {highlight}{bold}콧수염의 혼신{/bold}{/highlight}을 찾아올 줄이야!'라고 말하려던 차였어."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_silly")
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820034025))  -- "아무튼 고맙네. 이게 나에게 얼마나 소중한 녀석인지 모를 거야."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(820034026))  -- "이야기는 아주 멀고 먼 옛날까지 거슬러 올라간다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034027))  -- "내 할아버지의 할아버지의 할아버지보다도 더 먼 조상님들께서 사실 때는 지금처럼 댄스빌의 모든 사람이 춤을 춘 건 아니었다고 해."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034028))  -- "그런 시절에 춤을 너무 사랑해서 일생을 춤에 바친 한 조상님이 계셨지."
    -- 그림자 모양의 캐릭터 하나가 춤을 추다가 멈추면, 그 주위에 있던 다른 그림자가 깜짝 놀라며 머리 위에 느낌표가 뜨는 이미지 등장
    AnimationAdd("event_memory_09", "Characters/event_memory_09")
    AnimationSetFullScreen("event_memory_09")
    AnimationPlay( "event_memory_09")
    Wait(3.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034029))  -- "그분은 {highlight}{bold}춤이 곧 말이요, 말이 곧 춤인 경지{/bold}{/highlight}를 이룩하셨어."
    -- 앞에 등장했던 이미지 사라짐
    AnimationRemove( "event_memory_09")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034030))  -- "그리고 항상 그 분의 옆을 지키며 춤을 나눈 존재가 있었어."
    -- 카트라슈와 동일한 모양이지만 위엄이 느껴지는 댄시코기의 이미지를 검은 색으로 씌운 이미지 등장
    AnimationAdd("event_memory_10_01", "Characters/event_memory_10_01")
    AnimationSetFullScreen("event_memory_10_01")
    AnimationPlay( "event_memory_10_01")
    Wait(1.5)


    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034031))  -- "{highlight}{bold}댄시코기{/bold}{/highlight}라는 종의 개 한 마리. 그 이름은 알려지지 않았지만."
    -- 앞에 등장했던 이미지의 검은 색 처리가 없어지며 원래의 모습으로 바뀜
    AnimationRemove( "event_memory_10_01")

    AnimationAdd("event_memory_10_02", "Characters/event_memory_10_02")
    AnimationSetFullScreen("event_memory_10_02")
    AnimationPlay( "event_memory_10_02")
    Wait(2.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034032))  -- "{highlight}{bold}댄시코기{/bold}{/highlight}로 말할 것 같으면 태생적으로 흥이 많고 리듬감이 뛰어난 데다가 짧은 다리에 신비로운 보랏빛, 완벽한 콧수염까지!"
    -- 앞에 등장했던 이미지 사라짐
    AnimationRemove( "event_memory_10_02")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(820034033))  -- "춤에 특화된 인물의 반려 동물로 완벽하지 않나?"
    -- 콧수염의 혼신이 반짝이는 이미지 등장
    AnimationAdd("event_memory_11", "Characters/event_memory_11")
    AnimationSetFullScreen("event_memory_11")
    AnimationPlay( "event_memory_11")
    Wait(3.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034034))  -- "그 조상님께서도 {highlight}{bold}댄시코기{/bold}{/highlight}의 완벽함에 반한 나머지 어렵게 구한 보랏빛 돌을 콧수염 모양으로 조각해 이 {highlight}{bold}콧수염의 혼신{/bold}{/highlight}을 만드셨고..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034035))  -- "춤을 가장 잘 추는 후손들에게 대대로 이어져 나에게까지 온 거야."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034036))  -- "이 {highlight}{bold}콧수염의 혼신{/bold}{/highlight}은 우리 가문의 춤에 대한 자부심 그 자체!"
    -- 앞에 등장했던 이미지 사라짐
    AnimationRemove( "event_memory_11")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820034037))  -- "내가 왜 콧수염과 보라색을 좋아하는지도 알만하지?"
    -- 위엄이 느껴지는 앞의 댄시코기와 모양은 같지만 허술하고 우스꽝스러움이 가득한 카트라슈의 이미지 등장
    AnimationAdd("event_memory_12", "Characters/event_memory_12")
    AnimationSetFullScreen("event_memory_12")
    AnimationPlay( "event_memory_12")
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034038))  -- "아마 벌써 눈치챘겠지만 {highlight}{bold}카트라슈{/bold}{/highlight}는 그 {highlight}{bold}댄시코기의 후예{/bold}{/highlight}라네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(820034039))  -- "{highlight}{bold}카트라슈{/bold}{/highlight}는 그 대단한 혈통에 비해 춤에 소질은 없는 것 같지만... 허허."
    -- 앞에 등장했던 이미지 사라짐
    AnimationRemove( "event_memory_12")

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820034040))  -- "뭐... 그래서 결론은... 자네가 아주 큰 일을 해줬다는 걸세!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820034041))  -- "내 이 은혜는 절대로 잊지 않겠네."
    Wait(0.5)

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[카트라슈의 콧수염] 퀘스트 완료"

    QuestComplete()
end


local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN

-- 콧수염 동호회 회장 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        --DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034041))  -- "카바 씨의 콧수염 한 가닥 한 가닥에 숨은 사연들을 알앙?"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(162)
    end

    if OnClickQuestTab(TownCharacterGetNPC(162)) then
        --DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034041))  -- "카바 씨의 콧수염 한 가닥 한 가닥에 숨은 사연들을 알앙?"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then
    -- 콧수염 동호회 회장은 사라지고, 카바 머리 위에 스토리 진행 아이콘
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(101))
        TownCharacterSetIcon(TownCharacterGetNPC(101), "Scenario_Available")
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
        ScriptOnQuestComplete()
    end

elseif CheckQuestComplete() then
    -- 콧수염 동호회 회장은 사라지고, 카바 머리 위에 스토리 진행 아이콘
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(101))
        TownCharacterSetIcon(TownCharacterGetNPC(101), "Scenario_Available")
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(162))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
    TownCharacterSetQuest(TownCharacterGetNPC(162))

    ScriptTownMoveToSide(TownCharacterGetNPC(162))
    --DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(820034041))  -- "카바 씨의 콧수염 한 가닥 한 가닥에 숨은 사연들을 알앙?"
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(162)
end
