-- 뻣뻣한 춤은 이제 그만(820045) -- 일반형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()

    if CheckQuestManagerDummy() then
        return true
    end

    if not CheckHasLicence(710240) then
        PushPopupConfirm(STR_QUEST_TEXT(820045001))  -- "요원에게서 [기울기 조절] 자격증을 획득해야 진행할 수 있는 퀘스트에요."

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045002))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"

end

local function textQuestReplay()
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045002))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
end 




local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045003))  -- "안녕하세요! 오랜만이에요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045004))  -- "꽤 규모가 있는 심부름 계약을 하나 마무리하고 오는 길이에요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045005))  -- "절 찾는 사람들이 많아서 사업 확장을 고민 중일 정도라니까요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045006))  -- "하지만 잘 될 수록 방심은 금물! 더욱더 서비스를 확실하게 해서 자리를 잡아야죠!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045007))  -- "그래서! 제가 바로 이 자리에 온 거에요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045008))  -- "[유저의 닉네임] 님께 양질의 사후 서비스를 제공해드리기 위해서이죠!"
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_haha")
    Wait(1.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045009))  -- "최근에 쥬오와의 격렬한 댄스 게임을 치르셨던데..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045010))  -- "그 때 [유저의 닉네임] 님의 움직임을 분석해 보니, {highlight}{bold}기울기 조절점{/bold}{/highlight}을 활용한 유연한 동작을 익힐 때가 되셨더라구요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045011))  -- "서비스 차원에서 제가 사용법을 가르쳐 드릴게요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045012))  -- "카트라슈로 변장을 했는데 [유저의 닉네임] 님 인 줄 어떻게 알았냐구요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045013))  -- "그 따위 변장으로 누굴 속일 수 있을리가... 아, 내가 고객님께 무슨 소리를..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045014))  -- "고객의 동향을 파악하기 위해 제 눈과 귀가 될만한 친구들을 여기저기 풀어놨거든요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045015))  -- "걱정 마세요. 고객의 비밀은 심부름꾼으로서의 명예를 걸고 지켜드리니까요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045016))  -- "자, 그러면 지금부터 본격적으로 사후 서비스 들어갑니다."
    
      --몸이 뻣뻣한 아이 자세 교정 미션과 유사한 형태의 자세 편집 화면 등장
    --총 4프레임이고, 인형은 모두 가만히 서있는 상태
    PushSceneDanceMoveWithID(0)
    -- 첫번째 모션 편집 프레임이 선택 되어있는 상태
    SceneDanceSelectFrame(1, 1);
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045017))  -- "일단 익숙해 보일 거에요. 하지만 자세히 들여다보시면!"

    UISignalShow("cpHeadRot")  --머리 회전 조절점에 빨간 박스
    UISignalShow("cpBodyRot")  --몸통 회전 조절점에 빨간 박스
    Wait(2)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045018))  -- "조절점들 중에 {highlight}{bold}파란 점 두 개{/bold}{/highlight}가 슬쩍 자리 잡고 있죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045019))  -- "각각 {highlight}{bold}머리와 몸통의 기울기{/bold}{/highlight}를 조정할 수 있는 {highlight}{bold}기울기 조절점{/bold}{/highlight}이에요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045020))  -- "어떻게 사용하는 건지 잠깐 보여드릴까요?"
    UISignalHide()
    
    ::jmp_cpHead::  --머리 회전조절점 누르도록 유도
    RequireTouchUI("cpHeadRot")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045021))  -- "{highlight}{bold}머리{/bold}{/highlight}를 한번 기울여볼까요?"
        goto jmp_cpHead
    end
    
    SceneDanceMove_SelectCP("cpHeadRot")

    RequireDragFromTo(100, 0, 200, 0)  --머리 옆의 빈공간에서 손가락을 드래그하도록 유도(머리 기울이기 동작 유도)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045022))  -- "이제 {highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러보면..."
    ::jmp_btnPlay::  --[플레이] 버튼 누르기 유도
    RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_play_pause")  --[플레이] 버튼 누르기 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045022))  -- "이제 {highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러보면..."
        goto jmp_btnPlay  --[플레이] 버튼 누르기 유도
    end

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045023))  -- "히히히. 머리를 까닥까닥 하는 게 재미있지 않아요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045024))  -- "그리고 잘 생각해보세요. 댄스빌에 오시고 나서 한 번도 편히 누워서 쉰 적이 없었죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045025))  -- "왜냐! {highlight}{bold}기울기 조절점{/bold}{/highlight}이 없으면 눕는 자세를 취할 수가 없기 때문이죠! 큭큭"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045026))  -- "피곤하고 허리가 아프실 [유저의 닉네임] 님을 위해 편안히 누운 자세를 한 번 만들어볼까요?"
    
    RequireSceneDanceFollowForMainQuest(612392, 612591)  --가이드라인은 턱을 괴고 누워 다리를 까닥까닥 하는 춤(4프레임)
    DescriptionBarShow(STR_QUEST_TEXT(820045027))  -- "모든 프레임의 자세를 안내선과 같도록 교정하세요."
    RequireDanceFollow()
    DescriptionBarHide()
    Wait(0.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045028))  -- "아주 편안해 보이네요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045029))  -- "[유저의 닉네임] 님의 휴식을 위해서 이 춤은 {highlight}{bold}우편함{/bold}{/highlight}으로 보내드릴게요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045030))  -- "이제 {highlight}{bold}기울기 조절점{/bold}{/highlight} 사용법도 익히셨으니 이전보다 훨씬 더 다양하고 자연스러운 움직임을 만들 수 있을 거에요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045031))  -- "[유저의 닉네임] 님의 뮤비 수준이 한 단계 높아질 걸 생각하니 저까지 설레는데요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "그럼 오늘의 서비스는 여기까지! 다음에 또 뵐게요. 종종 찾아주세요!"
    Wait(0.5)

      -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[뻣뻣한 춤은 이제 그만] 퀘스트 완료"

      --퀘스트 내에서 제작한 춤을 우편으로 보냄
      --춤은 완성된 상태이고 유저가 수정할 있음
      -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

-- 과자가 제일 좋은 아이 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(113))
    ScriptTownMoveToSide(TownCharacterGetNPC(113))
    --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820045032))  -- "얼굴이랑 몸이 막막 이렇게 돌아가는 춤을 춰보고 싶죠?"
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(113)
end
