  -- 820049 고수처럼 움직이기  -- 일반형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520021) -- 동작 보완
    UnlockContents(520022) -- 배속 조절
end

local function CheckQuestStartReq()

    if CheckQuestManagerDummy() then
        return true
    end

    if not CheckHasLicence(710260) then
        PushPopupConfirm(STR_QUEST_TEXT(820049001))  -- "요원에게서 [동작보완] 자격증을 획득해야 진행할 수 있는 퀘스트에요."
        return false
    end

    if not CheckHasLicence(710270) then  --빠른동작 자격증도 선행조건에 추가
        PushPopupConfirm(STR_QUEST_TEXT(820049002))              -- "요원에게서 [빠른동작] 자격증을 획득해야 진행할 수 있는 퀘스트에요."
        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049003))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
end

local function textQuestReplay()

end 



local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(71) --=BGM=Character_Dancemasterbgm
    -- 퀘스트 인트로
    ScenarioIntroShow(158)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049004))  -- "자, 자, 뭘 그리 멍하니 섰어?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049005))  -- "춤의 고수가 되기 위한 가르침은 아직 끝나지 않았다고!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049006))  -- "내가 제자로 인정한 이상, 모든 걸 다 가르쳐주고 말 거니까 반항해도 소용없어."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049007))  -- "이번에 배울 건 말이지, 아주 섬세한 작업이야. {highlight}{bold}동작을 부드럽게{/bold}{/highlight} 만들어주거든."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049008))  -- "음.. 예시로 쓸 춤이 있어야 되는데... 내가 만든 건 너무 동작이 단순해서 좀..."

    TownCharacterStandAtCharacter(TownCharacterAddNPC(153), TownCharacterGetNPC(158), -10*40, 0*40)
    TownCharacterWalkToCharacter(TownCharacterGetNPC(153),TownCharacterGetNPC( 158), -4*40, 0*40)
    --춤바람 난 사내가 화면 왼쪽에서 걸어들어와 오른쪽으로 걸어간다.(두 캐릭터가 서 있는 위쪽에서)
    Wait(3)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049009))  -- "아, 마침 잘 됐군. 좀 이상한 녀석이긴 하지만 춤 실력은 괜찮으니."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049010))  -- "이 봐, 춤바람!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049011))  -- "아, 영감님이 여긴 웬일이에요? 그것도 [유저의 닉네임] 님이랑 같이?"
    
    TownCharacterWalkToCharacter(TownCharacterGetNPC(153),TownCharacterGetNPC( 158), -2*40, 0*40)  --재야의 춤선생 옆으로 이동
    Wait(2)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049012))  -- "[유저의 닉네임] 님. 설마.. 이 영감님한테서 춤을 배우는 거에요?"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049013))  -- "오호.. 영감님 능력도 좋으시네. 이렇게 뛰어난 제자도 생기고."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049014))  -- "내가 능력이 좋은 건 맞지만, 이 녀석에게 뛰어난 스승이 생겼다고 해야 맞는 말이지."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049015))  -- "뭐, 영감님이 춤에 미쳐있는 건 내가 충분히 인정하는 바이지만..."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049016))  -- "그렇게 춤을 못 추면서 {highlight}{bold}전설춤꾼{/bold}{/highlight}을 키워냈다는 뻥은 좀 심하다고 생각하지 않아요?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049017))  -- "네 녀석이 뭘 안다고 그래? 쓸데없는 소리 할 거면 저리 가!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049018))  -- "알겠어요. 뭐 실력이 중요하나. 춤에 대한 열정이 중요한 거지."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049019))  -- "이놈이 끝까지!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049020))  -- "글쎄, 알겠다니까요. 내가 잘못했어요. 그런데 전 왜 부른 거에요?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049021))  -- "못난 제자 놈 가르치는데 네 춤을 좀 써야겠다."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049022))  -- "[유저의 닉네임] 님 가르치는데 내 춤을? 그런 일이라면야 기꺼이 해드려야죠."
    
      -- 재생 중인 상태의 자세 편집 화면 등장, 최대 프레임은 8프레임으로 설정
      -- 총 4프레임이고, 고퀄이지만 동작이 다소 딱딱한 춤(동작 늘이기를 했을 때 움직임이 부드러워지는 것이 잘 보이도록, 춤기술은 쓰지 않음)
    
    PushSceneDanceMoveWithID(612054)

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049023))  -- "어때요? 조금 전에 만든 따끈따끈한 춤이라구요!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049024))  -- "이 정도 춤실력이라도 없었으면 내가 너 같은 놈을 상대라도 했겠어?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049025))  -- "자, 제자! 잘 봐두라고!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049026))  -- "이 춤바람 난 놈의 춤이 좀 딱딱한 감이 있지?"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049027))  -- "에이, 그건 실력이 부족해서 그런 게 아니라 그냥 의도적으로..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049028))  -- "내가 언제 네 놈 실력 가지고 뭐라고 했어? 그냥 이 춤에 딱딱한 감이 있다고만 했지!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049029))  -- "이 춤의 프레임 사이사이에 {highlight}{bold}중간 동작{/bold}{/highlight}을 넣으면 움직임이 부드러워질 텐데.."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049030))  -- "그걸 일일이 손으로 만들어 넣기에는 너무 귀찮잖아?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049031))  -- "그럴 때 바로 이 방법을 쓰는 거지!"

    UIListScrollLock("uiFrames", 1)
    RequireDragUI("uiFrame1", 0, 70)  --손가락이 등장, 첫 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 1)
    RequireDragUI("uiFrame4", 0, 70)  --손가락이 등장, 4번째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 1)
    SceneDanceSelectFrameMulti(4, 1)
    UIListScrollLock("uiFrames", 0)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049032))  -- "{highlight}{bold}동작을 부드럽게 만들고 싶은 구간{/bold}{/highlight}을 이렇게 선택한 다음에..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049033))  -- "{highlight}{bold}동작 늘이기{/bold}{/highlight} 버튼을 가볍게 눌러주는 거야!"

    SetSceneDanceFreeDoubling(1)

    UIShow("btnDoubling")
    ::jmp_btnDoubling::  --동작 늘이기 버튼 누르도록 유도
    RequireButton("btnDoubling")  --동작 늘이기 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049033))  -- "{highlight}{bold}동작 늘이기{/bold}{/highlight} 버튼을 가볍게 눌러주는 거야!"
        goto jmp_btnDoubling  --동작 늘이기 버튼 누르도록 유도
    end
    SetSceneDanceFreeDoubling(0)

    Wait(2.5)


    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049034))  -- "프레임 수가 두 배로 늘어났지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049035))  -- "원래 있던 자세들 사이사이에 그 중간 자세들이 들어간거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049036))  -- "그럼 춤이 어떻게 바뀌었는지 볼까."

    ::jmp_btnPlay::  --플레이 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  --플레이 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049037))  -- "자, {highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러 결과물을 확인해볼까?"
        goto jmp_btnPlay  --플레이 버튼을 누르도록 유도
    end
    Wait(1.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049038))  -- "동작이 확실히 부드러워진 게 보일 거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049039))  -- "전체 {highlight}{bold}프레임 수가 2배{/bold}{/highlight} 늘어나서 {highlight}{bold}춤추는 속도는 1/2{/bold}{/highlight}로 느려지긴 하지만 말이지."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049040))  -- "만약에 춤이 느려지는 게 싫다면, {highlight}{bold}X2{/bold}{/highlight} 버튼을 활용하면 간단히 해결할 수 있으니 걱정마."

    ::jmp_btnStop1::  --플레이(정지) 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  --플레이(정지) 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049041))  -- "춤이 1/2로 느려졌으니, 다시 2배로 빠르게 추면 되지 않겠어?"
        goto jmp_btnStop1  --플레이(정지) 버튼을 누르도록 유도
    end
    Wait(1.5)
        
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_speed")
    ::jmp_btnSpeed1::  --X2버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_speed")  --X2버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049041))  -- "춤이 1/2로 느려졌으니, 다시 2배로 빠르게 추면 되지 않겠어?"
        goto jmp_btnSpeed1  --X2버튼 누르도록 유도
    end

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049042))  -- "축축 처지던 춤이 제대로 살아났는지 볼까?"
        
    ::jmp_btnPlay1::  --플레이 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")   --플레이 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049042))  -- "축축 처지던 춤이 제대로 살아났는지 볼까?"
        goto jmp_btnPlay1  --플레이 버튼을 누르도록 유도
    end
    Wait(2)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049043))  -- "어때? 2배로 빨리 추니까 전의 춤 속도로 돌아온 게 보이지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049044))  -- "같은 춤이라도 고수라면 이렇게 움직임의 질을 팍팍 높여주는 게 필요한 거야. 꼭 기억하도록."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049045))  -- "아... 난 이렇게 부드러운 거 말고 남성미 팍팍 나는 춤이 좋은데... "
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049046))  -- "거, 사내 녀석이 말 참 많네. 내 수업 교재로 쓰였다는 것만으로도 영광인 줄 알아!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820049047))  -- "어이쿠! 이거 너무 영광이라 평생 이 춤은 지우지도 못 하겠네요!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049048))  -- "저 비아냥 거리는 것 좀 봐. 하여튼 요즘 젊은 것들이란..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "우리 제자님은 저런 몹쓸 놈이랑 어울리거나 하지 말고 내 신성한 가르침만 잘 따라와야 돼! 알았지?"
    Wait(0.5)
        
      -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[고수처럼 움직이기] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()
end

-- 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(158)) -- 대사가 없이 바로 이동
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(158)) -- 대사가 없이 바로 이동
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(158)) -- 대사가 없이 바로 이동
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820049049))  -- "동작을 좀 더 부드럽고 자연스럽게 만드는 법을 알아?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end
