-- 돌아선 뒷모습(820054)
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520024)  -- 뒤돌기 기능을 열어줌
    UnlockContents(520306)  -- 춤편집 배경 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054001))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
end

local function textQuestReplay()
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054001))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
end 


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    SceneTownSetStateEmpty()
    SoundPlay(71) --=BGM=Character_Dancemasterbgm
    ScenarioIntroShow(158)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054002))  -- "음... 역시 아주 뛰어난 춤 실력을 가졌다니까..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054003))  -- "나에게 조금만 가르침을 받는다면 높은 경지를 이룰 수 있겠어."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054004))  -- "수강료는 아주 양심적으로 받을 테니 너무 걱정 말고. 하하하."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_irritation")
    Wait(1.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054005))  -- "아, 그런데 말이지... 전부터 궁금한 게 있었는데..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054006))  -- "......"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054007))  -- "왜 앞을 보고 추는 춤만 만드는 거지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054008))  -- "마치 뒤로 돌 줄 모르는 것처럼 말이야."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054006))  -- "......"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054009))  -- "뭐야, 그 반응은... 정말 뒤로 돌 줄을 몰랐던 거야??"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054010))  -- "높은 수준의 춤은 잘 만들면서 뒤로 돌 줄은 몰랐다고?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054011))  -- "흠... 그럼 {highlight}{bold}뒤로 도는 법{/bold}{/highlight}만 익혀도 훨씬 다양한 동작을 만들어볼 수 있겠군"

    -- 춤 편집 화면으로
    --춤 편집 화면으로 전환(유저 데이터를 사용하지 않는 카바의 춤 편집 화면)
    --이미 4 프레임 길이의 조악한 춤이 완성된 상태
    PushSceneDanceMoveWithID(612035)

    -- 튜토리얼에 필요없는 UI감추기
    -- 이름 편집 커서 안나오게
    --UIHide("uiTextInput")

    -- UIHide("btnSpeed")
    -- UIHide("btnTurn")
    -- UIHide("btnDraw")
    -- UIHide("btnDoubling")
    -- UIHide("btnCopy")
    -- UIHide("btnPaste")
    -- UIHide("btnCut")
    -- UIHide("btnHelp")
    -- UIHide("uiTextInput")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054012))  -- "내가 직접 만든 춤을 보다니, 아주 운이 좋군."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054013))  -- "춤이 왜 이 모양이냐...고..?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054014))  -- "원래 춤을 직접 만드는 것과 춤 만들기를 가르치는 것은 아주 다른 거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054015))  -- "설마... 아직 뒤로 돌 줄도 모르는 주제에 {highlight}{bold}전설춤꾼{/bold}{/highlight}을 길러낸 내 실력을 의심하는 건 아니겠지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054016))  -- "예비 제자의 단점을 보완해주려는 선량하고 의욕적인 스승을 그리 대하면 못 써. 에헴."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054017))  -- "자, 그럼 뒤로 도는 방법을 전수해볼까? 먼저 {highlight}{bold}프레임{/bold}{/highlight}을 하나 선택해봐."

    ::jmp_btnFrame4::  --마지막 프레임을 누르도록 유도
    RequireButton("uiFrame4")  --마지막 프레임을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054018))  -- "먼저 {highlight}{bold}프레임{/bold}{/highlight}을 하나 선택해봐."
        goto jmp_btnFrame4  --마지막 프레임을 누르도록 유도
    end

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054019))  -- "이제 선택한 프레임에서 뒤로 돌아 자세를 취하려면 {highlight}{bold}뒤돌기{/bold}{/highlight} 버튼만 누르면 돼."
    
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_turn")
    
    ::jmp_btn_turn::
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_turn")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054020))  -- "이제 {highlight}{bold}뒤돌기{/bold}{/highlight} 버튼만 누르면 돼."
        goto jmp_btn_turn
    end

    Wait(1.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054021))  -- "어떻게 뒤로 돌지 궁금하지? 한 번 볼까?"
    
    ::jmp_btn_play_pause1::
    RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_play_pause")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054022))  -- "{highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러 어떻게 뒤로 도는지 볼까?"
        goto jmp_btn_play_pause1
    end
    
    Wait(3)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054023))  -- "팔랑하고 뒤로 돌아 춤을 추는 게 아주 매력적이지 않아?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054024))  -- "그래 봤자 내가 만든 춤은 형편없다고?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054006))  -- "......"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054025))  -- "서, 섣부른 판단은 금물이야! 그럴싸한 {highlight}{bold}배경{/bold}{/highlight}을 적용해보면 이야기가 달라질 걸?"

      -- 일시정지 버튼 유도
    ::jmp_btnStop4::
    -- 재생 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_play_pause")
    -- 재생 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054026))  -- "그럴싸한 {highlight}{bold}배경{/bold}{/highlight}을 적용해보면 이야기가 달라질 걸?"
        goto jmp_btnStop4
        -- 재생 버튼 누르도록 유도
    end
    -- 재생 버튼을 눌러서 UI가 다시 나타는 연출을 1초간 기다려줌
    Wait(1)

    ::jmp_btnSetting::  --설정 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")  --설정 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054027))  -- "배경을 바꾸려면 {highlight}{bold}설정{/bold}{/highlight} 버튼을 활용해야 돼."
        goto jmp_btnSetting  --설정 버튼 누르도록 유도
    end

    ::jmp_btnBackground::  --배경 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_popup_edit_dance", "btn_add_3")  --배경 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054028))  -- "{highlight}{bold}배경{/bold}{/highlight} 버튼을 이용해서 춤에 배경을 넣어볼 수 있어."
        goto jmp_btnBackground  --배경 버튼 누르도록 유도
        end
    
      --배경 선택 화면으로 전환(아래는 배경 선택 화면 설명)
    --•아카데미 입구 안 쪽으로 화면 전환
    --•[촬영 범위]가 아카데미 입구 바로 안 쪽에 등장
    --•현재 춤 위치 화면에서 설정된 범위와 크기가 같음
    --•[적용] 버튼이 화면 오른쪽 하단에 등장
    --•”원하는 배경을 선택하고 [적용] 버튼을!” 안내문구가 화면 상단에 깜빡임
    UIHide("btnBackScene")
    DescriptionBarShow(STR_QUEST_TEXT(820054029))  -- "원하는 배경을 선택하고 [적용] 버튼을!"
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054030))  -- "춤의 배경으로 넣어보고 싶은 곳을 선택하고 {highlight}{bold}적용{/bold}{/highlight} 버튼을 눌러봐."
    
    RequireSceneDanceTownOk()  --유저가 적용 버튼을 누르면 현재 선택된 배경이 적용된 춤 편집 화면으로 전환
    ::jmp_btnSettingOk::  -- 팝업 확인을 눌러 닫도록 유도
    RequireButtonWithCCB("UI_common/ui_popup_edit_dance", "btn_ok")  -- 팝업 확인을 눌러 닫도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054031))  -- "{highlight}{bold}확인{/bold}{/highlight} 버튼을 눌러봐."
        goto jmp_btnSettingOk  -- 팝업 확인을 눌러 닫도록 유도
    end

      -- 재생 버튼 유도
    ::jmp_btnPlay5::  -- 재생 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_play_pause")  -- 재생 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054032))  -- "{highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러봐."
        goto jmp_btnPlay5  -- 재생 버튼 누르도록 유도
        end
    Wait(3)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054033))  -- "어때? 배경을 넣으니까 좀 달라보이지 않아?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054034))  -- "춤 자체가 별로이면 저런 거 다 소용없다고?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054006))  -- "......"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054035))  -- "내가 춤을 잘 추고 못 추고는 전혀 중요한 게 아니야!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054036))  -- "나의 헌신적인 가르침으로 인해 또 한 명의 유망한 춤꾼이 밝은 미래를 향해 더 나아갔다는 게 중요한 거라고!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054037))  -- "오늘 이 짧은 가르침만으로도 훨씬 더 다채로운 춤을 만들 수 있게 됐다는 사실은 인정할 수 밖에 없을 걸?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054038))  -- "전설춤꾼과 같은 스승을 두게 된 것이니 평생의 영광으로 알라고."
    
      -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[돌아선 뒷모습] 퀘스트 완료"
   
    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
    TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
    TownCharacterSetQuest(TownCharacterGetNPC(158))

    ScriptTownMoveToSide(TownCharacterGetNPC(158))
    --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820054042))  -- "항상 앞만 보고 춤 추는 건 좀 심심하지?"
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(158)
end
