-- 열정만으로는 부족해(820057)  -- 진입형 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

-- 퀘스트 등장 조건 검사
local function CheckQuestAppearReq()

    if not CheckHasAnyDanceSkill() then
        return false
    end

    return true
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()

    return true
end

local function ScriptOnQuest()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")
    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057001))  -- "오랜만에 뵙는군요. 제가 인정한 '진짜' 춤꾼, [유저의 닉네임] 님."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057002))  -- "고급 {highlight}{bold}춤 기술{/bold}{/highlight}을 배우셨다는 소식을 듣고 기쁜 마음으로 달려왔어요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057003))  -- "혹자들은 말하죠. 화려한 {highlight}{bold}춤 기술{/bold}{/highlight}이 없어도 열정만 있으면 춤의 근본적인 가치는 퇴색하지 않는다고!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057004))  -- "흥! 하지만 그건 하나는 알고 둘은 모르는 소리!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057005))  -- "다양한 기술을 익힐수록 표현이 더 자유로워진다는 사실을 간과한 거라구요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057006))  -- "{highlight}{bold}춤 기술{/bold}{/highlight}을 능숙하게 사용하고 싶으시죠? 제가 도와드릴게요."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057007))  -- "배운 {highlight}{bold}춤 기술{/bold}{/highlight}은 조절점에 적용할 수 있어요."

    ::jmp_uiFrame1::  --첫 번째 자세 프레임 선택하도록 유도
    RequireButton("uiFrame1")  --첫 번째 자세 프레임 선택하도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057007))  -- "배운 {highlight}{bold}춤 기술{/bold}{/highlight}은 조절점에 적용할 수 있어요."
        goto jmp_uiFrame1  --첫 번째 자세 프레임 선택하도록 유도
    end
    
    ::jmp_cpLArm::  --왼손 조절점 누르도록 유도
    x = UIGetX("cpLArm")
    y = UIGetY("cpLArm")
    RequireTouchArea(x-30, x+30, y-30, y+30)
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(153, STR_NPC(158), "Characters/npc_014", STR_QUEST_TEXT(820057007))  -- "배운 {highlight}{bold}춤 기술{/bold}{/highlight}은 조절점에 적용할 수 있어요."
        goto jmp_cpLArm  --조절점을 누르도록 유도(기울기 조절점만 아니면 어떤 조절점이든 상관없음)
    end
    SceneDanceMove_SelectCP("cpLArm")

    ::jmp_btnToggleControlBox::  --선택된 조절점의 이름(왼손, 오른팔 등) 터치하도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_control","btn_control_name")  --선택된 조절점의 이름(왼손, 오른팔 등) 터치하도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057007))  -- "배운 {highlight}{bold}춤 기술{/bold}{/highlight}은 조절점에 적용할 수 있어요."
        goto jmp_btnToggleControlBox  --선택된 조절점의 이름(왼손, 오른팔 등) 터치하도록 유도
    end
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057008))  -- "여기에 보시면 [유저의 닉네임] 님께서 배운 {highlight}{bold}춤 기술{/bold}{/highlight}이 보이죠?"

    UISignalShowWithCCB("UI_dance/ui_dance_control", "collection_options")  --춤기술 목록 프레임에 빨간 박스
    Wait(2)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057009))  -- "{highlight}{bold}춤 기술{/bold}{/highlight}들 중에 하나만 선택하면 조절점에 적용돼요."
    UISignalHide()
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057010))  -- "춤 기술은 {highlight}{bold}같은 부위{/bold}{/highlight}에 {highlight}{bold}연속으로 2개 프레임 이상{/bold}{/highlight} 적용했을 때 더욱 효과적이니 참고하시구요."

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057011))  -- "아마 춤 기술이 들어간 동작을 보고나면 계속 쓰실 수 밖에 없을 걸요?"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057012))  -- "같은 위치로 몸을 움직이더라도 완전히 다른 느낌을 낼 수 있으니까 말이죠."
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057013))  -- "그런 면 때문에, 원하는 느낌의 춤을 추기 위해서는 춤 기술을 잘 쓰는 게 아주 중요한 거에요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(820057014))  -- "[유저의 닉네임] 님은 열정과 기술을 고루 갖춘 진짜 중의 진짜 춤꾼이 되기실 빌게요."
    
    --ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI(춤 편집 화면에서 조절점의 춤 기술 목록이 열려있는 상태)에 머물러 있는 상태
    UIEnableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")
end

--유저가 춤선생에게서 춤기술(종류는 상관없음)을 배운 후 처음으로 춤(어떤 춤이든 상관없음) 편집 화면(춤 목록 화면 아님)에 진입하면 진행
--이 퀘스트를 진행 가능한 상태가 되면, [춤] 버튼과 춤 목록 화면의 [수정] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

if CheckQuestAppear() then
    if CheckQuestAppearReq() then
        -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
        if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
            UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        end
    end
end

if CheckQuestAppearReq() then
    if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

        -- 내 춤꾼 팝업 생성 시, 춤 목록 버튼 해금
        if OnGameAction("OnBeforePopupCreate/PopupTownUser") then
            UnlockQuestContents()
        end

        -- 내 춤꾼 팝업 진입 시, 춤 목록에 New표시
        if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_003_05", "btn_info_dance", "btn_info_dance/iconNew", 29, 47)
        end

        -- 춤 목록 진입 시, 춤 편집 버튼에 New 표시
        if OnGameAction("OnAfterSceneEntered/SceneDanceList") then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_004_02", "btnToggle_modify_info", "btnToggle_modify_info/iconNew", 35, 30)
        end

        -- 춤 편집 진입 전, 춤 편집 버튼에 New 표시 제거
        if OnGameAction("OnBeforePushScene/SceneDanceMove") then
            UIRemoveNewIconWithCCB("UI_common/ui_btn2_004_02", "btnToggle_modify_info", "btnToggle_modify_info/iconNew")
            UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
            UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
            RefreshNewCount()
        end

        -- 춤 편집 진입 시, 퀘스트 진행 시작
        if OnGameAction("OnAfterSceneEntered/SceneDanceMove") then
            ScriptOnQuest()
        end
    end
end



