-- 나의 아카데미(820059) - 스토리 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059001))  -- "이곳은 [nickname] 님의 아카데미랍니다!"
end

local function textQuestReplay()

end 




local function ScriptOnQuest()

      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 아카데미 앞에 신입요원 등장
    TownCharacterStandAt(TownCharacterAddNPC(133), 0, -7*40)
    -- 유저 등장
    TownCharacterStandAt(TownCharacterAddNPC(1), -2*40, -7*40)

    -- 퀘스트 인트로
    ScenarioIntroShow(133)

    -- 신입요원 줌인
    TownCameraZoomIn(TownCharacterGetNPC(133), -40, 50, 2)
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059002))  -- "어서오세요, [nickname] 님! 전 춤꾼협회의 파릇파릇한 신입요원입니다!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059003))  -- "{highlight}{bold}아카데미{/bold}{/highlight}를 가지시게 된 걸 축하드려요!"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059004))  -- "...예? {highlight}{bold}아카데미{/bold}{/highlight}가 뭐냐구요?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(820059005))  -- "아~ 아직 아무 말씀도 못 들으셨구나?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059006))  -- "선배님도 참! 또 새 {highlight}{bold}아카데미{/bold}{/highlight}의 {highlight}{bold}마스터{/bold}{/highlight}에게 댄스비전 하나만 달랑 던져주고 가신 모양이네요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059007))  -- "제가 선배님을 대신해서 사과드릴게요. 워낙 시크한 요원에 대한 환상을 가지신 분이라..."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059008))  -- "하지만 걱정 마세요! 의욕 충만! 절대 친절! 이 신입요원이 있으니까요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059009))  -- "지금 우리가 들어와 있는 이 건물! 여기가 바로 [nickname] 님의 {highlight}{bold}아카데미{/bold}{/highlight}랍니다!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059010))  -- "뛰어난 춤꾼이 춤과 음악에 매진할 수 있도록 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서 지원해드리는 장소예요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059011))  -- "하늘에서 뚝 떨어지자마자 춤으로 춤꾼들을 사로잡고 카바 씨의 인정을 받는 건 결코 쉬운 일이 아니거든요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059012))  -- "게다가 춤, 음악을 만드는 데도 벌써 능숙해지셨으니, 이런 이례적인 지원을 받는 건 당연한 거죠!"
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_haha")
    Wait(1.5)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059013))  -- "아, 그리고 함께 떨어졌던 일행분들도 열심히 찾고 있으니까 곧 좋은 소식이 있을 거예요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059014))  -- "3명이나 되는 사람이 하늘에서 떨어지자마자 그렇게 감쪽같이 사라져버리다니, 참 신기한 일이죠?"

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059015))  -- "음...? 설마 모르고 계셨던 거에요?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059016))  -- "[nickname] 님이 하늘에서 떨어진 후에 다른 3명이 또 떨어졌어요. 그리고 순식간에 자취를 감춰버렸구요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059017))  -- "모르시는 걸 보니 일행이 아닌가봐요?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059018))  -- "그럼 도대체 그 사람들은... 조사를 좀 더 해봐야겠네요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059019))  -- "혹시 뭔가 알아내면 알려드릴게요! 앞으로 종종 뵙게 될 테니 반갑게 맞아주세요~"
    
    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow()  -- "[나의 아카데미] 스토리 완료"

    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()

end

-- PRELOAD_BEGIN

-- 신입요원 머리 위에 빨간 느낌표.
-- 신입요원을 누르면 줌인 후 유저의 캐릭터가 화면 왼쪽에서 등장하며 아래의 퀘스트 진행.
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(133), 0, -7*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        TownCameraZoomIn(TownCharacterGetNPC(133), -40, 50, 2)
        TownCharacterStandAt(TownCharacterGetUser(), 2*40, 0*40)
        TownCharacterWalkTo(TownCharacterGetUser(), -2*40, -7*40)
        Wait(2)
        --DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059019))  -- "이곳은 [nickname] 님의 아카데미랍니다!"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        --DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820059019))  -- "이곳은 [nickname] 님의 아카데미랍니다!"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end

-- PRELOAD_END
