-- 빨래 도둑(830037)  -- 진행형 퀘스트
-- version("0.51.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520002)  -- 아카데미 관련 기능을 열어줌
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
    UnlockContents(520009)  -- 장애물 제거 관련 기능을 열어줌
    UnlockContents(520010)  -- 춤/음악 배우기 관련 기능을 열어줌
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520012)  -- 춤꾼 영입 기능을 열어줌
    UnlockContents(520013)  -- 군무 제작 기능을 열어줌
    UnlockContents(520302)  -- 명예 상점 기능을 열어줌
    UnlockContents(520016)  -- NPC호감도 관리 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037001))  -- "분명히 여기 어디로 도망쳤는데..."
end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()
	DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037001))  -- "분명히 여기 어디로 도망쳤는데..."
end 



local function ScriptOnQuestAppear()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(119)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037002))  -- "아니, 글쎄, 내 이야기 좀 들어봐."
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037003))  -- "요즘 세상에도 빨래를 훔쳐가는 도둑이 있더라니까, 글쎄?"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037004))  -- "그것도 나에게 환상적으로 잘 어울려서 제일 아끼던 심플 누드톤 원피스를!"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037005))  -- "용하게도 그 놈을 현장에서 발견하지 않았겠어, 내가?"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037006))  -- "그런데 이놈이 다람쥐 마냥 재빠르지 뭐야."
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037007))  -- "하지만 그놈은 몰랐겠지. 내가 소싯적에 육상 선수였다는 사실을."
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037008))  -- "치열한 추격전 끝에 이 마을까지 오기는 했는데..."
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037009))  -- "여긴 사람이 많아서 어디 있는지 도통 찾을 수가 없네..."
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037010))  -- "이 마을 사람이니까 고 도둑놈 잡는 거 좀 도와줄 수 있지?"

    PushPopupClothesShow(202097);
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037011))  -- "요런 옷을 입은 놈 중 하나가 범인일 거야."

    QuestStart()

    TownCharacterStandAt(TownCharacterAddNPC(120), 28*40, 50*40)
    TownCharacterSetQuestIcon(TownCharacterGetNPC(120))

    GoTown()
end

local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037012))  -- "저한테 뭐 볼일이라도..."
    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037013))  -- "아, 이 옷이요? 저한테 딱 어울리죠? 이 옷을 처음 본 순간부터 내 꺼다 싶었죠!"
    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037014))  -- "그리고 마침내 손에 넣고 말았어요!"
    TownCharacterSetEmot(TownCharacterGetNPC(120), "Characters/Emoticon_heart")
    Wait(1)
    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037015))  -- "지금 이 순간 전 세상을 다 가진 것이나 다름없답니다!"

    RemoveSkipButton()
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037016))  -- "사람이란 가장 행복한 순간에 위기가 찾아오는 법이지!"
    TownCharacterSetEmot(TownCharacterGetNPC(120), "Characters/Emoticon_exclamation")

    TownCharacterStandAtCharacter(TownCharacterAddNPC(119), TownCharacterGetNPC(120), -12*40, 0*40)
    Wait(0.5)
    TownCameraZoomIn(TownCharacterGetNPC(119), -40, 50, 1.3)
    TownCharacterRunToCharacter(TownCharacterGetNPC(119),TownCharacterGetNPC( 120), 1*40 + 20, 0)

    Wait(5.5)

    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037017))  -- "히익! 여기까지 따라오다니!"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037018))  -- "이제야 잡았다, 이 파렴치한 빨래 도둑!"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037019))  -- "감히 내 몸에 맞춘 듯 어울리는 그 옷을 가져가다니, 각오는 되어있겠지?"
    DialogOpen(120, STR_NPC(120), "", STR_QUEST_TEXT(830037020))  -- "이 옷이 절규하고 있었어! 당신에게서 구해달라고! 내 몸에 입혀지고 싶다고!"
    TownCharacterSetEmot(TownCharacterGetNPC(119), "Characters/Emoticon_angry")
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037021))  -- "이런 돼먹지 못 한...!"
    
--    TownCharacterRunToCharacter(TownCharacterGetNPC(119),TownCharacterGetNPC( 120), 1*40, 0)
    Wait(1.5)
    AnimationAdd("smog", "Opening/Event_kick_smog")
    AnimationSetLayer("smog", 2);
    AnimationSetPos("smog", 0, 0);
    AnimationPlay("smog")
    Wait(0.35)
    TownCharacterUnwearClothes(TownCharacterGetNPC(120), 202097)
    TownCharacterWearClothes(TownCharacterGetNPC(119), 202097)
    Wait(1.65)

    AnimationRemove("smog");

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037022))  -- "히야아아압!!"
    TownCameraZoomIn(TownCharacterGetNPC(119), 0, 0, 2.0)
    TownCharacterAction(TownCharacterGetNPC(119), "kick")

    Wait(0.6)
    AnimationAdd("kick", "Characters/event_kick")
    AnimationSetPos("kick", 0, 0)
    AnimationPlay("kick")
    Wait(0.1)
    AnimationRemove("kick")
    TownCharacterAction(TownCharacterGetNPC(120), "fly0_1")
    TownCharacterFlyTo(TownCharacterGetNPC(120), -500, -0);
    TownCharacterAction(TownCharacterGetNPC(119), "dance_01")
    Wait(1.5)
    TownCharacterHide(TownCharacterGetNPC(120))
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037023))  -- "아휴, 속이 다 후련하다! 용케 찾아줬네! 고마워~"
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037024))  -- "간만에 옷도 차려입었으니 바깥양반이랑 데이트나 해야겠다~"


    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[빨래 도둑] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()

    GoTown()
end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN

-- 퀘스트 NPC가 돌아다니고 있다.
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
        TownCharacterSetQuest(TownCharacterGetNPC(119))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
        --DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037024))  -- "분명히 여기 어디로 도망쳤는데..."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(119)
    end

    if OnClickQuestTab(TownCharacterGetNPC(119)) then
        --DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037024))  -- "분명히 여기 어디로 도망쳤는데..."
		textCheckQuestAppear()
	end

	if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then
    --quest 진행 중
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(120), 16*40, 50*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(120))
        TownCharacterSetQuest(TownCharacterGetNPC(120))
    end
    if OnTownCharacterClick(TownCharacterGetNPC(120)) then
        PreLoad()
        ScriptTownMoveToLeftSide(TownCharacterGetNPC(120))
        PushPopupTownNpcWithSelectBox(120)
    end

    if OnClickQuestTab(TownCharacterGetNPC(120)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
        TownCharacterSetQuest(TownCharacterGetNPC(119))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
        PushPopupTownNpcWithSelectBox(119)
    end

    if OnClickQuestTab(TownCharacterGetNPC(119)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
-- PRELOAD_END

-- 퀘스트 다시하기
if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(119))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
    TownCharacterSetQuest(TownCharacterGetNPC(119))

    ScriptTownMoveToSide(TownCharacterGetNPC(119))
    --DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(830037024))  -- "분명히 여기 어디로 도망쳤는데..."
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(119)
end
