-- 일일 접속 보상(840015)  -- 일반형 퀘스트
-- version("0.48.00")
-- 신입요원 npc_id 133

-- PRELOAD_BEGIN

if CheckUnlock(520039) then

    if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
        if OnTownRefresh() then
            TownCharacterRoamInTown(TownCharacterAddNPC(133))
            TownCharacterSetIcon(TownCharacterGetNPC(133), "Has_Present")
            TownCharacterSetQuest(TownCharacterGetNPC(133))
        end

        if OnTownCharacterClick(TownCharacterGetNPC(133)) then
            PreLoad()
            -- 마을 UI 감추기
            SceneTownSetStateEmpty()
            -- 퀘스트 배경음
            SoundPlay(9) --=BGM=Event_Quest_common

            ScriptTownMoveToSide(TownCharacterGetNPC(133))

            if not CheckQuestExpired() then
                DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(840015001))  -- "아, 오셨군요! 여기 오늘의 지원금이 있습니다!"
                DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(840015002))  -- "잘 활용해서 좋은 춤꾼이 되시길."

                QuestStart()
                QuestComplete()
                QuestReward()

                DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(840015003))  -- "그럼 내일 또 찾아오겠습니다!"

                if CheckCharacterHasQuest(133) then
                    PushPopupTownNpcWithSelectBox(133)
                else
                    GoTown()
                end    
            end
        end

        if OnClickQuestTab(TownCharacterGetNPC(133)) then
        end

        if OnClickQuestStart() then
        end
    end

end

-- PRELOAD_END
