-- 어떻게 다 잘해?(870027)  -- 조건형 퀘스트
-- version("0.48.00")
-- 명쾌한 소녀 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표. 139 15

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027001))  -- "음악 만드는 게 어렵고 귀찮다면? 그냥 배워서 쓰면 그만이죠!"
end

local function textCheckQuestRunning()
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027002))  -- "다른 춤꾼의 {highlight}{bold}음악{/bold}{/highlight}을 [progress20105]회만 배워보세요."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 



local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(139)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027003))  -- "얼마 전에 친구 하나가 그러더라구요. 자기는 춤에는 자신이 있는데 음악에는 소질이 없어 고민이라고."
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027004))  -- "전 도대체 왜 그런 고민을 하는지 도무지 모르겠어요."
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027005))  -- "음악이 안 되겠다 싶으면, 음악 잘 만드는 다른 춤꾼의 음악을 써서 멋진 뮤비를 만들면 되잖아요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027006))  -- "사람이 어떻게 모든 걸 다 잘 할 수 있겠어요. 안 그래요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027007))  -- "아, 물론 [nickname] 님처럼 춤, 음악 가리지 않고 다 잘 하는 경우도 있긴 하죠."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_haha")
    Wait(1.5)
    
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027008))  -- "뭐... 그래도 모든 춤과 음악이 최고일 수는 없잖아요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027009))  -- "가끔은 다른 춤꾼들에게서 뮤직비디오의 질을 높일만한 춤이나 음악을 보실 거에요."
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027010))  -- "그럴 때는 망설임 없이 배워보세요!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027011))  -- "말이 나온 김에 지금 당장 해볼까요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027012))  -- "다른 춤꾼들의 뮤비들을 둘러보고 마음에 드는 {highlight}{bold}음악{/bold}{/highlight}을 찾아서 [progress20105]회 배워보세요."
      -- DialogOpen(139, "명쾌한 소녀", "Characters/npc_013", "(음악 배우기 미구현, 퀘스트를 바로 완료시킵니다.)")

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027013))  -- "[nickname] 님이 만든 춤과 어울리는 음악이 있죠?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027014))  -- "앞으로도 {highlight}{bold}배우기{/bold}{/highlight} 기능을 적극 이용해보세요."
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027015))  -- "즐겁자고 만드는 뮤직비디오인데 스트레스 받으면서 내가 다 만들 필요는 없으니까."
    
    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[어떻게 다 잘해?] 퀘스트 완료"

    QuestReward()
    GoTown()
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027014))  -- "음악 만드는 게 어렵고 귀찮다면? 그냥 배워서 쓰면 그만이죠!"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027014))  -- "음악 만드는 게 어렵고 귀찮다면? 그냥 배워서 쓰면 그만이죠!"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027015))  -- "다른 춤꾼의 {highlight}{bold}음악{/bold}{/highlight}을 [progress20105]회만 배워보세요."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20105)
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870027015))  -- "다른 춤꾼의 {highlight}{bold}음악{/bold}{/highlight}을 [progress20105]회만 배워보세요."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
