  --무플은 너무 슬퍼요(870033)  -- 조건형 퀘스트
-- version("0.48.00")
-- 사려 깊은 소녀 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033001))  -- "소외된 춤꾼들에게 댓글은 큰 힘이 된답니다!"
end

local function textCheckQuestRunning()
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033002))  -- "다른 유저의 뮤비에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 더 달면 행복한 댄스빌의 밑거름이 될 거에요."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 



local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(130)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033003))  -- "춤꾼이라면 누구나 자기가 만든 춤에 {highlight}{bold}댓글{/bold}{/highlight}이 달렸을 때의 설렘이 있죠."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033004))  -- "그런데 슬프게도... 춤꾼 모두가 많은 {highlight}{bold}댓글{/bold}{/highlight}을 받지는 못해요."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033005))  -- "열심히 만든 뮤비에 {highlight}{bold}댓글{/bold}{/highlight}이 없다니... 생각만 해도 슬퍼요."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033006))  -- "무플 방지를 위해 카바 씨나 아리가 노력은 하고 있지만... 역부족인가봐요."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033007))  -- "그런 어려움에 빠진 춤꾼을 도와줄 방법이 없을까..."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033008))  -- "아! [유저의 닉네임] 님처럼 유명한 춤꾼이 {highlight}{bold}댓글{/bold}{/highlight}을 달아주면 그 춤꾼들도 외롭지 않을 거에요!"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033009))  -- "그럼 밝고 희망찬 댄스빌을 위해! 다른 춤꾼들의 뮤직비디오에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 달아볼까요?"
    
    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033010))  -- "잘 하셨어요! [유저의 닉네임] 님께서 댓글을 단 춤꾼들이 의욕을 되찾았을 거에요!"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033011))  -- "이제 그 춤꾼들도 다른 춤꾼들의 뮤비에 댓글을 달고, 그렇게 아름다운 사회가 만들어지는 거 아니겠어요?"

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[무플은 너무 슬퍼요] 퀘스트 완료"

    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033010))  -- "소외된 춤꾼들에게 댓글은 큰 힘이 된답니다!"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033010))  -- "소외된 춤꾼들에게 댓글은 큰 힘이 된답니다!"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(130))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033011))  -- "다른 유저의 뮤비에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 더 달면 행복한 댄스빌의 밑거름이 될 거에요."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20107)
        PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870033011))  -- "다른 유저의 뮤비에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 더 달면 행복한 댄스빌의 밑거름이 될 거에요."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end
    
elseif CheckQuestComplete() then
    
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end

-- PRELOAD_END
