-- 진정한 자아 성찰(870035)  -- 조건형 퀘스트
-- version("0.48.00")
-- 도 닦는 할아버지 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035001))  -- "댓글은 그 댓글을 다는 사람의 자아에 대한 단서라네."
end

local function textCheckQuestRunning()
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035002))  -- "마음이 동하는 뮤직비디오에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 달면 된다네."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 


local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(129)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035003))  -- "자신을 안다는 것은 무엇일까?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035004))  -- "홀로 깊고 깊게 고민을 하면 자신에 대해 더 잘 알 수 있을까?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035005))  -- "사람이란 자연스럽게 다른 이들과의 관계를 통해 자아를 형성해나가지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035006))  -- "그래서 자아 성찰이란 자신과 다른이들과의 관계를 잘 살펴보는 게 중요한 법이야."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035007))  -- "내가 다른 사람에게, 다른 사람이 내게 하는 언행이 자아 성찰의 중요한 단서라는 말이지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035008))  -- "자네는 어떤 사람인가? 어떤 자아를 가지고 있지?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035009))  -- "다른 춤꾼의 뮤비 [progress20107]개에 {highlight}{bold}댓글{/bold}{/highlight}을 달아보면 조금 더 그 답에 가까워지지 않을까?"
    
    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035010))  -- "자신이 단 댓글을 보니 스스로를 좀 더 잘 알게 된 것 같은가?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035011))  -- "쉽지는 않을 거야. 더 많은 댓글과 그 댓글에 대한 다른 춤꾼들의 반응을 종합해보면 결국은 답을 얻을 수 있을 걸세."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035012))  -- "스스로를 잘 이해한 춤꾼은 그 춤의 깊이가 한층 깊어지게 마련이지. 꼭 그 경지를 이루길 바라네."

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[진정한 자아 성찰] 퀘스트 완료"
    
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035011))  -- "댓글은 그 댓글을 다는 사람의 자아에 대한 단서라네."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035011))  -- "댓글은 그 댓글을 다는 사람의 자아에 대한 단서라네."
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then
    
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035012))  -- "마음이 동하는 뮤직비디오에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 달면 된다네."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20107)
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870035012))  -- "마음이 동하는 뮤직비디오에 {highlight}{bold}댓글{/bold}{/highlight}을 [progress20107]회만 달면 된다네."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
-- PRELOAD_END
