-- 과자 CF촬영(880011) 제작 퀘스트
-- version("0.43.00")
if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011001))  -- "[nickname]님! 저예요!\n오늘은 심부름이 아니고 다른 일로 찾아왔어요!\n기쁜 일은 나눠야 배가 된다고 하잖아요~"
    end

end


if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011002))  -- "우와! 멜로디를 직접 연주해 볼 수 있겠네요!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011003))  -- "앗! 생각났다!\n이런 음이었던 것 같아요!"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011004))  -- "와~ 맞아요! 이 노래예요!\n듣기만 해도 마구 과자가 당기는 이 느낌!!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629001)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011005))  -- "냠냠~ 자, [nickname]님도 한 개 드릴게요!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011006))  -- "앗! 이런.. 연주해볼 수 없겠네요!\n그 노래엔 이 두 개가 필요했던 것 같은데..\n뭐, 어쩔 수 없죠! 다음에 알려드릴게요!"
    GoTown()

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011007))  -- "헤헤! 과자에 대한 무한한 제 사랑이 전 댄스빌에 알려진 걸까요?\n항상 먹는 과자의 회사에서 광고 출연 제의가 들어왔어요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011008))  -- "과자 광고로 정말 유명한 회산데~\n앗, [nickname]님 그 노래 모르세요?\n들으면 과자가 마구 당기는 그런 노랜데!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011009))  -- "앗! 갑자기 저도 기억이 안 나요!\n음~ 음~~.. 귀여운 멜로디였던 것 같은데~\n한번 연주해 보면 생각이 날 것 같기도.."
    end


        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011010))  -- "이런 악기들 소리가 들렸던 것 같아요!"


    PushPopupCollectionNeed()

end

if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011011))  -- "앗.. 바쁘시군요? 할 수 없죠!\n다음에 다시 얘기해 드릴게요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011007))  -- "헤헤! 과자에 대한 무한한 제 사랑이 전 댄스빌에 알려진 걸까요?\n항상 먹는 과자의 회사에서 광고 출연 제의가 들어왔어요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011008))  -- "과자 광고로 정말 유명한 회산데~\n앗, [nickname]님 그 노래 모르세요?\n들으면 과자가 마구 당기는 그런 노랜데!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011009))  -- "앗! 갑자기 저도 기억이 안 나요!\n음~ 음~~.. 귀여운 멜로디였던 것 같은데~\n한번 연주해 보면 생각이 날 것 같기도.."

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011010))  -- "이런 악기들 소리가 들렸던 것 같아요!"
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011002))  -- "우와! 멜로디를 직접 연주해 볼 수 있겠네요!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011003))  -- "앗! 생각났다!\n이런 음이었던 것 같아요!"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011004))  -- "와~ 맞아요! 이 노래예요!\n듣기만 해도 마구 과자가 당기는 이 느낌!!"
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011012))  -- "우와~~ 제가 봐도 너무 귀여운 것 같아요!\n이러다 모든 과자회사에서 광고제의가\n들어오면 어쩌죠!? 훗.."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880011013))  -- "그땐 제가 한턱 쏠게요!\n정말 감사해요, [nickname]님!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

