-- 과자 CF촬영2(880012) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then

        PreLoad()

        -- 유저가 과자가 제일 좋은 아이 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"
        PushPopupTownNpcWithSelectBox(113)

    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"

    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then

        PreLoad()

        -- 유저가 과자가 제일 좋은 아이 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"
        PushPopupTownNpcWithSelectBox(113)

    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"

    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then

        PreLoad()

        -- 유저가 과자가 제일 좋은 아이 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"
        PushPopupTownNpcWithSelectBox(113)

    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012001))  -- "[nickname]님! [nickname]님!\n헥, 헥, 저 [nickname]님을 찾고 있었어요!\n저 좀 도와주세요!"

    end
end


if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012002))  -- "지난 번에 제가 광고 찍는다고 말씀드렸죠!?\n윽, 과자를 많이 먹기만 하면 될 줄 알았는데!!\n맛있고! 귀엽게! 먹으라는 주문이 들어왔어요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012003))  -- "나름대로 열심히, 귀엽게 먹긴 했는데..\n뭔가, 살짝 2% 아쉬운 느낌!?\n[nickname]님이 한 번만 봐주면 안돼요? 네?"
    end


        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012004))  -- "앗! 과자가 있어야 해요!\n제가 지난번에 드렸던 것 같은데!"


    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012005))  -- "과자다!\n아직 다 안 드셨군요! 헤헤!\n자, 우리 어서 같이 과자 춤을 춰요!"

    RequireSceneDanceCorrection()
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012006))  -- "자! 과자 들고~! 이렇게~! 이렇게~!\n어서 2%를 채워주세요!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012007))  -- "우와~~ 제가 봐도 너무 귀여운 것 같아요!"

    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(113), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(113), 205090)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205090)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012008))  -- "이러다 모든 과자회사에서 광고제의가\n들어오면 어쩌죠!? 훗.."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012009))  -- "그땐 제가 한턱 쏠게요!\n정말 감사해요, [nickname]님!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end


-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012002))  -- "지난 번에 제가 광고 찍는다고 말씀드렸죠!?\n윽, 과자를 많이 먹기만 하면 될 줄 알았는데!!\n맛있고! 귀엽게! 먹으라는 주문이 들어왔어요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012003))  -- "나름대로 열심히, 귀엽게 먹긴 했는데..\n뭔가, 살짝 2% 아쉬운 느낌!?\n[nickname]님이 한 번만 봐주면 안돼요? 네?"

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012004))  -- "앗! 과자가 있어야 해요!\n제가 지난번에 드렸던 것 같은데!"
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012005))  -- "과자다!\n아직 다 안 드셨군요! 헤헤!\n자, 우리 어서 같이 과자 춤을 춰요!"
    ]]--

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612353, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012006))  -- "자! 과자 들고~! 이렇게~! 이렇게~!\n어서 2%를 채워주세요!"
    
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012010))  -- "우와~~ 제가 봐도 너무 귀여운 것 같아요!\n이러다 모든 과자회사에서 광고제의가\n들어오면 어쩌죠!? 훗.."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012009))  -- "그땐 제가 한턱 쏠게요!\n정말 감사해요, [nickname]님!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012011))  -- "과자는 무조건 손에 들고 춤춰야 한대요.."
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880012012))  -- "윽!.. 할 수 없죠!\n카바 아저씨께 여쭤봐야겠네요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612353, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

