-- 치카치카 춤(880013) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
    end


elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013001))  -- "흐으음...\n앗, 안녕하세요 [nickname]님!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013002))  -- "네? 무슨 고민이 있냐구요? 아아.. 별건 아닌데..\n음.. 혹시 [nickname]님 지금 시간 괜찮으신가요?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(133)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013003))  -- "다름 아니고 동생이 과자를 너~ 무 격하게 좋아해서요.\n요새 또 광고다 뭐다 하며 너무 많이 먹는 것 같아요.\n과자를 좋아하는 건 좋지만, 양치를 잘 해야 할 텐데.."
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013004))  -- "지난번에도 충치 때문에 곤욕을 치렀거든요.\n올바른 양치질 방법을 모르는 것 같아요.\n제가 바빠서 신경을 잘 못 쓴 바람에.. 제 탓이에요.."
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013005))  -- "아! 그렇지! 동생이 [nickname]님을 많이 따르던 것 같은데,\n혹시 [nickname]님께서 올바른 양치질 동작을 보여주신다면\n잘  따라 하지 않을까요?"
    end


        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013006))  -- "음.. 올바른 양치 시범을 보여주시려면,\n아무래도 칫솔이 있어야 할 것 같네요!"


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013007))  -- "앗! 모두 준비되셨네요!\n좋아요! 바로 시작하죠!"

    RequireSceneDanceCorrection()
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013008))  -- "그럼 [nickname]님의 양치질!\n기대하겠습니다~!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013009))  -- "오, 그냥 양치질일 뿐인데 마치...\n동작 하나하나 섬세한..! 하나의 아름다운 춤 같아요!\n엄청나네요! 역시 [nickname]님!!"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205091)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013010))  -- "정말 감사합니다!\n어서 동생에게 가르쳐주러 가봐야겠어요!\n이건 제 보답입니다!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    -- 퀘스트 인트로
    ScenarioIntroShow(133)

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013003))  -- "다름 아니고 동생이 과자를 너~ 무 격하게 좋아해서요.\n요새 또 광고다 뭐다 하며 너무 많이 먹는 것 같아요.\n과자를 좋아하는 건 좋지만, 양치를 잘 해야 할 텐데.."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013004))  -- "지난번에도 충치 때문에 곤욕을 치렀거든요.\n올바른 양치질 방법을 모르는 것 같아요.\n제가 바빠서 신경을 잘 못 쓴 바람에.. 제 탓이에요.."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013005))  -- "아! 그렇지! 동생이 [nickname]님을 많이 따르던 것 같은데,\n혹시 [nickname]님께서 올바른 양치질 동작을 보여주신다면\n잘  따라 하지 않을까요?"

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013006))  -- "음.. 올바른 양치 시범을 보여주시려면,\n아무래도 칫솔이 있어야 할 것 같네요!"
    end
    ]]--

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612352, 0)
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013008))  -- "그럼 [nickname]님의 양치질!\n기대하겠습니다~!"
        
	-- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)


    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013009))  -- "오, 그냥 양치질일 뿐인데 마치...\n동작 하나하나 섬세한..! 하나의 아름다운 춤 같아요!\n엄청나네요! 역시 [nickname]님!!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013010))  -- "정말 감사합니다!\n어서 동생에게 가르쳐주러 가봐야겠어요!\n이건 제 보답입니다!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013011))  -- "음.. 아직 준비가 안되셨군요!\n괜찮아요, 천천히 준비하세요~"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880013012))  -- "음.. 역시, 바쁘시구나..\n동생 일은 제가 알아서 해볼게요~\n들어주셔서 감사합니다!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612352, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end






