-- 클럽을 울려라(880021) 제작 퀘스트
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021001))  -- "요, 브로~! 디제잉은 나의 일상!\n비트에 몸을 흔들고 싶은 열망!\n핫한 곡에 대한 갈망!"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(148)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021002))  -- "핫~! 한 노래를 틀어야 하는 나의 의무감!\n클러버의 귀를 자극하는 음악을 선택하는 나의 직감!"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021003))  -- "오래된 곡들은 이제 지겹지!\n신선한 곡들을 찾기는 하늘의 별따기!"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021004))  -- "요, 마 브로 [nickname]!\n이건 나의 간절한 청탁!\n새 비지엠 작곡을 부탁!"
    end


        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021005))  -- "리듬을 타기 위한 비트를 위해서는\n이것들이 필요하지! 요!"

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021006))  -- "요, 요! 체키럽!\n두잇 롸잇 나우!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021007))  -- "예아~ 저절로 몸이 흔들리는,\n신나는 비트~\n손 들어, 흔들어! 요~!"
    RequireMusicFollowButton()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021008))  -- "엄청난 비트의 탄생!\n비트의 신이 이자리에 환생!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629002)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021009))  -- "요, 이건 나의 선물!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021010))  -- "요 브로, 이건 필수!\n없으면 포기하는 것으로 간주!"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021011))  -- "왓?! 지금 난 절망!\n무참히 짓밟힌 내 희망!\n하~ 실망!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(148)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021002))  -- "핫~! 한 노래를 틀어야 하는 나의 의무감!\n클러버의 귀를 자극하는 음악을 선택하는 나의 직감!"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021003))  -- "오래된 곡들은 이제 지겹지!\n신선한 곡들을 찾기는 하늘의 별따기!"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021004))  -- "요, 마 브로 [nickname]!\n이건 나의 간절한 청탁!\n새 비지엠 작곡을 부탁!"
        
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021005))  -- "리듬을 타기 위한 비트를 위해서는\n이것들이 필요하지! 요!"
    end

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021006))  -- "요, 요! 체키럽!\n두잇 롸잇 나우!"
    ]]--
        

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021007))  -- "예아~ 저절로 몸이 흔들리는,\n신나는 비트~\n손 들어, 흔들어! 요~!"
    RequireMusicFollowButton()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021008))  -- "엄청난 비트의 탄생!\n비트의 신이 이자리에 환생!"
    Wait(0.5)

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880021009))  -- "요, 이건 나의 선물!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


