-- 자연스러운 스웩(880022) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"

    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"

    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022001))  -- "[nickname]님! 저도 자연스럽게 리듬을 타고 싶어요!"

    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022002))  -- "클럽의 다른 사람들은 다 리듬에 자연스럽게 몸을\n맡기는 것 같은데, 전 그게 왜 이리도 어려울까요!?\n정말 간단한 동작인 것 같으면서도 너무 어려운 것 같아요.."
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022003))  -- "복잡하고 어려운 동작은 바라지도 않는데..\n[nickname]님은 어떤 식으로 가볍게 리듬을 타시나요?\n한 번만 보여주시면 안 돼요? 네??"
    end

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022004))  -- "음.. 모자를 써줘야 더 느낌이 사는 것 같던데..."

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022005))  -- "오! 역시 모자만으로도 느낌이 사는 것 같아요!\n물 흐르듯 자연스러운 [nickname]님의 리듬감!\n어서 보여주세요!"

    RequireSceneDanceCorrection()
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022006))  -- "와 ~ 기대된다!\n눈 크게 뜨고 잘 보고 있을게요!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022007))  -- "정말 간단해 보이면서도 엄청난 내공이 느껴져요!"

    GoSceneTown()
    TownCharacterAction(TownCharacterGetNPC(112), "copy")
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022008))  -- "흔들 흔들~ 히히, 어때요? 저도 자연스럽나요?!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    ScenarioIntroShow(112)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022002))  -- "클럽의 다른 사람들은 다 리듬에 자연스럽게 몸을\n맡기는 것 같은데, 전 그게 왜 이리도 어려울까요!?\n정말 간단한 동작인 것 같으면서도 너무 어려운 것 같아요.."
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022003))  -- "복잡하고 어려운 동작은 바라지도 않는데..\n[nickname]님은 어떤 식으로 가볍게 리듬을 타시나요?\n한 번만 보여주시면 안 돼요? 네??"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612348, 0)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022006))  -- "와 ~ 기대된다!\n눈 크게 뜨고 잘 보고 있을게요!"
    
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022009))  -- "정말 간단해 보이면서도 엄청난 내공이 느껴져요!\n흔들 흔들~ 히히, 어때요? 저도 자연스럽나요?!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022010))  -- "앗.. 아직 준비가 안되신 것 같아요.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880022011))  -- "엣.. 다음엔 꼭 가르쳐주세요!\n꼭이요! 저 정말 궁금하단 말이에요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612348, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

