-- 루즈함을 날리는 템포(880031) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031001))  -- "저기, 자네 혹시.. 좀 빠른 음악 없나?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031002))  -- "내가 조금 전까지 굉장히 루즈했는데 말이야..\n자네를 보니 갑자기 좀 더 빠른 스텝을 밟고 싶다네!!!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880031003))  -- "어디 보자.. 빠른 스텝에 어울릴만한 음악이...\n아닛!? 빠른 템포의 음악이 없어 보이는걸?!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880031004))  -- "이런 이런~\n빠르면서도 정확한 리듬감이 필요한데 말이야!"
    end

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031005))  -- "안되겠네! 같이 빠른 템포부터 만들어 보지!\n이것들을 준비해보게나!"

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880031006))  -- "오! 준비했군!\n자! 자! 빨리 다음 단계로 넘어가시게나!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880031007))  -- "듣기만 해도 저절로 엉덩이가 들썩이는 리듬!\n그런 리듬을 알려주겠네!"
    RequireMusicFollowButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880031008))  -- "오~ 오오~~\n음악의 소리가 마치 심장이 빠르게 뛰는 것 같지 않나!?\n내 엉덩이가 마구 들썩이고 있다네!! 굉장하지 않나?!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629003)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880031009))  -- "지금 이 느낌 그대로 뮤직비디오를 촬영해야겠어!\n그럼 난 이만!!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880031010))  -- "아, 잠시 시간이 필요한가?\n알겠네! 여기서 기다리고 있겠네!"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880031011))  -- "하... 답답한 친구일세..!\n날이면 날마다 알려주는 것이 아니란 말일세.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(101)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031002))  -- "내가 조금 전까지 굉장히 루즈했는데 말이야..\n자네를 보니 갑자기 좀 더 빠른 스텝을 밟고 싶다네!!!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880031003))  -- "어디 보자.. 빠른 스텝에 어울릴만한 음악이...\n아닛!? 빠른 템포의 음악이 없어 보이는걸?!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880031004))  -- "이런 이런~\n빠르면서도 정확한 리듬감이 필요한데 말이야!"
        
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880031005))  -- "안되겠네! 같이 빠른 템포부터 만들어 보지!\n이것들을 준비해보게나!"
    end

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880031006))  -- "오! 준비했군!\n자! 자! 빨리 다음 단계로 넘어가시게나!"
    ]]--
        

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880031007))  -- "듣기만 해도 저절로 엉덩이가 들썩이는 리듬!\n그런 리듬을 알려주겠네!"
    RequireMusicFollowButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880031008))  -- "오~ 오오~~\n음악의 소리가 마치 심장이 빠르게 뛰는 것 같지 않나!?\n내 엉덩이가 마구 들썩이고 있다네!! 굉장하지 않나?!"
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880031009))  -- "지금 이 느낌 그대로 뮤직비디오를 촬영해야겠어!\n그럼 난 이만!!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end





