-- 스윙 베이비(880032) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"
        PushPopupTownNpcWithSelectBox(101)

    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"
        
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"
        PushPopupTownNpcWithSelectBox(101)

    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"

    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"
        PushPopupTownNpcWithSelectBox(101)

    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032001))  -- "스텝만 잘 밟아도 모든 춤이 그럴 싸해 보이는 것을\n알고 있나? 내가 왕년에는 말이야!\n아주 빠른 스텝! 스윙 춤을 멋지게 췄었지!"

    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032002))  -- "신나는 스텝은 모든 생각을 잊고 춤에 집중할 수 있게 해주지!\n빠른 스텝을 밟는 동안의 무아지경!\n나는 지금도 그 시간이 정말 좋다네!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880032003))  -- "왜인지는 모르겠지만.. 자네를 보면 왕년의 내가 떠오르는군..!\n그때의 난 정말 하루도 빠짐없이, 빠르고 열정적인 춤을 추었지!\n심지어는 자면서도 춤을 추었다네.. 허허!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032004))  -- "이제는 나이가 들어 빠른 춤만 추기엔 조금 벅찬 감이 있지만...\n아직 나의 다리는 팔팔하다네!!!\n어떤가? 자네 나와 빠른 스텝 한번 밟아볼 텐가?"
    end


        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880032005))  -- "음.. 이 의상을 준비하게나!\n갑자기 찬란했던 그 시절로 돌아가고 싶은 마음이\n간절해졌다네!"

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202221)  
    TownCharacterWearClothes(TownCharacterGetNPC(101), 202221)  


    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880032006))  -- "오오!! 젊어지는 느낌이야!\n자! 친구! 어서 스텝을 밟아보자구!"

    RequireSceneDanceCorrection()
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032007))  -- "넘치는 흥을 주체할 수 없군!\n어서 신나게 한번 밟아보자구~"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880032008))  -- "햐~~ 이 살아있는 느낌~\n오랜만에 정말 신나는군!\n역시 춤은 위대해!"

    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202221)  
    TownCharacterWearClothes(TownCharacterGetNPC(101), 202221)  
    TownCharacterAction(TownCharacterGetNPC(1), "copy") 
    TownCharacterSetDanceIdle(TownCharacterAddNPC(101), 612354)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032009))  -- "하하! 오랜만에 정말 즐거웠다네!\n다음에 한번 또 같이 춤추세!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    ScenarioIntroShow(101)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032002))  -- "신나는 스텝은 모든 생각을 잊고 춤에 집중할 수 있게 해주지!\n빠른 스텝을 밟는 동안의 무아지경!\n나는 지금도 그 시간이 정말 좋다네!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880032003))  -- "왜인지는 모르겠지만.. 자네를 보면 왕년의 내가 떠오르는군..!\n그때의 난 정말 하루도 빠짐없이, 빠르고 열정적인 춤을 추었지!\n심지어는 자면서도 춤을 추었다네.. 허허!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032004))  -- "이제는 나이가 들어 빠른 춤만 추기엔 조금 벅찬 감이 있지만...\n아직 나의 다리는 팔팔하다네!!!\n어떤가? 자네 나와 빠른 스텝 한번 밟아볼 텐가?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612354, 0)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032007))  -- "넘치는 흥을 주체할 수 없군!\n어서 신나게 한번 밟아보자구~"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880032008))  -- "햐~~ 이 살아있는 느낌~\n오랜만에 정말 신나는군!\n역시 춤은 위대해!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880032009))  -- "하하! 오랜만에 정말 즐거웠다네!\n다음에 한번 또 같이 춤추세!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880032010))  -- "여기 있겠네!\n내 흥분이 가시기 전에 어서 돌아오게나!"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(880032011))  -- "이런.. 모처럼 신났는데 말이야.. 아쉽구먼~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612354, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

