-- 아카데미를 위한 클래식(880041) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041001))  -- "흠흠, 도움을 드리고자 찾아왔습니다."
    end

end


if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(110)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041002))  -- "댄스빌에 오셔서 아카데미도 소유하셨으니..\n수강생을 받으시는 것이 좋을 것 같습니다만,\n아카데미가 너무 조용하고... 한적하군요."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041003))  -- "이래서야 수강을 희망하는 춤꾼들이 왔다가\n그냥 돌아갈 것 같습니다만...\n괜찮으시다면, 분위기를 띄울만한 음악 한 곡 추천해드릴까요?"
    end


        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041004))  -- "수강생이 아카데미로 첫 발을 내디뎠을 때!\n고급스러운 첫인상을 위해 감미로운 클래식이\n흘러나오는 것이 좋겠죠."


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041005))  -- "준비하셨군요."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041006))  -- "테두리가 빛나는 노트를 찍은 후,\n화살표 방향에 맞추어 스크롤 해서\n음의 높이를 맞추면 됩니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041007))  -- "자, 시작하겠습니다."
    RequireMusicFollowButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041008))  -- "이 감미로운 사운드!\n아카데미로 찾아오는 수강생들이\n차마 쉽게 못 돌아서겠군요!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629004)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041009))  -- "도움이 되셨으면 좋겠습니다.\n그럼 저는 이만."

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041010))  -- "아직이시군요.\n흠.. 서두르실 필요는 없습니다."
    GoTown()

end



if OnQuestGiveUp() then

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041011))  -- "알겠습니다.\n오늘은 이만 돌아가도록 하죠."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(110)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041002))  -- "댄스빌에 오셔서 아카데미도 소유하셨으니..\n수강생을 받으시는 것이 좋을 것 같습니다만,\n아카데미가 너무 조용하고... 한적하군요."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041003))  -- "이래서야 수강을 희망하는 춤꾼들이 왔다가\n그냥 돌아갈 것 같습니다만...\n괜찮으시다면, 분위기를 띄울만한 음악 한 곡 추천해드릴까요?"

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041004))  -- "수강생이 아카데미로 첫 발을 내디뎠을 때!\n고급스러운 첫인상을 위해 감미로운 클래식이\n흘러나오는 것이 좋겠죠."
    end

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041005))  -- "준비하셨군요."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041006))  -- "테두리가 빛나는 노트를 찍은 후,\n화살표 방향에 맞추어 스크롤 해서\n음의 높이를 맞추면 됩니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041007))  -- "자, 시작하겠습니다."
    RequireMusicFollowButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041008))  -- "이 감미로운 사운드!\n아카데미로 찾아오는 수강생들이\n차마 쉽게 못 돌아서겠군요!"
    Wait(0.5)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880041009))  -- "도움이 되셨으면 좋겠습니다.\n그럼 저는 이만."

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


