-- 흥겨운 몸동작(880053) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
    end
    

elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
    end
    
elseif CheckQuestComplete() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053001))  -- "앗! [nickname]님!\n찾고 있었어요!"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)

        TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
        TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(113), 612608)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053002))  --   -- "어때요 [nickname]님! 저 멋지죠?!\n저번에 제가 좀 더 생각해서 온다고 했잖아요~\n그때부터 쭉~ 연구하고, 또 연구했죠!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053003))  --   -- "어지러워 보인다고요!?\n아니에요 괜찮아요~\n요령이 생기면 쉽다구요~!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053004))  -- "저번처럼 같이 해보시지 않을래요!?"
    end
    

        TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
        TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053005))  -- "저번에 그 모자 아직 갖고 계시죠!?\n음 이번에는 저랑 같은 옷을 입어요~!"

    
    PushPopupCollectionNeed()
    
end

if OnClickCollectionQuestPopupOk() then
    
    SetCostumeCollectionNeeds()
    TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201201)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202319)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053006))  -- "좋아요! 준비 완료!"
    
    RequireSceneDanceCorrection()
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053007))  -- "넘어지지 않게 다리로\n균형을 잘 잡는 게 중요해요~!\n동선도 크게 크게~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053008))  -- "와! 잘하셨어요! 쉽죠!?"
    
    GoSceneTown()
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201201)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(113), 612608)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053009))  -- "헤헤 역시 [nickname]님!\n한 번에 잘하시다니!\n대단해요! 굉장히 뿌듯해지네요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(113), 612608)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053002))  --   -- "어때요 [nickname]님! 저 멋지죠?!\n저번에 제가 좀 더 생각해서 온다고 했잖아요~\n그때부터 쭉~ 연구하고, 또 연구했죠!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053003))  --   -- "어지러워 보인다고요!?\n아니에요 괜찮아요~\n요령이 생기면 쉽다구요~!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053004))  -- "저번처럼 같이 해보시지 않을래요!?"
    
    --[[
    if CheckQuestStart() then
    else
        TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
        TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053005))  -- "저번에 그 모자 아직 갖고 계시죠!?\n음 이번에는 저랑 같은 옷을 입어요~!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612608, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053007))  -- "넘어지지 않게 다리로\n균형을 잘 잡는 게 중요해요~!\n동선도 크게 크게~"
    
	-- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053008))  -- "와! 잘하셨어요! 쉽죠!?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053010))  -- "제가 좀 더 생각해보니까\n장신구 못지않게\n옷도 중요한 것 같아요~"
    GoTown()
    
end


if OnQuestGiveUp() then

    TownCharacterWearClothes(TownCharacterGetNPC(113), 202319)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880053011))  -- "엑..!\n그렇게 어렵지 않은뎅...\n열심히 생각한 건데... 힝.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612608, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
