-- 아름다운 부채춤(880061) 제작 퀘스트
-- version("0.61.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
        PushPopupTownNpcWithSelectBox(114)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
        PushPopupTownNpcWithSelectBox(114)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
        PushPopupTownNpcWithSelectBox(114)
    end

    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061001))  -- "아이고, 너무 빙글 빙글 돌았나\n어지럽네~~"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(114)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061002))  --   -- "내 기억력이 더 안 좋아지기 전에\n손녀에게 부채춤을 알려주고 싶어서\n오랜만에 다시 연습을 하고 있었다네.."
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061003))  --   -- "양손에 부채를 들고 여러 가지\n아름다운 모양을 구사하며 춤을 추는 거지."
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061004))  -- "여러 명이서 하나의 꽃처럼 표현하는 걸 보면\n가련하면서도 힘찬 그 자태에 넋이 나갈걸세~"
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061005))  -- "허허, 이 늙은이의 말에\n관심이 많은가 보구먼~?\n자네도 한번 배워볼 텐가?"
    end

        TownCharacterWearClothes(TownCharacterGetNPC(114), 205152)
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061006))  -- "이런 부채를 가져온다면\n어떻게 추는 건지 알려주겠네~"


    PushPopupCollectionNeed()
    
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205152)
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061007))  -- "역시 젊은이라 준비도 빠르구먼~~"
    
    RequireSceneDanceCorrection()
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061008))  -- "가련하듯 힘차게,\n살랑~ 살랑~ 춰야 하네."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061009))  -- "오오~ 처음 하는 게 맞나?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205152)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061010))  -- "마치 젊은 시절의 나를 보는\n느낌이구먼.. 허허..\n우리 손녀도 잘 따라줘야 할 텐데.."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061011))  -- "여러 명이 함께 추면 더 예쁠 테니\n자네 아카데미의 크루들과 함께\n군무를 만들어보시게나."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
      -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(114)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061002))  --   -- "내 기억력이 더 안 좋아지기 전에\n손녀에게 부채춤을 알려주고 싶어서\n오랜만에 다시 연습을 하고 있었다네.."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061003))  --   -- "양손에 부채를 들고 여러 가지\n아름다운 모양을 구사하며 춤을 추는 거지."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061004))  -- "여러 명이서 하나의 꽃처럼 표현하는 걸 보면\n가련하면서도 힘찬 그 자태에 넋이 나갈걸세~"
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061005))  -- "허허, 이 늙은이의 말에\n관심이 많은가 보구먼~?\n자네도 한번 배워볼 텐가?"
    
      --[[
    if CheckQuestStart() then
    else
        
        TownCharacterWearClothes(TownCharacterGetNPC(114), 205152)
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061012))  -- "이런 부채를 가져오면\n어떻게 추는 건지 알려주겠네~"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612609, 0)
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061008))  -- "가련하듯 힘차게,\n살랑~ 살랑~ 춰야 하네."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061009))  -- "오오~ 처음 하는 게 맞나?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061013))  -- "이잉? 부채가 없는데\n어떻게 배운다는 건가~"
    GoTown()
    
end

if OnQuestGiveUp() then
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880061014))  -- "모처럼 힘써서 알려주려 했는데..\n아쉽게 됐구먼.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612609, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end






