-- 절도 있는 문워킹(880071) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
        PushPopupTownNpcWithSelectBox(153)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071001))  -- "유행이 뭐, 별건가요?\n내가 추는 모든 춤이 유행이죠!"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(153)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071002))  --   -- "너무 유행을 좇다간 오히려 자신의 개성을\n잃을 수 있다고 생각하는데요..\n유행 안에서 자신의 색을 찾아야 하지 않을까요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071003))  -- "그래서 말이죠, 제가 개발했어요!\n요새 유행하는 춤에서 살짝 변형했죠, 하하."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071004))  -- "첫 공개를 특별히 [nickname]님에게 해주죠!"
    end

	DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071005))  -- "사람들의 뇌리에 박혀서 유행이 되려면,\n이런 특색 있는 복장을 입는게 어떨까요."
    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then
    
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202307)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071006))  -- "오, 멋진데요?\n곧 유행할 것 같아요!"
    
    RequireSceneDanceCorrection()
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071007))  -- "아까 말했다시피, 살~짝 변형했어요.\n잘 보세요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071008))  -- "어때요! 내 개성이 돋보이죠?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202307)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(153), 202307)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 611317)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071009))  -- "막연히 새 춤을 따라 한다고 다 좋은 게 아니죠.\n자신만의 고유색을 찾는 게 중요한 것이란 거!\n[nickname]님은 이미 아실 거라 생각해요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(153)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071002))  --   -- "너무 유행을 좇다간 오히려 자신의 개성을\n잃을 수 있다고 생각하는데요..\n유행 안에서 자신의 색을 찾아야 하지 않을까요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071003))  -- "그래서 말이죠, 제가 개발했어요!\n요새 유행하는 춤에서 살짝 변형했죠, 하하."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071004))  -- "첫 공개를 특별히 [nickname]님에게 해주죠!"

    
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071005))  -- "사람들의 뇌리에 박혀서 유행이 되려면,\n이런 특색 있는 복장을 입는게 어떨까요."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(611317, 0)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071007))  -- "아까 말했다시피, 살~짝 변형했어요.\n잘 보세요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071008))  -- "어때요! 내 개성이 돋보이죠?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071010))  -- "음, 아직 평범하군요."
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880071011))  -- "!? [nickname]님도 유행에는 관심이 없다고요??!\n역시...! 자신만의 춤이 더 중요한 걸 아시다니!\n창작의 열기가 느껴지네요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(611317, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
