-- 디제잉, 비보잉(880082) 제작 퀘스트
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
        PushPopupTownNpcWithSelectBox(148)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082001))  -- "YO, 내가 디제잉만 하는 건 아니다,\n춤도 춘다, 맨~! 주목받는 뮤직비디오를\n만들고 싶다면. 나를 따라 해 yo."
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(148)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082002))  --   -- "퀄리티 높은 음악 제작? 중요하지.\nBUT.\n춤도 잘 춰야 주목받을 수 있지."
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082003))  -- "나도 디제잉을 하기 전엔 꽤 인지~\n도, 높은 춤꾼이었지~"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082004))  -- "내 뮤비 중에 가장 많은 별점을,\n받은 춤을,\n보여줄게 맨~"

        
    end

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082005))  -- "아 잠시만.\n미리 말해두지만.\n조금 어려울 거야, 맨."

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
  
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082006))  -- "예아! 준비됐나! 춤춰볼까!"
    
    RequireSceneDanceCorrection()
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082007))  -- "알 유 레디?\n시작해볼까~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082008))  -- "굿 잡! 맨~"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082009))  -- "좋아~ 이제 멋진 뮤비를 만들면\n팬이 늘어나는 건\n시간문제~ 예~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(148)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082002))  --   -- "퀄리티 높은 음악 제작? 중요하지.\nBUT.\n춤도 잘 춰야 주목받을 수 있지."
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082003))  -- "나도 디제잉을 하기 전엔 꽤 인지~\n도, 높은 춤꾼이었지~"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082004))  -- "내 뮤비 중에 가장 많은 별점을,\n받은 춤을,\n보여줄게 맨~"

    
     --[[
    if CheckQuestStart() then
    else
                DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082005))  -- "아 잠시만.\n미리 말해두지만.\n조금 어려울 거야, 맨."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612598, 0)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082007))  -- "알 유 레디?\n시작해볼까~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082008))  -- "굿 잡! 맨~"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082010))  -- "오~ 노노.\n준비, 미비~"
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880082011))  -- "오케이!\n너의 결정, 나는 인정."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612598, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
