-- 노력은 배신하지 않아(880084) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
        PushPopupTownNpcWithSelectBox(112)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084001))  -- "[nickname]님!\n저도 춤을 알려주세요!"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084002))  --   -- "어떤 형이 추는 춤을 봤는데,\n감정이 벅차고 심장이 엄청\n두근두근 뛰지 뭐예요!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084003))  -- "그 형한테 물어보니까 [nickname]님이 \n알려주셨다고 하더라구요!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084004))  -- "완벽할 순 없겠지만, 조금이라도\n비슷하게 해보고 싶은데.."
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084005))  -- "아시잖아요! 제가 [nickname]님의 도움이\n약~간 필요한 거.. 헤헤..\n도와주시면 안 될까요..?"
        
    end
    

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084006))  -- "에이, 옷이 뭐 중요한가요~?\n동작이 중요하죠!"

    
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
  
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084007))  -- "넵! 전 준비됐어요!\n[nickname]님도 되셨군요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084008))  -- "헤헤, [nickname]님 파이팅!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084009))  -- "우와아..\n또 심장이 두근두근..!\n역시 [nickname]님, 멋져요..!"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(112), "copy")
     TownCharacterAction(TownCharacterGetNPC(1), "copy")   
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084010))  -- "어때요 [nickname]님?\n저 이제 따라 추는 거 많이 늘었죠? 헤헤"
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084011))  -- "이게 다 [nickname]님 덕분이죠~\n정말 감사해요!"
    
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(112)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084002))  --   -- "어떤 형이 추는 춤을 봤는데,\n감정이 벅차고 심장이 엄청\n두근두근 뛰지 뭐예요!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084003))  -- "그 형한테 물어보니까 [nickname]님이 \n알려주셨다고 하더라구요!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084004))  -- "완벽할 순 없겠지만, 조금이라도\n비슷하게 해보고 싶은데.."
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084005))  -- "아시잖아요! 제가 [nickname]님의 도움이\n약~간 필요한 거.. 헤헤..\n도와주시면 안 될까요..?"

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084007))  -- "넵! 전 준비됐어요!\n[nickname]님도 되셨군요!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612599, 0)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084008))  -- "헤헤, [nickname]님 파이팅!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084009))  -- "우와아..\n또 심장이 두근두근..!\n역시 [nickname]님, 멋져요..!"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084012))  -- "앗 [nickname]님.. 배우는 입장에서\n이런 말씀드리긴 죄송하지만..\n아직 준비가 덜 되신 것 같은데.."
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084013))      -- "괜찮아요..!\n저 기다리고 있을게요!!"
    
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880084014))  -- "지금은 바쁘시다구요!?\n아.. 알겠어요..\n이 들뜬 마음을 잠시 접어둘게요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612599, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
