-- 춤바람 커뮤니케이션(880093) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
        PushPopupTownNpcWithSelectBox(153)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093001))  -- "호오? [nickname]님도 관절을 좀\n튕길 줄 아는 것 같은데요?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(153)

       TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093002))  --   -- "보아하니~ 제법이신데요?\n정말로 그 영감님한테 배운 게 맞나요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093003))  -- "그 영감님 말이죠. 말로는 춤 선생이니 하면서\n정작, 자신은 춤은 잘 못 추잖아요?\n별로 믿음이 가지 않는데..."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093004))  -- "음. 어쨌든.. [nickname]님은 꽤 기술을 \n잘 활용하시는 것 같으니... 함께 춤기술을\n활용해서 춤을 춰보지 않을래요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093005))  -- "춤을 주거니 받거니 해서 서로\n교감을 나누는 것이죠! 재밌겠죠!?"
        
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093006))  -- "뭐, 다른 건 필요 없어요.\n그저 길게 춤만 출 수 있다면~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
  
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093007))  -- "음. 준비되셨군요!\n후, 오랜만에 온몸에 전율이 흐르는걸요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093008))  -- "좋~아! 어디 한번 시작해보자구요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093009))  -- "오, [nickname]님의 춤..!\n...대단한데요? 감명받았어요!"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy") -- 유저가 방금 만든 춤을 춤
    TownCharacterAction(TownCharacterGetNPC(153), "copy") -- NPC가 방금 만든 춤을 춤

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093010))  -- "하하. 엄청나요. [nickname]님의 소울이\n그대로 느껴지는 것 같군요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093011))  -- "정말 즐거운 경험이었어요!\n우리 마을에 [nickname]님 같은,\n열정 넘치는 인재가 있다니.. 기쁜 일이에요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093012))  -- "또 종종 같이 춤추자구요~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(153)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093002))  --   -- "보아하니~ 제법이신데요?\n정말로 그 영감님한테 배운 게 맞나요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093003))  -- "그 영감님 말이죠. 말로는 춤 선생이니 하면서\n정작, 자신은 춤은 잘 못 추잖아요?\n별로 믿음이 가지 않는데..."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093004))  -- "음. 어쨌든.. [nickname]님은 꽤 기술을 \n잘 활용하시는 것 같으니... 함께 춤기술을\n활용해서 춤을 춰보지 않을래요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093005))  -- "춤을 주거니 받거니 해서 서로\n교감을 나누는 것이죠! 재밌겠죠!?"

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093008))  -- "좋~아! 어디 한번 시작해보자구요!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612555, 0)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093008))  -- "좋~아! 어디 한번 시작해보자구요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093009))  -- "오, [nickname]님의 춤..!\n...대단한데요? 감명받았어요!"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093013))  -- "잠시만요.\n아직 저와 교감을 나눌 수 없겠어요."

    
    GoTown()
    
end

if OnQuestGiveUp() then

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880093014))  -- "응? 이런.. 내심 기대했는데..\n거절하시다니... 아쉬운데요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612555, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

