-- 명성에 걸맞는 춤(880094) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterStandAt(TownCharacterAddNPC(157), 29*40, 41*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(157))
        TownCharacterSetQuest(TownCharacterGetNPC(157))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(157)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(157))
        
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
        PushPopupTownNpcWithSelectBox(157)
    end

    if OnClickQuestTab(TownCharacterGetNPC(157)) then
    
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
        
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterStandAt(TownCharacterAddNPC(157), 29*40, 41*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(157))
        TownCharacterSetQuest(TownCharacterGetNPC(157))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(157)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(157))
        
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
        
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
        PushPopupTownNpcWithSelectBox(157)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(157)) then
    
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
        
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterStandAt(TownCharacterAddNPC(157), 29*40, 41*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(157))
        TownCharacterSetQuest(TownCharacterGetNPC(157))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(157)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(157))
        
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
        
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
        PushPopupTownNpcWithSelectBox(157)
    end

    if OnClickQuestTab(TownCharacterGetNPC(157)) then
    
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
    
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094001))  -- "[nickname]님의 명성이 명성이 자자하더군요...\n야외무대에서 춤을 뽐내보지 않겠습니까?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(157)

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094002))  --   -- "야외무대에는 가끔씩 엄청난 실력자들이\n제각기 갈고닦은 춤을 뽐내죠."
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094003))  -- "그들 사이에서 당신의 이름이 자주 들리길래\n대체 얼마나 뛰어난 실력을 지니셨을지..\n궁금해졌습니다."
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094004))  -- "제게 춤을 한번 보여주지 않겠습니까?"
        
    end
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094005))  -- "아! 그리고..\n이 정도 길이의 춤을 보고 싶습니다만.."

    
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
       
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
  
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094006))  -- "오, 준비되셨다구요.\n기쁘군요."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094007))  -- "기대가 됩니다."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094008))  -- "오... 역시. \n제 기대를 저버리지 않으시군요."
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy") -- 유저가 방금 만든 춤을 춤
    
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094009))  -- "엄청나십니다.\n역시 명성이 자자한 이유가 있었네요."
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094010))  -- "가끔은 야외무대에서도\n이런 무대를 뽐내주십시오."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(157)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094002))  --   -- "야외무대에는 가끔씩 엄청난 실력자들이\n제각기 갈고닦은 춤을 뽐내죠."
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094003))  -- "그들 사이에서 당신의 이름이 자주 들리길래\n대체 얼마나 뛰어난 실력을 지니셨을지..\n궁금해졌습니다."
        DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094004))  -- "제게 춤을 한번 보여주지 않겠습니까?"

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094006))  -- "오, 준비되셨다구요.\n기쁘군요."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612558, 0)
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094007))  -- "기대가 됩니다."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094008))  -- "오... 역시. \n제 기대를 저버리지 않으시군요."
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094011))  -- "아직 준비되지 않으셨군요.\n기다리겠습니다."

    
    GoTown()
    
end

if OnQuestGiveUp() then

     TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

    DialogOpen(157, STR_NPC(157), "Characters/npc_manager_stage_001", STR_QUEST_TEXT(880094012))  -- "음...? 이런.. 제가 들은 게 분명\n '[nickname]'이었던 것 같은데..\n설마.. 잘못 들은 건가..?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612558, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
