-- 쁘띠의 호수(880101)
-- version("0.51.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)         
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
    
         TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)    
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)         
                DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)     
              DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)         
              DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)     
               DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101001))    -- "안녕 자기~?\n내가 추는 이 우아한 춤에 어울릴만한\n음악 좀 같이 고민해줄래?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(145)
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524) 
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101002))   -- "어때~?\n마치 우아한 한 마리 백조 같지 않니~?"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101003))   -- "근데 말이지, 춤은 너무나 고저스한데,\n어울리는 음악이 없어서 쁘띠는 슬퍼..\n잔잔한 호수 같은 느낌의 음악이 필요한데.."
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101004))  -- "그래서 말이야, 자기한테 좀 부탁하려고~\n도와줄 거지~??"
        
    end


        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101005))   -- "아, 맞다 맞다~~\n생각해보니, 이런 악기가 좋겠다~\n자기, 악기 상점에 좀 갔다 와보지 않을래~?"


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101006))   -- "오우, 정말 가져왔네~\n고마워 자기~\n어서 제작해보자구~"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101007))  -- "음~ 있지~ 약간.. 잔잔하고~\n고요한~ 느낌으로 부탁해~"
    RequireMusicFollowButton()

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101008))   -- "어머, 어머!! 딱 내 스타일!!\n잔잔한 내 마음속에 감동의 물결이~~~"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629033)
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524) 
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101009))   -- "호호. 고마워~ \n춤이 한층 더 우아해 보이는 것 같아서 기뻐~"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101010))   -- "정말로 어메이징 한 음악이야.\n제목은 '내 마음속 호수'로 정했어!\n어머! 내가 지었지만, 넘 세련된 느낌!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101011))   -- "음~~ 노농~~\n아직 악기가 없잖아~!"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101012))  -- "응? 그래애?\n자기.. 내 부탁을 거절했다.. 이거지?!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(145)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101002))   -- "어때~?\n마치 우아한 한 마리 백조 같지 않니~?"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101003))   -- "근데 말이지, 춤은 너무나 고저스한데,\n어울리는 음악이 없어서 쁘띠는 슬퍼..\n잔잔한 호수 같은 느낌의 음악이 필요한데.."
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101004))  -- "그래서 말이야, 자기한테 좀 부탁하려고~\n도와줄 거지~??"
        
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101005))   -- "아, 맞다 맞다~~\n생각해보니, 이런 악기가 좋겠다~\n자기, 악기 상점에 좀 갔다 와보지 않을래~?"
         
    end

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101006))   -- "오우, 정말 가져왔네~\n고마워 자기~\n어서 제작해보자구~"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101007))  -- "음~ 있지~ 약간.. 잔잔하고~\n고요한~ 느낌으로 부탁해~"
    RequireMusicFollowButton()
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101008))   -- "어머, 어머!! 딱 내 스타일!!\n잔잔한 내 마음속에 감동의 물결이~~~"
      
      Wait(0.5)

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101009))   -- "호호. 고마워~ \n춤이 한층 더 우아해 보이는 것 같아서 기뻐~"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880101010))   -- "정말로 어메이징 한 음악이야.\n제목은 '내 마음속 호수'로 정했어!\n어머! 내가 지었지만, 넘 세련된 느낌!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end



