-- 발끝으로 톡톡, 다리를 쭉~(880103) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
        
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
          
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
        PushPopupTownNpcWithSelectBox(117)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(117)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)       
            TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103001))  -- "흠?\n왜? 뭐, 용건이라도 있어?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(117)

        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103002))  --   -- "내가 추고 있는 이 춤이 궁금해서 불렀다구?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103003))  -- "하긴. 우리 춤요정들의 춤은\n보는 사람으로 하여금 호기심을 가지지 않고서는\n못 배길 정도로 매력적이니.. 이해해."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103004))  -- "뭐, 지금 동작은 춤요정들의 춤 중에서도\n가장 간단한 기본 동작이야~"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103005))  -- "쁘웽뜨와 포인이지.\n원한다면 알려줄 수도 있는데."

    end

        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103006))  -- "그럼 의상을 갖춰 입고 오도록.\n우리 요정들은 워낙 가벼우니 따라 하려면\n최소한 가볍게 입는 게 좋을 거야."

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202314)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103007))  -- "음 준비했군."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103008))  -- "간단해.\n발끝을 가볍게 톡톡 튀기듯이.\n잘 따라 해보도록."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103009))  -- "어때, 꽤 간단하지?"
    
    GoSceneTown()
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
    TownCharacterAction(TownCharacterGetNPC(1), "copy") -- 방금 만든 춤을 춤
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202314)
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103010))  -- "우아한 우리 춤을 알아보다니.\n네 안목도 좀 괜찮은걸?\n그럼 다음에 또 보자구~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(117)
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103002))  --   -- "내가 추고 있는 이 춤이 궁금해서 불렀다구?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103003))  -- "하긴. 우리 춤요정들의 춤은\n보는 사람으로 하여금 호기심을 가지지 않고서는\n못 배길 정도로 매력적이니.. 이해해."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103004))  -- "뭐, 지금 동작은 춤요정들의 춤 중에서도\n가장 간단한 기본 동작이야~"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103005))  -- "쁘웽뜨와 포인이지.\n원한다면 알려줄 수도 있는데."
        

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103007))  -- "음 준비했군."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612587, 0)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103008))  -- "간단해.\n발끝을 가볍게 톡톡 튀기듯이.\n잘 따라 해보도록."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103009))  -- "어때, 꽤 간단하지?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612587)   
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103011))  -- "아직 알려줄 수가 없겠는걸?"

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880103012))  -- "아, 별로 궁금하지 않다고?\n그럼 왜 부른 거야?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612587, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
