-- 부드럽게, 우아하게(880104) 제작 퀘스트
-- version("0.51.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)       
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
        
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
        PushPopupTownNpcWithSelectBox(145)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(145)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104001))  -- "Bonjour~~\n오늘 하루도 우아~하게~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104002))  -- "응~?\n혹시 자기 내 춤에 관심 있어?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(145)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)    

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104003))  --   -- "오홍~ 자기도 우아한 춤사위에 관심이 많나 봐?\n나도 참 좋아하지~\n더욱더 빛날 수 있도록 엄청 연구 했다구~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104004))  -- "내가 이 춤을 처음 출 때 춤 요정들의\n움직임에서 많은 영감을 받았어~\n요정들의 움직임이 정말 가볍고 아름답단 말이지~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104005))  -- "그래, 우아한 춤은 말이야~\n아름답게~ 발끝을 쭉 쭉 ~\n포인트를 정확하게 잡아주는 것이 중요해~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104006))  -- "발끝까지 쭉~ 펴고, 부드~럽게\n턴~ 하면 이렇게 우아한 춤의 완성이야~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104007))          -- "원한다면 아주 약~간만 알려줘볼까?\n고저스 한 내 동작을 과연\n잘 따라 할 수 있을지 모르겠지만?"
    end
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104008))  -- "음~ 내가 아름답게 손봐주고 싶지만~\n지금은 좀 바빠서 말이야~\n춤에 어울릴 의상이나 좀 입어보겠어~?"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202310)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104009))  -- "호홍~ 준비가 된 것 같네~\n어서 시작해볼까?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104010))  -- "프레 파라 시옹~~\n준비~~~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104011))  -- "오우~ 뷰리~풀!\n생각보다 잘 따라 하는걸?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202310)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)    

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104012))  -- "그래, 이제 좀 우아해 보이네~"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104013))  -- "그리구~ 우아한 춤도 중요하지만~\n몸치장도 매일 꾸준히 해야 한다는 것도 잊지 마~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104014))  -- "응?\n뭐야 자기~\n준비가 안됐잖아~"

    
    GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(145)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)    

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104003))  --   -- "오홍~ 자기도 우아한 춤사위에 관심이 많나 봐?\n나도 참 좋아하지~\n더욱더 빛날 수 있도록 엄청 연구 했다구~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104004))  -- "내가 이 춤을 처음 출 때 춤 요정들의\n움직임에서 많은 영감을 받았어~\n요정들의 움직임이 정말 가볍고 아름답단 말이지~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104005))  -- "그래, 우아한 춤은 말이야~\n아름답게~ 발끝을 쭉 쭉 ~\n포인트를 정확하게 잡아주는 것이 중요해~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104006))  -- "발끝까지 쭉~ 펴고, 부드~럽게\n턴~ 하면 이렇게 우아한 춤의 완성이야~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104007))          -- "원한다면 아주 약~간만 알려줘볼까?\n고저스 한 내 동작을 과연\n잘 따라 할 수 있을지 모르겠지만?"

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104009))  -- "호홍~ 준비가 된 것 같네~\n어서 시작해볼까?"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612524, 0)
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104010))  -- "프레 파라 시옹~~\n준비~~~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104011))  -- "오우~ 뷰리~풀!\n생각보다 잘 따라 하는걸?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnQuestGiveUp() then

    TownCharacterSetDanceIdle(TownCharacterAddNPC(145), 612524)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880104015))  -- "응~ 괜찮아~ 이해해~\n누군가 내 우아함 넘치는 동작을\n습득하기에는 벅찰 수 있는 거니까~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612524, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
