-- 이 구역 쇼핑왕은 나(880111)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

        
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

        PushPopupTownNpcWithSelectBox(101)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(101)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009",  STR_QUEST_TEXT(880111001))   -- "에고고 힘들다...\n샤바와 쇼핑을 다녀오는 길일세..\n잠깐 좀 쉬어야지.. 아카데미에서 물 한잔만 주겠나?"

    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880111002))    -- "응? 이렇게 힘든데 왜 항상 샤바와 쇼핑에 같이 가냐고?"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880111003))     -- "자고로, 춤에 어울리는 의상을 갖춰 입어야\n좀 더 춤추는 자의 그 섬세한 감정을\n잘 전달할 수 있다고 생각한다네..!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111004))   -- "춤꾼에게 있어서 아주 중요한 일이지..\n그 점에서 나는 항상 쇼핑을 하는\n샤바가 참 존경스럽고말고.."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006",  STR_QUEST_TEXT(880111005))     -- "현란한 춤을 추듯 옷을 고르는 그녀의 모습이란..!\n그 모습을 하염없이 보고 있다가 정신을 차려보면,\n어느새 나의 양손은 그녀의 옷들로 가득하지.. 하하.."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880111006))     -- "흐음, 아무래도 자네는 쇼핑을 잘 즐기지 못하는 것 같군..\n샤바가 추는 쇼핑 춤을 한번 춰보지 않겠나?\n내가 알려줄 수 있다네."
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111007))   -- "자, 이왕 추는 김에 새로운 옷도 한번 입어보게나!\n기분 전환 겸 말일세! 하하하!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202354) -- 나중에 바꿔야함
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111008))  -- "오 멋진 의상이군!\n이렇게 훌륭한 의상도 입었으니\n어서 춤을 춰보자고~!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880111009))    -- "이것이 바로 샤바의 '신나는 쇼핑' 춤이라네!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111010))    -- "하하하!!\n정말 잘 추는걸?\n샤바와 대결을 해도 좋겠어!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202354)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(101), 612603)    
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880111011))   -- "신나는 춤을 추듯이 쇼핑을 즐겨보라구!\n모든 옷들이 자네에게 영감을 줄 테니 말이야!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(101)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
 
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880111002))    -- "응? 이렇게 힘든데 왜 항상 샤바와 쇼핑에 같이 가냐고?"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880111003))     -- "자고로, 춤에 어울리는 의상을 갖춰 입어야\n좀 더 춤추는 자의 그 섬세한 감정을\n잘 전달할 수 있다고 생각한다네..!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111004))   -- "춤꾼에게 있어서 아주 중요한 일이지..\n그 점에서 나는 항상 쇼핑을 하는\n샤바가 참 존경스럽고말고.."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006",  STR_QUEST_TEXT(880111005))     -- "현란한 춤을 추듯 옷을 고르는 그녀의 모습이란..!\n그 모습을 하염없이 보고 있다가 정신을 차려보면,\n어느새 나의 양손은 그녀의 옷들로 가득하지.. 하하.."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880111006))     -- "흐음, 아무래도 자네는 쇼핑을 잘 즐기지 못하는 것 같군..\n샤바가 추는 쇼핑 춤을 한번 춰보지 않겠나?\n내가 알려줄 수 있다네."


    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612603, 0)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880111009))    -- "이것이 바로 샤바의 '신나는 쇼핑' 춤이라네!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880111010))    -- "하하하!!\n정말 잘 추는걸?\n샤바와 대결을 해도 좋겠어!"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880111012))    -- "응? 아직 새로운 의상을 입지 않았는걸?"

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880111013))   -- "이런..\n관심이 없다니!\n유감일세~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612603, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

