-- 개구리 동요(880122)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
         DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
                DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
              DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
              DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
               DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122001))    -- "[nickname]님 혹시 동요 아세요?\n개울가의 개구리요~"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122002))   -- "모르신다구요?\n요새 아이들 사이에서 엄청 유행인데~?!\n그럼 제가 알려드릴까요?"
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122003))   -- "이게 있어야 해요!~"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122004))   -- "오 가져오셨네요!\n알려드릴게요!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122005))  -- "팔~짝, 팔~짝~ 개구리 됐네~"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122006))   -- "정말 귀여운 노래죠!?"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629026)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122007))   -- "헤헤, 중독성 있어서 자꾸 부르게 돼요~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122008))   -- "으.. 이게 있어야 하는데..!"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122009))  -- "아? 안 궁금하세요?\n이런.. 아쉽네요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122002))   -- "모르신다구요?\n요새 아이들 사이에서 엄청 유행인데~?!\n그럼 제가 알려드릴까요?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122003))   -- "이게 있어야 해요!~"
         
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122004))   -- "오 가져오셨네요!\n알려드릴게요!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122005))  -- "팔~짝, 팔~짝~ 개구리 됐네~"
    RequireMusicFollowButton()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122006))   -- "정말 귀여운 노래죠!?"
      
      Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880122007))   -- "헤헤, 중독성 있어서 자꾸 부르게 돼요~"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end



