-- 개구리 춤(880123)
-- version("0.53.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(67) --=BGM=Theme_Interiorshop
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"
        
        PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(67) --=BGM=Theme_Interiorshop
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"

        PushPopupTownNpcWithSelectBox(144)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(144)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(67) --=BGM=Theme_Interiorshop
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"

        PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123001))   -- "휴..... 개구리..\n[nickname], 혹시 개구리 좋아해..?"


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(144)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123002))      -- "우리 조카가 개구리를 참 좋아해.\n요새 개구리 동요만 부르지 뭐야."
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123003))    -- "그래서 개구리 모양 소품을 하나 줬더니, \n신나서 개구리 동요에 맞는 춤을 알려 달라고 하길래\n나름대로 알려줬는데... 그게 아니라며 울고불고.."
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123004))    -- "아무튼, 대체 그 개구리 춤이 뭔지 몰라서\n[nickname]에게 도움을 좀 요청하려고..!\n개구리 춤 좀 가르쳐줄 수 있어?"
    
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880123005))    -- "아, 이 옷을 입으면 좀 더 개구리 같은\n느낌이 잘 살지 않을까?"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202363)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201242)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123006))   -- "오! 정말 개구리 같네?! 호호!\n그럼 기대할게~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123007))   -- "조카가 따라 하기 쉽도록,\n쉬운 춤으로 부탁해~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880123008))  -- "오호~ \n뒷다리가 쑥~ 앞다리가 쑥~\n하는 거야?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202363)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201242)
    TownCharacterAction(TownCharacterGetNPC(144), "copy")    
        
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123009))  -- "우와~! 너무 기발해~~\n조카가 좋아할 것 같아~!\n너무 고마워!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(144)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
 
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123002))      -- "우리 조카가 개구리를 참 좋아해.\n요새 개구리 동요만 부르지 뭐야."
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123003))    -- "그래서 개구리 모양 소품을 하나 줬더니, \n신나서 개구리 동요에 맞는 춤을 알려 달라고 하길래\n나름대로 알려줬는데... 그게 아니라며 울고불고.."
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123004))    -- "아무튼, 대체 그 개구리 춤이 뭔지 몰라서\n[nickname]에게 도움을 좀 요청하려고..!\n개구리 춤 좀 가르쳐줄 수 있어?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612513, 0)
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123007))   -- "조카가 따라 하기 쉽도록,\n쉬운 춤으로 부탁해~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880123008))  -- "오호~ \n뒷다리가 쑥~ 앞다리가 쑥~\n하는 거야?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880123010))     -- "아주 약간만 더 느낌이 살면 좋을 것 같은데.."

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880123011))    -- "아..? 너무 어려운 요구였나?.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612513, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
