-- 체중 조절(880131)
-- version("0.53.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."
        
        PushPopupTownNpcWithSelectBox(162)
    end

    if OnClickQuestTab(TownCharacterGetNPC(162)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."

        PushPopupTownNpcWithSelectBox(162)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(162)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."

        PushPopupTownNpcWithSelectBox(162)
    end

    if OnClickQuestTab(TownCharacterGetNPC(162)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131001))     -- "혹싱... 지금 시간 좀 있낭?\n내가 은밀히 좀 얘기할 게 있는뎅...."


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(162)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  

        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131002))      -- "흠흠... 은밀하게 할 이야기는..\n사실 요새 내가 살이 좀 많이 쪘지 뭐양?"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131003))     -- "뭐 급격히는 아니고, 꾸준히 쪄오긴 했지만...\n건강에 적신호가 켜진 것 같아서 말이양.."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131004))     -- "체중 조절을 해야 해서 식습관을\n개선 중인데 말양, 밤에 너어어어무\n배고파성 결국 참고 참다가.... 그만!!!"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131005))     -- "야식을 먹었단 말이징..\n하아.. 굶는 건 너무 힘들엉...."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131006))     -- "혹시 살이 빠질만한 격렬한 댄스를 알고 있엉?\n알고 있다면.. 추천 좀 해줭.."
        
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880131007))    -- "아아~ 잠시만!!\n운동복을 아직 준비하지 못했다궁..!!\n[nickname]가 대신 좀 준비해줭.. 부탁행!!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202364)
    TownCharacterWearClothes(TownCharacterGetNPC(162), 202364)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131008))     -- "오! 운동복이당!!\n자 그럼 이제 어서 보여줭!!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131009))     -- "열심히 따라 춰 볼겡!!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880131010))    -- "헉.. 헉..\n너무 힘든 것 아니양??"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202364)
    TownCharacterWearClothes(TownCharacterGetNPC(162), 202364)
    TownCharacterAction(TownCharacterGetNPC(162), "copy")    
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131011))     -- "뭔가 살이 빠지는 느낌이양..\n역시 살 빼는 건 너무나 힘들구낭..."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131012))     -- "그래도 정말 고마웡!\n집에서도 열심히 해볼겡..!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(162)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
 
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131002))      -- "흠흠... 은밀하게 할 이야기는..\n사실 요새 내가 살이 좀 많이 쪘지 뭐양?"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131003))     -- "뭐 급격히는 아니고, 꾸준히 쪄오긴 했지만...\n건강에 적신호가 켜진 것 같아서 말이양.."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131004))     -- "체중 조절을 해야 해서 식습관을\n개선 중인데 말양, 밤에 너어어어무\n배고파성 결국 참고 참다가.... 그만!!!"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131005))     -- "야식을 먹었단 말이징..\n하아.. 굶는 건 너무 힘들엉...."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131006))       -- "혹시 살이 빠질만한 격렬한 댄스를 알고 있엉?\n알고 있다면.. 추천 좀 해줭.."

    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612557, 0)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131009))    -- "열심히 따라 춰 볼겡!!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131010))  -- "헉.. 헉..\n너무 힘든 것 아니양??"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880131013))     -- "운동할 땐 운동복을 입는 거징~~\n땀이 날 테니까 말이양~~"

    
    GoTown()
    
end


if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880131014))    -- "뭐~엉~!??!\n알려주기 싫다궁?!?!?\n정말 흥!! 이양!!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612557, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

