-- 괴상한 음악(880143)
-- version("0.31.00")

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583) 
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
         TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583) 
         DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583) 
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583)    
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583) 
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612583) 
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143001))    -- "광장의 해괴한 정체?\n음? 그거 혹시 나인가?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(117)

        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612605) 
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143002))   -- "아 요새 또 새로운 춤을 연습하고 있거든.\n몸동작과 목동작이 마치 따로 움직이는 듯한 춤인데.."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143003))  -- "이게 그렇게 무섭나..? 왜인지 모르겠지만\n내 새 춤을 보고는 사람들의 표정이 점점 굳어지면서\n도망가더라니까? 이해가 안 되네.. 내 춤이 별론가?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143004))  -- "음.. 그런데 말이야.. 슬슬 이 춤으로 뮤비를 찍어서\n댄스비전에 올려볼까 하는데.. \n이 춤에 어울릴 만한 음악이 있을까?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143005))                     -- "약간 생각해둔 음악이 있긴 해. 들어볼래?"
    end

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143006))   -- "이런 악기 소리가 있으면 좋겠지?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    SetCostumeCollectionNeeds()
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143007))   -- "오, 그래 이 악기 맞아~\n제대로 준비했군!"
    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143008))  -- "어떨지 기대되지 않나?"
    RequireMusicFollowButton()

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143009))   -- "음. 역시 내 예상이 맞았어.\n춤과 엄청 잘 맞는 음악이야!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629011)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612605) 
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143010))   -- "어서 뮤직비디오를 찍으러 가야겠어!\n도와줘서 고맙네 친구!\n그럼 난 이만~!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143011))   -- "음.. 아직인가? "
    GoTown()
end

if OnQuestGiveUp() then
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143012))  -- "흠.. 그래.\n그로테스크한 음악이 만들기 어려울 수 있지."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end






-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(117)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143002))   -- "아 요새 또 새로운 춤을 연습하고 있거든.\n몸동작과 목동작이 마치 따로 움직이는 듯한 춤인데.."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143003))  -- "이게 그렇게 무섭나..? 왜인지 모르겠지만\n내 새 춤을 보고는 사람들의 표정이 점점 굳어지면서\n도망가더라니까? 이해가 안 되네.. 내 춤이 별론가?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143004))  -- "음.. 그런데 말이야.. 슬슬 이 춤으로 뮤비를 찍어서\n댄스비전에 올려볼까 하는데.. \n이 춤에 어울릴 만한 음악이 있을까?"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143005))                     -- "약간 생각해둔 음악이 있긴 해. 들어볼래?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143006))   -- "이런 악기 소리가 있으면 좋겠지?"
         
    end

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143007))   -- "오, 그래 이 악기 맞아~\n제대로 준비했군!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143008))  -- "어떨지 기대되지 않나?"
    RequireMusicFollowButton()
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143009))   -- "음. 역시 내 예상이 맞았어.\n춤과 엄청 잘 맞는 음악이야!"
      
      Wait(0.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880143010))   -- "어서 뮤직비디오를 찍으러 가야겠어!\n도와줘서 고맙네 친구!\n그럼 난 이만~!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end




