-- 치어리딩 음악(880151)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
                DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
              DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
              DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
               DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151001))    -- "누군가 나를 응원해주는 음악을 듣는다면,\n힘이 샘솟겠지!?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(117)
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151002))    -- "항상 우리 춤요정들을 위해 댄소나이트를 모으시는\n여왕님께 감사의 뜻을 담아 응원을 해드리고 싶은데.."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151003))  -- "혹시 응원가 같은 음악이 있을까?\n들으면 막, 힘이 나는 것 같은 음악 말이야..!\n알려줄 수 있어?"
    end

	DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151004))   -- "음.. 개인적으로 이 악기 소리가 맘에 들던데..\n들을 때마다 힘이 나더라구!\n그럼 부탁해!"
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151005))   -- "준비되었군!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151006))  -- "들으면 막 힘이 나는 음악으로 부탁해!"
    RequireMusicFollowButton()

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151007))   -- "오...마치 몸속 깊숙한 곳에서부터\n기운이 넘쳐 오르는 듯한 느낌이야..!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629008)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151008))   -- "정말 좋은 곡이야!\n여왕님도 분명 힘이 나시겠지!\n고마워!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151009))   -- "음. 아직 준비되지 않았군..\n그 악기가 없잖아.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151010))  -- "알겠어..\n나 혼자 고민하도록 하지.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(117)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151002))    -- "항상 우리 춤요정들을 위해 댄소나이트를 모으시는\n여왕님께 감사의 뜻을 담아 응원을 해드리고 싶은데.."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151003))  -- "혹시 응원가 같은 음악이 있을까?\n들으면 막, 힘이 나는 것 같은 음악 말이야..!\n알려줄 수 있어?"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151004))   -- "음.. 개인적으로 이 악기 소리가 맘에 들던데..\n들을 때마다 힘이 나더라구!\n그럼 부탁해!"
         
    end

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151005))   -- "준비되었군!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151006))  -- "들으면 막 힘이 나는 음악으로 부탁해!"
    RequireMusicFollowButton()
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151007))   -- "오...마치 몸속 깊숙한 곳에서부터\n기운이 넘쳐 오르는 듯한 느낌이야..!"
      
      Wait(0.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880151008))   -- "정말 좋은 곡이야!\n여왕님도 분명 힘이 나시겠지!\n고마워!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end





