-- 때로는 섹시하게(880162)
-- version("0.60.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"
        
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"
        PushPopupTownNpcWithSelectBox(126)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"

        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162001))     -- "걸그룹 안무쯤이야!\n모두 섭렵했죠 훗!"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음	
	SoundPlay(9) --=BGM=Event_Quest_common    
    
	if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(126)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162002))      -- "유행과 더불어 걸그룹 안무는 기본 중에 기본!\n걸그룹들의 모든 안무쯤은 알아야 어디 가서\n말을 할 수 있다구요~!"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162003))      -- "핫 한 안무는 바로~ 섹시한 안무가 핵심!\n저한테 한번 배워볼래요?"
	end
    
	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880162004))    -- "이런 섹시한 의상 정도는 입어줘야겠죠~?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202298)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202298)           
     
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162005))     -- "섹시한 옷도 입었으니,\n어서 춤을 춰보죠!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162006))     -- "후훗, 별거 없어요~\n저만 따라 해보세요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880162007))    -- "어때요~?\n완전 섹시하죠?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612585)    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202298)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202298)       
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162008))     -- "완전 섹시한 걸그룹 안무 완성!\n핫~ 하죠?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown() 
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(126)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162002))      -- "유행과 더불어 걸그룹 안무는 기본 중에 기본!\n걸그룹들의 모든 안무쯤은 알아야 어디 가서\n말을 할 수 있다구요~!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162003))    -- "핫 한 안무는 바로~ 섹시한 안무가 핵심!\n저한테 한번 배워볼래요?"
        
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612585, 0)
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162006))     -- "후훗, 별거 없어요~\n저만 따라 해보세요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880162007))    -- "어때요~?\n완전 섹시하죠?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880162009))     -- "그럼 입고 오시길 기대할게요~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880162010))    -- "앗? 또 유행에 뒤쳐지시려는 건가요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612585, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
