-- 언제나 귀엽게(880163)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "
        
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "

        PushPopupTownNpcWithSelectBox(150)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "

        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163001))     -- "사! 랑! 해! 요! 밸! 리! "
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(150)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163002))      -- "[nickname]님! 아이티즈의 밸리님 아시죠?\n밸리님 말이에요!\n예쁘고 청순한 귀여움의 대명사!"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163003))      -- "그녀가 추는 춤은 정말 얼마나 귀여운지 몰라요~!\n한번 보실래요?"
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880163004))    -- "일단 밸리님처럼 귀여운 옷을 입어보자구요~!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202299)    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163005))     -- "헤헤. 정말 귀여우시네요...\n물론 우리 밸리님이 훨씬 귀엽지만!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163006))     -- "한번 춰보시면 귀여운 매력에 빠지실 거예요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880163007))    -- "헤헤 어때요!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202299)    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(202), 612545)    
        
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163008))     -- "정말 귀엽죠?!\n그녀가 추면 더 귀엽다구요...!!\n사랑! 해요! 밸! 리!~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(150)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163002))      -- "[nickname]님! 아이티즈의 밸리님 아시죠?\n밸리님 말이에요!\n예쁘고 청순한 귀여움의 대명사!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163003))      -- "그녀가 추는 춤은 정말 얼마나 귀여운지 몰라요~!\n한번 보실래요?"
        
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612545, 0)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163006))    -- "한번 춰보시면 귀여운 매력에 빠지실 거예요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880163007))    -- "헤헤 어때요!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880163004))     -- "일단 밸리님처럼 귀여운 옷을 입어보자구요~!"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880163009))    -- "앗.... 너무해..\n밸리님도 모르시고...\n관심도 없으시고..."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612545, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
