-- 혈통있는 개의 춤사위(880173)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"
        
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"

        PushPopupTownNpcWithSelectBox(103)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"

        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173001))     -- "어머! 아리에게 카트라슈와 함께 추는 춤을\n가르쳐 줬다면서요? 너무 귀엽던데!\n나도 좀 부탁해도 될까요?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173002))      -- "아리와 카트라슈가 함께 춤추는 걸 봤어요!\n아리가 콧수염까지 붙이고는... 호호 정말 웃겼는데~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880173003))      -- "동그랗게 말린 콧수염이 얼마나 귀여운 지..\n카트라슈의 콧수염 정말 귀엽지 않나요? 호호"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173004))            -- "그래서 말인데, 우리 가족 모두 함께 출 수 있는\n콧수염 춤을 좀 알려주지 않을래요?\n뭐랄까.. 카트라슈와의 교감을 춤으로 표현하고 싶달까~?"    
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002",  STR_QUEST_TEXT(880173005))    -- "아! 그래~~ 콧수염도 있어야 하지만, \n뭔가 우리 가족을 잘 표현할 수 있는 의상도\n입고 싶네요~! 그럼 잘 부탁해요~"

    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202300)    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880173006))     -- "어머, 벌써 다 준비하셨네요?\n빠르기도 하셔라~\n우리 가족이 추게 될 춤! 기대되네요!~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173007))     -- "그럼, 잘 부탁해요~~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002",  STR_QUEST_TEXT(880173008))    -- "어머나! 호호호!\n우리 가족이 모두 함께 추면\n너무 귀여울 것 같은데요!?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(103), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202300)   
    TownCharacterWearClothes(TownCharacterGetNPC(103), 202300) 
        
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173009))     -- "고마워요~ 어서 가서 춰보자고 해야지~\n이건 내 부탁을 들어준 보답~\n다음에 또 봐요~ 카트라슈 어딨니~ 이리 온~"

    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(103)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173002))      -- "아리와 카트라슈가 함께 춤추는 걸 봤어요!\n아리가 콧수염까지 붙이고는... 호호 정말 웃겼는데~"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880173003))      -- "동그랗게 말린 콧수염이 얼마나 귀여운 지..\n카트라슈의 콧수염 정말 귀엽지 않나요? 호호"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173004))             -- "그래서 말인데, 우리 가족 모두 함께 출 수 있는\n콧수염 춤을 좀 알려주지 않을래요?\n뭐랄까.. 카트라슈와의 교감을 춤으로 표현하고 싶달까~?"
           
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612600, 0)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173007))    -- "그럼, 잘 부탁해요~~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002",  STR_QUEST_TEXT(880173008))    -- "어머나! 호호호!\n우리 가족이 모두 함께 추면\n너무 귀여울 것 같은데요!?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880173010))     -- "천천히 준비하세요~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005",  STR_QUEST_TEXT(880173011))    -- "음.. 지금은 좀 곤란한가 봐요?\n알겠어요, 그럼 다음에 다시 말하죠~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612600, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

