-- 구애의 춤(880174)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(107))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"
        
        PushPopupTownNpcWithSelectBox(107)
    end

    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(107))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"

        PushPopupTownNpcWithSelectBox(107)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(107))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"

        PushPopupTownNpcWithSelectBox(107)
    end

    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(880174001))     -- "앗! 찾고 있었다구!!"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(107)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_008", STR_QUEST_TEXT(880174002))      -- "너지! 날 이렇게 힘들게 한 게!\n가족들이 계속 춤이며 음악이며 배워와서는..\n날 한 시도 가만히 두질 않는다고!"
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(880174003))      -- "반짝이는 눈을 보니 안출 수도 없고 휴우..\n흠... 그, 그래도 덕분에 잠들어있던 내 춤 세포들이\n활력을 찾은 느낌이야! 그래서 말인데~"
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_010", STR_QUEST_TEXT(880174004))            -- "웅디에게 잘 보일 멋있는 춤을 추고 싶어!\n춤 연습을 좀 하려는데 내 파트너로 춤 실력이 뛰어난\n네가 제격인 것 같아서 말이야! 같이 춰보지 않겠어?"    
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_009",  STR_QUEST_TEXT(880174005))    -- "아 맞다! 웅디는 이런 걸 좋아하더라구!\n이걸 활용해서 추는 춤을 알려줄 수 있어?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205161)    
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_002", STR_QUEST_TEXT(880174006))     -- "왕! 왔어?\n어디 어디.. 오오! 좋아! 제대로 준비했네!\n어서 알려줘! 왕!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(880174007))     -- "어디, 같이 춰볼까?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_005",  STR_QUEST_TEXT(880174008))    -- "오오!!! 왕왕! 내가 원하던 춤이야!!\n이제 웅디도 날 멋있게 봐주겠지?!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(107), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205161)   
    TownCharacterWearClothes(TownCharacterGetNPC(107), 205161) 
        
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(880174009))     -- "고마워! 왕왕!\n다음엔 웅디와 함께 출 수 있는\n커플 댄스를 부탁할게~! "
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(107)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_008", STR_QUEST_TEXT(880174002))      -- "너지! 날 이렇게 힘들게 한 게!\n가족들이 계속 춤이며 음악이며 배워와서는..\n날 한 시도 가만히 두질 않는다고!"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004", STR_QUEST_TEXT(880174003))      -- "반짝이는 눈을 보니 안출 수도 없고 휴우..\n흠... 그, 그래도 덕분에 잠들어있던 내 춤 세포들이\n활력을 찾은 느낌이야! 그래서 말인데~"
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_010", STR_QUEST_TEXT(880174004))            -- "웅디에게 잘 보일 멋있는 춤을 추고 싶어!\n춤 연습을 좀 하려는데 내 파트너로 춤 실력이 뛰어난\n네가 제격인 것 같아서 말이야! 같이 춰보지 않겠어?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612570, 0)
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(880174007))    -- "어디, 같이 춰볼까?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_005",  STR_QUEST_TEXT(880174008))    -- "오오!!! 왕왕! 내가 원하던 춤이야!!\n이제 웅디도 날 멋있게 봐주겠지?!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_008", STR_QUEST_TEXT(880174010))     -- "왕왕! 뭐 하는 거야! 어서 구해오라구!"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_004",  STR_QUEST_TEXT(880174011))    -- "휴우.. 어쩔 수 없지..\n왕! 생각이 바뀌면 얘기해!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612570, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

