-- 정열의 커플 댄스(880181)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)          
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"
        
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)              
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)              
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"

        PushPopupTownNpcWithSelectBox(103)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)              
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)              
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"

        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
            TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)              
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880181001))     -- "어깨에 손을 올리고, 원~투, 원~투~\n아? [nickname]님? 같이 해볼래요?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)         
    
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880181002))      -- "어제 2150번째 드레스를 산 기념으로,\n우리 여보와 함께 출 춤을 연습 중이었어요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880181003))      -- "미리 호흡을 맞춰볼 사람이 필요한데...\n혹시 괜찮다면 같이 연습해주지 않을래요?"
	end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)       
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006",  STR_QUEST_TEXT(880181004))    -- "미안하지만~ 나와 어울리는 의상을 좀 갖춰주지 않겠어요~?"
    
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612540)          
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202304) 
    TownCharacterWearClothes(TownCharacterGetNPC(103), 202304)           
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880181005))     -- "어머 오셨네요!\n저도 입었답니다~ 호호!\n이제 춤춰 볼까요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880181006))     -- "원, 투, 쓰리~ 원, 투, 쓰리~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001",  STR_QUEST_TEXT(880181007))    -- "좋아요~ 스텝은 완벽해요~"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(103), "612540")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202304)
    TownCharacterWearClothes(TownCharacterGetNPC(103), 202304)      
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880181008))     -- "호호~! 정말 고마워요~\n연습하게 돼서 너무 좋네요~!\n역시 [nickname]님 최고~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(103)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterAction(TownCharacterGetNPC(103), "612540")
   
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880181002))      -- "어제 2150번째 드레스를 산 기념으로,\n우리 여보와 함께 출 춤을 연습 중이었어요~"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880181003))      -- "미리 호흡을 맞춰볼 사람이 필요한데...\n혹시 괜찮다면 같이 연습해주지 않을래요?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612540, 0)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880181006))    -- "원, 투, 쓰리~ 원, 투, 쓰리~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001",  STR_QUEST_TEXT(880181007))    -- "좋아요~ 스텝은 완벽해요~"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(880181009))     -- "음~~\n의상이 아직 준비가 안된 것 같아요~\n준비 좀 부탁해요~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006",  STR_QUEST_TEXT(880181010))    -- "앗!?.. 어쩔 수 없네요..\n아리와 연습해야겠어요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612540, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

