-- 피곤함은 춤으로 날려버려(880183)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."
        
        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(68) --=BGM=Theme_Clothshop
        
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."

        PushPopupTownNpcWithSelectBox(146)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."
    end    
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."

        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183001))     -- "왜 이렇게 손님이 없지~\n하루 종일 서있으니 피곤하네요..\n정열적인 춤이라도 춰볼까.."
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(146)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183002))      -- "응? 무슨 춤을 출 거냐구요?\n'플라멩코'라는 춤이에요."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183003))      -- "음? 원한다면 동작 일부만 알려줄까요?"
	end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880183004))    -- "플라멩코는 드레스를 차올리면서\n추는 동작이 많아요~\n플라멩코 의상을 입어보는 게 어때요?"
    
    PushPopupCollectionNeed()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(146)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183002))      -- "응? 무슨 춤을 출 거냐구요?\n'플라멩코'라는 춤이에요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183003))      -- "음? 원한다면 동작 일부만 알려줄까요?"
            
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612597, 0)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183005))   -- "윽... 막상 알려드리려니 귀찮음이 몰려오지만....\n보기 보다 간단할 거예요~\n손과 발의 포인팅에 조금 유의해주시구요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880183006))    -- "어때요~ 하고 나니 쉽죠?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202306)    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183007))     -- "앗 입으셨네요, 화려하시네요~!\n왠지 설레지 않나요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183005))     -- "윽... 막상 알려드리려니 귀찮음이 몰려오지만....\n보기 보다 간단할 거예요~\n손과 발의 포인팅에 조금 유의해주시구요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880183006))    -- "어때요~ 하고 나니 쉽죠?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(146), 612597)    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202306)   
        
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183008))      -- "화려한 의상과 함께 하니 정열이 넘쳐 보이시네요~"
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183009))  -- "그래도 춤을 추고 나니, 힘이 조금 나는 것 같아요~\n호호~ 그럼 다음에 또 봬요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880183010))      -- "아무래도 어울리는 의상을 입어야 하지 않겠어요?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880183011))     -- "흠, 잠시 말 상대해줘서 고마웠어요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612597, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

