-- 내 얼굴을 감추고(880191)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"
        
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"
        PushPopupTownNpcWithSelectBox(129)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(129)) then    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"

        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191001))     -- "얼굴이란 곧 생김새와 감정을 고스란히\n담아놓은 그릇과 같은 것.\n자네 혹시 '탈춤'을 춰보지 않겠는가?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191002))      -- "탈은 현실에서는 존재하기 힘든 것들을 가능하게\n해준다네. 아니지, 존재하지만 존재하기 힘들다고\n부정하는 것들이라고 해야 할까. "
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191003))      -- "우스꽝스러운 얼굴을 하고 근엄한 몸짓을 한다거나,\n가슴이 미어지는 슬픈 상황인데\n웃겨서 숨이 넘어가는 얼굴을 하고 있다거나, "
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191004))            -- "곱고 조신한 얼굴을 하고 해괴망측한 춤을 춘다거나\n하는 것들 말일세. 어색하고 어울리지 않을 것 같지만\n사실은 어디에서나 흔히 볼 수 있는 그런 것들이지."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191005))      -- "흠흠.. 내 심오한 철학을 자네에게 말해주려니\n말이 참 길어졌군. 어떤가 자네도 탈춤 한번 춰보지 않겠나?\n일단은 간단하게 고개를 흔들어 볼 걸세."        
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880191006))    -- "나의 진짜 생김새, 진짜 감정을 가리고\n탈이 가진 생김새와 감정으로 춤을 춘다는 것은\n춤을 추는 사람에게도, 보는 사람에게도 매우 흥미로운 일이지."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191007))     -- "오, 잘 가져왔구먼."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191008))     -- "오오, 자네의 얼굴이 탈에 가려져서\n어떤 감정을 가지고 있는지 보이지 않으니..\n무슨 춤을 출 지 더욱더 기대가 되는군..!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880191009))    -- "오오, 그래. \n흥겨움이 잘 느껴지는 탈춤일세!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(129), 612508)     
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)   
        
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191010))     -- "허허, 즐겁지 않나?\n자네도 곧 탈춤의 매력에 푹\n빠지게 될 걸세!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(129)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191002))      -- "탈은 현실에서는 존재하기 힘든 것들을 가능하게\n해준다네. 아니지, 존재하지만 존재하기 힘들다고\n부정하는 것들이라고 해야 할까. "
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191003))      -- "우스꽝스러운 얼굴을 하고 근엄한 몸짓을 한다거나,\n가슴이 미어지는 슬픈 상황인데\n웃겨서 숨이 넘어가는 얼굴을 하고 있다거나, "
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191004))            -- "곱고 조신한 얼굴을 하고 해괴망측한 춤을 춘다거나\n하는 것들 말일세. 어색하고 어울리지 않을 것 같지만\n사실은 어디에서나 흔히 볼 수 있는 그런 것들이지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191005))      -- "흠흠.. 내 심오한 철학을 자네에게 말해주려니\n말이 참 길어졌군. 어떤가 자네도 탈춤 한번 춰보지 않겠나?\n일단은 간단하게 고개를 흔들어 볼 걸세."
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612508, 0)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191008))    -- "오오, 자네의 얼굴이 탈에 가려져서\n어떤 감정을 가지고 있는지 보이지 않으니..\n무슨 춤을 출 지 더욱더 기대가 되는군..!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880191009))    -- "오오, 그래. \n흥겨움이 잘 느껴지는 탈춤일세!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880191011))     -- "음.. 아직일세..\n탈을 못 구해왔잖나.."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880191012))    -- "탈춤에 관심이 없다니..\n자네라면 멋진 탈춤을 출 수\n있을 줄 알았네만.. 아쉽게 됐군.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612508, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

