-- 공중 덤블링(880202)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"
        
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"

        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"

        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202001))     -- "[nickname]님! [nickname]님!\n혹시 서커스 본 적 있으세요?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202002))      -- "얼마 전에 옆 마을에 심부름을 하러 갔다가\n서커스단이 왔길래 보고 왔거든요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202003))   -- "와아.. 저 정말 반했어요!\n공중에서 날아다니고.. 갖가지 동물들이 나오고..\n맛있는 팝콘에.. 헤헷! 너무 재밌었어요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202004))   -- "그 중에 공중 제비가 제일 인상 깊었어요!\n어떻게 그렇게 할 수 있는 걸까요?\n마치 날아다니는 것 같이!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202005))            -- "혹시 [nickname]님도 할 수 있으세요?\n엄청 유연하시니까, 충분히 하실 수 있을 것 같은데!?\n간단하게 자리에서 한 바퀴 돌아보실 수 있으세요?!"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880202006))    -- "음~\n몸에 딱 맞는 옷을 입는 게 더\n회전하기 편하지 않을까요?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202315)    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202007))   -- "우와! 정말 완벽한 복장이네요!\n마치 서커스 공연에 온 것 같아요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202008))     -- "어떻게 돌아야 잘도는 지\n시범 부탁드려요~~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880202009))    -- "와아 이렇게 하는 거구나!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202315)   
        
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202010))  -- "멋져요! [nickname] 님!\n정말 서커스 단원 같으세요!! 헤헤!!\n보여주셔서 감사해요!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202002))      -- "얼마 전에 옆 마을에 심부름을 하러 갔다가\n서커스단이 왔길래 보고 왔거든요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202003))   -- "와아.. 저 정말 반했어요!\n공중에서 날아다니고.. 갖가지 동물들이 나오고..\n맛있는 팝콘에.. 헤헷! 너무 재밌었어요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202004))   -- "그 중에 공중 제비가 제일 인상 깊었어요!\n어떻게 그렇게 할 수 있는 걸까요?\n마치 날아다니는 것 같이!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202005))       -- "혹시 [nickname]님도 할 수 있으세요?\n엄청 유연하시니까, 충분히 하실 수 있을 것 같은데!?\n간단하게 자리에서 한 바퀴 돌아보실 수 있으세요?!"
           
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612575, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202008))      -- "어떻게 돌아야 잘도는 지\n시범 부탁드려요~~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880202009))    -- "와아 이렇게 하는 거구나!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880202006))     -- "음~\n몸에 딱 맞는 옷을 입는 게 더\n회전하기 편하지 않을까요?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880202011))    -- "아~ 어지러우시다구요?\n알겠어요 다음에 올게요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612575, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

