-- 추억의 서커스(880203)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
                DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
              DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
              DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
               DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203001))    -- "음.. [nickname]님.\n혹시 '서커스'를 아십니까?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(110)
        
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203002))   -- "어릴 적 어머니 손을 붙잡고 보러 갔던 서커스..\n정말 인상 깊었죠.\n흥겨운 분위기에 놀라운 공연에.."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203003))  -- "[nickname]님 혹시 서커스 음악을 모르는 건가요?\n몇십 년이 지난 지금도 저는 생생히 기억하고 있는데..\n원하신다면 제가 알려드리겠습니다만."
    end

	DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203004))   -- "음, 알려 드리기 위해선 이런 게 있어야겠군요."
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203005))   -- "준비되셨군요.\n자, 진행해보실까요."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203006))  -- "저도 음악을 직접 만들어보는 것은 처음이군요.\n완성곡을 들으시면 생각보다 익숙하실 겁니다."
    RequireMusicFollowButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203007))   -- "어떻습니까.\n정말 흥미진진한 곡 아닙니까."

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629009)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203008))   -- "[nickname]님께 서커스 음악을 알려드리니\n뿌듯하군요. 잘 따라와 주셔서 감사합니다."

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203009))   -- "음..\n아직 준비가 덜 되신 것 같습니다."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203010))  -- "음 관심이 없으시군요.\n알겠습니다."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end





-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(110)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203002))   -- "어릴 적 어머니 손을 붙잡고 보러 갔던 서커스..\n정말 인상 깊었죠.\n흥겨운 분위기에 놀라운 공연에.."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203003))  -- "[nickname]님 혹시 서커스 음악을 모르는 건가요?\n몇십 년이 지난 지금도 저는 생생히 기억하고 있는데..\n원하신다면 제가 알려드리겠습니다만."
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203004))   -- "음, 알려 드리기 위해선 이런 게 있어야겠군요."
         
    end

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203005))   -- "준비되셨군요.\n자, 진행해보실까요."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203006))  -- "저도 음악을 직접 만들어보는 것은 처음이군요.\n완성곡을 들으시면 생각보다 익숙하실 겁니다."
    RequireMusicFollowButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203007))   -- "어떻습니까.\n정말 흥미진진한 곡 아닙니까."
      
      Wait(0.5)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880203008))   -- "[nickname]님께 서커스 음악을 알려드리니\n뿌듯하군요. 잘 따라와 주셔서 감사합니다."

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end



