-- 상상의 벽(880205)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"
        
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"

        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"

        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205001))     -- "[nickname]님, [nickname]님!!\n저 정말 궁금한 게 생겼어요!!"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205002))      -- "제가 피에로 분장을 한 어떤 사람을 봤는데,\n말없이 마구 허공을 더듬는 거예요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205003))      -- "근데 보고 있자니, 정말 벽이\n있는 것 같이 보이는 거 있죠!?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205004))            -- "아.. 그게 '마임'이라는 거예요? 우와 신기하다..\n어떤 대사 없이 몸짓으로만 표현하는 거구나..\n[nickname]님! 그거 [nickname]님도 할 수 있는 거예요!?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205005))            -- "최고다!! 저 한 번만 보여주시면 안 돼요!?!?"        
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880205006))    -- "장갑을 끼면 마임이 좀 더\n그럴싸해 보이지 않을까요!?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205158)    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205007))     -- "우왓! 장갑을 준비하셨군요!\n자 어서 보여주세요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205008))     -- "우와아!! 기대된다!\n마임은 어떻게 하는 건가요?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880205009))    -- "오오!\n엄청나다..!! 앞에 마치 벽이 있는 느낌..!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(113), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205158)   
        
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205010))   -- "정말 감사해요 ([nickname])님!\n헤헤! 나도 연습해서 다른 사람들한테 보여줘야지!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205002))      -- "제가 피에로 분장을 한 어떤 사람을 봤는데,\n말없이 마구 허공을 더듬는 거예요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205003))      -- "근데 보고 있자니, 정말 벽이\n있는 것 같이 보이는 거 있죠!?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205004))            -- "아.. 그게 '마임'이라는 거예요? 우와 신기하다..\n어떤 대사 없이 몸짓으로만 표현하는 거구나..\n[nickname]님! 그거 [nickname]님도 할 수 있는 거예요!?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205005))                 -- "최고다!! 저 한 번만 보여주시면 안 돼요!?!?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612657, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205008))      -- "우와아!! 기대된다!\n마임은 어떻게 하는 건가요?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880205009))    -- "오오!\n엄청나다..!! 앞에 마치 벽이 있는 느낌..!"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880205011))     -- "으음.. 맨손으로는 표현하기\n힘들지 않을까요..."
    GoTown()
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880205012))    -- "이런... 기대했는데...\n어쩔 수 없죠 뭐.\n다음에 다시 올게요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612657, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

