-- 수영 전 준비운동은 철저히!(880211)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"
        
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"

        PushPopupTownNpcWithSelectBox(133)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"

        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211001))     -- "[nickname]님, 날씨가 좋아요!\n딱~ 어디 놀러 가서\n수영하고 싶은 날씨죠?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(133)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211002))      -- "음. 안전 차원에서 미리 안내를 해드리고 있어요.\n물에 들어가기 전에는 꼭 준비운동을\n하셔야 하는 거, 아시죠?"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211003))      -- "앗, 모르셨다고요!?\n이런... 제가 알려드릴게요!\n수영하기 전의 준비 동작!"
	end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880211004))    -- "참! 그전에! 수영장에서\n수영복은 필수인 것 아시죠?!\n수영모도 잊지 마시구요~!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202305)    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201208)    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211005))    -- "정말 귀여운 수영복이네요!\n수영할 준비 완료!~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211006))     -- "손, 발을 가볍게 돌리듯이\n시작해보자구요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880211007))    -- "준비 운동 완성!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(133), 612529)      
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202305)    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201208)     
        
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211008))     -- "잘 아셨죠~? 수영하기전에\n이렇게 준비운동하는 걸\n꼭~! 잊지 마세요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(133)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211002))      -- "음. 안전 차원에서 미리 안내를 해드리고 있어요.\n물에 들어가기 전에는 꼭 준비운동을\n하셔야 하는 거, 아시죠?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211003))      -- "앗, 모르셨다고요!?\n이런... 제가 알려드릴게요!\n수영하기 전의 준비 동작!"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612529, 0)
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211006))     -- "손, 발을 가볍게 돌리듯이\n시작해보자구요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880211007))    -- "준비 운동 완성!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880211009))     -- "수영복을 착용하는 게 좋을 거예요!"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880211010))    -- "아.. 관심 없으시구나?\n그럼 다음에 알려드릴게요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612529, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

