-- 수영은 이렇게(880213)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuest(TownCharacterGetNPC(128))        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"
        
        PushPopupTownNpcWithSelectBox(128)
    end

    if OnClickQuestTab(TownCharacterGetNPC(128)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuest(TownCharacterGetNPC(128))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"

        PushPopupTownNpcWithSelectBox(128)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(128)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuest(TownCharacterGetNPC(128))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"

        PushPopupTownNpcWithSelectBox(128)
    end

    if OnClickQuestTab(TownCharacterGetNPC(128)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213001))     -- "여-!\n수영하러 갈 건데, 너도 갈래?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(128)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213002))      -- "왕년에 내가 수영 좀 했어!\n이 우람한 어깨가 수영 덕분이라고 후후.."
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213003))      -- "남자라면 폭풍헤엄을 칠 줄 알아야지!\n너도 혹시 수영 할 줄 알아?"
        DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213004))        -- "뭐? 수영하는 법을 잘 몰라?!\n이런!!! 그걸 모를 수 있다니....\n그렇다면 내가 친절히 알려주겠어!!"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(128, STR_NPC(128), "Characters/npc_015",  STR_QUEST_TEXT(880213005))    -- "일단 폭풍 헤엄을 치기 위해\n물안경을 착용하자고!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203061)    
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213006))  -- "오! 좋아!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213007))      -- "자! 그럼 시작해보실까!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(128, STR_NPC(128), "Characters/npc_015",  STR_QUEST_TEXT(880213008))    -- "어때, 생각보다 쉽지 않아?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203061)   
        
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213009))    -- "수영도 별것 아니지? 하하하!\n자, 내 가르침에 잘 따라준 보상이야!\n신나게 헤엄쳐 보라고~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(128)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213002))      -- "왕년에 내가 수영 좀 했어!\n이 우람한 어깨가 수영 덕분이라고 후후.."
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213003))      -- "남자라면 폭풍헤엄을 칠 줄 알아야지!\n너도 혹시 수영 할 줄 알아?"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213004))     -- "뭐? 수영하는 법을 잘 몰라?!\n이런!!! 그걸 모를 수 있다니....\n그렇다면 내가 친절히 알려주겠어!!"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612578, 0)
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213007))    -- "자! 그럼 시작해보실까!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(128, STR_NPC(128), "Characters/npc_015",  STR_QUEST_TEXT(880213008))    -- "어때, 생각보다 쉽지 않아?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(880213010))     -- "이봐~\n수영할 때 물안경이 얼마나 중요한데~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(128, STR_NPC(128), "Characters/npc_015",  STR_QUEST_TEXT(880213011))    -- "이런, 배우는 게 귀찮은 거야?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612578, 0)
    ScenarioEndingShow()
    PopScene()
end

