-- 열정적인 무술(880221)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."
        
        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."

        PushPopupTownNpcWithSelectBox(110)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(110))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(110))
        TownCharacterSetQuest(TownCharacterGetNPC(110))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(110)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(110))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."

        PushPopupTownNpcWithSelectBox(110)
    end

    if OnClickQuestTab(TownCharacterGetNPC(110)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221001))   -- "[nickname]님.\n무술 동작을 춤에 응용할 수 있다는 것을 아십니까."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(110)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(110), 612594)        
    
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221002))      -- "[nickname]님께서 보시기에 동작이 다소 거칠고\n공격적이게 보일 수 있지만, 이런 무예 동작을\n춤으로 승화시켜 공연을 하는 일도 적지 않습니다."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221003))     -- "저는 개인적으로 이런 춤을 좋아하죠.\n마치 벌이 날아올라 쏘는 것 같은 날렵함과 민첩함!\n볼수록 가슴속이 시원해지니까요."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221004))      -- "원하신다면 제가 동작을 알려드리도록 하겠습니다."
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(880221005))   -- "아, 혹시 복장도 갖춰 입어보시지 않겠습니까?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201202)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202294)       
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221006))     -- "오셨군요. 완벽합니다."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221007))     -- "무예 동작을 춤으로 승화시키는 겁니다."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(880221008))    -- "어떻습니까.\n왠지 모르게 가슴이 시원하지 않으십니까."
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(110), 612594)        
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201202)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202294)       
        
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221009))   -- "아주 훌륭하십니다.\n배우시느라 고생 많으셨습니다.\n그럼 다음에 뵙죠."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(110)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(110), 612594)            
   
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221002))      -- "[nickname]님께서 보시기에 동작이 다소 거칠고\n공격적이게 보일 수 있지만, 이런 무예 동작을\n춤으로 승화시켜 공연을 하는 일도 적지 않습니다."
        DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221003))     -- "저는 개인적으로 이런 춤을 좋아하죠.\n마치 벌이 날아올라 쏘는 것 같은 날렵함과 민첩함!\n볼수록 가슴속이 시원해지니까요."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221004))        -- "원하신다면 제가 동작을 알려드리도록 하겠습니다."

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612594, 0)
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221007))     -- "무예 동작을 춤으로 승화시키는 겁니다."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(880221008))    -- "어떻습니까.\n왠지 모르게 가슴이 시원하지 않으십니까."
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(880221010))     -- "음.. 아직 준비가 안되신 것 같습니다만."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(880221011))    -- "음.. 알겠습니다.\n다음에 뵙겠습니다."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612594, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

