-- 열정과 낭만의 춤(880223)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"
        
        PushPopupTownNpcWithSelectBox(162)
    end

    if OnClickQuestTab(TownCharacterGetNPC(162)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"

        PushPopupTownNpcWithSelectBox(162)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(162)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"

        PushPopupTownNpcWithSelectBox(162)
    end

    if OnClickQuestTab(TownCharacterGetNPC(162)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223001))     -- "홍홍~\n이번에 휴양지에 갔다 왔는뎅~\n재밌는 댄스를 알아왔엉~"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(162)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterAction(TownCharacterGetNPC(162), "612546")        
    
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223002))      -- "이번에 정말 아름다운 섬에 다녀왔엉~\n알록달록한 꽃들도 많고~\n맛있는 과일도 많더라구~!"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223003))      -- "그 곳에서는 특이하게도 춤을 '훌라' 라고 하더라궁?\n다들 손을 이렇게 웨이브 하면서 '훌라~~' 라고 해!\n어때, 참 재밌징?"
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223004))       -- "[nickname]씨도 같이 한번 춰볼랭?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880223005))    -- "이런 장신구도 한번 해봥~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201203)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202295)    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223006))     -- "오~ 좋앙~ 뷰리풀행~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223007))     -- "부드럽게 손을 돌려봥~ 훌라~~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880223008))    -- "오옹~ 잘하는뎅~?\n혹시 이미 알고 있던 거양~?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(162), 612546)    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201203)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202295)       
        
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223009))     -- "훌라~훌랑~~~ 너무 재밌징~~\n힐링 되는 기분이양~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(162)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223002))      -- "이번에 정말 아름다운 섬에 다녀왔엉~\n알록달록한 꽃들도 많고~\n맛있는 과일도 많더라구~!"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223003))      -- "그 곳에서는 특이하게도 춤을 '훌라' 라고 하더라궁?\n다들 손을 이렇게 웨이브 하면서 '훌라~~' 라고 해!\n어때, 참 재밌징?"
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223004))         -- "[nickname]씨도 같이 한번 춰볼랭?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612546, 0)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223007))     -- "부드럽게 손을 돌려봥~ 훌라~~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880223008))    -- "오옹~ 잘하는뎅~?\n혹시 이미 알고 있던 거양~?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880223010))     -- "으응~?\n아직 장신구가 없잖앙~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001",  STR_QUEST_TEXT(880223011))    -- "히잉~ 재밌을 텐뎅~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612546, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
