-- 열정적으로 고개를 흔들어(880224)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
    
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)               
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"
        
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                          
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                          
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"

        PushPopupTownNpcWithSelectBox(117)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                          
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                         
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"

        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                          
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224001))     -- "흥미로운 춤이지?\n어떻게 추는지 알고 싶지 않아?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(117)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
         TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                         
    
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224002))      -- "이 춤은 먼 옛날 우리 춤요정 누군가에 의해\n전해져 내려오던 고전 춤..\n'바라타나티암' 의 일부이지!"
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224003))      -- "아주 열정적으로 고개를 흔드는 것이 특징이야."
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)                        
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880224004))    -- "이런 머리장식이 잘 어울리겠는데?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201204)    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224005))     -- "음, 가져왔군."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224006))     -- "고개를 열정적으로 흔들어보라구!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880224007))    -- "음.. 그래 이만하면 됐어.."
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)           
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201204)   
        
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224008))     -- "음, 고전 춤도 잘 따라 하는군.\n가르치면 스펀지처럼 흡수하는 능력이 있어...\n놀랍군."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(117)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(117), 612565)       
   
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224002))      -- "이 춤은 먼 옛날 우리 춤요정 누군가에 의해\n전해져 내려오던 고전 춤..\n'바라타나티암' 의 일부이지!"
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224003))      -- "아주 열정적으로 고개를 흔드는 것이 특징이야."
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612565, 0)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224006))     -- "고개를 열정적으로 흔들어보라구!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880224007))    -- "음.. 그래 이만하면 됐어.."
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880224009))     -- "아직 알려줄 수 없군."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880224010))    -- "알고 싶지 않다면 어쩔 수 없지."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612565, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
