-- 장기 자랑(880231)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"
        
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"

        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"

        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231001))     -- "장기자랑에서 춤을 추고 싶은데\n뭘 추면 좋을까요?"


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231002))      -- "장기자랑 상품이 무려 댄소 100개!\n꼭 일등 해야겠죠!? 저 좀 도와주세요 [nickname]님!\n제가 상금의 10%를 드릴게요 헤헷."
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880231003))    -- "저, 좀 특이하게 하고 싶어요!\n이거 입고 춰볼래요!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201205)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201205)           
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231004))     -- "생각보다 훨씬 귀여운데요!?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231005))     -- "우와, 기대된다!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880231006))    -- "멋져요!!! 역시 [nickname]님!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(113), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201205)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201205)          
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231007))     -- "이대로만 춘다면 1등은\n확정일 것 같은데요!\n감사해요~~ [nickname]님!~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
	DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231002))     -- "장기자랑 상품이 무려 댄소 100개!\n꼭 일등 해야겠죠!? 저 좀 도와주세요 [nickname]님!\n제가 상금의 10%를 드릴게요 헤헷."

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612623, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231005))     -- "우와, 기대된다!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880231006))    -- "멋져요!!! 역시 [nickname]님!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880231008))     -- "응? 아무것도 준비하지 않으면 평범해서\n 사람들 기억에 오래 남지 못할 거라구요~"

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880231009))    -- "앗..\n상금에 관심이 없으시군요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612623, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
