-- 악기장인의 음악(880243)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()


        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
        PushPopupTownNpcWithSelectBox(164)

        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
        PushPopupTownNpcWithSelectBox(164)

        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end

    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
              DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
        PushPopupTownNpcWithSelectBox(164)

        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end

    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
               DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243001))    -- "새로운 음악을 만들어 봤어요.\n(한번 들어보겠..?)\n#평가 #궁금"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243002))   -- "짬 나는 시간에 음악을 만들어 봤습니다.\n(특별하진 않지만..)\n굳이 뭐 안 들어도 되긴 합니다만.."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243003))  -- "혹시 내 음악이 어떤지 들어보고\n어색한 부분을 바꿔줄 수 있나요? #기대"

    end

	DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243004))   -- "잠시만요.\n이것이 필요합니다만."
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243005))   -- "준비했군요. 잘했습니다."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243006))  -- "어떻게 바꿀지 궁금하네요."
    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243007))   -- "오 이제 그럴싸하군요."

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629024)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243008))   -- "어색한 부분을 단번에 고쳐주다니.\n보기 보다 똑똑하군요.\n잘했습니다. #짝짝짝"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243009))   -- "이게 필요하다니까요."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243010))  -- "음... 알겠습니다."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243002))   -- "짬 나는 시간에 음악을 만들어 봤습니다.\n(특별하진 않지만..)\n굳이 뭐 안 들어도 되긴 합니다만.."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243003))  -- "혹시 내 음악이 어떤지 들어보고\n어색한 부분을 바꿔줄 수 있나요? #기대"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243004))   -- "잠시만요.\n이것이 필요합니다만."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243005))   -- "준비했군요. 잘했습니다."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243006))  -- "어떻게 바꿀지 궁금하네요."
    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243007))   -- "오 이제 그럴싸하군요."

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880243008))   -- "어색한 부분을 단번에 고쳐주다니.\n보기 보다 똑똑하군요.\n잘했습니다. #짝짝짝"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end




