-- 어릴 적 자장가(880251)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
         DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251001))    -- "[nickname]님도 혹시 어릴 적 잠이 들 때에\n누군가 자장가를 불러주셨나요? "
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251002))  -- "저는 우리 누나가 매일 불러줬었는데...\n요원 일이 바빠진 이후로는 거의 못 들었지만요.."
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251003))  -- "근데 사실 너무 아기 때라 잘 생각이 안 나요 헤헤..\n[nickname]님도 기억나는 자장가가 있으세요?\n혹시 한번 들려주시지 않을래요?"

    end

	DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251004))  -- "음.. 이 악기 소리로 듣는 자장가는\n정말 좋을 것 같아요~!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251005))   -- "앗 가져오셨네요!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251006))   -- "과연 [nickname]님이 기억하시는\n자장가는 어떤 걸까요~?"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251007))   -- "우와.. 이런 자장가구나~ \n앗! 생각났다! 누나의 자장가!\n이 음이랑 비슷한 것 같아요!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629030)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251008))    -- "헤헤, [nickname]님 덕분에 누나가 들려준\n자장가를 떠올릴 수 있었어요~!\n정말 감사해요!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251009))  -- "힝~ 저는 이 악기로 만든 자장가가 듣고 싶은데.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251010))   -- "아.. 자장가를 들어보신 적이 없다구요?\n저런... 아쉽네요..."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251002))  -- "저는 우리 누나가 매일 불러줬었는데...\n요원 일이 바빠진 이후로는 거의 못 들었지만요.."
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251003))  -- "근데 사실 너무 아기 때라 잘 생각이 안 나요 헤헤..\n[nickname]님도 기억나는 자장가가 있으세요?\n혹시 한번 들려주시지 않을래요?"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251004))  -- "음.. 이 악기 소리로 듣는 자장가는\n정말 좋을 것 같아요~!"
         
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251005))   -- "앗 가져오셨네요!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251006))   -- "과연 [nickname]님이 기억하시는\n자장가는 어떤 걸까요~?"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251007))   -- "우와.. 이런 자장가구나~ \n앗! 생각났다! 누나의 자장가!\n이 음이랑 비슷한 것 같아요!"

      
      Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880251008))    -- "헤헤, [nickname]님 덕분에 누나가 들려준\n자장가를 떠올릴 수 있었어요~!\n정말 감사해요!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

