-- 들려주고 싶은 음(880252)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
                DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
              DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
              DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
               DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252001))    -- "어머, [nickname]님? \n마침 잘 만났어요!\n저 좀 도와주실래요?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880252002))   -- "아리한테 들려주고픈 음악이 있는데, 음이 이랬던가..?\n뭔가 헷갈려서 한참을 고민하고 있었어요.. "
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252003))   -- "[nickname]님은 그 곡을 알 것 같아서 찾아가려 했는데~\n마침 이렇게 만났네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252004))   -- "혹시 이 음악 아나요? 안다면 음을 좀 수정해주실래요?"

    end

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252005))  -- "아, 제가 악기를 아직 준비하지 못해서요~\n대신 좀 부탁해도 될까요~ 호호!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880252006))    -- "어머! 빨리 준비하셨군요?!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880252007))    -- "음~~ 음음~~\n대충 이런 곡인 것 같거든요!\n일부만 좀 고쳐주세요~"
    RequireMusicFollowButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252008))  -- "어머~! 맞아요~! 이 음악이에요~!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629027)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252009))  -- "[nickname]님은 정말 친절하시다니까~!\n항상 고마워요~!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880252010))    -- "앗.. 아직 준비가 안되셨군요~!"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(880252011))   -- "어머~ 그래요?\n이런.. 혼자 떠올려봐야겠네요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(103)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880252002))   -- "아리한테 들려주고픈 음악이 있는데, 음이 이랬던가..?\n뭔가 헷갈려서 한참을 고민하고 있었어요.. "
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252003))   -- "[nickname]님은 그 곡을 알 것 같아서 찾아가려 했는데~\n마침 이렇게 만났네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880252004))   -- "혹시 이 음악 아나요? 안다면 음을 좀 수정해주실래요?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252005))  -- "아, 제가 악기를 아직 준비하지 못해서요~\n대신 좀 부탁해도 될까요~ 호호!"
         
    end

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880252006))    -- "어머! 빨리 준비하셨군요?!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880252007))    -- "음~~ 음음~~\n대충 이런 곡인 것 같거든요!\n일부만 좀 고쳐주세요~"
    RequireMusicFollowButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252008))  -- "어머~! 맞아요~! 이 음악이에요~!"

      
      Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880252009))  -- "[nickname]님은 정말 친절하시다니까~!\n항상 고마워요~!"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


