-- 추억의 소풍(880261)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(67) --=BGM=Theme_Interiorshop
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"
        
        PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(67) --=BGM=Theme_Interiorshop
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"

        PushPopupTownNpcWithSelectBox(144)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(144))
        TownCharacterSetQuest(TownCharacterGetNPC(144))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(144)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(67) --=BGM=Theme_Interiorshop        
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"

        PushPopupTownNpcWithSelectBox(144)
    end

    if OnClickQuestTab(TownCharacterGetNPC(144)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261001))   -- "날씨가 참 좋지?\n어디론가 소풍 가고 싶은 날씨랄까?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(144)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261002))    -- "그러고 보니 요새는 소풍을 간 적이 별로 없네~\n예전에 어렸을 적엔 학교에서 단체로 소풍을\n버스 타고 많이 갔었는데~"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261003))  -- "소풍 가는 날은 참 신났었지..!\n맛있는 걸 잔뜩 싸서 버스를 타고\n다 같이 멀리 소풍을 갈 때의 그 신나는 기분이란~"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261004))      -- "그 전날 괜히 두근두근 설레잖아!! 후훗!\n아~ 맞다! 우리 때 유행이던 춤이 있었는데~\n일명 '관광버스 춤' !"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261005))   -- "소풍 갈 때 버스를 운전해주시던 기사 아저씨를\n보고 누군가 만들어낸 춤이야!"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261006))    -- "남녀노소 누구나 다 출 수 있고\n보다 보면 중독성 있어!\n한번 볼래?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880261007))   -- "이 춤은 엄지를 치켜 세우는게 포인트야!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205159)   
    TownCharacterWearClothes(TownCharacterGetNPC(144), 205159)   
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261008))     -- "좋아~! 그럼 진행해볼까~?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261009))    -- "여럿이서 따라 추다 보면\n은근~히 재미있어!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880261010))   -- "어때~? 정말 재미있지?\n분위기가 저절로 업! 업!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(144), 612560)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205159)   
    TownCharacterWearClothes(TownCharacterGetNPC(144), 205159)        
        
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261011))    -- "호호, 오랜만에 그때의 추억이 떠오르네!\n재미있는 시간이었어~"
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(144)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261002))    -- "그러고 보니 요새는 소풍을 간 적이 별로 없네~\n예전에 어렸을 적엔 학교에서 단체로 소풍을\n버스 타고 많이 갔었는데~"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261003))  -- "소풍 가는 날은 참 신났었지..!\n맛있는 걸 잔뜩 싸서 버스를 타고\n다 같이 멀리 소풍을 갈 때의 그 신나는 기분이란~"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261004))      -- "그 전날 괜히 두근두근 설레잖아!! 후훗!\n아~ 맞다! 우리 때 유행이던 춤이 있었는데~\n일명 '관광버스 춤' !"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261005))   -- "소풍 갈 때 버스를 운전해주시던 기사 아저씨를\n보고 누군가 만들어낸 춤이야!"
        DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261006))    -- "남녀노소 누구나 다 출 수 있고\n보다 보면 중독성 있어!\n한번 볼래?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612560, 0)
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261009))    -- "여럿이서 따라 추다 보면\n은근~히 재미있어!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880261010))   -- "어때~? 정말 재미있지?\n분위기가 저절로 업! 업!"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001", STR_QUEST_TEXT(880261012))     -- "음.. 아직 마음의 준비가 안되었나봐?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(144, STR_NPC(144), "Characters/npc_shop_interior_001",  STR_QUEST_TEXT(880261013))    -- "아, 관심이 없구나?\n알겠어~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612560, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

