-- 나른한 낮잠(880263)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)        
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."
        
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)           
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)           
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."

        PushPopupTownNpcWithSelectBox(158)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
         TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)          
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)          
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."

        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)           
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263001))     -- "Zzz..\n꾸벅.. 꾸벅.."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(158)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263002))      -- "..... 어~ 제자님~? 언제왔어~?\n오늘 날이 좋아서 그런가..\n왜 이리 졸리지.."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263003))  -- "뭐라고? 내가 마치 리듬을 타는 줄 알았다고?\n나 참... 이건 뭐, 내가 졸기만 해도\n뭔가 있어 보이는 건가 하하~"
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263004))   -- "이리 와봐. 오늘 햇볕이 참 좋아.\n제자님도 같이 낮잠을 즐기지 않을래?"
        
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880263005))    -- "뭐 별거 필요 없어~\n마음 편히 낮잠 자보자고~!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263006))     -- "마음을 편히 먹는 거야~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263007))     -- "잠이 온다... 잠이 온다...\n주문을 걸어보라고~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880263008))   -- "어이쿠! 졸다가 넘어진 거야!?\n하하, 제자님도 참.. 못말린다니까~"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612819)      
        
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263009))    -- "하암... 이제 나는 좀 더 자야겠어~\n제자님도 한숨 푹 자도록 해~"
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(158)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263002))      -- "..... 어~ 제자님~? 언제왔어~?\n오늘 날이 좋아서 그런가..\n왜 이리 졸리지.."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263003))  -- "뭐라고? 내가 마치 리듬을 타는 줄 알았다고?\n나 참... 이건 뭐, 내가 졸기만 해도\n뭔가 있어 보이는 건가 하하~"
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263004))   -- "이리 와봐. 오늘 햇볕이 참 좋아.\n제자님도 같이 낮잠을 즐기지 않을래?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612566, 0)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263007))     -- "잠이 온다... 잠이 온다...\n주문을 걸어보라고~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880263008))   -- "어이쿠! 졸다가 넘어진 거야!?\n하하, 제자님도 참.. 못말린다니까~"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880263010))     -- "응? 아직 준비가 안됐다고?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880263011))    -- "아 지금은 졸리지 않다고?\n그래 알겠네~~\n그럼 난 이만 좀 더 자야겠어~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612566, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

