-- 소풍 가는 날(880264)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
                DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
              DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
              DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
               DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264001))    -- "아~~ 이런 날은 어딘가에서\n한가롭게 과자를 잔뜩~ 먹고 싶다아~!"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264002))   -- "[nickname]님! 소풍 가고 싶지 않으세요?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264003))  -- "왠지 요즘 심부름 가는 길에 자꾸\n딴 길로 새고 싶어서 큰일이에요!\n그만큼 날씨가 너무 좋잖아요 헤헤~!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264004))  -- "특히 잔잔한 음악이 들려오면\n정말 과자랑 돗자리를 챙겨서\n가까운 광장이라도 가고 싶어요~"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264005))  -- "음~ 뭐랄까, 마음이 편안해지는...\n잠이 스르륵 올 것만 같은.... 이런 음악?"

    end

	DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264006))   -- "이 악기 소리를 들으면 좀 졸음이 오더라구요~\n마음이 편안해져서 그런가~?"
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264007))   -- "와~ 준비해오셨군요."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264008))  -- "헤헤, 어떤 따뜻한 음악이 만들어질 지\n기대되네요~!"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264009))   -- "우와 마음이 정말 편안해져요..!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629032)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264010))    -- "감사합니다 헤헤!!\n조만간 같이 소풍 한번 가요, 네? [nickname] 님~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264011))   -- "으음... 악기가 없다면 무리겠네요..."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264012))  -- "아... 소풍에 별로 관심이 없으시구나~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264002))   -- "[nickname]님! 소풍 가고 싶지 않으세요?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264003))  -- "왠지 요즘 심부름 가는 길에 자꾸\n딴 길로 새고 싶어서 큰일이에요!\n그만큼 날씨가 너무 좋잖아요 헤헤~!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264004))  -- "특히 잔잔한 음악이 들려오면\n정말 과자랑 돗자리를 챙겨서\n가까운 광장이라도 가고 싶어요~"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264005))  -- "음~ 뭐랄까, 마음이 편안해지는...\n잠이 스르륵 올 것만 같은.... 이런 음악?"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264006))   -- "이 악기 소리를 들으면 좀 졸음이 오더라구요~\n마음이 편안해져서 그런가~?"
         
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264007))   -- "와~ 준비해오셨군요."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264008))  -- "헤헤, 어떤 따뜻한 음악이 만들어질 지\n기대되네요~!"
    RequireMusicFollowButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264009))   -- "우와 마음이 정말 편안해져요..!"

      
      Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880264010))    -- "감사합니다 헤헤!!\n조만간 같이 소풍 한번 가요, 네? [nickname] 님~"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end
