-- 사랑의 세레나데(880271)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(122))
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
        PushPopupTownNpcWithSelectBox(122)
    end

    if OnClickQuestTab(TownCharacterGetNPC(122)) then
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(122))
                DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
        PushPopupTownNpcWithSelectBox(122)
    end

    if OnClickQuestTab(TownCharacterGetNPC(122)) then
              DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(122))
              DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
        PushPopupTownNpcWithSelectBox(122)
    end

    if OnClickQuestTab(TownCharacterGetNPC(122)) then
               DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271001))    -- "아, 아리에게 사랑의 세레나데를\n부르면서 고백하면 어떨까요..!"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(122)
        
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271002))   -- "음.. 제가 어디선가 봤는데,\n남자가 여자에게 노래를 부르며\n정성스럽게 사랑을 고백하더라구요.."
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271003))  -- "정성스럽게 노래를 부르며 고백하면\n제게 감동받지 않을까요..?"
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271004))  -- "부, 부탁이에요.\n아리에게 부를 사랑의 세레나데를\n[nickname]님께서 좀 알려주세요!"
        
    end

	DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271005))   -- "이.. 이런 악기로 만든 음악은 어때요?"
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271006))   -- "이, 이제 만들어볼 수 있겠네요!!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271007))  -- "기, 기대해도 될까요..\n감동적인 곡..!"
    RequireMusicFollowButton()

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271008))   -- "우와..... 정말 감동적이에요..!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629029)
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271009))   -- "정말 감사해요 [nickname]님.\n아리도 이 곡이면 제게 감동할 것 같아요..!"
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271010))   -- "이, 이건 감사의 표시입니다!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271011))   -- "이, 이런 건 있어야 할 것 같은데요..."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271012))  -- "아리에게.. 세레나데를..\n불러주고 싶었는데...\n아쉽네요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(122)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271002))   -- "음.. 제가 어디선가 봤는데,\n남자가 여자에게 노래를 부르며\n정성스럽게 사랑을 고백하더라구요.."
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271003))  -- "정성스럽게 노래를 부르며 고백하면\n제게 감동받지 않을까요..?"
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271004))  -- "부, 부탁이에요.\n아리에게 부를 사랑의 세레나데를\n[nickname]님께서 좀 알려주세요!"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271005))   -- "이.. 이런 악기로 만든 음악은 어때요?"
         
    end

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271006))   -- "이, 이제 만들어볼 수 있겠네요!!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271007))  -- "기, 기대해도 될까요..\n감동적인 곡..!"
    RequireMusicFollowButton()

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271008))   -- "우와..... 정말 감동적이에요..!"

      
      Wait(0.5)

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271009))   -- "정말 감사해요 [nickname]님.\n아리도 이 곡이면 제게 감동할 것 같아요..!"
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880271010))   -- "이, 이건 감사의 표시입니다!"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

