-- 섹시한 음악(880272)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
                DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
              DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
              DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
               DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272001))    -- "혹시 섹시한 음악을 아시나요?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(150)
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272002))   -- "아무래도 요새 대세는 섹시남인 것 같아요~"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272003))  -- "흐흐.. 그래서 이번엔 섹시한 컨셉으로\n뮤직비디오를 찍어보려고요~\n혹시 제 섹시 컨셉에 어울리는 음악이 없을까요?"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272004))  -- "뭔가 들으면 섹시하고 끈적~ 끈적한 음악이오!\n보는 사람이 모두 제 섹시함에 빠져들 수 있도록!"
        
    end

	DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272005))   -- "음~ 이런 악기로 만든 음악이\n끈적~ 하지 않을까요~?"
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272006))   -- "오~ 좋아요 좋아!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272007))  -- "끈~적 끈적하게요!!"
    RequireMusicFollowButton()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272008))   -- "네!! 그래요!!! 맞아요!!! 이런 걸 원했어요!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629021)
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(150), 612584)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272009))   -- "헤헤!!!! \n어때요 저 섹시한가요?\n섹시남 같아요!?"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272010))   -- "정말 감사해요 친절한 [nickname]님!\n전 이만 뮤직비디오 찍으러 가볼게요!!~~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272011))   -- "음~ 이 정도는 있어야 하지 않아요?\n저도 그 정도는 아는데~"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272012))  -- "이런~ [nickname]님도 그런 건 잘 모르시는구나~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(150)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272002))   -- "아무래도 요새 대세는 섹시남인 것 같아요~"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272003))  -- "흐흐.. 그래서 이번엔 섹시한 컨셉으로\n뮤직비디오를 찍어보려고요~\n혹시 제 섹시 컨셉에 어울리는 음악이 없을까요?"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272004))  -- "뭔가 들으면 섹시하고 끈적~ 끈적한 음악이오!\n보는 사람이 모두 제 섹시함에 빠져들 수 있도록!"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272005))   -- "음~ 이런 악기로 만든 음악이\n끈적~ 하지 않을까요~?"
         
    end

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272006))   -- "오~ 좋아요 좋아!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272007))  -- "끈~적 끈적하게요!!"
    RequireMusicFollowButton()

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272008))   -- "네!! 그래요!!! 맞아요!!! 이런 걸 원했어요!"

      
      Wait(0.5)

    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272009))   -- "헤헤!!!! \n어때요 저 섹시한가요?\n섹시남 같아요!?"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880272010))   -- "정말 감사해요 친절한 [nickname]님!\n전 이만 뮤직비디오 찍으러 가볼게요!!~~"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

