-- 무중력 상태의 춤(880281)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."
        
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."

        PushPopupTownNpcWithSelectBox(121)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(121)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."

        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281001))     -- "우주는 참 신비로워요.\n우리가 모르는 일들이 가득하답니다."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(121)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880281002))      -- "댄스게이트는 우주의 시공간을 이어주는 역할을 하죠!\n우리는 바로 그 댄스게이트를 통해 이곳에\n오게 됐어요. 벌써 오래전 이야기네요.."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281003))     -- "그 댄스게이트의 내부는 무중력 상태라는 사실~!"
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281004))    -- "댄스게이트 속에서 이동하는 동안\n날갯짓을 하지 않아도 이동할 수 있는\n신비로운 경험을 할 수 있었죠."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281005))      -- "이 곳에선 날개로 공중에 뜰 수 있지만요.\n공중에서 춤을 추는 것도 자유롭죠.\n무중력에서는 아무래도 동작이 좀 느려져요."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281006))   -- "[nickname]님도 혹시 마치 공중에서 추는듯한\n춤을 춰보고 싶나요?\n원한다면 알려드릴게요~"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880281007))   -- "음~ 공중에 떠있는 게 좀 더 자연스러워 보이기 위해\n우리 춤요정들과 같은 날개를 한번 착용해볼까요~?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204024)    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281008))     -- "날개가 있으니 정말 춤요정같은데요? 후훗"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281009))   -- "자 그럼, 공중에 떠있는 것처럼\n보이는 춤을 알려드릴게요.\n잘 보세요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880281010))   -- "어때요?\n마치 공중에 떠있는 것 같죠?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204024)   
        
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281011))  -- "호호! 공중 춤은 좀 더 연습이 필요해요~\n다음엔 좀 더 그럴싸한 춤을\n알려드리도록 하죠!~~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281012))      -- "누군가에게 도움이 된다는 건 역시\n항상 뿌듯하군요~\n그럼 오늘도 역동적인 하루 보내요!"
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(121)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880281002))      -- "댄스게이트는 우주의 시공간을 이어주는 역할을 하죠!\n우리는 바로 그 댄스게이트를 통해 이곳에\n오게 됐어요. 벌써 오래전 이야기네요.."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281003))     -- "그 댄스게이트의 내부는 무중력 상태라는 사실~!"
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281004))    -- "댄스게이트 속에서 이동하는 동안\n날갯짓을 하지 않아도 이동할 수 있는\n신비로운 경험을 할 수 있었죠."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281005))      -- "이 곳에선 날개로 공중에 뜰 수 있지만요.\n공중에서 춤을 추는 것도 자유롭죠.\n무중력에서는 아무래도 동작이 좀 느려져요."
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281006))   -- "[nickname]님도 혹시 마치 공중에서 추는듯한\n춤을 춰보고 싶나요?\n원한다면 알려드릴게요~"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612579, 0)
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281009))   -- "자 그럼, 공중에 떠있는 것처럼\n보이는 춤을 알려드릴게요.\n잘 보세요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880281010))   -- "어때요?\n마치 공중에 떠있는 것 같죠?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281013))   -- "날개가 있으면 공중에 떠있는 게\n덜 어색할 것 같지 않아요?~"
    GoTown()
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880281014))    -- "네, 원한다면..\n다음에 또 얘기해요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612579, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

