-- 무중력 댄스(880283)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"
        
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"

        PushPopupTownNpcWithSelectBox(153)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"

        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283001))     -- "우주에서 춤을 춘다면...?\n그래요, '무중력 상태'에서 춤을 추면!\n어떻게 될까~요?"


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(153)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283002))     -- "궁금하단 말이죠, 흠.. \n저와 함께 마치 중력을 받지 않는 듯한\n춤을 개발해보지 않을래요?"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283003))     -- "제 예상이지만 무중력에선 동작이\n매우 느려지지 않을까 싶은데..\n어때요. 느린 춤에 좀 관심이 있나요?"
	end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880283004))    -- "느~리게 동작해볼 거라구요~\n이런 게 필요해요!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283005))     -- "오~ 벌써 준비된 건가요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283006))     -- "이렇게 하는 거죠!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880283007))    -- "어때요, 괜찮죠!?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612613)
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283008))     -- "느려서 오히려 더 재미있는데요! 하하!\n덕분에 느린 춤의 매력에 빠진 것 같아요!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(153)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283002))     -- "궁금하단 말이죠, 흠.. \n저와 함께 마치 중력을 받지 않는 듯한\n춤을 개발해보지 않을래요?"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283003))     -- "제 예상이지만 무중력에선 동작이\n매우 느려지지 않을까 싶은데..\n어때요. 느린 춤에 좀 관심이 있나요?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612613, 0)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283006))     -- "이렇게 하는 거죠!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880283007))    -- "어때요, 괜찮죠!?"
    SetCollectionData()
    
    PopScene()
end



if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880283009))     -- "이런?\n별로 준비할 것도 없어 보이는데요.."

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880283010))    -- "음...\n관심이 없군요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612613, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

