-- 심심한 요정 여왕(880291)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"
        
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"

        PushPopupTownNpcWithSelectBox(121)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"

        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291001))     -- "아, [nickname]님 안녕하세요~\n오늘도 참 춤추기 좋은 날이죠?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(121)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291002))     -- "댄소나이트를 위해 댄스게이트 옆에만\n있어서 그런지, 좀 따분하네요~\n버리고 놀러 갈까나~ 에헷. 물론 농담~"
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291003))     -- "뭘 해야 좀 재밌을까?~ 흠..\n아! 혹시 요정의 춤을 알려줄까요?\n내가 춤을 알려주면 그대로 추기만 하면 돼요~"
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291004))    -- "자 동작을 알려줄 테니 잘 봐요~"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880291005))    -- "근데 잠깐?\n아? 이게 없네?\n음.. 이게 필요할 것 같은데.."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204004)    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291006))     -- "좋아요! 시작해보죠!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291007))     -- "잘 가르쳐 드릴게요~!\n보수는 댄소로 주시면 돼요~!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880291008))    -- "보수 얘기는 농담이에요 헤헷!\n요정들의 춤을 잘 추시는군요~?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(121), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204004)   
        
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291009))     -- "호오~ 몸이 참 가벼우신 것 같아요~\n요정들의 춤을 익히기가 좀 까다로울 텐데."
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291010))     -- "덕분에 심심함을 덜었어요~\n고마워요~! 보답을 해야겠죠?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(121)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291002))     -- "댄소나이트를 위해 댄스게이트 옆에만\n있어서 그런지, 좀 따분하네요~\n버리고 놀러 갈까나~ 에헷. 물론 농담~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291003))     -- "뭘 해야 좀 재밌을까?~ 흠..\n아! 혹시 요정의 춤을 알려줄까요?\n내가 춤을 알려주면 그대로 추기만 하면 돼요~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291004))    -- "자 동작을 알려줄 테니 잘 봐요~"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612631, 0)
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291007))     -- "잘 가르쳐 드릴게요~!\n보수는 댄소로 주시면 돼요~!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880291008))    -- "보수 얘기는 농담이에요 헤헷!\n요정들의 춤을 잘 추시는군요~?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880291011))     -- "준비물이 좀 필요한데~\n구해올 수 있죠~?"
    GoTown()
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001",  STR_QUEST_TEXT(880291012))    -- "음? 앗.. 가지 마요~\n심심한데..."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612631, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

