-- 댄스파를 뿜어내!(880292)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"
        
        PushPopupTownNpcWithSelectBox(135)
    end

    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"

        PushPopupTownNpcWithSelectBox(135)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"

        PushPopupTownNpcWithSelectBox(135)
    end

    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292001))     -- "어서 춤을 춰서 댄스파를\n더 많은 춤요정들에게!"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
  
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(135)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292002))     -- "사람들이 계속 댄스파를 열심히\n만들 수 있도록 춤을 가르쳐야겠어요!\n바로 요정들만의 특별한 춤을!"
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292003))     -- "잘 봐요, 춤을 알려줄 테니까,\n열심히 댄스비전에 올리는 거예요.\n알겠죠?"        
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880292004))    -- "요정들의 춤을 추려면 이 정도는\n있어야 한답니다~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292005))     -- "준비됐네요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292006))     -- "좋아요! 댄스파 장전!\n마구마구 발사할 준비됐죠~!?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880292007))    -- "좋네요! 아주 좋아요~!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(135), "copy")    
        
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292008))     -- "댄스파가 마구마구 뿜어져 나오는군~!\n좋아요 좋아! 어서 더 많은 춤을 추는 거예요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292009))     -- "자! 이거 받아요~\n더 많은 춤을 춘다고 약속!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(135)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292002))     -- "사람들이 계속 댄스파를 열심히\n만들 수 있도록 춤을 가르쳐야겠어요!\n바로 요정들만의 특별한 춤을!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292003))      -- "잘 봐요, 춤을 알려줄 테니까,\n열심히 댄스비전에 올리는 거예요.\n알겠죠?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612624, 0)
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292006))     -- "좋아요! 댄스파 장전!\n마구마구 발사할 준비됐죠~!?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880292007))    -- "좋네요! 아주 좋아요~!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880292010))     -- "아직 준비가 필요해 보이네요~"
    GoTown()
 end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880292011))    -- "앗! 안되는데..!!\n어서 춤을 춰서 댄스파를 내뿜어달라구요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612624, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

