-- 춤요정들의 춤(880293)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"
        
        PushPopupTownNpcWithSelectBox(202)
    end

    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"

        PushPopupTownNpcWithSelectBox(202)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"

        PushPopupTownNpcWithSelectBox(202)
    end

    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293001))     -- "안녕~? 뭐 해??\n나? 또 몰래 나왔지 헤헤~!"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(202)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293002))     -- "이제 내가 얼마나 인기 많은지 알겠다고~?!\n그럼~! 거의 1세대 급 아이돌인 걸 헤헤~!"
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293003))     -- "음~ 사람들이 우리 안무를 신기해하는 건..\n춤요정들의 전통 춤에서 따온 춤들이\n많아서이지 않을까~?"
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293004))            -- "춤요정들의 춤은 예쁘기로 유명한데~\n그래서! 난 더 많은 사람들에게 우리 요정들의 춤을\n보이기 위해 그룹을 형성하고 방송을 시작한 거라구~"
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293005))     -- "음... 그래! 기본이 되는 동작을 알려줄까?\n너라면 이 동작을 기반으로 해서 더 많은\n안무를 창조해낼 수 있을 거라 믿어!"
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880293006))    -- "이 정도는 할 수 있지?"
    
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293007))     -- "좋아~! 역시 너는 준비도 완벽해!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293008))     -- "분명 많은 영감을 얻을 수 있을 거야!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880293009))    -- "어때? 내 말이 맞지?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(202), 612626)
        
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293010))     -- "역시 넌 재능이 넘쳐~!\n우리 멤버로 영입하고 싶을 정도야!"
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293011))     -- "앗 시간 다 됐다!\n이만 가볼게. 오늘 즐거웠어! 또 봐~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(202)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293002))     -- "이제 내가 얼마나 인기 많은지 알겠다고~?!\n그럼~! 거의 1세대 급 아이돌인 걸 헤헤~!"
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293003))     -- "음~ 사람들이 우리 안무를 신기해하는 건..\n춤요정들의 전통 춤에서 따온 춤들이\n많아서이지 않을까~?"
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293004))            -- "춤요정들의 춤은 예쁘기로 유명한데~\n그래서! 난 더 많은 사람들에게 우리 요정들의 춤을\n보이기 위해 그룹을 형성하고 방송을 시작한 거라구~"
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293005))     -- "음... 그래! 기본이 되는 동작을 알려줄까?\n너라면 이 동작을 기반으로 해서 더 많은\n안무를 창조해낼 수 있을 거라 믿어!"
  
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612626, 0)
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293008))     -- "분명 많은 영감을 얻을 수 있을 거야!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880293009))    -- "어때? 내 말이 맞지?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880293012))     -- "앗? 시간이 별로 없는데~\n알겠어! 조금 기다릴게~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880293013))   -- "응? 그래? 알겠어~!\n그럼 이만 가봐야겠다~! 다음에 봐!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612626, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

