-- 우아한 공중 턴(880294)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"
        
        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"

        PushPopupTownNpcWithSelectBox(117)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"

        PushPopupTownNpcWithSelectBox(117)
    end

    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294001))     -- "요정들의 춤이 궁금하지 않나?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(117)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294002))     -- "몸집이 작아서 그런가,\n우아하면서도 동작이 큰 게 바로\n춤요정들의 춤 특징이지."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294003))     -- "아 물론 날개가 있어서 공중으로의\n이동이 부드럽고 자유로운 것도 있고."
        DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294004))            -- "공중에서 추는 춤이 궁금해?\n흠.. 한번 보여줄 테니 따라 해봐."
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880294005))    -- "그래도 요정의 춤을 배우는 건데~\n구색이라도 맞춰봐야지 않겠어?\n날개 좀 달고 와~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204004)    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294006))     -- "음. 좋아 보여줄게."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294007))     -- "자~! 컨디션 좋고?\n몸 가벼운 거 맞지?\n공중에서 가볍게 턴도 할 거야~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880294008))    -- "음~ 좋아. 아주 잘했어~"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(117), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 204004)   
        
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294009))     -- "잘하는군~!\n다음엔 좀 더 어려운 걸 알려줘도 되겠어~!"

    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(117)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294002))     -- "몸집이 작아서 그런가,\n우아하면서도 동작이 큰 게 바로\n춤요정들의 춤 특징이지."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294003))     -- "아 물론 날개가 있어서 공중으로의\n이동이 부드럽고 자유로운 것도 있고."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294004))          -- "공중에서 추는 춤이 궁금해?\n흠.. 한번 보여줄 테니 따라 해봐."

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612653, 0)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294006))    -- "음. 좋아 보여줄게."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880294008))    -- "음~ 좋아. 아주 잘했어~"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(880294010))     -- "기다리고 있을 테니 어서 다녀와."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(117, STR_NPC(117), "Characters/npc_017",  STR_QUEST_TEXT(880294011))    -- "궁금하지 않다면 할 수 없군."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612653, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
