-- 댄스빌의 살아있는 전설(880301)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."
        
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."

        PushPopupTownNpcWithSelectBox(158)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."

        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301001))     -- "댄스빌에서 나를 만난 건 엄청난 행운이지.\n암 그렇고말고."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(158)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301002))     -- "나날이 발전하는 자네의 춤을 보니,\n왠지 예전의 내가 생각나는구먼. 하하.."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301003))  -- "그래서 말이야. 오늘은 자네한테\n내가 처음으로 개발한 춤기술과 춤을\n전수해 주고 싶어서 와봤다네."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301004))   -- "예전의 나로 돌아간 것처럼 갑자기\n설레는군... 후후.. 자 시작해볼까?"
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880301005))    -- "우선은 이게 필요하다네."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301006))     -- "음. 역시 내 제자님의 준비 속도는 언제나 빠르다니까?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301007))     -- "정~말로 특별히 자네에게만 알려주는 거니,\n잘 따라 해보시게나."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880301008))    -- "음~ \n역시 타고난 감각이 있어서..\n꽤나 잘 따라 하는군그래."
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(158), 612660)
        
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301009))     -- "하하! 자네 그거 아는가?\n자네에게 춤을 가르쳐주는 것은 꽤나 즐거운 일이라네.\n왠지 뿌듯함을 느끼게 해주거든!"

    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(158)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301002))     -- "나날이 발전하는 자네의 춤을 보니,\n왠지 예전의 내가 생각나는구먼. 하하.."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301003))     -- "그래서 말이야. 오늘은 자네한테\n내가 처음으로 개발한 춤기술과 춤을\n전수해 주고 싶어서 와봤다네."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301004))             -- "예전의 나로 돌아간 것처럼 갑자기\n설레는군... 후후.. 자 시작해볼까?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612660, 0)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301007))      -- "정~말로 특별히 자네에게만 알려주는 거니,\n잘 따라 해보시게나."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880301008))    -- "음~ \n역시 타고난 감각이 있어서..\n꽤나 잘 따라 하는군그래."
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880301010))     -- "아직은 배울 준비가 되지 않았군."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(158, STR_NPC(158), "Characters/npc_002",  STR_QUEST_TEXT(880301011))    -- "..이 스승의 성의를 무시하는 겐가!?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612660, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
