-- 댄스빌 고전 음악(880302)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
                DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
              DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
              DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
               DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302001))    -- "예전부터 댄스빌에 전해져 오는\n전설 같은 음악이 있지.."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302002))   -- "먼 옛날.. 우리 조상님께서 작곡하셨던..\n주옥같은 음악이 있지.."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302003))  -- "듣는 이로 하여금.. 춤을 추지 않고서는\n배기지 못하는... 그런 곡이라네!"
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302004))  -- "왠지 모르겠지만 자네한테는\n특별히 그 음을 알려주고 싶군..\n한번 들어볼 텐가?"
        
    end


        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302005))   -- "그 곡을 알려주기 위해서는..\n이런 악기들이 필요하다네."


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302006))   -- "오오, 준비했는가."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302007))  -- "기대해도 좋다네!"
    RequireMusicFollowButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302008))   -- "자 완성일세! 어떠한가?\n정말 명곡이지 않은가? 허허허~~"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629037)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302009))   -- "다음에 또 좋은 곡을 알려 주겠네~\n또 보세."

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302010))   -- "음, 아직 준비가 안되었군."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302011))  -- "이런! 궁금하지 않은가?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(129)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302002))   -- "먼 옛날.. 우리 조상님께서 작곡하셨던..\n주옥같은 음악이 있지.."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302003))  -- "듣는 이로 하여금.. 춤을 추지 않고서는\n배기지 못하는... 그런 곡이라네!"
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302004))  -- "왠지 모르겠지만 자네한테는\n특별히 그 음을 알려주고 싶군..\n한번 들어볼 텐가?"
        
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302005))   -- "그 곡을 알려주기 위해서는..\n이런 악기들이 필요하다네."
         
    end

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302006))   -- "오오, 준비했는가."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302007))  -- "기대해도 좋다네!"
    RequireMusicFollowButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302008))   -- "자 완성일세! 어떠한가?\n정말 명곡이지 않은가? 허허허~~"

      
      Wait(0.5)

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880302009))   -- "다음에 또 좋은 곡을 알려 주겠네~\n또 보세."


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


