-- 댄스빌에 울려퍼지는(880303)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
                DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
              DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
              DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
               DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303001))    -- "댄스빌에 올 때마다, 듣기만 해도\n온몸에 전율이 흐르는 것 같은\n음악 소리가 들리지 않나요~?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(121)
        
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303002))   -- "댄스빌에 울려 퍼지는 익숙한 이 음악 소리!\n익숙한 이 곡은 어떻게 만든 건지.. \n제가 알려드릴까요?"
        
    end


        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303003))   -- "훗! 좋아요~\n특별히 댄소를 받지 않고 알려드리죠!\n이걸 준비해오세요~"


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303004))   -- "준비하셨군요?"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303005))  -- "훗! 기대하세요!"
    RequireMusicFollowButton()

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303006))   -- "어때요~\n직접 만들어보니 쉽죠?"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629038)
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303007))   -- "익숙한 음악을 직접 만드니 재밌죠?\n이런 식으로 잘 알고 있는 음악을\n한번 만들어 보는 게 어때요?~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303008))   -- "이런~? 아직 준비 안 하셨군요?\n조금 더 기다려드리죠~"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303009))  -- "음? 그래요, 아쉽지만 알겠어요~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(121)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303002))   -- "댄스빌에 울려 퍼지는 익숙한 이 음악 소리!\n익숙한 이 곡은 어떻게 만든 건지.. \n제가 알려드릴까요?"
        
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303003))   -- "훗! 좋아요~\n특별히 댄소를 받지 않고 알려드리죠!\n이걸 준비해오세요~"
         
    end

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303004))   -- "준비하셨군요?"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303005))  -- "훗! 기대하세요!"
    RequireMusicFollowButton()

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303006))   -- "어때요~\n직접 만들어보니 쉽죠?"

      
      Wait(0.5)

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(880303007))   -- "익숙한 음악을 직접 만드니 재밌죠?\n이런 식으로 잘 알고 있는 음악을\n한번 만들어 보는 게 어때요?~"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


