-- 드럼 비트 만들기(880311)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311001))  -- "작곡을 시작할 때, 드럼 비트를 만들어보면\n쉽게 영감이 떠오를 때가 있습니다. #꿀팁"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311002))  -- "작곡이란 매우 쉬우면서도, 매우 어렵죠.\n이해합니다. \n무엇을 어떻게 시작해야 하는지 모를 때의 그 난감함. "
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311003))  -- "그럴 땐 한번 무심한 듯(+시크하게)\n비트를 톡, 톡 찍어보라고 말해주고 싶군요."
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311004))  -- "뭐 원한다면 간단하게 드럼 비트를\n알려드리겠습니다.\n드럼들을 이와 같이 준비해주세요."

    PushPopupCollectionNeed()
end

local function SctiptOnQuest()
    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)

    CheckMusicFollowButton()

    if GetUIIsEnable("btnCorrectComplete") == 0 then

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311005))  -- "살짝 빠른 박자로 만들어볼까요?\n자, BPM은 120으로 세팅했습니다. \n킥 드럼부터 시작해봅시다."

        -- 1채널의 킥드럼 강제 터치 유도
        ::jmp_btnInst1::
        RequireButton("btnInst1")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst1
        end
    
        --킥드럼 노트 화면 진입 시
        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")
        ShowMusicEditSpotLight()
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311006))  -- "주위가 밝게 돌아가는 노트가 보이죠?\n가볍게 터치해봅시다."
        RemoveMusicEditSpotLight()
    
        ::jmp_addnote1::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote1
        end
    
        --노트를 모두 찍었을 시
        UIShowWithCCB("UI_music/ui_music_02", "btn_backward")
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311007))  -- "잘했습니다. 정말 쉽죠?\n이제 뒤로 가기 버튼을 눌러서\n악기 채널 화면으로 돌아갑시다."
    
        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        ::jmp_btn_back1::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back1
        end
    
        --[뒤로 가기] 버튼을 누르면 아래의 스크립트 진행
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311008))  -- "둥, 둥. 킥 드럼이 울리죠.\n자 이제 스네어 드럼 비트를 하나 더 넣어볼까요?\n아까와 같이 하면 됩니다."
    
        --2채널의 스네어 드럼 강제 터치 유도
        ::jmp_btnInst2::
        RequireButton("btnInst2")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst2
        end
    
        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")
    
        ::jmp_addnote2::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote2
        end
    
        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        UIShowWithCCB("UI_music/ui_music_02", "btn_backward")
        ::jmp_btn_back2::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back2
        end
    
        --[뒤로 가기] 버튼을 누르면 아래의 스크립트 진행
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311009))  -- "매우 기본적인 비트가 만들어졌죠.\n(하지만 뭔가 허전한…)\n하이 햇 드럼을 추가해보죠."
        
        --3채널의 스네어 드럼 강제 터치 유도
        ::jmp_btnInst3::
        RequireButton("btnInst3")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst3
        end
    
        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")
    
        ::jmp_addnote3::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote3
        end
    
        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        UIShowWithCCB("UI_music/ui_music_02", "btn_backward")
        ::jmp_btn_back3::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back3
        end
    
        CheckMusicFollowButton()
    end

    --[뒤로 가기] 후 완료 버튼을 강제 터치 유도
    ::jmp_MusicFollow::
    RequireButton("btnCorrectComplete") -- 구빌더 버튼
    if RequireCheckResult("OutOfTouch") then
        goto jmp_MusicFollow
    end

    Wait(0.5)
    if CheckCurrentPopupName("PopupYesNoMusic") then
        ::jmp_popup_ok::
        RequireButtonWithCCB( "UI_common/ui_popup_making_02_music", "btn_ok")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_popup_ok
        end
    end
    
    --완료 버튼을 누르면 완료 대사 등장

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311010))  -- "완성입니다. #매우 간단\n제법 많이 들어본 드럼비트죠?"

  
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311011))  -- "준비했군요. 시작해볼까요."

    SctiptOnQuest()

    Wait(0.5)

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    --SoundPlayMusicData(629081) 
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311012))  -- "어때요. 쉽지 않나요.#명강의"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311013))  -- "음악이 만들기 어려울 땐, 드럼을 활용하여\n간단한 비트부터 만들어보면 조금 더 쉽고 재미있을 겁니다.\n(다음에 기회가 되면 또 알려드리겠…)"
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()

    --GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311014))  -- "아직 드럼이 없군요. #실망"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311015))  -- "포기가 빠르군요. #실망"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end

-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311002))  -- "작곡이란 매우 쉬우면서도, 매우 어렵죠.\n이해합니다. \n무엇을 어떻게 시작해야 하는지 모를 때의 그 난감함. "
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311003))  -- "그럴 땐 한번 무심한 듯(+시크하게)\n비트를 톡, 톡 찍어보라고 말해주고 싶군요."
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311004))  -- "뭐 원한다면 간단하게 드럼 비트를\n알려드리겠습니다.\n드럼들을 이와 같이 준비해주세요."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311011))  -- "준비했군요. 시작해볼까요."
    ]]--

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)

    CheckMusicFollowButton()

    if CheckQuestAppear() then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311005))  -- "살짝 빠른 박자로 만들어볼까요?\n자, BPM은 120으로 세팅했습니다. \n킥 드럼부터 시작해봅시다."
    end

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311012))  -- "어때요. 쉽지 않나요.#명강의"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880311013))  -- "음악이 만들기 어려울 땐, 드럼을 활용하여\n간단한 비트부터 만들어보면 조금 더 쉽고 재미있을 겁니다.\n(다음에 기회가 되면 또 알려드리겠…)"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

