-- 드럼비트 변형하기(880313)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))      -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))    -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))     -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))   -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))   -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313001))   -- "오호. 마침 잘 왔군요. #반가움\n만들어둔 드럼 비트가 있는데 살짝 아쉬워서..\n함께 변형해보실…?"
    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313002))   -- "아무 생각 없이 패턴을 만들었는데\n마음에 들지 않아서 살짝 변형해볼까 합니다. "
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313003))   -- "원한다면 함께해도 좋습니다.\n#준비물 #필요함"
    PushPopupCollectionNeed()
end

local function SctiptOnQuest()

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)

    CheckMusicFollowButton()

    if CheckQuestAppear() then

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313004))  -- "1패턴에서 4패턴까지 동일한 비트로 연주하다가,\n5패턴~8패턴에서 약간의 변화를 주고 싶었는데.."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313005))    -- "네, 지금은 너무 재미없는 비트죠. #인정\n어서 바꿔봅시다."
    end

    if GetUIIsEnable("btnCorrectComplete") == 0 then
            -- 1채널의 킥드럼 강제 터치 유도
        ::jmp_btnInst1::
        RequireButton("btnInst1")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst1
        end

        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")

        ::jmp_addnote1::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote1
        end

        UIShowWithCCB("UI_music/ui_music_02", "btn_backward")

        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        ::jmp_btn_back1::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back1
        end

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313006))      -- "흠.. 킥 드럼만 바꿔서는 크게 변화가 없는 것 같죠?\n어서 스네어 드럼을 바꿔봅시다."
        
        -- 2채널의 킥드럼 강제 터치 유도
        ::jmp_btnInst2::
        RequireButton("btnInst2")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst2
        end

        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")

        ::jmp_addnote3::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote3
        end

        UIShowWithCCB("UI_music/ui_music_02", "btn_backward")

        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        ::jmp_btn_back3::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back3
        end

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313007))      -- "이제 좀 바뀐 것 같군요.\n훨씬 좋아졌습니다. #짝짝"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313008))      -- "앗.\n클로즈 하이 햇이 아무 소리도 내지 않고 있네요.\n(어서 패턴을 찍어봅시…)"

        -- 3채널의 킥드럼 강제 터치 유도
        ::jmp_btnInst3_0::
        RequireButton("btnInst3")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnInst3_0
        end

        UIHideWithCCB("UI_music/ui_music_02", "btn_backward")

        ::jmp_addnote4::
        RequireSceneMusicTrackEditChannelCorrect()
        if RequireCheckResult("check_note") then
            goto jmp_addnote4
        end

         UIShowWithCCB("UI_music/ui_music_02", "btn_backward")

        --[뒤로 가기] 버튼 강제 터치 유도
        Wait(0.5)
        ::jmp_btn_back4::
        RequireButtonWithCCB("UI_music/ui_music_02", "btn_backward")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_back4
        end
        
    end

    CheckMusicFollowButton()
    
    --[뒤로 가기] 후 완료 버튼을 강제 터치 유도
    ::jmp_MusicFollow::
    RequireButton("btnCorrectComplete") -- 구빌더 버튼
    if RequireCheckResult("OutOfTouch") then
        goto jmp_MusicFollow
    end
    
    Wait(0.5)
    if CheckCurrentPopupName("PopupYesNoMusic") then
        ::jmp_popup_ok::
        RequireButtonWithCCB( "UI_common/ui_popup_making_02_music", "btn_ok")
            if RequireCheckResult("OutOfTouch") then
            goto jmp_popup_ok
        end
    end
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313009))   -- "준비가 빠르군요. #칭찬"

    SctiptOnQuest()

    QuestStart()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313010))   -- "#완성. 처음의 비트와 느낌이 많이 다르죠?\n이런 식으로 패턴의 위치만 살짝 바꿔도\n큰 변화를 줄 수 있습니다 #간단"

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629083)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313011))  -- "드럼 비트는 이제 어느 정도 감이 왔나요?\n다음번엔 비트에 창작 멜로디를 한번 붙여 보는 걸로…\n#재미 보장"

    Wait(0.5)
    ScenarioEndingShow()

    
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313012))  -- "음.. 생각한 것보다 시간이 걸리는 것 같...\n뭐.. 굳이 빨리할 필요는 없습.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313013))   -- "이런.. 아쉽.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313002))   -- "아무 생각 없이 패턴을 만들었는데\n마음에 들지 않아서 살짝 변형해볼까 합니다. "
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313003))   -- "원한다면 함께해도 좋습니다.\n#준비물 #필요함"
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313009))   -- "준비가 빠르군요. #칭찬"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)

    CheckMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313004))  -- "1패턴에서 4패턴까지 동일한 비트로 연주하다가,\n5패턴~8패턴에서 약간의 변화를 주고 싶었는데.."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313005))    -- "네, 지금은 너무 재미없는 비트죠. #인정\n어서 바꿔봅시다."

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313010))   -- "#완성. 처음의 비트와 느낌이 많이 다르죠?\n이런 식으로 패턴의 위치만 살짝 바꿔도\n큰 변화를 줄 수 있습니다 #간단"


      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880313011))  -- "드럼 비트는 이제 어느 정도 감이 왔나요?\n다음번엔 비트에 창작 멜로디를 한번 붙여 보는 걸로…\n#재미 보장"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

