-- 음 길이 변경하기(880321)
-- version("0.54.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))      -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))    -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))     -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))   -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))   -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321001))   -- "음의 길이를 길게, 혹은 짧게 바꿔본 적이 있나요?\n#음 길이 설정"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321002))   -- "음의 길이를 변경하면, 곡의 박자에 변화를 주어\n곡의 느낌이 많이 달라집니다."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321003))   -- "마침 음길이를 수정하려고 놔둔 곡이 있는데 [nickname] 씨가\n한번 수정 해보겠?  #음길이 조정 체험"
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321004))   -- "이 정도만 준비하면 됩니다."

    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321005))   -- "진행합시다."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321006))  -- "지금 곡의 박자를 잘 기억해두세요.\n변화 후의 곡과 비교해봅시다. "

    if GetUIIsEnable("btnCorrectComplete") == 0 then
        ::jmp_scene::
        RequireCurrentSceneName("SceneMusicTrackEdit")
        if RequireCheckResult("check_scene") then
            goto jmp_scene
        end
    
        Wait(1.0)
        -- btnLength는 구빌더라 CCB명이 없어서 RequireButton()로 사용 
        ::jmp_btnLength::
        RequireButton( "btnLength")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btnLength
        end
    
        ::jmp_btn_edit_all::
        RequireButtonWithCCB( "UI_music/ui_btn2_031_03", "btn_edit_all")
        if RequireCheckResult("OutOfTouch") then
            goto jmp_btn_edit_all
        end    
    end

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321007))   -- "처음 곡과 많이 달라졌죠?"

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629034)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321008))  -- "이런 식으로 음길이에 변화를 줘보세요.\n재미있는 곡이 탄생할지도..?"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321009))  -- "아직 준비되지 않았군요. #실망"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321010))   -- "이런.. 알겠습니다."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321002))   -- "음의 길이를 변경하면, 곡의 박자에 변화를 주어\n곡의 느낌이 많이 달라집니다."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321003))   -- "마침 음길이를 수정하려고 놔둔 곡이 있는데 [nickname] 씨가\n한번 수정 해보겠?  #음길이 조정 체험"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321004))   -- "이 정도만 준비하면 됩니다."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321005))   -- "진행합시다."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321006))  -- "지금 곡의 박자를 잘 기억해두세요.\n변화 후의 곡과 비교해봅시다. "

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321007))   -- "처음 곡과 많이 달라졌죠?"

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880321008))  -- "이런 식으로 음길이에 변화를 줘보세요.\n재미있는 곡이 탄생할지도..?"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

