-- 음 세기 조정하기(880322)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))      -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))    -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))     -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))   -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))   -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322001))   -- "아! 제자님 어서 와. 마침 잘 왔어.\n내가 노래를 만들었는데...\n이 느낌을 원한 게 아닌데 말이지.."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(158)
        
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322002))   -- "곡이 너무 밋밋한 것 같아.\n뭐랄까, 나는 곡 중간의 강조하고 싶은 음에\n임팩트를 주고 싶단 말이야?"
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322003))   -- "제자님이 한번 손봐주지 않을래?\n왠지 제자님이라면 내가 원하는 곡으로\n만들어줄 수 있을 것 같아."
    end

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322004))   -- "이런 악기만 있으면 돼.\n쉽게 구할 수 있지, 제자님?"

    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322005))   -- "오오. 좋아. 역시 내 제자님은 준비도 빠르단 말이야."

local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322006))  -- "다시 말하지만, 나는 임팩트를 주고 싶어.\n내 제자님이라면 알아서 척 척 바꿔주겠지만 말이야."

    RequireMusicFollowButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322007))   -- "그래! 이거야 이거!"

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629028)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322008))  -- "역시 내 제자님은 아주 우수해!\n음악 작곡에도 아주 뛰어나군.\n역시 내 명성을 더 빛내줄 수 있는 제자는 자네뿐이야!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322009))  -- "엉~? 아직도 준비가 안됐어?"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322010))   -- "이런~ 제자님 무슨 바쁜 일이 있나 봐?\n어쩔 수 없지 뭐.. \n내가 너무 제자님한테 거는 기대가 컸던 것 같네.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(158)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322002))   -- "곡이 너무 밋밋한 것 같아.\n뭐랄까, 나는 곡 중간의 강조하고 싶은 음에\n임팩트를 주고 싶단 말이야?"
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322003))   -- "제자님이 한번 손봐주지 않을래?\n왠지 제자님이라면 내가 원하는 곡으로\n만들어줄 수 있을 것 같아."
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322004))   -- "이런 악기만 있으면 돼.\n쉽게 구할 수 있지, 제자님?"
         
    end

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322005))   -- "오오. 좋아. 역시 내 제자님은 준비도 빠르단 말이야."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322006))  -- "다시 말하지만, 나는 임팩트를 주고 싶어.\n내 제자님이라면 알아서 척 척 바꿔주겠지만 말이야."

    RequireMusicFollowButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322007))   -- "그래! 이거야 이거!"

      
      Wait(0.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880322008))  -- "역시 내 제자님은 아주 우수해!\n음악 작곡에도 아주 뛰어나군.\n역시 내 명성을 더 빛내줄 수 있는 제자는 자네뿐이야!"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

