-- 자유멜로디 제작하기(880324)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))      -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))    -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))     -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))   -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))   -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324001))   -- "[nickname]씨가 심심해 보이는 것 같아\n불러봤습니다. #명중?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324002))   -- "음.. [nickname]씨는 워낙 출중해서 더 이상 제가\n알려줄 것이 없는 것 같고.. (이제 그만 하산...)"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324003))   -- "제가 작곡한 곡의 대다수의 채널에\n노트가 빠져 있습니다. 한번 빈칸을 채워보겠?\n#창작"
        
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324004))   -- "빈 채널에 채울 소리들까지 고려하면..\n이 악기들이 필요할 것 같군요."

    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324005))   -- "오. 생각보다 빨리 준비했습니다. #짝짝짝"

local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324006))  -- "노트가 빠진 채널을 채우면 됩니다.\n(의외로 간단할 지도..)"

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324007))   -- "잘했습니다. #짝짝짝"

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629025)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324008))  -- "마치 처음부터 이렇게 작곡한 곡 같군요.\n(역시.. [nickname]씨는 이제 그만 하산을...)"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324009))  -- "천천히 준비하세요. #한가함"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324010))   -- "아. 심심한 게 아니었군요. #오해\n알겠습니다."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324002))   -- "음.. [nickname]씨는 워낙 출중해서 더 이상 제가\n알려줄 것이 없는 것 같고.. (이제 그만 하산...)"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324003))   -- "제가 작곡한 곡의 대다수의 채널에\n노트가 빠져 있습니다. 한번 빈칸을 채워보겠?\n#창작"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324004))   -- "빈 채널에 채울 소리들까지 고려하면..\n이 악기들이 필요할 것 같군요."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324005))   -- "오. 생각보다 빨리 준비했습니다. #짝짝짝"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324006))  -- "노트가 빠진 채널을 채우면 됩니다.\n(의외로 간단할 지도..)"

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324007))   -- "잘했습니다. #짝짝짝"

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880324008))  -- "마치 처음부터 이렇게 작곡한 곡 같군요.\n(역시.. [nickname]씨는 이제 그만 하산을...)"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

