
-- 아르바이트를 시작하면 레스토랑 내를 돌아다니며 춤을 춤
-- 레스토랑 유니폼을 착용
-- 테이블 앞에서 뒤로 돌아 테이블을 정리하는 듯 한 연출 가미

local function WearDefault()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202707)
end

local function WearWithFood1()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202707)
    Character_Wear("dancer", 205708)
end

local function WearWithFood2()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202707)
    Character_Wear("dancer", 205711)
end

local function WearWithPlate()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202707)
    Character_Wear("dancer", 205713)
end

local function Character_RoamInRestorant(char_name)
    -- 레스토랑
    restorant_tile_x = Item_GetX("restorant")/40
    restorant_tile_y = Item_GetY("restorant")/40

    Character_RoamIn(char_name, restorant_tile_x, restorant_tile_x+12, restorant_tile_y, restorant_tile_y+12)
end

if OnArbeit() then
    -- 레스토랑
    SetItem("restorant", 10020600)

    -- 레스토랑 바깥 테이블
    SetItem("table_1", 10020602)
    table_1_x = Item_GetX("table_1")
    table_1_y = Item_GetY("table_1")

    -- 레스토랑 내부 테이블
    SetItem("table_2", 10020604)
    table_2_x = Item_GetX("table_2")
    table_2_y = Item_GetY("table_2")

    -- 음식
    SetAnimationByTownObjectID("food_ani_1", 10020608)
    SetAnimationByTownObjectID("food_ani_2", 10020609)

    WearDefault()
    -- 레스토랑 돌아다님
    Character_RoamInRestorant("dancer")

    SetCharacter("client_1_1", 348)
    Item_SetCharacterFront("table_1", "client_1_1", 0)
    Character_ActionID_Offset("client_1_1", 612219)

    SetCharacter("client_1_2", 349)
    Item_SetCharacterFront("table_1", "client_1_2", 0)
    Character_ActionID_Offset("client_1_2", 612218)

    SetCharacter("client_2_1", 346)
    Item_SetCharacterFront("table_2", "client_2_1", 0)
    Character_ActionID_Offset("client_2_1", 612220)

    SetCharacter("client_2_2", 347)
    Item_SetCharacterFront("table_2", "client_2_2", 0)
    Character_ActionID_Offset("client_2_2", 612221)

    -- 반복
    while 1 do
        -- 카운터 근처로 이동
        Character_WaitMoveTo("dancer", table_1_x+320, table_1_y+240)

        -- 음식을 들려주자
        WearWithFood1()

        -- 레스토랑 돌아다님, 음식 든 자세
        Character_SetIdleAction("dancer", 612201)
        Character_SetRoamingAction("dancer", 612194, 612200)
        Character_RoamInRestorant("dancer")
        Wait(1)

        -- 아래 테이블 근처로 이동
        Character_WaitMoveTo("dancer", table_1_x+80, table_1_y+80)

        -- 음식 놓기
        Item_SetCharacterBack("table_1", "dancer", 0)
        Character_LeftArmToFront("dancer", "table_1")
        Character_ActionID_Offset("dancer", 612198)
        Wait(1)
        WearDefault()
        Item_SetAniFront("table_1", "food_ani_1")
        Animation_Play("food_ani_1")
        Item_UnsetCharacter("table_1", "dancer")
        Character_ArmsToBack("dancer")

        -- 카운터 근처로 이동
        Character_WaitMoveTo("dancer", table_1_x+320, table_1_y+240)

        -- 음식을 들려주자
        WearWithFood2()

        -- 레스토랑 돌아다님, 음식 든 자세
        Character_SetIdleAction("dancer", 612201)
        Character_SetRoamingAction("dancer", 612194, 612200)
        Character_RoamInRestorant("dancer")
        Wait(1)

        -- 위 테이블 근처로 이동
        Character_WaitMoveTo("dancer", table_2_x+80, table_2_y)

        -- 음식 놓기
        Item_SetCharacterFront("table_2", "dancer", 0)
        Character_ActionID_Offset("dancer", 612199)
        Wait(1)
        WearDefault()
        Item_SetAniFront("table_2", "food_ani_2")
        Animation_Play("food_ani_2")
        Item_UnsetCharacter("table_2", "dancer")
        Character_ArmsToBack("dancer")

        -- 레스토랑 돌아다님
        Character_SetRoamingAction("dancer", 612065, 0)
        Character_RoamInRestorant("dancer")
        Wait(12)

        -- 아래 테이블 근처로 이동
        Character_WaitMoveTo("dancer", table_1_x+80, table_1_y+80)

        -- 음식 제거
        Item_SetCharacterBack("table_1", "dancer", 0)
        Character_LeftArmToFront("dancer", "table_1")
        Character_RightArmToFront("dancer", "table_1")
        Character_ActionID_Offset("dancer", 612203)
        Wait(1)
        Item_UnsetCharacter("table_1", "dancer")
        Character_ArmsToBack("dancer")
        Item_UnsetAni("table_1", "food_ani_1")
        WearWithPlate()

        -- 위 테이블 근처로 이동
        Character_WaitMoveTo("dancer", table_2_x+80, table_2_y)

        -- 음식 제거
        Item_SetCharacterFront("table_2", "dancer", 0)
        Character_ActionID_Offset("dancer", 612204)
        Wait(1)
        Item_UnsetCharacter("table_2", "dancer")
        Character_ArmsToBack("dancer")
        Item_UnsetAni("table_2", "food_ani_2")
        WearWithPlate()
    end
end
