
-- 아르바이트를 시작하면 클럽 DJ박스 앞에서 춤을 춤
-- 문하생을 집중적으로 비추는 조명 연출 가미
if OnArbeit() then
    -- 클럽 춤꾼들은 주변으로 배치
    TownClubDancerSpread()

    -- 클럽
    SetItem("club", 10020101)
    SetItem("club_ex", 10020104)

    -- 클럽 위치
    x = Item_GetX("club");
    y = Item_GetY("club")+40;

    -- 테이블
    SetAnimation("table", "Object/obj_build_danceclub_item_1x1_alba_table")
    Animation_SetPos("table", 0, 0)
    Item_SetAniFront("club_ex", "table")

    -- 폭죽
    SetAnimation("fire_right", "Object/obj_build_danceclub_item_1x1_alba_fire_right")
    Animation_SetPos("fire_right", 320-80, 440)
    Item_SetAniFront("club_ex", "fire_right")

    SetAnimation("fire_left", "Object/obj_build_danceclub_item_1x1_alba_fire_left")
    Animation_SetPos("fire_left", 80-80, 440)
    Item_SetAniFront("club_ex", "fire_left")

    -- 발판
    SetAnimation("stage", "Object/obj_build_danceclub_item_4x2_alba_middlestage")
    Animation_SetPos("stage", -40, -40)

    -- 춤꾼
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202711) -- 옷
    Character_Wear("dancer", 201709) -- 모자
    Character_Wear("dancer", 205709) -- 손
    Character_Wear("dancer", 203701) -- 얼굴
    Character_StandAt("dancer", x+320, y+200)
    Character_ActionID("dancer", 612149) -- 춤
    Character_SetAniBack("dancer", "stage") -- 스테이지

    -- NPC
    SetCharacter("club_alba_1", 334)
    SetCharacter("club_alba_2", 335)

    SetCharacter("club_wait_1", 336)
    SetCharacter("club_wait_2", 337)
    SetCharacter("club_wait_3", 338)

    Character_StandAt("club_alba_1", x+40, y+120)
    Character_ActionID("club_alba_1", 612180)

    -- 그냥 배치 시 데크 뒤쪽으로 배치되는 문제가 있어 데크 아이템 기준으로 앞쪽으로 배치
    Item_SetCharacterFront("club_ex", "club_alba_2", 0)
    Character_ActionID("club_alba_2", 612181)
    Character_StandAt("club_alba_2", 30, 50)

    Character_StandAt("club_wait_1", x-40, y-80)
    Character_ActionID("club_wait_1", 612182)
    Character_StandAt("club_wait_2", x-120, y-80)
    Character_ActionID("club_wait_2", 612184)
    Character_StandAt("club_wait_3", x-200, y-80)
    Character_ActionID("club_wait_3", 612179)

    -- 폭죽 반복재생
    while 1 do
        Animation_Play("fire_right")
        Animation_Play("fire_left")
        Wait(2)
        Animation_Play("fire_left")
        Wait(1)
        Animation_Play("fire_right")
        Wait(1)
        Animation_Play("fire_left")
        Wait(2)
    end

    WaitFinish()
end
