

local function ScriptDancerDismissDialog(npc_id)

    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(600, 0)) -- "어떻게 나한테 이럴 수가..."

end

-- 평상시 호감도에 따른 대화, Dialog 1~2 개 설정
local function ScriptFollowerCommonDialog(npc_id)

    closeness = GetFollowerCloseness(npc_id)

    if closeness < 10 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 280) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 280))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 281) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 281))
        end
        
    elseif closeness < 50 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 270) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 270))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 271) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 271))
        end
        
    elseif closeness < 60 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 260) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 260))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 261) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 261))
        end
        
    elseif closeness < 70 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 250) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 250))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 251) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 251))
        end
        
    elseif closeness < 80 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 240) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 240))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 241) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 241))
        end
        
    elseif closeness < 90 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 230) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 230))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 231) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 231))
        end
        
    elseif closeness < 100 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 220) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 220))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 221) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 221))
        end
        
    else
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 210) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 210))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 211) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 211))
        end
        
    end

end

-- 호감도 대화, Dialog 1~2 개 설정
local function ScriptDancerCommunicateDialog(npc_id)

    closeness = GetFollowerCloseness(npc_id)

    if closeness < 1 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 480) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 480))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 481) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 481))
        end
        
    elseif closeness < 20 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 470) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 470))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 471) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 471))
        end
        
    elseif closeness < 50 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 460) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 460))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 461) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 461))
        end
        
    elseif closeness < 60 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 450) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 450))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 451) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 451))
        end
        
    elseif closeness < 70 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 440) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 440))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 441) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 441))
        end
        
    elseif closeness < 80 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 430) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 430))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 431) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 431))
        end
        
    elseif closeness < 90 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 420) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 420))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 421) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 421))
        end
        
    elseif closeness < 100 then
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 410) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 410))
        end
        if STR_FOLLOWER_DIALOG_IS_EXIST(npc_id, 411) then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 411))
        end
        
    end

end

if OnTownAnyCharacterClick() then
    npc_id_clicked = GetInteger("npc_id_clicked")

    ScriptTownZoomInCharacter(TownCharacterGetNPC(npc_id_clicked))
    PushPopupTownMyDancer(npc_id_clicked)

    UIHideWithCCB("UI_common/ui_btn2_003_02", "btn_backward")
    UIHideWithCCB("UI_common/ui_btn2_003_02", "btn_closet")
    UIHide("btnChange")
    UIHideWithCCB("UI_common/ui_btn2_003_02", "btn_folldel")
    UIHideWithCCB("UI_common/ui_btn2_003_02", "btn_follmain")

    if CheckFollowerCommunicate(npc_id_clicked) then

        ScriptDancerCommunicateDialog(npc_id_clicked)

        SendProtocolCommunicateFollower(npc_id_clicked)

        WaitUIFollwerBoxClosenessUpEvent()

        PushPopupFollowerCommunicateResult(npc_id_clicked)

    else

        ScriptFollowerCommonDialog(npc_id_clicked)

    end

    UIShowWithCCB("UI_common/ui_btn2_003_02", "btn_backward")
    UIShowWithCCB("UI_common/ui_btn2_003_02", "btn_closet")
    UIShow("btnChange")
    UIShowWithCCB("UI_common/ui_btn2_003_02", "btn_folldel")
    UIShowWithCCB("UI_common/ui_btn2_003_02", "btn_follmain")

end

if OnTownDancerDismiss() then
    dancer_id_dismiss = GetInteger("dancer_id_dismiss")

    ScriptDancerDismissDialog(dancer_id_dismiss)

    SendProtocolFireDancer(dancer_id_dismiss)
    TownCameraUnsetCharacter()
    TownCharacterRunTo(TownCharacterGetNPC(dancer_id_dismiss), 0, -1*40)
    Wait(2)
    TownCharacterRemoveNPC(dancer_id_dismiss)
    SceneTownSetStateIdle()
    GoTown()
end
