-- 회전 초밥
-- version("0.19.00")

local function Use_This_Item()
    use_count = GetInteger("use_count")

    if use_count >= 3 then
        do return end
    end
    use_count = use_count+1
    SetInteger("use_count" , use_count)
    Item_WaitAndGetCharacterIn("self")

    ::Start_Animation::
    use_count = GetInteger("use_count")

    --테이블에 사용자가 1명
    if use_count == 1 then

        chr = GetPtr("dancer_ptr")
        if chr == 0 then
            do return end
        end
        SetCharacterWithPtr("dancer1", chr)

        Item_Hide("self")
        Item_SetAniBack("self", "on")
        Item_SetCharacterFront("self", "dancer1", 1)

        Character_ActionID_Offset("dancer1", 612398) -- card_table_01

        Animation_PlayWithCount("on", 1)
    
        while 1 do
            if Animation_isFinished("on") then
                do break end
            end

            if Item_GetCharacterInCount("self") then
                dancer_count = GetInteger("dancer_count")
                if dancer_count > use_count then
                    --현재 동작하는 애니메이션 제거
                    Item_UnsetCharacter("self", "dancer1")
                    UnsetCharacterInScript("dancer1")
                    Item_UnsetAni("self", "on")

                    for i=1, dancer_count do
                        dancer_ptr_name = "dancer_ptr" .. i;
                        dancer_ptr = GetPtr(dancer_ptr_name)
                        dancer_name = "dancer" .. i
                        SetCharacterWithPtr(dancer_name, dancer_ptr)
                    end
                    use_count = dancer_count
                    SetInteger("use_count" , use_count)
                    goto Start_Animation
                end
            end
            Wait(0.1)
        end
        
        Item_UnsetCharacter("self", "dancer1")
        UnsetCharacterInScript("dancer1")

    --테이블에 사용자가 2명
    elseif use_count == 2 then

        Item_Hide("self")
        Item_SetAniBack("self", "on")
        Item_SetCharacterFront("self", "dancer1", 1)
        Item_SetCharacterFront("self", "dancer2", 1)

        Character_ActionID_Offset("dancer1", 612398)
        Character_ActionID_Offset("dancer2", 612399)

        Animation_PlayWithCount("on", 1)
        while 1 do
            if Animation_isFinished("on") then
                do break end
            end

            if Item_GetCharacterInCount("self") then
                dancer_count = GetInteger("dancer_count")
                if dancer_count > use_count then
                    --현재 동작하는 애니메이션 제거
                    Item_UnsetCharacter("self", "dancer1")
                    UnsetCharacterInScript("dancer1")
                    Item_UnsetCharacter("self", "dancer2")
                    UnsetCharacterInScript("dancer2")
                    Item_UnsetAni("self", "on")

                    for i=1, dancer_count do
                        dancer_ptr_name = "dancer_ptr" .. i;
                        dancer_ptr = GetPtr(dancer_ptr_name)
                        dancer_name = "dancer" .. i
                        SetCharacterWithPtr(dancer_name, dancer_ptr)
                    end
                    use_count = dancer_count
                    SetInteger("use_count" , use_count)
                    goto Start_Animation
                end
            end
            Wait(0.1)
        end

        Item_UnsetCharacter("self", "dancer1")
        UnsetCharacterInScript("dancer1")
        Item_UnsetCharacter("self", "dancer2")
        UnsetCharacterInScript("dancer2")

    --테이블에 사용자가 3명
    elseif use_count == 3 then

        Item_Hide("self")
        Item_SetAniBack("self", "on")
        Item_SetCharacterFront("self", "dancer1", 1)
        Item_SetCharacterFront("self", "dancer2", 1)
        Item_SetCharacterFront("self", "dancer3", 1)

        Character_ActionID_Offset("dancer1", 612398)
        Character_ActionID_Offset("dancer2", 612399)
        Character_ActionID_Offset("dancer3", 612400)

        Animation_PlayWithCount("on", 1)
        Animation_WaitFinish("on")

        Item_UnsetCharacter("self", "dancer1")
        UnsetCharacterInScript("dancer1")
        Item_UnsetCharacter("self", "dancer2")
        UnsetCharacterInScript("dancer2")
        Item_UnsetCharacter("self", "dancer3")
        UnsetCharacterInScript("dancer3")
    end

    Item_UnsetAni("self", "on")
    Item_Show("self")

    -- 캐릭터가 나갈 때까지 대기
    Item_WaitCharacterOut("self")
    Wait(0.6)
    use_count = 0
    SetInteger("use_count" , use_count)
end

if OnCreate() then
    SetInteger("use_count_max", 3)
    SetAnimationByTownObjectID("on", 13004119)
    while 1 do
        Use_This_Item()
    end
end

if OnCharacterUse() then
    SetAnimationByTownObjectID("on", 13004119)
    Use_This_Item()
end
