-- 목욕탕_온열탕
-- version("0.19.00")

local function Use_This_Item()

    use_count = GetInteger("use_count")
    if use_count >= 2 then
        do return end
    end
    use_count = use_count+1
    SetInteger("use_count" , use_count)
    Item_WaitAndGetCharacterIn("self")

    ::Start_Animation::
    use_count = GetInteger("use_count")

    if use_count == 1 then

        chr = GetPtr("dancer_ptr")
        if chr == 0 then
            do return end
        end
        SetCharacterWithPtr("dancer1", chr)

        Item_Hide("self")
        Item_SetCharacterFront("self", "dancer1", 1)
        Item_SetAniBack("self", "on1")
        Item_SetAniFront("self", "on2")
        
        Character_UnwearClothesAll("dancer1")
        Character_Wear("dancer1", 201139)
        Character_Wear("dancer1", 202282)

        Character_StandAt("dancer1", 90, 165)
        Character_ActionID("dancer1", 612866)
        
        Animation_PlayWithCount("on1", 1)
        Animation_PlayWithCount("on2", 1)
     
        while 1 do
            if Animation_isFinished("on1") then
                do break end
            end

            if Item_GetCharacterInCount("self") then
                dancer_count = GetInteger("dancer_count")
                if dancer_count > use_count then
                   
                    Item_UnsetCharacter("self", "dancer1")
                    UnsetCharacterInScript("dancer1")
                    Item_UnsetAni("self", "on1")
                    Item_UnsetAni("self", "on2")

                    for i = 1, dancer_count do
                        dancer_ptr_name = "dancer_ptr" .. i;
                        dancer_ptr = GetPtr(dancer_ptr_name)
                        dancer_name = "dancer" .. i
                        SetCharacterWithPtr(dancer_name, dancer_ptr)
                    end
                    
                    use_count = dancer_count
                    SetInteger("use_count" , use_count)
                    goto Start_Animation
                end
            end
            Wait(0.1)
        end
        
        Item_UnsetCharacter("self", "dancer1")
        UnsetCharacterInScript("dancer1")

    elseif use_count == 2 then

        Item_Hide("self")
        Item_SetCharacterFront("self", "dancer1", 1)
        Item_SetCharacterFront("self", "dancer2", 1)
        Item_SetAniBack("self", "on1")
        Item_SetAniFront("self", "on2")

        Character_UnwearClothesAll("dancer2")
        Character_Wear("dancer2", 201139) 
        Character_Wear("dancer2", 202282)

        Character_UnwearClothesAll("dancer1")
        Character_Wear("dancer1", 201139)
        Character_Wear("dancer1", 202282)

        Character_StandAt("dancer1", 90, 165)
        Character_StandAt("dancer2", 255, 205)

        Character_ActionID("dancer1", 612866)
        Character_ActionID("dancer2", 612867)

        Animation_PlayWithCount("on1", 1)
        Animation_PlayWithCount("on2", 1)
        
        while 1 do
            if Animation_isFinished("on1") then
                do break end
            end

            if Item_GetCharacterInCount("self") then
                dancer_count = GetInteger("dancer_count")
                if dancer_count > use_count then
                   
                    Item_UnsetCharacter("self", "dancer1")
                    UnsetCharacterInScript("dancer1")
                    Item_UnsetCharacter("self", "dancer2")
                    UnsetCharacterInScript("dancer2")
                    Item_UnsetAni("self", "on1")
                    Item_UnsetAni("self", "on2")

                    for i=1, dancer_count do
                        dancer_ptr_name = "dancer_ptr" .. i;
                        dancer_ptr = GetPtr(dancer_ptr_name)
                        dancer_name = "dancer" .. i
                        SetCharacterWithPtr(dancer_name, dancer_ptr)
                    end
                    use_count = dancer_count
                    SetInteger("use_count" , use_count)
                    goto Start_Animation
                end
            end
            Wait(0.1)
        end

        Item_UnsetCharacter("self", "dancer1")
        UnsetCharacterInScript("dancer1")
        Item_UnsetCharacter("self", "dancer2")
        UnsetCharacterInScript("dancer2")
    end

    Item_UnsetAni("self", "on1")
    Item_UnsetAni("self", "on2")
    Item_Show("self")

    -- 캐릭터가 나갈 때까지 대기
    Item_WaitCharacterOut("self")
    Wait(0.6)
    use_count = 0
    SetInteger("use_count" , use_count)
end


if OnCreate() then
    SetInteger("use_count_max", 2)
    SetAnimationByTownObjectID("on1", 13009029)
    SetAnimationByTownObjectID("on2", 13009028)
    while 1 do
        Use_This_Item()
    end
end

if OnCharacterUse() then
    SetAnimationByTownObjectID("on1", 13009029)
    SetAnimationByTownObjectID("on2", 13009028)
    Use_This_Item()
end

