-- 뮤비 배우기 관련 스크립트

if OnTownAnyCharacterClick() then
    dancer_owner_uid_clicked = GetInteger("dancer_owner_uid_clicked")
    dancer_seq_clicked = GetInteger("dancer_seq_clicked")
    character_clicked = GetPtr("character_clicked")

    state = GetString("state")
    type = GetInteger("lesson_type")

    teacher_owner_uid = GetInteger("teacher_owner_uid")
    teacher_seq = GetInteger("teacher_seq")
    student_owner_uid = GetInteger("student_owner_uid")
    student_seq = GetInteger("student_seq")


    if state == "learning_complete" then

        -- 도로쪽이라 걸어갈 경로가 안나오니 즉시 이동시킨다.
        ScriptTownMoveToLeftDirect(character_clicked)

        RequireMVLearningComplete()

        GoTown()

    elseif state == "teaching" then

        MVLessonPushPopupTeaching(dancer_owner_uid_clicked, dancer_seq_clicked)
        MVLessonShowPlayer(dancer_owner_uid_clicked, dancer_seq_clicked)

        if type == 64 then -- 64 : Dance
            while 1 do
                MVLessonCheckFinish()
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 0)
                MVLessonSetDance(student_owner_uid, student_seq, 0)

                Delay(3)

                MVLessonCheckFinish()
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(student_owner_uid, student_seq), "Characters/eff_mg_dance_miss")
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 612210)
                MVLessonSetDance(student_owner_uid, student_seq, 612211)

                Delay(2)
            end

        elseif type == 65 then  -- 65 : Music
            while 1 do
                MVLessonCheckFinish()
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(teacher_owner_uid, teacher_seq), "Characters/eff_mg_lesson_music1")
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(student_owner_uid, student_seq), "Characters/eff_mg_lesson_music1")
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 612212)
                MVLessonSetDance(student_owner_uid, student_seq, 612212)

                Delay(3)

                MVLessonCheckFinish()
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(student_owner_uid, student_seq), "Characters/eff_mg_dance_miss")
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 612214)
                MVLessonSetDance(student_owner_uid, student_seq, 612213)

                Delay(2)
            end

        elseif type == 66 then  -- 66 : Inst
            while 1 do
                MVLessonCheckFinish()
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(teacher_owner_uid, teacher_seq), "Characters/eff_mg_lesson_music2")
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(student_owner_uid, student_seq), "Characters/eff_mg_lesson_music2")
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 612215)
                MVLessonSetDance(student_owner_uid, student_seq, 612215)

                Delay(3)

                MVLessonCheckFinish()
                TownCharacterSetEmotRepeat(TownCharacterGetByUID(student_owner_uid, student_seq), "Characters/eff_mg_dance_miss")
                MVLessonSetDance(teacher_owner_uid, teacher_seq, 612217)
                MVLessonSetDance(student_owner_uid, student_seq, 612216)

                Delay(2)
            end
        end

    elseif state == "teaching_complete" then

        -- 도로쪽이라 걸어갈 경로가 안나오니 즉시 이동시킨다.
        ScriptTownMoveToLeftDirect(character_clicked)

        RequireMVTeachingComplete(dancer_seq_clicked)

        GoTown()

    elseif state == "waiting" then

        ScriptTownMoveToLeftSide(character_clicked)

        PushPopupTownWaitingDancer(dancer_owner_uid_clicked, dancer_seq_clicked)

    end
end




