if OnMVLearningDance() then
    leason = GetPtr("lesson")
    leason_id = GetInteger("lesson_id")

    -- 배우는 춤을 같이 춤
    Character_Action_Lesson("teacher", leason)
    Character_Action_Lesson("student", leason)

    -- 춤을 추는 옆에는 음표 애니메이션이 주위에 떠다니는 휴대용 오디오
    SetAnimation("ani_audio", "UI_common/ui_music_instrument_033_2")
    Animation_SetPos("ani_audio", 0, 200)
    Character_SetAniFront("teacher", "ani_audio")
    Character_SetAniFront("student", "ani_audio")
    Animation_PlayRepeat("ani_audio")

    while 1 do
        Wait(5)
        -- 춤을 배우기 시작한지 15분 이상이 흐른 후에는 춤 틀리는 연출 등장 않음

        if CheckLessonMistake(leason_id) then

            -- 춤을 틀린 듯한 액션
            Character_Action("student", "dance_01")
            -- 땀이 흐르는 이모티콘
            Character_Emoticon("student", "Characters/Emoticon_sweat")

            Wait(1)

            -- 가르치는 문하생이 춤을 멈춤
            Character_Action("teacher", "dance_01")

            Wait(2)

            -- 배우는 춤을 같이 춤
            Character_Action_Lesson("teacher", leason)
            Character_Action_Lesson("student", leason)
        end
    end

end

if OnMVLearningMusic() then
    leason = GetPtr("lesson")
    leason_id = GetInteger("lesson_id")

    -- 나란히 앉아 좌우로 몸을 흔듦(음악을 들으며 따라 부르는 듯 한 액션)
    Character_Action("teacher", "shake_01")
    Character_Action("student", "shake_01")

    -- 음악을 듣는 옆에는 음표 애니메이션이 주위에 떠다니는 휴대용 오디오
    SetAnimation("ani_audio", "UI_common/ui_music_instrument_033_2")
    Animation_SetPos("ani_audio", 0, 200)
    Character_SetAniFront("teacher", "ani_audio")
    Character_SetAniFront("student", "ani_audio")
    Animation_PlayRepeat("ani_audio")

    -- 두 문하생의 머리 위에는 오선지&음표가 끝없이 흐르듯 지나가는 애니메이션
    SetAnimation("ani_symbol", "UI_common/ui_music_instrument_032_2")
    Animation_SetPos("ani_symbol", 0, 200)
    Character_SetAniFront("teacher", "ani_symbol")
    Character_SetAniFront("student", "ani_symbol")
    Animation_PlayRepeat("ani_symbol")

    -- 음표가 하나 날아와서 흐르고 있던 오선지&음표가 망가지는 애니메이션
    SetAnimation("ani_broken", "UI_common/ui__music_pattern_note_light_02")
    Animation_SetPos("ani_broken", 0, 200)

    while 1 do
        Wait(10)

        -- 춤을 배우기 시작한지 15분 이상이 흐른 후에는 춤 틀리는 연출 등장 않음
        if CheckLessonMistake(leason_id) then
            -- 오선지&음표가 애니메이션 제거
            Character_UnsetAni("teacher", "ani_symbol")
            Character_UnsetAni("student", "ani_symbol")
            -- 음표가 하나 날아와서 흐르고 있던 오선지&음표가 망가지는 애니메이션
            Character_UnsetAni("teacher", "ani_broken")
            Character_UnsetAni("student", "ani_broken")
            Animation_Play("ani_broken")

            Character_Action("student", "dance_01")
            -- 땀이 흐르는 이모티콘
            Character_Emoticon("student", "Characters/Emoticon_sweat")

            Wait(1)

            -- 가르치는 문하생이 춤을 멈춤
            Character_Action("teacher", "dance_01")

            Wait(2)

            -- 좌우로 몸을 흔듦
            Character_Action("teacher", "shake_01")
            Character_Action("student", "shake_01")

            -- 오선지, 음표 애니메이션
            Character_SetAniFront("teacher", "ani_symbol")
            Character_SetAniFront("student", "ani_symbol")
            Animation_PlayRepeat("ani_symbol")
        end
    end

end

if OnMVLearningInst() then
    leason = GetPtr("lesson")
    leason_id = GetInteger("lesson_id")

    -- 나란히 앉아 좌우로 몸을 흔듦(음악을 들으며 따라 부르는 듯 한 액션)
    Character_Action("teacher", "shake_01")
    Character_Action("student", "shake_01")

    -- 음악을 듣는 옆에는 음표 애니메이션이 주위에 떠다니는 휴대용 오디오
    SetAnimation("ani_audio", "UI_common/ui_music_instrument_033_2")
    Animation_SetPos("ani_audio", 0, 200)
    Character_SetAniFront("teacher", "ani_audio")
    Character_SetAniFront("student", "ani_audio")
    Animation_PlayRepeat("ani_audio")

    -- 두 문하생의 머리 위에는 오선지&음표가 끝없이 흐르듯 지나가는 애니메이션
    SetAnimation("ani_symbol", "UI_common/ui_music_instrument_032_2")
    Animation_SetPos("ani_symbol", 0, 200)
    Character_SetAniFront("teacher", "ani_symbol")
    Character_SetAniFront("student", "ani_symbol")
    Animation_PlayRepeat("ani_symbol")

    -- 음표가 하나 날아와서 흐르고 있던 오선지&음표가 망가지는 애니메이션
    SetAnimation("ani_broken", "UI_common/ui__music_pattern_note_light_02")
    Animation_SetPos("ani_broken", 0, 200)

    while 1 do
        Wait(10)

        -- 춤을 배우기 시작한지 15분 이상이 흐른 후에는 춤 틀리는 연출 등장 않음
        if CheckLessonMistake(leason_id) then
            -- 오선지&음표가 애니메이션 제거
            Character_UnsetAni("teacher", "ani_symbol")
            Character_UnsetAni("student", "ani_symbol")
            -- 음표가 하나 날아와서 흐르고 있던 오선지&음표가 망가지는 애니메이션
            Character_UnsetAni("teacher", "ani_broken")
            Character_UnsetAni("student", "ani_broken")
            Animation_Play("ani_broken")

            Character_Action("student", "dance_01")
            -- 땀이 흐르는 이모티콘
            Character_Emoticon("student", "Characters/Emoticon_sweat")

            Wait(1)

            -- 가르치는 문하생이 춤을 멈춤
            Character_Action("teacher", "dance_01")

            Wait(2)

            -- 좌우로 몸을 흔듦
            Character_Action("teacher", "shake_01")
            Character_Action("student", "shake_01")

            -- 오선지, 음표 애니메이션
            Character_SetAniFront("teacher", "ani_symbol")
            Character_SetAniFront("student", "ani_symbol")
            Animation_PlayRepeat("ani_symbol")
        end
    end

end
