arbeit_id = GetInteger("script_arbeit_id")

character_clicked = GetPtr("character_clicked")

arbeit_dancer = GetArbeitDancer(arbeit_id)

follower_npc_id = TownCharacterGetNPCID(arbeit_dancer)

-- 카페
-- 카페 주인은 카페 주방 안에 위치
-- 아르바이트를 시작하면 카페 유니폼을 착용하고 카페 안을 돌아다니며 춤을 춤
if arbeit_id == 1000001 then
    local npc_id = 154
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        if CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000001, STR_FOLLOWER_DIALOG(follower_npc_id, 710))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

-- 광장
-- 광장 관리인은 분수 옆에 위치
-- 옆에 휴대용 오디오와 움직이는 음표들 등장
if arbeit_id ==  1000002 then
    local npc_id = 156
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        if CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000002, STR_FOLLOWER_DIALOG(follower_npc_id, 720))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetArbeit(arbeit_dancer, arbeit_id);
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            if not CheckArbeitHelper(arbeit_id) then
                ScriptTownZoomInCharacterNotHideAll(character_clicked)                
                PushPopupTownArbeitHelp(arbeit_id)
                if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                    DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
                end
                if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                    DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
                end
            end
        end
    end
end

-- 레스토랑
-- 레스토랑 주인은 레스토랑 주방 혹은 계산대에 위치
-- 레스토랑 유니폼을 착용
if arbeit_id == 1000003 then
    local npc_id = 155
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        if CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000003, STR_FOLLOWER_DIALOG(follower_npc_id, 730))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end

    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

-- 클럽
-- 클럽 DJ는 클럽 DJ박스에 위치
-- 문하생을 집중적으로 비추는 조명 연출 가미
if arbeit_id == 1000004 then
    local npc_id = 148
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        if CheckArbeitRunning(arbeit_id) then
            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000004, STR_FOLLOWER_DIALOG(follower_npc_id, 740))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

-- 1000005	홍보 - 옷 가게
-- 1000006	홍보 - 미용실
-- 1000007	홍보 – 인테리어
-- 홍보 >> 이거 알바 3개로나누어도?
-- 옷 가게 / 미용실 / 인테리어 가게 중, 임의의 한 시설에 해당 시설의 담당 NPC 머리 위에 알바 가능 표시(!?)
-- 원래 옷 가게 / 미용실 / 인테리어 가게 NPC가 줌인 될 때 등장하는 기존의 버튼과 [아르바이트] 버튼이 함께 등장
-- 해당 시설의 홍보용 의상을 착용
-- 해당 시설 홍보용 입간판이 옆에 등장
if arbeit_id == 1000005 then
    local npc_id = 146
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020215)
        SceneTownHideItem(10020216)
        SceneTownHideItem(10020217)
        SceneTownHideItem(10020218)
        SceneTownHideItem(10020219)
        SceneTownHideItem(10020220)

        if CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020215)
            SceneTownShowItem(10020216)
            SceneTownShowItem(10020217)
            SceneTownShowItem(10020218)
            SceneTownShowItem(10020219)
            SceneTownShowItem(10020220)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000005, STR_FOLLOWER_DIALOG(follower_npc_id, 750))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_npc) then
            ScriptTownMoveToDress(TownCharacterGetNPCOtherTown(0, 146), TownCharacterGetUserOtherTown())
            SoundPlayWithLock(68) --=BGM=Theme_Clothshop
            PushPopupTownDress(146)
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
        elseif OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

if arbeit_id == 1000006 then
    local npc_id = 145
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020418)
        SceneTownHideItem(10020419)
        SceneTownHideItem(10020420)

        if CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020418)
            SceneTownShowItem(10020419)
            SceneTownShowItem(10020420)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000006, STR_FOLLOWER_DIALOG(follower_npc_id, 760))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

if arbeit_id == 1000007 then
    local npc_id = 144
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020312)
        SceneTownHideItem(10020313)
        SceneTownHideItem(10020314)
        SceneTownHideItem(10020315)
        SceneTownHideItem(10020316)
        SceneTownHideItem(10020317)

        if CheckArbeitRunning(arbeit_id) then
            -- 알바 전용 아이템 보이기
            SceneTownShowItem(10020312)
            SceneTownShowItem(10020313)
            SceneTownShowItem(10020314)
            SceneTownShowItem(10020315)
            SceneTownShowItem(10020316)
            SceneTownShowItem(10020317)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000007, STR_FOLLOWER_DIALOG(follower_npc_id, 770))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end

-- 야외 무대
-- 야외 무대 관리인은 무대 옆에 위치
-- 문하생을 집중적으로 비추는 조명 연출, 무대 스피커 주위에 움직이는 음표 연출 가미
-- 알바를 완료한 문하생을 터치하면 줌인, 좋아하는 표정과 몸짓(좋아요를 받았을 때와 동일)을 하고, 아래의 팝업창 등장
if arbeit_id == 1000008 then
    local npc_id = 157
    local arbeit_npc = TownCharacterGetNPCOtherTown(0, npc_id)

    if OnTownRefresh() then
        -- 알바 전용 아이템 감춤
        SceneTownHideItem(10020814)
        SceneTownHideItem(10020816)
        SceneTownHideItem(10020803)
        SceneTownHideItem(10020804)
        SceneTownHideItem(10020806)
        SceneTownHideItem(10020809)
        SceneTownHideItem(10020810)
        SceneTownHideItem(10020812)

        if CheckArbeitRunning(arbeit_id) then
            SceneTownShowItem(10020814)
            SceneTownShowItem(10020816)
            SceneTownShowItem(10020803)
            SceneTownShowItem(10020804)
            SceneTownShowItem(10020806)
            SceneTownShowItem(10020809)
            SceneTownShowItem(10020810)
            SceneTownShowItem(10020812)

            SceneTownHideItem(10020813)
            SceneTownHideItem(10020815)
            SceneTownHideItem(10020801)
            SceneTownHideItem(10020802)
            SceneTownHideItem(10020805)
            SceneTownHideItem(10020807)
            SceneTownHideItem(10020808)
            SceneTownHideItem(10020811)

            TownCharacterSetArbeit(arbeit_npc, arbeit_id)
            TownCharacterSetArbeit(arbeit_dancer, arbeit_id)
            TownCharacterSetIcon(arbeit_dancer, "") -- 아르바이트시 이외 아이콘 노출 제거
            TownCharacterDoArbeit(arbeit_id, 1000008, STR_FOLLOWER_DIALOG(follower_npc_id, 780))
            if not CheckArbeitHelper(arbeit_id) then
                TownCharacterSetIcon(arbeit_dancer, "ALBA_HELP")
            end
        end
    end

    if CheckArbeitRunning(arbeit_id) then
        if OnOtherTownCharacterClick(arbeit_dancer) then
            ScriptTownZoomInCharacterNotHideAll(character_clicked)
            PushPopupTownArbeitHelp(arbeit_id)
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 810) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 810))
            end
            if STR_FOLLOWER_DIALOG_IS_EXIST(follower_npc_id, 811) then
                DialogOpen(follower_npc_id, STR_NPC(follower_npc_id), STR_NPC_IMG(follower_npc_id, 1), STR_FOLLOWER_DIALOG(follower_npc_id, 811))
            end
        end
    end
end


