-- 카바의 초대(810002) -- 진행형 퀘스트
-- version("0.54.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()
  --TODO
    return true
end


local function textCheckQuestAppear()
	DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810002001))  -- "앞에 보이는 게 우리 집이야. 왜 그런지는 모르겠지만 다들 딱 보기만 해도 우리 집인 걸 알더군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810002002))  -- "집에 들어가려면 {highlight}{bold}시작{/bold}{/highlight} 버튼을 눌러봐."  
end

local function textCheckQuestRunning()
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_008", STR_QUEST_TEXT(810002003))  -- "너무 실망하지는 마. 내 춤 실력이 너~무 뛰어나서 그런 거니까. 호호."
end

local function textCheckQuestComplete()
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001",  STR_QUEST_TEXT(810002001))  -- "앞에 보이는 게 우리 집이야. 왜 그런지는 모르겠지만 다들 딱 보기만 해도 우리 집인 걸 알더군."
end


local function ScriptOnQuestAppear()

  -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)
    -- 카바 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    -- 퀘스트 인트로
    ScenarioIntroShow(101)

    -- 카바 등장, 걸어옴
    CharacterAdd(101, -120, -160)
    CharacterWalkTo(101, 0, -160)

    -- 이어서 유저 등장, 걸어옴
    CharacterAdd(1, -240, -160)
    CharacterWalkTo(1, -120, -160)

    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002004))  -- "어서 들어오게."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002005))  -- "하하. 우리 집의 아름다움에 눈이 휘둥그레졌구만. 당연히 그렇겠지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002006))  -- "오오! 저기 우리 사랑스러운 {highlight}{bold}카트라슈{/bold}{/highlight}가 오는군."

    -- 화면 우측에서 카트라슈 등장, 뛰어옴
    CharacterAdd(107, 1000, -160)
    CharacterRunTo(107, 120, -160)
    Wait(1)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810002007))  -- "세상에서 이렇게 예쁜 색깔과 콧수염을 가진 강아지는 이 녀석 밖에 없지!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002008))  -- "오오! 저기 우리 사랑스러운 딸도 오는군."
      -- 화면 우측 아리 등장, 뛰어옴
    CharacterAdd(102, 1000, -160)
    CharacterRunTo(102, 240, -160)
    Wait(1)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810002009))  -- "다녀오셨어요~ 아빠!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002010))  -- "우리 딸은 이렇게 인사성 좋고 착하기까지 하다네! 하하."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810002011))  -- "물론 얼굴이야 날 닮았으니 예쁜 것은 말할 것도 없고!"

  -- 유저 어이없음
    CharacterShowEmotion(1, "Characters/Emoticon_silly")
    Wait(1.5)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_003", STR_QUEST_TEXT(810002012))  -- "이 분은 누구세요?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002013))  -- "아, 인사하거라. 오늘 하늘에서 떨어진 [nickname] 님 이시다."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002014))  -- "춤에 아주 뛰어난 소질을 가지고 있지!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_003", STR_QUEST_TEXT(810002015))  -- "춤을.. 잘 추시는구나.."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810002016))  -- "그나저나 하늘에서 떨어지다니 별난 취미를 가지고 계시네요"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002017))  -- "이 아이는 내 딸 {highlight}{bold}아리{/bold}{/highlight}라고 한다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002018))  -- "음악을 워낙 좋아해 태어나서 한 번도 헤드폰을 벗어본 적이 없어."

    -- 유저 상상
    CharacterShowEmotion(1, "Characters/event_think_01")
    Wait(3)

    -- 유저 식은땀
    CharacterShowEmotion(1, "Characters/Emoticon_sweat")
    Wait(1.5)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810002019))  -- "아빠가 데려온 분이니 틀림없이 좋은 사람이겠네요."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810002020))  -- "정말 반가워요! 춤을 잘 추신다니 정말 멋져!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002021))  -- "당분간은 우리 집에서 함께 지낼 것 같으니 집 구조를 안내해 드리려무나, 나의 어여쁜 딸아."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810002022))  -- "난 가서 환영 파티에 쓸 식재료들을 좀 사오마."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810002023))  -- "예, 걱정 말고 다녀오세요."

    -- 카바 화면 좌측으로 퇴장
    CharacterWalkOut(101, -1000, -160)
    Wait(1)

    -- 카트라슈도 이어서 퇴장
    CharacterWalkOut(107, -1000, -160)
    Wait(2)

    -- 아리는 유저 옆으로 접근
    CharacterWalkTo(102, 0, -160)
    Wait(1.5)

    -- 아리 역변 배경음 재생
    SoundPlayBGM(629055) --=BGM=Character_Ari_evil

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002024))  -- "어이."

      -- 유저 물음표
    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810002025))  -- "어이, 너. 아주 볼품없어 보이는데 정말 춤을 출 줄 알아?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002026))  -- "아빠가 뭔가를 착각하신 게 분명해! 그런 걸로 우쭐하기는!"

    -- 유저 식은땀
    CharacterShowEmotion(1, "Characters/Emoticon_sweat")
    Wait(1.5)
    
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002027))  -- "한 마디도 대답이 없다니... 아주 기세가 등등하군! 내가 그 오만함을 꺾어주겠어!"

    -- 댄스 게임 화면으로 이동, stage3을 플레이
    PushSceneMiniGameDance(1200003)
    UIHide("uiScore")
    UIHide("btnBack")
    UIHide("btnLeft")
    UIHide("btnRight")

    SceneMiniGameDanceHideFollower()
    
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002028))  -- "좌우로 뻗는 나의 번개 같은 동작들을 어디 한 번 따라 해 보시지!"

    SceneMiniGameDanceAppearFollower()
    Wait(2)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810002029))  -- "내가 한 동작을 가운데에 있는 댄스 인형이 한 번 더 보여주기까지 하는데 못 하는 건 아니겠지?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002030))  -- "조작은 무대 아래에 있는 {highlight}{bold}좌, 우 버튼{/bold}{/highlight}으로!"

    -- 좌/우 버튼 등장, 안내신호
    UIShow("btnLeft")
    UIShow("btnRight")

    UISignalShow("btnLeft")
    UISignalShow("btnRight")
    Wait(2)
    UISignalHide()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810002031))  -- "설마... 좌우를 구분 못 하는 건 아닐 테고..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810002032))  -- "초점 없는 눈빛을 보니 영 이해를 못 한 것 같은데..."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002033))  -- "강자의 넓은 마음으로 시범을 한 번 보여줄 테니까 잘 보라고!"

    -- 댄스게임 1턴 자동플레이, 시범 보이기
    RequireSceneMiniGameDanceAutoPlay()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002034))  -- "잘 봤지? {highlight}{bold}좌, 우 순서{/bold}{/highlight}와 {highlight}{bold}박자{/bold}{/highlight}를 잘 기억하는 게 중요해."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810002035))  -- "뭐, 어차피 나를 따라 하긴 불가능하겠지만."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810002036))  -- "그럼, 시작해볼까?"

      -- 이후 게임에 실패하면 아리가 광장에 등장한다.
    -- 퀘스트 시작
    QuestStart()
    
    ::jmp_retry::
    RequireSceneMiniGameDanceFinish()
    Wait(2)
    if RequireCheckResult("Fail") then
        DialogOpen(102, STR_NPC(102), "Characters/npc_ari_008", STR_QUEST_TEXT(810002003))  -- "너무 실망하지는 마. 내 춤 실력이 너~무 뛰어나서 그런 거니까. 호호."

        RequireSceneMiniGameDancePopupPass()
        if RequireCheckResult("Pass") then
            QuestProgressBuy()
            SceneMiniGameDanceSuccess()
            Wait(2)
            QuestComplete()
            do return end
        end

        RequireSceneMiniGameDancePopupRetry()
        goto jmp_retry
    end

    -- 퀘스트 완료
    QuestComplete()
end


local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    PushSceneMiniGameDance(1200003)
    UIHide("uiScore")
    UIHide("btnBack")
    UIHide("btnLeft")
    UIHide("btnRight")

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810002037))  -- "춤을 좀 춘다면 댄스 게임 정도는 해 본 적 있겠지?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810002028))  -- "좌우로 뻗는 나의 번개 같은 동작들을 어디 한 번 따라 해 보시지!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810002038))  -- "뭐, 해보나 마나 불가능이겠지만."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_018", STR_QUEST_TEXT(810002036))  -- "그럼, 시작해볼까?"

    UIShow("btnLeft")
    UIShow("btnRight")

    Wait(1)

    ::jmp_retry::
    RequireSceneMiniGameDanceFinish()
    Wait(2)
    if RequireCheckResult("Fail") then
        DialogOpen(102, STR_NPC(102), "Characters/npc_ari_008", STR_QUEST_TEXT(810002003))  -- "너무 실망하지는 마. 내 춤 실력이 너~무 뛰어나서 그런 거니까. 호호."

        RequireSceneMiniGameDancePopupPass()
        if RequireCheckResult("Pass") then
            QuestProgressBuy()
            SceneMiniGameDanceSuccess()
            Wait(2)
            QuestComplete()
            do return end
        end

        RequireSceneMiniGameDancePopupRetry()
        goto jmp_retry
    end

    QuestComplete()
end


local function ScriptOnQuestComplete()
    FullLoad()
    UnlockQuestContents()

    -- 카바네 집으로
    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)
    -- 아리 역변 배경음
    SoundPlayBGM(629055) --=BGM=Character_Ari_evil

    -- 유저 등장
    CharacterAdd(1, -60, -160)
    -- 아리 등장
    CharacterAdd(102, 60, -160)

    -- 아리 화남 효과음
    SoundPlayEffect(629075) --ANGRY

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_009", STR_QUEST_TEXT(810002039))  -- "이럴 순 없어! 이번엔 그냥 운이 나빴어! 컨디션이 안 좋았다고! 흥!"
    
      -- 아리 화면 우측 달려서 퇴장
    CharacterRunOut(102, -1000, -160)
    Wait(1.5)

    -- 유저 당황
    CharacterShowEmotion(1, "Characters/Emoticon_unanser")
    Wait(1.5)

    MonologOpen(STR_QUEST_TEXT(810002040))  -- "... 나는 한 마디도 하지 않았..."
    Wait(2)
    MonologClose()

  -- 시나리오 배경음
    SoundPlay(0) --=BGM=Title_UPUP_-14Lufs

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(810002041))  -- "[nickname] 님! 안에 계십니까?"

    -- 유저 물음표
    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    -- 화면 좌측 요원 등장, 걸어옴
    CharacterAdd(110, -1000, -160)
    CharacterWalkTo(110, -180, -160)
    Wait(2)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810002042))  -- "안녕하십니까. 저는 {highlight}{bold}춤꾼협회{/bold}{/highlight}의 요원입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001",  STR_QUEST_TEXT(810002043))  -- "하늘에서 떨어진 [nickname] 님이시죠?"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810002044))  -- "잠깐 저랑 가주셔야겠습니다."

    CharacterShowEmotion(1, "Characters/Emoticon_question")
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810002045))  -- "협조해 주시는 것이 서로 편할 겁니다."

    CharacterShowEmotion(1, "Characters/Emoticon_sweat")

    -- 화면 좌측 요원 퇴장
    CharacterWalkOut(110, -1000, -160)
    Wait(1)

    -- 화면 좌측 유저 퇴장
    CharacterWalkOut(1, -1000, -160)
    Wait(1.5)

    -- 독백, 퀘스트 완료
    Wait(1)

    -- 아리 제거
    CharacterRemove(102)
    -- 요원 제거
    CharacterRemove(110)
    -- 유저 제거
    CharacterRemove(1)

    ScenarioEndingShow() -- "[카바의 초대] 스토리 완료"

    -- TownMapSetPos(TownCharacterGetNPC(0), 23, -16, 0.5)

    -- 퀘스트 보상
    QuestReward()

    --TownMapSetPos(TownCharacterGetNPC(0), -10, 53, 0.5)
    GoTown()
end


-- PRELOAD_BEGIN
-- 카바네 집 앞에 카바 서있음
if CheckQuestAppear() then
	if OnTownRefresh() then
        -- 카바 등장
        TownCharacterStandAt(TownCharacterAddNPC(101), -12*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    -- 카바를 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
		textCheckQuestAppear()
    end

    if OnClickQuestStart() then
       ScriptOnQuestAppear()
       ScriptOnQuestComplete()
    end

elseif CheckQuestRunning() then
	    -- 댄스게임 도중 실패한 단계에서는 아리가 등장
    if OnTownRefresh() then
        -- 아리 등장
        TownCharacterStandAt(TownCharacterAddNPC(102), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(102))
        TownCharacterSetQuest(TownCharacterGetNPC(102))
    end

    -- 아리를 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(102)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(102))
		textCheckQuestRunning()
        PushPopupTownNpcWithSelectBox(102)
    end

    if OnClickQuestTab(TownCharacterGetNPC(102)) then
		textCheckQuestRunning()
    end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
        ScriptOnQuestComplete()
    end

elseif CheckQuestComplete() then
	if OnTownRefresh() then
        -- 카바 등장
        TownCharacterStandAt(TownCharacterAddNPC(101), -12*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    -- 카바를 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
		textCheckQuestComplete()
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
		textCheckQuestComplete()
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end


-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
