 -- 댄스게이트(810004) -- 체험형 퀘스트
-- version("0.31.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end
  
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520017)  -- 댄스게이트 기능을 열어줌
end


local function textCheckQuestAppear()
end

local function textCheckQuestRunning()
end

local function textCheckQuestComplete()
end

local function textCheckQuestAll()
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004001))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?"
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end




local function ScriptOnQuestComplete()
    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    SceneTownSetStateEmpty()

    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004002))  -- "댄소나이트 말고 {highlight}{bold}소셜포인트{/bold}{/highlight}를 가져오셔도 선물을 드린답니다!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004003))  -- "{highlight}{bold}소셜포인트{/bold}{/highlight}는 {highlight}{bold}다른 춤꾼들과 교류{/bold}{/highlight}할 때마다 자동으로 쌓이니, 저에게 찾아오시면 확인해드려요~"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810004004))  -- "마진 하나도 안 남기고 해드리는 거니까 조금은 고맙게 생각하시길..."
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_005", STR_QUEST_TEXT(810004005))  -- "...같은 건 농담인 거 이젠 아시죠?"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004006))  -- "자주자주 뵙자구요~"

    QuestComplete()
    QuestReward()
    GoTown()
end

local function ScriptOnQuest()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlayBGM(629060) --=BGM=Character_Gadi
    ScenarioIntroShow(121)
    
 
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
  	QuestStart()

 	AddQuestSkipButton()
	  
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004007))  -- "잘 오셨어요~ {highlight}{bold}댄스게이트{/bold}{/highlight}에 대해 좀 더 알아보고 싶으신 거죠?"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004008))  -- "먼저 {highlight}{bold}댄스게이트{/bold}{/highlight}를 가까이에서 한번 보자구요~"
    
    RemoveQuestSkipButton()
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004009))  -- "우선 제 뒤에 있는 {highlight}{bold}댄스게이트{/bold}{/highlight}를 한번 보시겠어요?"
    
    PushPopupTownGadi(121)
    
    ::jmp_btnGacha::
    RequireButtonWithCCB("UI_common/ui_btn2_015_01", "btn_shop_danceskill")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004010))  -- "우선 {highlight}{bold}댄스게이트{/bold}{/highlight}를 한번 보시겠어요?"
        goto jmp_btnGacha
    end
    
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004011))  -- "이것이 {highlight}{bold}우주 통로{/bold}{/highlight}를 여닫는 {highlight}{bold}댄스게이트{/bold}{/highlight}랍니다!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810004012))  -- "어떻게 작동하는지 궁금하시죠? 보여드릴까요?"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004013))  -- "그럼 {highlight}{bold}1회 뽑기{/bold}{/highlight} 버튼을  눌러보세요~"
    
    ::jmp_btn_gacha:: -- 1회 뽑기 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_dg/ui_dg_ui_main", "btn_gacha01")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004014))  -- "{highlight}{bold}1회 뽑기{/bold}{/highlight} 버튼을  눌러보세요~"
        goto jmp_btn_gacha
    end
    
    ::jmp_btn_gacha_ok:: -- 팝업창에서 뽑기 확인 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_popup_buy_01", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004014))  -- "{highlight}{bold}1회 뽑기{/bold}{/highlight} 버튼을  눌러보세요~"
        goto jmp_btn_gacha_ok
    end    
    
    -- 이 시간동안 터치를 막음
    BeginTimeTouchLock(1.5)

    RequireSceneGachaReward()		
	
	AddQuestSkipButton()
	
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004015))  -- "쨔잔~ 우주 통로를 이용해 200만 광년 밖에 있는 비밀 창고에서 물건을 꺼내왔어요!"
	PopScene()
	
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004016))  -- "{highlight}{bold}댄스게이트{/bold}{/highlight}에 {highlight}{bold}강한 댄스파{/bold}{/highlight}를 주입하면 우주 통로를 열어줘요~"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004017))  -- "보통은 이렇게 {highlight}{bold}댄소나이트{/bold}{/highlight} 여러 개를 뭉쳐 만든 강화 댄소나이트로 댄스파를 주입한답니다!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004018))  -- "아, 그리고 방금 댄스게이트에서 나온 물건은 [유저의 닉네임] 님께 선물로 드릴게요~"
  
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_happy")
    Wait(1.5)
  
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004019))  -- "앞으로도 {highlight}{bold}댄소나이트{/bold}{/highlight}를 들고 오시면 {highlight}{bold}값진 선물{/bold}{/highlight}을 드릴 테니 애용해주시구요!"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810004020))  -- "이렇게 떡밥을 던져놔야 댄소나이트를 가져올 테니까..."

	TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_angry")
	Wait(1.5)
    
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_005", STR_QUEST_TEXT(810004021))  -- "...는 또다시 농담~ 제가 좋은 거 하나 더 알려드릴 테니까 화내지 마세요~"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", STR_QUEST_TEXT(810004002))  -- "댄소나이트 말고 {highlight}{bold}소셜포인트{/bold}{/highlight}를 가져오셔도 선물을 드린답니다!"
    DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004003))  -- "{highlight}{bold}소셜포인트{/bold}{/highlight}는 {highlight}{bold}다른 춤꾼들과 교류{/bold}{/highlight}할 때마다 자동으로 쌓이니, 저에게 찾아오시면 확인해드려요~"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_002", STR_QUEST_TEXT(810004004))  -- "마진 하나도 안 남기고 해드리는 거니까 조금은 고맙게 생각하시길..."
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_005", STR_QUEST_TEXT(810004005))  -- "...같은 건 농담인 거 이젠 아시죠?"
	DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_003", STR_QUEST_TEXT(810004006))  -- "자주자주 뵙자구요~"
	Wait(0.5)
    
	-- 독백, 퀘스트 완료
	Wait(1)
	ScenarioEndingShow()  -- "[댄스게이트] 퀘스트 완료"

    QuestComplete()
    QuestReward()
    GoTown()
end

local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    if CheckQuestProgress(10106, 1) then
        ScriptOnQuestComplete()
        return
    end

    ScriptOnQuest()
end


if CheckQuestAppear() then
	if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)  -- -1520, 1080 (댄스게이트 위치 이동하고 나면 수정 필요)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
		PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(121)
	end
    
    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
        textCheckQuestAll()
    end
        
	if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)  -- -1520, 1080 (댄스게이트 위치 이동하고 나면 수정 필요)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end
	
    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
		PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(121)
	end
    
    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
		textCheckQuestAll()
	end
       
	if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)  -- -1520, 1080 (댄스게이트 위치 이동하고 나면 수정 필요)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(121))
        TownCharacterSetQuest(TownCharacterGetNPC(121))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(121)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(121))
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
        textCheckQuestAll()
        PushPopupTownNpcWithSelectBox(121)
    end

    if OnClickQuestTab(TownCharacterGetNPC(121)) then
        --DialogOpen(121, STR_NPC(121), "Characters/npc_gardy_001", "{highlight}{bold}댄스게이트{/bold}{/highlight}를 사용해서 어떤 일을 할 수 있는지 알려드릴까요?")
        textCheckQuestAll()
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end

    -- PRELOAD_END
    
    --퀘스트 다시하기
if OnQuestReplay() then
        --TODO
end

