-- 알 수 없는 인연(810007) -- 스토리 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

local function UnlockQuestContents()
    UnlockStartQuestMode()
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007001))  -- "실력을 빨리 되찾는 게 좋을 거야."
end



local function ScriptOnQuest()
      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad()  -- 리소스 로딩
    UnlockQuestContents()  -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
	SoundPlayBGM(629059) --=BGM=Character_CwarZ
      -- 퀘스트 인트로
    ScenarioIntroShow(106)
    
	-- 대사 스킵
	AddQuestSkipButton()
	
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007002))  -- "역시. 그런 멍한 표정으로 날 볼 줄 알았지."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007003))  -- "날 기억하지 못하다니 섭섭한데? 나름 강렬한 인상을 줬다고 생각했는데 말야."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_question")
    Wait(1.5)
    
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007004))  -- "개 탈을 쓴 미치광이와의 춤 대결은 잘 봤어."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007005))  -- "몸놀림이 서서히 예전의 모습을 되찾는 것 같던데?"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007006))  -- "하지만 아직 멀었어. 그 미치광이 놈이 봐주지 않았으면 패했겠지."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007007))  -- "넌 빨리 기억을 찾을 필요가 있어. 특히나 그 미치광이가 널 본 순간부터는 더더욱."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007008))  -- "내가 도와주도록 하지. 잠들어있는 네 춤 세포 하나하나의 기억이 다 되살아나도록!"
    
    QuestStart()  --시워즈와의 춤 대결
    PushSceneMiniGameDance( 1200015)  --현존하는 최고의 난이도
    
    UIHide("uiScore")
    UIHide("btnBack")
    UIHide("btnLeft")
    UIHide("btnRight")

    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007009))  -- "덤벼라! [유저의 닉네임]!"
    UIShow("btnLeft")
    UIShow("btnRight")
    Wait(1)
	
    RequireSceneMiniGameDanceFinish()
    Wait(2)
      --아래부터는 이기든, 지든 공통으로 동일한 진행
	DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007010))  -- "이 정도의 가벼운 대결에도 꽤 힘겨워보이네. 아직도 준비가 부족한 모양이야."
	DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007011))         -- "아니면... 본래 그 정도가 한계인가?"
    PopScene()

	
    TownCharacterStandAt(TownCharacterAddNPC(101), -13*40, 29*40)  --카바가 화면 밖에서 등장
    TownCharacterRunTo(TownCharacterGetNPC(101), -5*40, 29*40)  --카바가 화면 안으로 뛰어 들어옴
    Wait(1.5)
      --카바가 합류한 상태에서 카메라 중심 재조정
	TownCameraZoomIn(TownCharacterGetNPC(101), 1.8*40, 1*40, 2)
	Wait(1.0)
	  	-- 대사 스킵
	AddQuestSkipButton()
	
	SoundPlay(9) --=BGM=Event_Quest_common
	
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810007012))  -- "오랜만에 모습을 드러냈군. {highlight}{bold}시워즈{/bold}{/highlight}."
    
    TownCharacterSetEmot(TownCharacterGetNPC(106), "Characters/Emoticon_exclamation")
    Wait(1.5)
	
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007013))  -- "......"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007014))  -- "카바. 여전히 의욕적이고 자신감이 넘치네."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007015))  -- "넌 다 안 좋은데 그런 부분이 제일 거슬린단 말이야."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007016))  -- "이번에도 쓸데없는 참견을 하러 나타나셨나?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810007017))  -- "...쓸데가 있는지 없는지는 두고보면 알겠지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810007018))  -- "난 네가 돌아오기를 기다리는 사람에게 널 데려가야할 의무가 있기도 하니까."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007013))  -- "......"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007019))  -- "못 보던 사이에 헛소리가 많이 늘었네."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007020))  -- "어디 헛소리 하는 능력만큼 춤도 늘었는지 볼까?"
    Wait(1.5)
    
   -- 시워즈와 카바가 배경음악에 맞춰 춤을 추기 시작.
      --원래 추고 있던 춤
      --유저 캐릭터는 그냥 가만히 서있는 동작(숨쉬는 듯한 동작도 제외)
      --둘의 춤이 점점 빨라져 눈으로 쫓기 함들어짐(음악도 자연스럽게 빨라짐, 최고 속도 빠르기까지 도달하는데 5초 정도의 시간)
      --최고 속도에 도달하고 1.5초 후 독백 등장

	TownCharacterSetDanceCustomBpm( TownCharacterGetUser(), 1, 120)

    Wait(1.5)
	SoundSetBpm( 160.0)
    Wait(1.5)
	SoundSetBpm( 200.0)
    Wait(2.0)
	SoundSetBpm( 240.0)
    Wait(1.5)
    
    MonologOpen(STR_QUEST_TEXT(810007021))  -- "이건 마치... 춤으로 치열한 설전을 펼치는 것 같아..."
    Wait(2)
    MonologClose()
    Wait(2)
    
      --춤 대결 중 요원, 신입요원 화면 아래서 뛰어와 등장
    TownCharacterStandAt(TownCharacterAddNPC(110), 1*40, 22*40)
	TownCharacterSetDanceCustomBpm( TownCharacterGetNPC(110), 1, 120)
    TownCharacterStandAt(TownCharacterAddNPC(133), -1*40, 22*40)
	TownCharacterSetDanceCustomBpm( TownCharacterGetNPC(133), 1, 120)
    TownCharacterRunTo(TownCharacterGetNPC(110), 1*40, 26*40)
    TownCharacterRunTo(TownCharacterGetNPC(133), -1*40, 26*40)
    Wait(1.5)
    --요원과 신입요원이 합류한 상태에서 카메라 중심 재조정
	TownCameraZoomIn( TownCharacterGetNPC(110), -3*40, 3*40, 2)
	Wait(1.0)

 	-- 대사 스킵
	AddQuestSkipButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810007022))  -- "시워즈! 겁도 없이 다시 나타났군!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(810007023))  -- "다시 나타났군!"

    --시워즈와 카바 춤 정상적인 속도로 돌아옴
	SoundSetBpm( 120.0)
	TownCharacterSetDanceCustomBpm( TownCharacterGetUser(), 0, 120)
	TownCharacterSetDanceCustomBpm( TownCharacterGetNPC(110), 0, 120)
	TownCharacterSetDanceCustomBpm( TownCharacterGetNPC(133), 0, 120)
	
    TownCharacterSetEmot(TownCharacterGetNPC(106), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007024))  -- "위대하신 루키님과 오붓하게 이야기 좀 하려했더니 가만히 두질 않네."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007025))  -- "뭐, 괜찮아. 우리의 인연은 아주 질기고 질길 테니까 말이야."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007026))  -- "다음에 만났을 때는 실력을 충분히 되찾았길 빌게."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007027))  -- "그래야 너에게 닥칠 미래를 조금이라도 감당할 수 있을 테니."

    TownCharacterSetEmot(TownCharacterGetNPC(110), "Characters/Emoticon_angry")
    
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810007028))  -- "누가 네놈에게 다음이 있을 거라고 말했지?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(810007029))  -- "누가 그랬지?"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007030))  -- "춤꾼협회 요원 나부랭이들의 허락 따위는 필요 없어. 너희는 날 못 잡거든."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007031))  -- "난 말이지... 무척이나..."
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007032))  -- "빨라."

    TownCharacterRunTo(TownCharacterGetNPC(106), 11*40, 39*40)
    Wait(1)    
    TownCharacterSetEmot(TownCharacterGetNPC(110), "Characters/Emoticon_sweat")
    Wait(1.5)

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(810007033))  -- "거, 거기섯!"

    TownCameraFree()

    TownCharacterRunTo(TownCharacterGetNPC(110), 11*40, 38*40)
    Wait(1)
    

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(810007034))  -- "거기서!"
    
    TownCharacterRunTo(TownCharacterGetNPC(133), 9*40, 39*40)
    Wait(1.5)

	--TownCameraZoomIn(TownCharacterGetNPC(101), 1.8*40, 1*40, 2)
	Wait(1.0)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810007035))  -- "흠... 한동안 조용하다 했더니... 역시 방심할 수 없는 놈이군."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810007036))  -- "많이 놀랐지? 저 녀석은 {highlight}{bold}시워즈{/bold}{/highlight}라고 한다네."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(810007037))  -- "한 때 {highlight}전설춤꾼{/highlight} 자리를 노렸지만, 현재의 {highlight}전설춤꾼{/highlight}에게 밀려서 뜻을 이루지 못하자 어딘가로 사라졌지."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810007038))  -- "그리고... 이렇게 다시 나타났군. 자네 앞에."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810007039))  -- "놈이 무슨 생각을 하고 있는지는 모르겠지만, 조심하는게 좋겠어."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810007040))  -- "한번 목표를 정하면, 무슨 수를 써서라도 해내려고 할 놈이니 말이야..."
    
    MonologOpen(STR_QUEST_TEXT(810007041))  -- "그런 자가 나를 알고 있어... 어째서...?"
    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow()  -- "[알 수 없는 인연] 스토리 완료"
      -- 퀘스트 시작/완료/보상

    QuestComplete()
    QuestReward()
    TownCameraZoomOut();
	GoTown()
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnGameAction("OnAfterSceneEntered/SceneTown") then
        TownCharacterRemoveNPC( 111) -- 인상 좋은 청년이 있으면 제거
    end

    if OnTownRefresh() then
          -- 가면 쓴 시워즈 등장
        TownCharacterStandAt(TownCharacterAddNPC(106), 0*40, 29*40)  --광장 가운데 동상 앞에 시워즈 서있음
        TownCharacterSetQuestIcon(TownCharacterGetNPC(106))
        TownCharacterSetQuest(TownCharacterGetNPC(106))
        TownCharacterRemoveNPC( 111) -- 인상 좋은 청년이 있으면 제거
    end

      -- 시워즈를 누르면
    if OnTownCharacterClick(TownCharacterGetNPC(106)) then
  	    PreLoad()
        ScriptTownMoveToRightSide(TownCharacterGetNPC(106))
        --DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007041))  -- "실력을 빨리 되찾는 게 좋을 거야."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(106)
    end

    if OnClickQuestTab(TownCharacterGetNPC(106)) then
        --DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810007041))  -- "실력을 빨리 되찾는 게 좋을 거야."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end

