-- 친절한 아리(810016) -- 체험형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016001))  -- "응? 이제 더 이상 너한테 볼일은 없..."
end



local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810016002))  -- "아카데미 레벨 [start10001]이 되면 다음 이야기를 볼 수 있다네.(수정 예정)"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810016003))  -- "다른 춤꾼들과 이야기하다 보면 경험을 쌓을 수 있을 거야.(수정 예정)"

        return false
        
    elseif not CheckHasDance() then
        DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810016004))  -- "춤 하나 정도는 만들어오는 게 어때? 그래야 말이 좀 통하지 않겠어?"
        
        return false

    elseif not CheckHasMusic() then
        DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810016005))  -- "음악 하나 정도는 만들어오는 게 어때? 그래야 말이 좀 통하지 않겠어?"

        return false
    elseif CheckGuestUser() then
        DialogOpen(102, STR_NPC(102), "Characters/npc_ari_013", STR_QUEST_TEXT(810016006))  -- "게스트 유저는 더 이상 진행할 수 없어!"

        OpenHiveLoginInduce()

        return false
    end

    return true
end



local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    if CheckQuestManagerDummy() then
        SetInteger("skip_mv_register", 1)
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    if CheckQuestProgress(10102, 1) then
        SceneTownSetStateEmpty()
        QuestComplete()
        return true
    end

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 시나리오 배경음
    SoundPlayBGM(629055) --=BGM=Character_Ari_evil

    ScenarioIntroShow(102)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016007))  -- "왜 자꾸 따라오는 거야? 귀찮게 굴지 말고..."

      -- 화면 좌측에서 카바 등장, 아리 좌측으로 걸어옴
    TownCharacterStandAt(TownCharacterAddNPC(101), -10*40, 33*40-182)
    TownCharacterWalkTo(TownCharacterGetNPC(101), -3*40, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPC(101), 3*40, 50, 2);
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016008))  -- "오오. 사이좋게 산책을 하고 있었군."

    AnimationAdd("mentality", "Characters/event_mentality_01")
    AnimationPlay("mentality")
    SoundPlayEffect(629077) --SUPRISE
    Wait(2)
    AnimationRemove("mentality")

    TownCharacterSetEmot(TownCharacterGetNPC(102), "Characters/Emoticon_exclamation")
    Wait(1.5)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016009))  -- "그, 그럼요! 사이좋게! [유저의 닉네임] 님이 바깥 바람을 쐬고 싶다고..."

    -- 유저 당황
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016010))  -- "하하. 친절한 것도 나를 쏙 빼닮았어!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810016011))  -- "아, 자네를 {highlight}{bold}춤꾼협회{/bold}{/highlight}에서도 주목하고 있다지? 정말 축하하네!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016012))  -- "역시 실력 있는 춤꾼을 알아보는 내 눈은 틀리지 않았어! 하하!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016013))  -- "댄스비전도 받았을 테니 {highlight}{bold}뮤직비디오{/bold}{/highlight}를 부지런히 찍어 올리도록 하게."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810016014))  -- "아, 아직 {highlight}{bold}뮤직비디오{/bold}{/highlight}를 제대로 만들어 본 적이 없다고?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016015))  -- "그럼 말이 나온 김에 우리 딸아이가 {highlight}{bold}뮤직비디오{/bold}{/highlight}에 대해서 가르쳐 주면 되겠군."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016016))  -- "......"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016016))  -- "......"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_010", STR_QUEST_TEXT(810016017))  -- "제가요?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016018))  -- "물론."

    -- 아리 식은땀
    TownCharacterSetEmot(TownCharacterGetNPC(102), "Characters/Emoticon_sweat")
    Wait(1.5)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016019))  -- "그렇죠! 당연한 말씀! 그렇지 않아도 갑자기 뭔가를 친절하게 가르쳐드리고 싶더라구요!"
    
      -- 유저 당황
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    -- 아리 착한 BGM
    SoundPlayBGM(629056) --=BGM=Character_Ari_kind

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016020))  -- "춤으로 다른 춤꾼들과 소통하려면 먼저 내 춤을 알려야겠죠?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016021))  -- "내 춤을 알리는 가장 효과적인 수단이 바로 {bold}{highlight}뮤직비디오{/highlight}{/bold}!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016022))  -- "[유저의 닉네임] 님의 춤과 음악으로 {bold}{highlight}멋진 영상{/highlight}{/bold}을 찍어서 사람들에게 보여주는 거에요!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016023))  -- "지금 춤과 음악도 충분히 멋지니 바로 촬영을 해볼까요?"
    
    -- 마을 UI등장
    SceneTownSetStateIdle()
    Wait(1)

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

    DialogOpenNoOffUI(102, STR_NPC(102), "Characters/npc_ari_016", STR_QUEST_TEXT(810016024))  -- "{bold}{highlight}[뮤비 촬영]{/highlight}{/bold} 버튼을 한 번 눌러보세요! 어떤 일이 일어날까요?"

    ::jmp_btnMakeMV::
    RequireButton("btn_make_mv")
    if RequireCheckResult("OutOfTouch") then
        DialogOpenNoOffUI(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016025))  -- "쑥쓰러워할 것 없어요. 자신감을 가지고 {highlight}{bold}뮤비 촬영{/bold}{/highlight} 버튼을!"
        goto jmp_btnMakeMV
    end

      -- 유저가 [뮤비 촬영] 버튼을 누르면 춤 선택 화면 등장
    Wait(0.5)
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016026))  -- "먼저 뮤직비디오에서 가장 중요한! 춤을 선택해야겠죠?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016027))  -- "춤을 하나 고르고 {highlight}{bold}춤 적용{/bold}{/highlight} 버튼을 눌러보세요."
    
      --춤은 처음부터 이미 하나가 선택되어 있는 상태이지만, 유저가 원하는 춤을 선택할 수 있게 해줌
      --춤 목록 중 하나를 선택하는 액션과 [춤 적용] 버튼을 누르는 액션 외의 조작 막음(뒤로 가기 버튼은 비활성화 상태)
      -- 유저가 [춤 적용] 버튼을 누르면 크루 선택 화면 등장
    UIDisableWithCCB("UI_common/ui_btn2_008_01", "btn_backward")
    WaitScene("SceneMVCharacter")

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016028))  -- "춤을 선택했으니, 아카데미 구성원 중 그 춤을 누가 출지 정해야 하지만!"
    
    SceneMVCharacterSelectUserDancer()
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016029))  -- "가장 실력이 뛰어난 [유저의 닉네임] 님 자동 당첨!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016030))  -- "{highlight}{bold}선택 완료{/bold}{/highlight} 버튼을 눌러서 계속 진행하자구요!"
    
    ::jmp_btn_ok::
    RequireButtonWithCCB("UI_common/ui_btn2_008_01", "btn_ok")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btn_ok
    end


    -- 유저가 [선택 완료] 버튼을 누르면 음악 선택 화면 등장
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016031))  -- "춤에 맞는 음악이 빠지면 안 되겠죠?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016032))  -- "음악을 하나 고르신 후에 {highlight}{bold}음악 적용{/bold}{/highlight} 버튼을 누르세요."

      --음악은 처음부터 이미 하나가 선택되어 있는 상태이지만, 유저가 원하는 음악을 선택할 수 있게 해줌
      --음악 목록 중 하나를 선택하는 액션과 [음악 적용] 버튼을 누르는 액션 외의 조작 막음(뒤로 가기 버튼은 비활성화 상태)
      -- 유저가 [음악 적용] 버튼을 누르면 춤 위치 지정 화면 등장
    UIDisableWithCCB("UI_common/ui_btn2_008_01", "btn_backward")
    WaitScene("SceneMVMusic")


    WaitScene("SceneMVTown")

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_015", STR_QUEST_TEXT(810016033))  -- "춤 좋고! 음악 좋고! 이제 {highlight}{bold}촬영{/bold}{/highlight}만 하면 멋진 뮤직비디오 한편이 완성되겠네요! 두근두근!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016034))  -- "아카데미에 {highlight}{bold}밝게 표시된{/bold}{/highlight} 사각형의 공간에서 춤추는 [유저의 닉네임] 님이 보이죠?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016035))  -- "그 사각형의 공간 안이 뮤직비디오가 {highlight}{bold}촬영되는 부분{/bold}{/highlight}이에요."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_001", STR_QUEST_TEXT(810016036))  -- "어디를 배경으로 촬영할지 손가락으로 공간을 옮겨 정하신 다음에, {highlight}{bold}촬영 시작{/bold}{/highlight} 버튼을 누르시면 돼요."
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016037))  -- "어떤 작품이 나올지 제가 다 설레네요!"

    -- 마을에서 촬영 범위 선택
    RequireSceneTownMakeMVOk()
    UIDisable("btnPopupCancel")
    Wait(0.5)

    -- 이름 작성 후 뮤비 등록
    RequireRegisterMV()
    SetQuestProgress_Dummy(10112, 1)

    -- 공개 안내 팝업창 등장
    ::jmp_btnPopupOk::
    RequireClick("btnPopupOk")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnPopupOk
    end

    QuestComplete()

    return true
end

local function ScriptOnQuestAppear()
-- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestStart()
    return ScriptOnQuestRunning()
end

local function ScriptOnQuestComplete()
    FullLoad()
    UnlockQuestContents()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();
    -- 시나리오 배경음
    SoundPlay(0) --=BGM=Title_UPUP_-14Lufs

    -- 유저가 팝업창을 확인한 후에 원래 카바와 아리와 유저 캐릭터가 있는 곳(광장의 분수대 위 쪽)으로 화면 이동
    TownCharacterHideAll();
    TownCharacterStandAt(TownCharacterAddNPC(102), 0, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(1), 3*40, 33*40-182)
    TownCharacterStandAt(TownCharacterAddNPC(101), -3*40, 33*40-182)
    TownCameraZoomIn(TownCharacterGetNPC(0), 0, 33*40-182+50, 2)
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016038))  -- "축하해요! 첫 뮤직비디오 촬영을 무사히 마치셨네요!"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016039))  -- "{highlight}{bold}댄스비전{/bold}{/highlight}에 {highlight}{bold}공개{/bold}{/highlight}하면 반응이 아주 뜨겁겠는데요?"
    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_007", STR_QUEST_TEXT(810016040))  -- "쑥스러워 마시고 꼭 {highlight}{bold}공개{/bold}{/highlight}해보세요! 아셨죠?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810016041))  -- "물 흐르듯 막힘없는 설명을 듣고 있자니 감동이 밀려오는구나."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810016042))  -- "역시 이 카바의 딸 답다!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810016043))  -- "자, 그럼 어두워지기 전에 집으로 갈까?"
    
      -- 카바 카바네 집으로 걸어감
    TownCharacterWalkTo(TownCharacterGetNPC(101), -12*40, 53*40)
    Wait(2)

    DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016016))  -- "......"
    Wait(1)
    -- 아리 카바네 집으로 걸어감
    TownCharacterWalkTo(TownCharacterGetNPC(102), -8*40, 53*40)
    Wait(2)

    -- 유저 캐릭터 줌인
    TownCameraZoomIn(TownCharacterGetNPC(1), 0, 50, 2);
    Wait(1)
    -- 유저 당황
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    MonologOpen(STR_QUEST_TEXT(810016044))  -- "...뭐, 어떻게든 되겠지."
    Wait(2)
    MonologClose()

    -- 유저 카바네 집으로 걸어감
    TownCharacterWalkTo(TownCharacterGetNPC(1), -8*40, 53*40)
    Wait(2)
    -- 광장 우측에 정체불명의 인물 등장
    TownCharacterStandAt(TownCharacterAddNPC(106), 240, 33*40-182)
    Wait(1)
    -- 정체불명의 인물 줌인
    TownCameraZoomIn(TownCharacterGetNPC(106), 0, 50, 2);
    Wait(1)
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810016016))  -- "......"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810016045))  -- "기억을 전혀 못 하는 건가…"
    DialogOpen(106, STR_NPC(106), "Characters/npc_shiwarz_mask_001", STR_QUEST_TEXT(810016046))  -- "그래… 그것도 괜찮겠지… 후후."

    -- 독백, 시나리오 완료
    -- MonologOpen("")
    Wait(1)
    ScenarioEndingShow() -- "[친절한 아리] 시나리오 완료"

    QuestReward()
    TownMapSetPos(TownCharacterGetNPC(0), -10, 53, 0.5)
    
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then
    -- 레벨 3 충족하면 아리가 등장, 아니면 카바가 등장
    if CheckQuestStartRequire(10001) then

        if OnTownRefresh() then
            TownCharacterStandAt(TownCharacterAddNPC(102), 0, 33*40-182)
            TownCharacterSetQuestIcon(TownCharacterGetNPC(102))
            TownCharacterSetQuest(TownCharacterGetNPC(102))
        end

        if OnTownCharacterClick(TownCharacterGetNPC(102)) then
            PreLoad()

            ScriptTownMoveToRightSide(TownCharacterGetNPC(102))
            --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
			textCheckQuestAll()
			PushPopupTownNpcWithSelectBox(102)
        end

        if OnClickQuestTab(TownCharacterGetNPC(102)) then
            --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
			textCheckQuestAll()
		end

        if OnClickQuestStart() then
            if ScriptOnQuestAppear() then
                ScriptOnQuestComplete()
            end
        end

    else

        if OnTownRefresh() then
            TownCharacterStandAt(TownCharacterAddNPC(101), 0, 33*40-182)
            TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
            TownCharacterSetQuestBlocked(TownCharacterGetNPC(101))

            -- TownCharacterSetIcon(TownCharacterGetNPC(101), "Scenario_Unavailable")
        end

        if OnTownCharacterClick(TownCharacterGetNPC(101)) then
            PreLoad()

            ScriptTownMoveToRightSide(TownCharacterGetNPC(101))
            PushPopupTownNpcWithSelectBox(101)
        end

        if OnClickQuestTab(TownCharacterGetNPC(101)) then
        end

        if OnClickQuestStart() then
            if ScriptOnQuestAppear() then
                ScriptOnQuestComplete()
            end
        end

    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(102), 0, 33*40-182)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(102))
        TownCharacterSetQuest(TownCharacterGetNPC(102))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(102)) then
        PreLoad()

        ScriptTownMoveToRightSide(TownCharacterGetNPC(102))
        --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(102)
    end

    if OnClickQuestTab(TownCharacterGetNPC(102)) then
        --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end
    
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(102), 0, 33*40-182)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(102))
        TownCharacterSetQuest(TownCharacterGetNPC(102))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(102)) then
        PreLoad()

        ScriptTownMoveToRightSide(TownCharacterGetNPC(102))
        --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(102)
    end

    if OnClickQuestTab(TownCharacterGetNPC(102)) then
        --DialogOpen(102, STR_NPC(102), "Characters/npc_ari_014", STR_QUEST_TEXT(810016050))  -- "응? 이제 더 이상 너한테 볼일은 없..."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
