-- 쇼핑의 자격(810019) -- 스토리 퀘스트
-- version("0.53.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019001))  -- "아카데미 {highlight}{bold}레벨 [start10001]{/bold}{/highlight}가 돼야 다음 이야기를 볼 수 있다구!(수정 예정)"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019002))  -- "수강생이나 다른 춤꾼들에게 춤, 음악을 가르쳐주면 경험치를 얻을 수 있다는데 참고하든지, 흥. (수정 예정)"

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019003))  -- "외모를 가꾸는 것도 춤꾼의 덕목 중 하나라네."
end


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    if CheckQuestProgress(10104, 1) then
        SceneTownSetStateEmpty() 
        QuestComplete()
        return true
    end

    QuestStart()
    
    -- 카바네 집으로
    PushSceneScript()
    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)
    -- 시나리오 배경음
    SoundPlayBGM(629057) --=BGM=Character_Shaba

    ScenarioIntroShow(103)

    -- 탁자 위 카트라슈 등장
    CharacterAdd(107, 0, 20)
    -- 샤바 우측에 등장
    CharacterAdd(103, 240, -160)
    -- 카바 화면 좌측에서 걸어들어옴
    CharacterAdd(101, -1000, -160)
    CharacterWalkTo(101, -240, -160)
    Wait(1.5)


    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810019004))  -- "어머! 여보, 오셨어요? 얼마나 기다렸다구요."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810019005))  -- "오오! 샤바!"
    Wait(0.5)

    -- 카바 샤바 옆으로 달려감
    CharacterRunTo(101, 120, -160)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(810019006))  -- "나도 얼마나 보고싶었는지 모르오!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(810019007))  -- "좀 전에는 보이지 않던데 어딜 다녀온 게요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019008))  -- "당연히 쇼핑 다녀왔죠."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019009))  -- "양손 가득 쇼핑백을 들었을 때의 기분이란!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019010))  -- "하하. 춤의 매력을 제대로 살리려면 다채로운 의상은 필수지!"

    -- 유저 화면 좌측에서 걸어들어옴
    CharacterAdd(1, -1000, -160)
    CharacterWalkTo(1, -240, -160)
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019011))  -- "당신한테는 처음으로 소개하는군. 맨몸으로 하늘에서 떨어진 [유저의 닉네임] 님이오."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019012))  -- "당분간 우리집에서 함께 지내기로 했소."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(810019013))  -- "어머, 그러고도 용케 살아 계시네요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019014))  -- "아무튼 정말 반가워요, [유저의 닉네임] 님!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810019015))  -- "그런데 여보… 오늘이 무슨 날인지 잊은 건 아니죠?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810019016))  -- "오늘? 음... 어디 보자... 글쎄 잘..."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810019017))  -- "설마... 모르는 건가요?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019018))  -- "하하, 아니, 그게 저..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810019019))  -- "당신이 옆집 여자와 춤 대결을 펼쳐서 사투 끝에 승리를 거둔 날?"

    -- 유저 상상
    CharacterShowEmotion(101, "Characters/event_memory_01")
    Wait(2)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_007", STR_QUEST_TEXT(810019020))  -- "아니에요."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(810019021))  -- "그렇다면..."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810019022))  -- "당신과 내가 [쇼, 춤추는 TV]에 나가서 맹활약 한 날?"

    -- 유저 상상
    CharacterShowEmotion(101, "Characters/event_memory_03")
    Wait(2)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_007", STR_QUEST_TEXT(810019023))  -- "아니라구요!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007", STR_QUEST_TEXT(810019024))  -- "미안하오. 도저히 기억이 나지 않는구려."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(810019025))  -- "어떻게 오늘처럼 중요한 날을 잊을 수가 있죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_007", STR_QUEST_TEXT(810019026))  -- "올해 당신이 내게 사랑한다는 말을 777번 한 걸 기념해서 밤샘 쇼핑 가기로 한 날이잖아요!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009", STR_QUEST_TEXT(810019027))  -- "아, 그랬군! 그랬어!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009", STR_QUEST_TEXT(810019028))  -- "음... 이를 어쩌나. 난 급한 뮤직비디오 촬영이 있어서 가봐야 하는데..."

    -- 카바 아이디어
    CharacterShowEmotion(101, "Characters/Emoticon_goodidea")
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019029))  -- "[유저의 닉네임] 님이 이곳에서 적응하는 것도 도울 겸, 함께 다녀오는 것이 어떻소?"

    -- 유저 물음표
    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019030))  -- "그것도 재미있겠네요! [유저의 닉네임] 님의 패션 센스도 구경할 수 있고!"

    -- 유저 경악
    CharacterShowEmotion(1, "Characters/Emoticon_exclamation")
    Wait(3)

    -- 샤바 유저 우측으로 접근함
    CharacterWalkTo(103, -120, -160)
    Wait(1.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019031))  -- "[유저의 닉네임] 님도 좋으시죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810019032))  -- "음... 그런데 아직 쇼핑을 할 준비가 되지 않으셨네요."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810019033))  -- "외모를 최선을 다해 꾸민 후에야 쇼핑 할 자격이 생기는 거에요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(810019034))  -- "그래야 비로소 옷을 입었을 때 그 옷의 진정한 가치를 알 수 있다구요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810019035))  -- "아무래도 쇼핑을 하기 전에 {highlight}{bold}미용실{/bold}{/highlight}부터 가야겠네요."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019036))  -- "오오! 그거 흥미롭군. 춤꾼에게는 외모를 가꾸는 것도 중요하지!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810019037))  -- "뮤직비디오 촬영 전까지는 아직 시간이 있으니 함께 {highlight}{bold}미용실{/bold}{/highlight}에 가볼까?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810019038))  -- "자, 그럼 말이 나온 김에 바로 출발할까요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002",STR_QUEST_TEXT(810019039))  -- "먼저 {highlight}{bold}미용실{/bold}{/highlight}에 가있을 테니, [유저의 닉네임] 님도 얼른 따라오세요!"

    -- 샤바 화면 좌측으로 퇴장
    CharacterWalkOut(103, -1000, -160)
    Wait(1)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810019040))  -- "같이 가오, 샤바."

    -- 카바 화면 좌측으로 퇴장
    CharacterRunOut(101, -1000, -160)
    Wait(1.5)

    -- 유저 어이없음
    CharacterShowEmotion(1, "Characters/Emoticon_silly")
    Wait(1.5)

    -- 독백, 시나리오 완료
    MonologOpen(STR_QUEST_TEXT(810019041))  -- "...일단 미용실로 가볼까..."
    Wait(2)
    MonologClose()
    Wait(1)

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()
    -- 카트라슈 제거
    CharacterRemove(107)
    -- 유저 제거
    CharacterRemove(1)
    -- 샤바 제거
    CharacterRemove(103)
    -- 카바 제거
    CharacterRemove(101)

    ScenarioEndingShow() -- "[쇼핑의 자격] 스토리 완료"

    -- 퀘스트 시작/완료/보상
    QuestComplete()
    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN

-- 카바네 집 앞에 아리 서있음
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(101), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        --DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810033086))  -- "외모를 가꾸는 것도 춤꾼의 덕목 중 하나라네."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        --DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(810033086))  -- "외모를 가꾸는 것도 춤꾼의 덕목 중 하나라네."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
