-- 쇼핑의 고수(810038) -- 체험형 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520032)  -- 옷가게 메뉴 열어줌
end

local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810038001))  -- "아카데미 {highlight}{bold}레벨 [start10001]{/bold}{/highlight}이 되면 다음 이야기를 볼 수 있다네. (수정 예정)"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(810038002))  -- "{highlight}{bold}아르바이트{/bold}{/highlight}는 경험치와 재화를 얻을 수 있는 좋은 수단이지. (수정 예정)"

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038003))  -- "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요."
end


local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    if CheckQuestManagerDummy() then
        SetInteger("skip_buy_clothes", 1)
    else
        -- 의상 구매까지 완료 한 경우, 의상 구매 요청 프로토콜 스킵
        if CheckQuestProgress(10105, 1) then
            SceneTownSetStateEmpty()
            SetInteger("skip_buy_clothes", 1)
            return true
        end
    
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
--[[
    if CheckQuestProgress(10105, 1) then
        SceneTownSetStateEmpty() 
        QuestComplete()
        return true
    end
]]

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(103)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038004))  -- "어서 오세요. 샤바 씨 일행이시죠?"
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038005))  -- "샤바 씨는 늘 그렇듯 우리 가게의 옷을 다 쓸어 담는 중이에요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038006))  -- "덕분에 제가 먹고 산다니까요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038007))  -- "물건이 몇 개 안 남았지만 구경이라도...?"

    PushPopupTownDress(146)

    ::jmp_btn_shop_dress::
    RequireButtonWithCCB("UI_common/ui_btn2_012_02", "btn_shop_dress")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038007))  -- "물건이 몇 개 안 남았지만 구경이라도...?"
        goto jmp_btn_shop_dress
    end

    -- 옷가게
    SoundPlayBGM(629057) --=BGM=Character_Shaba

    -- 아이템을 정리, 202005 한개만 보이게 한다.
    SceneShopClothesClearItems()
    SceneShopClothesAddItem(202005)

    -- 샤바 마구 돌아다님
    CharacterAdd(103, -1000, -320)
    CharacterScale(103, 1.15)
    AnimationAdd("shoppingcart", "BG/BG_cabahome_item_cart")
    AnimationSetPosWithCharacter("shoppingcart", 103, -120, 0)
    CharacterRunTo(103, 1000, -320)
    Wait(3)
    CharacterRunTo(103, -240, -320)
    Wait(2)
    AnimationPlay("shoppingcart")
    CharacterShowEmotion(103, "Characters/Emoticon_exclamation")
    Wait(1)
    CharacterRunTo(103, -120, -300)
    Wait(1)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810038008))  -- "아, 오셨네요. 새 춤에 어울리는 옷을 찾는데 정신이 팔려서 그만...."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038009))  -- "쇼핑 하는 법은 아주 간단해요."

    -- 하단 탭 안내
    UISignalShow("uiBottomTab")
    Wait(2)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038010))  -- "위에서 {highlight}{bold}어떤 종류{/bold}{/highlight}의 물건을 살 것인지 정한 다음에,"
    UISignalHide()

    -- 아이템 안내
    UISignalShow("btnItem202005")
    Wait(2)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038011))  -- "위에 나온 물건들 중 마음에 드는 것을 {highlight}{bold}골라 입어보고{/bold}{/highlight},"
    UISignalHide()
    
    -- 구매 버튼 안내
    UISignalShowWithCCB("UI_common/ui_btn2_009_02", "btn_buy")
    Wait(2)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038012))  -- "이거다 싶을 때 {highlight}{bold}구입{/bold}{/highlight} 버튼을 누르면 끝!"
    UISignalHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038013))  -- "간단하죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810038014))  -- "그럼 본격적인 심야 할인 시간이 되기 전에 몸을 좀 풀어볼까요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038015))  -- "쇼핑의 하이라이트는 역시 구매할 때의 그 손맛! 한번 느껴보셔야죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(810038016))  -- "제가 물건을 싹 쓸어버려서 하나 밖에 남지 않았다는 아주 사소한 문제가 있기는 하지만.."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810038017))  -- "마지막 물건을 구입할 때의 그 특유한 짜릿함을 느껴보는 것도 필요하답니다! 호호!"

    -- 유저 헛웃음
    CharacterShowEmotion(1, "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038018))  -- "옷값은 제가 대신 내드릴 테니 부담 없이 구입해보세요~"

    -- 미리 정해진 튜토리얼용 의상 아이템에 유도 신호.
    ::jmp_btnItem202005::
    RequireButton("btnItem202005")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038019))  -- "저기에 마지막 남은 멋드러진 옷이 있죠?"
        goto jmp_btnItem202005
    end

    -- [구입] 버튼에 유도 신호
    -- 구입 이외 다른 동작 불가
    ::jmp_btnBuy::
    RequireButtonWithCCB("UI_common/ui_btn2_009_02", "btn_buy")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038020))  -- "{highlight}{bold}구입{/bold}{/highlight} 버튼을 누르려니 막 설레고 가슴이 떨리고 그렇죠?"
        goto jmp_btnBuy
    end

    ::jmp_buy::
    RequireSceneShopBuy()
    if RequireCheckResult("OutOfTouch") then
        goto jmp_buy
    end
    SetQuestProgress_Dummy(10105, 1)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810038021))  -- "어머나! 옷을 바꿔입으니 다른 사람 같아요! 이렇게 또 쇼핑의 보람을 느끼네요!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038022))  -- "고를 수 있는 옷들이 더 많으면 더 큰 보람을 느낄 수 있을 텐데 상당히 아쉬우시겠어요."

    CharacterAdd(146, 1000, -320)  --옷가게 주인이 화면 오른쪽 바깥에서 등장
    CharacterScale(146, 1.15)
    CharacterWalkTo(146, 120, -300)  --옷가게 주인이 유저 캐릭터 옆으로 걸어서 이동
    Wait(4)

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038023))  -- "아쉬워하실 것 없어요. 새 물건을 들여와서 {highlight}{bold}판매 의상 목록을 교체{/bold}{/highlight}하면 되니까."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038024))  -- "다만 약간의 {highlight}{bold}배송료{/bold}{/highlight}가 필요할 뿐."
    
    UISignalShowWithCCB("UI_common/ui_btn2_009_02", "btn_change")  --목록 리프레쉬 버튼에 빨간 박스 깜빡임

    Wait(2)
    UISignalHide()

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038025))  -- "이 버튼을 누르면 바로 {highlight}{bold}새 물건{/bold}{/highlight}이 들어와요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038026))  -- "{highlight}{bold}일정 기간{/bold}{/highlight}에 {highlight}{bold}한 번{/bold}{/highlight}의 배송료는 저희가 부담해서 {highlight}{bold}무료{/bold}{/highlight}로 가능하지만..."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038027))  -- "그 기간 안에 새 물건을 더 자주 보시고 싶으시면 배송료를 부담해주셔야 해요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038028))  -- "요즘 장사가 시원찮아서 가게 사정이 좋지 않거든요."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038029))  -- "옷들이 제 미모에 가려 초라해보인다나..."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(810038030))  -- "매력적인 외모를 가진 게 먹고 살기에 좋기만 한 건 아니네요."
    
    CharacterShowEmotion(103, "Characters/Emoticon_sweat")
    CharacterShowEmotion(1, "Characters/Emoticon_sweat")
    Wait(2)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(810038031))  -- "이... 이만 나갈까요...?"

    Wait(0.5)

    QuestComplete()
    return true
end

local function ScriptOnQuestAppear()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestStart()
    return ScriptOnQuestRunning()
end

local function ScriptOnQuestComplete()

    FullLoad()
    UnlockQuestContents()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll();
    -- 시나리오 배경음
    SoundPlay(0) --=BGM=Title_UPUP_-14Lufs

    -- 옷가게 앞에 집합!
    TownCharacterStandAt(TownCharacterAddNPC(1), -12*40, 7*40)
    TownCharacterStandAt(TownCharacterAddNPC(103), -15*40, 7*40)
    TownCameraSetPos(TownCharacterGetNPC(1), -60, 50, 2)
    Wait(0.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(810038032))  -- "구입을 누르는 손 끝의 느낌이 짜릿하죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038033))  -- "하지만 오늘은 이 정도로 마무리 하자구요."
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(810038034))  -- "자제력이야 말로 바람직한 쇼퍼의 핵심 자질이니까요. 잊지 마세요."
    
      -- 유저 짜증남
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_irritation")
    Wait(2)

    MonologOpen(STR_QUEST_TEXT(810038035))   -- "...훌륭한 자질이다......"
    Wait(2)
    MonologClose()
    ScenarioEndingShow() -- "[쇼핑의 고수] 스토리 완료"

    Wait(2)
    -- 퀘스트 시작/완료/보상
    QuestComplete()
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

-- 카바네 집 앞에 카바 서있음
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(146), -15*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(146))
        --DialogOpen(145, STR_NPC(146), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        --DialogOpen(145, STR_NPC(146), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestAppear() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(146), -15*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(146))
        --DialogOpen(145, STR_NPC(146), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        --DialogOpen(145, STR_NPC(146), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuestRunning() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(146), -15*40, 15*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(146))
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        --DialogOpen(145, STR_NPC(145), "Characters/npc_shop_fashion_001", "샤바 씨가 가게의 모든 의상을 쓸어 담고 있어요.")
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
