  -- 승부의 달인(810048)
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

local function CheckQuestStartReq()
    if not CheckQuestStartRequire(10001) then
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810048001))  -- "아카데미 레벨 15가 되면 다음 이야기를 볼 수 있지."
        DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_001", STR_QUEST_TEXT(810048002))  -- "뮤비를 페이스북, 유튜브, 트위터에 자랑하면 경험치와 소셜포인트를 꽤 주던데?"

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
    DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048003))  -- "어째 하늘이 심상찮은데?"
end




local function ScriptOnQuestAppear()

    if not CheckQuestStartReq() then
        return
    end

    FullLoad()
    UnlockQuestContents()

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()
    -- 시나리오 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    -- 광장 시점
    TownCameraSetPos(TownCharacterGetNPC(0), -3, 33*40-182, 1)

    ScenarioIntroShow(141)

    -- 3명 추락 애니메이션 재생
    AnimationAdd("opening2_1", "Opening/Event_falling02_01")
    AnimationSetFullScreen("opening2_1")
    Wait(0.5)
    AnimationPlay("opening2_1")
    Wait(0.45)
    SoundPlayEffect(629072) --FALL_SEQUENCE_HEAD
    Wait(2.6)
    AnimationRemove("opening2_1")

    AnimationAdd("opening2_2", "Opening/Event_falling02_02")
    AnimationSetPos("opening2_2", 80, 100)
    Wait(0.5)

    AnimationPlay("opening2_2")
    Wait(0.1)
    SoundPlayEffect(629073) --FALL_SEQUENCE_TAIL

    Wait(0.5)
    -- 추락하는 3인 케릭터 생성
    AnimationAdd("avatar_dummy", "Opening/Event_falling02_dummy")
    AnimationDisable( "avatar_dummy")

    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(142), AnimationGetSpriteProperty( "avatar_dummy", "dummy1"), 40, 33*40-82)
    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(141), AnimationGetSpriteProperty( "avatar_dummy", "dummy2"), 40, 33*40-82)
    TownCharacterAddNPCApplyNodeDynamicProperty( TownCharacterAddNPC(143), AnimationGetSpriteProperty( "avatar_dummy", "dummy3"), 40, 33*40-82)

    TownCharacterActionByID(TownCharacterGetNPC(142), 612875)
    TownCharacterActionByID(TownCharacterGetNPC(141), 612873)
    TownCharacterActionByID(TownCharacterGetNPC(143), 612874)

    Wait(5.0)

    TownCharacterActionByID(TownCharacterGetNPC(142), 611142)
    TownCharacterActionByID(TownCharacterGetNPC(141), 611141)
    TownCharacterActionByID(TownCharacterGetNPC(143), 611143)

    MonologOpen(STR_QUEST_TEXT(810048004))  -- "며칠 후..."
    Wait(2)
    PushSceneScript()
    MonologClose()



    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(142))
    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(141))
    TownCharacterNPCRestoreNodeDynamicPropertyColor( TownCharacterGetNPC(143))


    AnimationAdd("livingroom", "BG/BG_cabahome_livingroom")
    AnimationSetFullScreen("livingroom")
    AnimationAdd("table", "BG/BG_cabahome_item_table")
    AnimationSetPos("table", 0, -15)

    CharacterAdd(101, -1000, -160)
    CharacterRunTo(101, 0, -160)
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810048005))  -- "[nickname]!"

    CharacterAdd(1, 1000, -160)
    CharacterWalkTo(1, 120, -160)
    Wait(1.5)

    CharacterShowEmotion(1, "Characters/Emoticon_question")
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810048006))  -- "지금 밖이 아주 난리일세!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810048007))  -- "{highlight}{bold}하늘에서 떨어졌다고{/bold}{/highlight} 주장하는 3인방이 자네를 찾고 있어! 혹시 아는 사람들인가?"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(810048008))  -- "일단 밖으로 나와보게."

    CharacterRunOut(101, -1000, -160)
    Wait(1.5)

    MonologOpen(STR_QUEST_TEXT(810048009))  -- "하늘에서 떨어졌다고...? 나처럼?"
    Wait(2)
    MonologOpen(STR_QUEST_TEXT(810048010))  -- "혹시... 전에 신입요원이 이야기했던 그 세 명...?"
    Wait(2)
    MonologClose()

    CharacterRunOut(1, -1000, -160)
    Wait(1.5)

    GoSceneTown()

    SceneTownSetStateEmpty()
    TownCharacterHideAll()

    SoundPlayBGM(629058) --=BGM=Character_Akoo

    -- 막내
    TownCharacterStandAt(TownCharacterGetNPC(143), -240, 33*40-182)
    -- 외삼촌
    TownCharacterStandAt(TownCharacterGetNPC(142), -120, 33*40-182)
    -- 아쿠
    TownCharacterStandAt(TownCharacterGetNPC(141), 0, 33*40-182)
    -- 카바
    TownCharacterStandAt(TownCharacterAddNPC(101), 120, 33*40-182)
    -- 유저
    TownCharacterStandAt(TownCharacterAddNPC(1), 240, 33*40-182)
    TownCameraSetPos(TownCharacterGetNPC(141), 0, 50, 1.5)
    TownCameraZoomIn(TownCharacterGetNPC(141), 0, 50, 1.5)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048011))  -- "네가 [nickname]이냐쿠?"
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_001", STR_QUEST_TEXT(810048012))  -- "생김새는 맞는 것 같아, {highlight}{bold}아쿠{/bold}{/highlight} 오빠!"
    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_001", STR_QUEST_TEXT(810048013))  -- "그렇다면 실망인데~ 전혀 샤방하지 않아~"
    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_001", STR_QUEST_TEXT(810048014))  -- "특히 옆에 저 보라색 남자의 콧수염은 내 샤방한 수염과 비교해서 너무 초라하네~"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810048015))  -- "뭣이?!?! 수염계의 르네상스라 불리는 내 수염을! ...보는 눈이 아주 형편 없구만."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810048016))  -- "...자네들은 누군가?"
    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_002", STR_QUEST_TEXT(810048017))  -- "{highlight}{bold}아쿠{/bold}{/highlight}야, 샤방한 우리가 누구냐고 묻는데~?"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_003", STR_QUEST_TEXT(810048018))  -- "우리로 말할 것 같으면! 삶이 곧 미니 게임 그 자체! 미니 게임의 절대 고수! {highlight}{bold}액션퍼즐패밀리{/bold}{/highlight}!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048019))  -- "...중에 {highlight}{bold}아쿠{/bold}{/highlight}, {highlight}{bold}외삼촌{/bold}{/highlight}, {highlight}{bold}막내{/bold}{/highlight}이다쿠."
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048020))  -- "내 말투가 왜 이런지, {highlight}{bold}외삼촌{/bold}{/highlight}과 {highlight}{bold}막내{/bold}{/highlight}는 이름이 따로 없는지는 묻지 마라쿠. {highlight}{bold}액션퍼즐패밀리{/bold}{/highlight} 원작이 그러니까."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_001", STR_QUEST_TEXT(810048021))  -- "우리처럼 샤방하게 하늘에서 떨어졌다지~?"
    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_001", STR_QUEST_TEXT(810048022))  -- "아쿠를 모르는 걸 보니 우리와는 다른 세계에서 왔거나~ {highlight}{bold}액션퍼즐패밀리{/bold}{/highlight}를 해보지 않은 트렌드에 뒤떨어진 자이거나 둘 중 하나겠군."
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_005", STR_QUEST_TEXT(810048023))  -- "맞아! 우리 아쿠 오빠는 진짜 유명해! 승부에서 누구한테도 져본 적이 없다구!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_003", STR_QUEST_TEXT(810048024))  -- "춤을 아주 잘 춘다고 들었다쿠. 내 승부욕을 마구 자극한다쿠!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_005", STR_QUEST_TEXT(810048025))  -- "나와 승부를 내보자쿠! 종목은... 공평하게 내가 정하겠다쿠!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_002", STR_QUEST_TEXT(810048026))  -- "내가 지금 추는 춤을 똑같이 따라 만들기로 하자쿠! 과연 나의 고품격 몸짓을 똑같이 만들 수 있을까쿠?"

    RequireSceneDanceFollowMotionOnly(612071, 0)
    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")
    UIHideWithCCB("UI_dance/ui_dance_01", "btn_backward")
    DescriptionBarShow(STR_QUEST_TEXT(810048027))  -- "아쿠의 춤을 따라해주세요"
    RequireDanceFollow()
    Wait(0.5)

    GoSceneTown()

    SceneTownSetStateEmpty()
    TownCharacterHideAll()

    SoundPlayBGM(629058) --=BGM=Character_Akoo

    QuestStart()

    -- 막내
    TownCharacterStandAt(TownCharacterAddNPC(143), -240, 33*40-182)
    -- 외삼촌
    TownCharacterStandAt(TownCharacterAddNPC(142), -120, 33*40-182)
    -- 아쿠
    TownCharacterStandAt(TownCharacterAddNPC(141), 0, 33*40-182)
    -- 카바
    TownCharacterStandAt(TownCharacterAddNPC(101), 120, 33*40-182)
    -- 유저
    TownCharacterStandAt(TownCharacterAddNPC(1), 240, 33*40-182)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")     -- "copy"  "따라하기"
    TownCameraSetPos(TownCharacterGetNPC(141), 0, 50, 1.5)
    TownCameraZoomIn(TownCharacterGetNPC(141), 0, 50, 1.5)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_004", STR_QUEST_TEXT(810048028))  -- "이... 이 춤을 따라하다니... 쿠..."
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_004", STR_QUEST_TEXT(810048029))  -- "아쿠 오빠가 승부에서 진 거야?"
    DialogOpen(142, STR_NPC(142), "Characters/npc_aku_uncle_003", STR_QUEST_TEXT(810048030))  -- "[nickname]... 춤 실력 하나는 샤방 그 자체네~"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(810048031))  -- "이계의 못생긴 침입자라고는 하지만 상당한 실력자였는데... 잘 해주었네! 역시 자네의 재능은 감탄이 절로 나오는군."
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_006", STR_QUEST_TEXT(810048032))  -- "누가 못생긴 침입자냐쿠!!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_004", STR_QUEST_TEXT(810048033))  -- "쿠우... 언젠가는 첫 패배가 올 줄 알고 있었지만 그게 오늘일 줄은 몰랐다쿠..."
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048034))  -- "하지만 나와 호적을 이루는 상대를 만나다니 가슴이 뛴다쿠."
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048035))  -- "[nickname]! 네 실력을 인정한다쿠!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048036))  -- "비록 최고의 자리에 오래 있다 보니 다소 안일해져 오늘은 패배했지만!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048037))  -- "이제 뼈를 깎는 노력으로 다음 번에는 반드시 승리하고 말 거다쿠!"
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_002", STR_QUEST_TEXT(810048038))  -- "어쩌면 이게 우리 {highlight}{bold}하늘에서 떨어진 자{/bold}{/highlight}들의 숙명일지도... 후훗."
    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_002", STR_QUEST_TEXT(810048039))  -- "그럼 다음에 다시 만날 때까지 최고의 자리를 만끽하라쿠! 아주 잠깐이겠지만. 하하!"
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_005", STR_QUEST_TEXT(810048040))  -- "그래! 아주 잠깐일 거야!"

    TownCharacterWalkTo(TownCharacterGetNPC(143), -600, 33*40-182)
    TownCharacterWalkTo(TownCharacterGetNPC(142), -600, 33*40-182)
    TownCharacterWalkTo(TownCharacterGetNPC(141), -600, 33*40-182)
    Wait(2)

    TownCameraZoomIn(TownCharacterGetNPC(1), -40, 50, 2)
    Wait(1)
    TownCharacterHide(TownCharacterGetNPC(143))
    TownCharacterHide(TownCharacterGetNPC(142))
    TownCharacterHide(TownCharacterGetNPC(141))

    TownCharacterSetEmot(TownCharacterGetNPC(101), "Characters/Emoticon_unanser")
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(810048041))  -- "저 얘긴 또 온다는 건가... 이상한 자들이군. 집으로 들어 가세나."

    MonologOpen(STR_QUEST_TEXT(810048042))  -- "하늘에서 떨어진 자들에게 어떤 비밀이..."
    Wait(2)
    MonologOpen(STR_QUEST_TEXT(810048004))  -- "며칠 후..."
    Wait(4)
    MonologClose()

    GoSceneTown()

    SceneTownSetStateEmpty()
    TownCharacterHideAll()

    -- 막내
    TownCharacterStandAt(TownCharacterAddNPC(143), -240, 33*40-182)
    -- 외삼촌
    TownCharacterStandAt(TownCharacterAddNPC(142), -120, 33*40-182)
    -- 아쿠
    TownCharacterStandAt(TownCharacterAddNPC(141), 0, 33*40-182)
    -- 쥬오
    TownCharacterStandAt(TownCharacterAddNPC(160), 120, 33*40-182)
    TownCameraSetPos(TownCharacterGetNPC(141), 0, 50, 1.5)
    TownCameraZoomIn(TownCharacterGetNPC(141), 0, 50, 1.5)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048043))  -- "네가 이 일대의 개들을 춤으로 평정했다고 들었다쿠!"
    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810048044))  -- " ......"
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_006", STR_QUEST_TEXT(810048045))  -- "내 5년 인생에 저렇게 잘 생긴 개는 처음이야... 나... 사랑에 빠진 건가..."

    Wait(2)

    ScenarioEndingShow() -- "[승부의 달인] 스토리 완료"

    QuestComplete()
    QuestReward()
    GoTown()    
end

local function ScriptOnQuestComplete()

    SoundPlayBGM(629058) --=BGM=Character_Akoo

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()

    -- 막내
    TownCharacterStandAt(TownCharacterAddNPC(143), -240, 33*40-182)
    -- 외삼촌
    TownCharacterStandAt(TownCharacterAddNPC(142), -120, 33*40-182)
    -- 아쿠
    TownCharacterStandAt(TownCharacterAddNPC(141), 0, 33*40-182)
    -- 쥬오
    TownCharacterStandAt(TownCharacterAddNPC(160), 120, 33*40-182)
    TownCameraSetPos(TownCharacterGetNPC(141), 0, 50, 1.5)
    TownCameraZoomIn(TownCharacterGetNPC(141), 0, 50, 1.5)
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(141, STR_NPC(141), "Characters/npc_aku_aku_001", STR_QUEST_TEXT(810048043))  -- "네가 이 일대의 개들을 춤으로 평정했다고 들었다쿠!"
    DialogOpen(160, STR_NPC(108), "Characters/npc_juo_mask_001", STR_QUEST_TEXT(810048044))  -- " ......"
    DialogOpen(143, STR_NPC(143), "Characters/npc_aku_sister_006", STR_QUEST_TEXT(810048045))  -- "내 5년 인생에 저렇게 잘 생긴 개는 처음이야... 나... 사랑에 빠진 건가..."

    Wait(2)

    ScenarioEndingShow() -- "[승부의 달인] 스토리 완료"

    QuestComplete()
    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

-- 카바네 집 앞에 카트라슈 서있음
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(107), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(107)
    end

    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(107), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(107)
    end

    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(107), -8*40, 53*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(107))
        TownCharacterSetQuest(TownCharacterGetNPC(107))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(107)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(107))
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(107)
    end

    if OnClickQuestTab(TownCharacterGetNPC(107)) then
        --DialogOpen(107, STR_NPC(107), "Characters/npc_katrasche_003", STR_QUEST_TEXT(810048048))  -- "어째 하늘이 심상찮은데?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end


-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
