-- 아카데미의 새 식구(820003) -- 체험형 퀘스트
-- version("0.59.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520034)  -- 내 춤꾼 목록 메뉴를 열어줌
end


-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end


local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
	DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003001))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
end




local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return false
    end

    -- 춤꾼 목록 더미 모드 ####################################################
    SetInteger("dummy_follower_list", 1)
    SetString("dummy_follower_list_npc_id_arr", "[601, 602]")
    -- ##################################################################

    -- 춤 교습 더미 모드 ####################################################
    SetInteger("dummy_dance_lesson", 1)
    SetInteger("dummy_dance_lesson_dancer_id", 602)
    SetInteger("dummy_dance_lesson_student_id", 801)
    SetInteger("dummy_dance_lesson_id", 910001)
    SetInteger("dummy_dance_lesson_detail_id", 911001)
    -- ##################################################################

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을로
    GoSceneTown()
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 마을 캐릭터 모두 감추기
    TownCharacterHideAll()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

      -- 유저 등장
    TownCharacterStandAt(TownCharacterAddNPC(1), 3*40, 0*40)
      -- 춤꾼 1, 2 아카데미에 등장
    TownCharacterStandAtAndFixed(TownCharacterAddNPC(601), 1*40, 0*40)
    TownCharacterStandAtAndFixed(TownCharacterAddNPC(602), -1*40, 0*40)
    
      -- 퀘스트 인트로
    ScenarioIntroShow(601)
    
      --줌인
    TownCameraZoomIn(TownCharacterGetNPC(601), 0, 50, 2)
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003002))  -- "[nickname] 님! 이렇게 뵙게 되어 영광이에요!!"
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003003))  -- "저희는 얼마 전 광장에서 [nickname] 님의 춤을 보고 푹 빠진 춤꾼들이랍니다!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003004))  -- "[nickname] 님과 함께 댄스빌의 춤과 음악을 이끌고 싶어요!"
    
    TownCharacterSetEmot(TownCharacterGetNPC(601), "Characters/Emoticon_heart")
    TownCharacterSetEmot(TownCharacterGetNPC(602), "Characters/Emoticon_heart")
    Wait(1.5)
    
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003005))  -- "[nickname] 님의 {highlight}{bold}크루{/bold}{/highlight}가 되어 [nickname] 님을 도와드려도 되죠?"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003006))  -- "반드시 아카데미의 발전에 이바지하는 {highlight}{bold}크루{/bold}{/highlight}가 되어 보이겠어요!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_question")
    Wait(1.5)
    
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003007))  -- "놀라실 것 없어요. 원래 [nickname] 님 같은 훌륭한 춤꾼들은 저희같은 {highlight}{bold}크루{/bold}{/highlight}들이 자연스럽게 생기는 법이에요."
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003008))  -- "그리고 아카데미의 발전을 위해서 {highlight}{bold}크루{/bold}{/highlight}는 꼭 필요한 존재죠!"
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003009))  -- "저희가 바쁜 [nickname] 님을 대신해 많은 일을 할 예정이거든요!"
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003010))  -- "주로 아카데미를 홍보하거나 돈을 버는 일인데, 예를 들어 춤이나 음악을 배우려는 {highlight}{bold}수강생{/bold}{/highlight}이 찾아오면..."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()
    -- 화면이 아카데미 입구 쪽으로 이동, 2초 후에 춤 수강생 등장해 입구로 들어와 정지.
    TownCharacterStandAt(TownCharacterAddNPC(801), 0*40, 10*40)
    TownCameraZoomIn(TownCharacterGetNPC(801), 0*40, 0*40, 2.0) -- 수강생이 걸어오는 목적지를 중심으로 줌인
    Wait(1)
    TownCharacterWalkTo(TownCharacterGetNPC(801), 0*40, 3*40)
    Wait(2)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()
    DialogOpen(801, STR_NPC(801), "", STR_QUEST_TEXT(820003011))  -- "여기가 [유저의 닉네임] 님의 아카데미인가요?"
    DialogOpen(801, STR_NPC(801), "", STR_QUEST_TEXT(820003012))  -- "춤을 배우고 싶어서 왔습니다!"
    Wait(1)

    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003013))  -- "앗! 마치 연습이라도 해보라는 듯, 이 절묘한 타이밍에 우리 아카데미의 첫 {highlight}{bold}수강생{/bold}{/highlight}이!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_exclamation")
    Wait(1.5)

    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003014))  -- "원래 인생이란 이렇듯 그 자체로 극적인 것이죠!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003015))  -- "제가 활약할 시간이 이렇게 극적으로 찾아온 것처럼 말이에요!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003016))  -- "전 말이죠. 춤을 통해 인생을 배웠어요."
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003017))  -- "뭐랄까, 동작 하나하나마다 모두 기승전결이 존재하죠."
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003018))  -- "그 작은 '기승전결'들이 모여서 하나의 안무로 완성될 때의 경이로움!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003019))  -- "아아… 하루하루가 모여 인생이 되는 우리네 삶과 어찌 그리 닮았는지!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003020))  -- "그런 의미에서, 첫 수강생을 가르치는 영광은 저에게 주시면 안 될까요?"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003021))  -- "저 어린 친구에게 하나의 작은 인생과 같은 춤을 가르쳐주고 싶어요."
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003022))  -- "허락하신다면 우리의 첫 수강생을 터치해보세요."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()
      -- 춤수강생1에 유도 신호.
    ScriptTownZoomInCharacter(TownCharacterGetNPC(801))
    Wait(1)

    ::jmp_click1::
    RequireSceneTownCharacterClick(TownCharacterGetNPC(801))
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003023))  -- "첫 수강생이 어떤 춤을 배우러 왔는지 궁금하군요!"
        goto jmp_click1
    end

    -- 춤수강생2을 터치하면 줌인 되며 [춤 교습] 버튼 등장
    PushPopupTownNpcWithSelectBox(801)
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003024))  -- "춤을 가르쳐주려면 {highlight}{bold}춤 교습{/bold}{/highlight} 버튼을 눌러야 해요."

    ::jmp_btnTrainDance::
    RequireButtonWithCCB("UI_common/ui_popup_reward_student", "btn_start_long")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003025))  -- "{highlight}{bold}춤 교습{/bold}{/highlight} 버튼을 누르면 춤을 가르칠 수 있어요."
        
        goto jmp_btnTrainDance
    end

    -- [춤 교습] 버튼을 누르면 크루 목록이 등장
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003026))  -- "이제 [유저의 닉네임] 님의 크루들 중에 춤을 가르칠 춤꾼을 고르시.."
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003027))  -- "면 되는데 당연히 저를 고르실 거라 믿어 의심치 않습니다!"

    -- 춤꾼2에 유도 신호
    ::jmp_btnDancer602::
    RequireButton("btnDancer602")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003028))  -- "크루 중 한 명을 눌러보면..."
        goto jmp_btnDancer602
    end

    --교습 시작 버튼 누르도록 유도
    ::jmp_btnStartLesson::
    RequireButton("btnStartLesson")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003029))  -- "크루를 선택했으니 {highlight}{bold}교습 시작{/bold}{/highlight} 버튼을 눌러야겠죠?"
        goto jmp_btnStartLesson
    end

    if CheckQuestRunning() == false then
        QuestStart()
    end

    --가장 쉬운 난이도의 춤 교습 미션 진행, 유저가 어떤 선택을 하든 무조건 정답 처리
    RequireDanceLessonFinish(602, 801)

    QuestComplete()

    return true
end


local function ScriptOnQuestComplete()

    -- 춤꾼 목록 더미 모드 ####################################################
    SetInteger("dummy_follower_list", 1)
    SetString("dummy_follower_list_npc_id_arr", "[601, 602]")
    -- ##################################################################

    SceneTownSetStateEmpty()
        -- 유저 등장
    TownCharacterStandAt(TownCharacterAddNPC(1), 3*40, 0*40)
    -- 춤꾼 1, 2 아카데미에 등장
    TownCharacterStandAtAndFixed(TownCharacterAddNPC(601), 1*40, 0*40)
    TownCharacterStandAtAndFixed(TownCharacterAddNPC(602), -1*40, 0*40)
    -- 리아 등장
    TownCharacterStandAtAndFixed(TownCharacterAddNPC(801), 0*40, 3*40)

    TownCameraZoomIn(TownCharacterGetNPC(801), 0*40, 0*40, 2.0)  -- 리아(수강생)를 줌인
    TownCharacterAction(TownCharacterGetNPC(801), "cheer_01") -- 리아(수강생) 환호
    Wait(1)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(801, STR_NPC(801), "0", STR_QUEST_TEXT(820003030))  -- "이렇게 빨리 춤을 익히다니! 역시 이 아카데미에 오길 잘했어요!"
    DialogOpen(801, STR_NPC(801), "0", STR_QUEST_TEXT(820003031))  -- "정말 감사합니다!"
    
     -- 춤 수강생이 달려서 아카데미 입구 밖으로 나간다. 춤 수강생이 달리기 시작한지 2초가 지나면 아래의 스크립트 진행.
    TownCameraFree()
    TownCharacterRunTo(TownCharacterGetNPC(801), 0*40, 14*40)
    Wait(2)
    TownCharacterHide(TownCharacterGetNPC(801))
    -- 다시 유저와 크루들 줌인
    TownCameraZoomIn(TownCharacterGetNPC(602), 0, 50, 2)
    Wait(1)
        
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003032))  -- "이렇게 수강생에게 춤이나 음악을 가르쳐주면 {highlight}{bold}골드{/bold}{/highlight}를 받아요!"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003033))  -- "아! 다른 사람의 춤에 대한 갈망을 해소해주고 골드도 얻다니, 정말 보람 있는 일이지 않아요?"
    DialogOpen(602, STR_NPC(602), "", STR_QUEST_TEXT(820003034))  -- "오늘 가르쳐준 춤으로 아까의 수강생이 한 발자국의 인생을 더 나아갔길."
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003035))  -- "시작이 좋군요! 앞으로도 많은 수강생들이 올 텐데 오늘처럼만 하면 인기 아카데미가 될 수 있겠어요!"
        
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_happy")
    Wait(1.5)
        
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003036))  -- "앞으로도 아카데미를 위해 열심히 뛸 테니 지켜봐주세요!"
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003037))  -- "만약에 저희가 필요한데 찾기가 어렵거나 귀찮으실 때는 이 버튼을 이용하시면 돼요."

    -- 화면 줌아웃
    -- 마을 UI 표시
    SceneTownSetStateIdle()
    -- PopupDancerList시 마을 refresh 하지 않도록 설정
    ::jmp_btnDancerList::
    RequireButtonWithCCB("UI_common/ui_btn2_001_01", "btn_folllist")
    if RequireCheckResult("OutOfTouch") then

        DialogOpenNoOffUI(601, STR_NPC(601), "", STR_QUEST_TEXT(820003038))  -- "{highlight}{bold}크루 목록{/bold}{/highlight}을 확인할 수 있는 버튼이랍니다!"
        goto jmp_btnDancerList
    end
    Wait(2)

    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003039))  -- "버튼을 누르면 이렇게 {highlight}{bold}크루 목록{/bold}{/highlight}이 나와서, 크루들의 상태를 한눈에 확인할 수 있거든요."
    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003040))  -- "지금을 저희 둘 뿐이지만 앞으로는 이 목록이 넘칠 정도로 많은 크루들이 생길 거에요!"

    ::jmp_btnDancerListClose::
    RequireButtonWithCCB("UI_common/ui_btn2_001_02", "btn_follclose")
    if RequireCheckResult("OutOfTouch") then
        goto jmp_btnDancerListClose
    end

    DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003041))  -- "다 함께 힘을 모아 최고의 아카데미를 만들어보자구요!"

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow()  -- "[아카데미의 새 식구] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()

    SendSingularLog(13) -- id 13 : First_Crew
end

-- PRELOAD_BEGIN

  -- 하니(크루1) 머리 위에 빨간 느낌표.
  -- 하니(크루1)을 누르면 줌인 후 유저의 캐릭터가 화면 왼쪽에서 등장하며 아래의 퀘스트 진행.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(601), 1*40, 0*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(601))
        TownCharacterSetQuest(TownCharacterGetNPC(601))
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(602), -1*40, 0*40)
        TownCharacterSetQuest(TownCharacterGetNPC(602))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(601)) then
        ScriptTownMoveToRightSide(TownCharacterGetNPC(601))
        TownCharacterShow(TownCharacterGetNPC(602))
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(601)
    end

    if OnClickQuestTab(TownCharacterGetNPC(601)) then
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuest() then
            ScriptOnQuestComplete()
        end
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(601), 1*40, 0*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(601))
        TownCharacterSetQuest(TownCharacterGetNPC(601))
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(602), -1*40, 0*40)
        TownCharacterSetQuest(TownCharacterGetNPC(602))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(601)) then
        ScriptTownMoveToRightSide(TownCharacterGetNPC(601))
        TownCharacterShow(TownCharacterGetNPC(602))
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
		textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(601)
    end

    if OnClickQuestTab(TownCharacterGetNPC(601)) then
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuest() then
            ScriptOnQuestComplete()
        end
    end
elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(601), 1*40, 0*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(601))
        TownCharacterSetQuest(TownCharacterGetNPC(601))
        TownCharacterStandAtAndFixed(TownCharacterAddNPC(602), -1*40, 0*40)
        TownCharacterSetQuest(TownCharacterGetNPC(602))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(601)) then
        ScriptTownMoveToRightSide(TownCharacterGetNPC(601))
        TownCharacterShow(TownCharacterGetNPC(602))
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(601)
    end

    if OnClickQuestTab(TownCharacterGetNPC(601)) then
        --DialogOpen(601, STR_NPC(601), "", STR_QUEST_TEXT(820003042))  -- "[nickname] 님의 아카데미에서 춤추고 싶어요!"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        if ScriptOnQuest() then
            ScriptOnQuestComplete()
        end
    end

end

-- PRELOAD_END

if OnQuestReplay() then
 	--TODO
end
