-- 유행이라는 전염병(820014) -- 진입형 퀘스트
-- version("0.51.00")

local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520010)  -- 춤/음악 배우기 관련 기능을 열어줌
end


  --진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    UIHide("uiCommentInput")

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014001))  -- "[nickname] 님도 이 뮤비에서 뭔가 배우실 생각인가 봐요?"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014002))  -- "저도 이 뮤비가 마음에 쏙 들어서 춤을 배워볼까 했거든요."
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014003))  -- "뮤비에서 배워보는 건 처음이라구요? 그렇다면 얼른 배우는 법을 익히셔야겠네요!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014004))  -- "요즘은 워낙 유행이 빨리 지나가서 조금만 신경을 안 쓰면 낙오하기 십상이잖아요?"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014005))  -- "다른 춤꾼들이 어떤 음악에 맞춰 어떤 춤을 추는지 주시하다가, 괜찮은 게 있으면 바로 낚아채야 된다구요!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014006))  -- "왼쪽에 보시면 {highlight}{bold}춤{/bold}{/highlight}, {highlight}{bold}음악{/bold}{/highlight}, {highlight}{bold}악기{/bold}{/highlight} 버튼이 보이죠?"

    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_1")   -- btnLearnDance
    Wait(2)
    UISignalHide()
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014007))  -- "{highlight}{bold}춤{/bold}{/highlight} 버튼을 누르면 지금 뮤직비디오에서 추고 있는 춤을 배워 사용할 수 있고,"

    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_2")   -- btnLearnMusic
    Wait(2)
    UISignalHide()
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014008))  -- "{highlight}{bold}음악{/bold}{/highlight} 버튼을 누르면 지금 뮤직비디오에서 흘러나오는 음악을 배워 사용할 수 있고,"

    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_3")   -- btnLearnSound
    Wait(2)
    UISignalHide()
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014009))  -- "{highlight}{bold}악기{/bold}{/highlight} 버튼을 누르면 지금 흐르는 음악을 만들 때 쓰인 악기를 배워서 써보실 수 있어요."
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014010))  -- "뮤비에서 배우는 비용은 공원에서 배우는 비용보다 저렴하니까 부담없이 이용하셔도 돼요."
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014011))  -- "직접 만나서 배우는 게 아니다 보니, 배워오거나 가르쳐줄 크루가 필요하다는 것도 공원에서 배우기와는 좀 다르죠."

    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_1_txt_num")
    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_2_txt_num")
    UISignalShowWithCCB("UI_common/ui_dv_03_mv_03", "btn_learn_3_txt_num")
    Wait(2)
    UISignalHide()
    
	-- 스킵 버튼 활성화
    AddQuestSkipButton()
	
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014012))  -- "여기를 보면 몇 명의 춤꾼이 이 뮤직비디오의 춤, 음악, 악기를 배워갔는지 알 수 있어요."
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014013))  -- "이 뮤직비디오가 얼마나 유행하고 있는지 한 눈에 알 수 있겠죠?"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014014))  -- "뮤직비디오를 공유하시면 [유저의 닉네임] 님의 춤, 음악, 악기가 널리 퍼질 수 있도록 제가 열심히 배워갈게요!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(820014015))  -- "[유저의 닉네임] 님의 춤과 음악을 댄스빌의 모든 춤꾼들이 따라하는 날이 올지도 모르잖아요?"
    
    Wait(1)
    --ScenarioEndingShow()

    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    --퀘스트가 끝나도 마을로 가지 않고 원래 진입해있던 뮤비 정보 화면을 그대로 유지
end


--유저가 타유저의 뮤비에서 [배우기] 버튼(종류에 상관없이) 누르면 진행(배우기 확인 팝업을 띄우지 않고 바로 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 타유저의 뮤비에서 세 종류의 [배우기] 버튼에 모두 NEW 표시(내 뮤비에는 배우기 버튼 등장X, 이 퀘스트 끝나면 등장)

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 타 유저 뮤비 상세보기 생성 시, 배우기 관련 기능 열어줌
    if OnGameAction("OnBeforeSwapScene/SceneDanceVisionDetail") or OnGameAction("OnBeforeSwapScene/SceneMVDetail") or OnGameAction("OnBeforeSwapScene/SceneMVDetailContest") then
        UnlockQuestContents()
    end
    -- 타 유저 뮤비 상세보기 진입 시, 배우기 관련 버튼에 New 표시
    if OnGameAction("OnAfterSceneEntered/SceneDanceVisionDetail") or OnGameAction("OnAfterSceneEntered/SceneMVDetail") then
        if CheckMVDetailMusicVideoID() then
            local ccb_name = GetMvDetailLoadedCCBName()
            UIAddNewIconAtWithCCB(ccb_name, "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
            UIAddNewIconAtWithCCB(ccb_name, "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
            UIAddNewIconAtWithCCB(ccb_name, "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        end
    elseif OnGameAction("OnAfterSceneEntered/SceneMVDetailContest") then
        if CheckMVDetailMusicVideoID() then
            UIAddNewIconAtWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
            UIAddNewIconAtWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
            UIAddNewIconAtWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        end
    end

    -- 타 유저 뮤비 상세보기 에서 춤 배우기 버튼 클릭 시, 배우기 관련 버튼에 New 표시 제거, 퀘스트 진행
    if OnGameAction("OnBlockUIClick/SceneDanceVisionDetail/btn_learn_1") or OnGameAction("OnBlockUIClick/SceneMVDetail/btn_learn_1") then
        local ccb_name = GetMvDetailLoadedCCBName()
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    elseif OnGameAction("OnBlockUIClick/SceneMVDetailContest/btn_learn_1") then
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    end

    -- 타 유저 뮤비 상세보기 에서 음악 배우기 버튼 클릭 시, 배우기 관련 버튼에 New 표시 제거, 퀘스트 진행
    if OnGameAction("OnBlockUIClick/SceneDanceVisionDetail/btn_learn_2") or OnGameAction("OnBlockUIClick/SceneMVDetail/btn_learn_2") then
        local ccb_name = GetMvDetailLoadedCCBName()
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    elseif OnGameAction("OnBlockUIClick/SceneMVDetailContest/btn_learn_2") then
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    end

    -- 타 유저 뮤비 상세보기 에서 악기 배우기 버튼 클릭 시, 배우기 관련 버튼에 New 표시 제거, 퀘스트 진행
    if OnGameAction("OnBlockUIClick/SceneDanceVisionDetail/btn_learn_3") or OnGameAction("OnBlockUIClick/SceneMVDetail/btn_learn_3") then
        local ccb_name = GetMvDetailLoadedCCBName()
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB(ccb_name, "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)

        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    elseif OnGameAction("OnBlockUIClick/SceneMVDetailContest/btn_learn_3") then
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_1", "ui_btn_learn_1/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_2", "ui_btn_learn_2/iconNew", 31, 39)
        UIRemoveNewIconWithCCB("UI_contest/ui_contest_dv_mv", "btn_learn_3", "ui_btn_learn_3/iconNew", 31, 39)
        if CheckMVDetailMusicVideoID() then
            ScriptOnQuest()
        end
    end
end


