-- 마당발 DJ(820018) -- 진입형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520308)  -- 춤꾼 교체 기능을 열어줌
    UnlockContents(520309)  -- 크루 소개 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(30) --=BGM=Character_DJ

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018001))  -- "요! 얼마 전 우리 클럽에서 아카데미 식구를 들였던 [유저의 닉네임], 롸잇?"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018002))  -- "여기서 크루를 간택한 건 현명한 선택!\n이곳은 훌륭한 춤꾼들이 머무는 가택!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018003))  -- "우리 클럽에는 풋내기 따윈 전무!\n리듬을 아는 자만이 즐길 수 있는 가무!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018004))  -- "진짜 음악을 이해 못 한다면 이곳에서의 댄스는 격무!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018005))  -- "여길 거쳐간 진정한 춤꾼들이 한 트럭!\n그들은 언제나 이곳으로 발길을 틀어!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018006))  -- "{highlight}{bold}더 다양한 크루 후보들을 보고 싶을 때{/bold}{/highlight} 나를 찾아오면 노 트러블!"

    UISignalShowWithCCB("UI_Common/ui_btn2_032_01", "btn_club_dancer_change") -- 춤꾼 교체 버튼을 빨간 박스로 표시
    Wait(2)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018007))  -- "이 버튼을 누르면 내가 음악을 비틀고, 그들은 몸은 비틀고, 결국에는 못 버티고."
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018008))  -- "고인 물들이 고막의 통증을 호소하며 클럽을 비워!\n뉴 페이스들이 스테이지의 여백을 반기며 클럽을 채워!"
    UISignalHide()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018009))  -- "어디 그 뿐? 난 댄스빌을 대표하는 마당발!\n그 소문을 증명하는 나의 말발!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018010))  -- "만약 {highlight}{bold}무역상 오르카의 소개장{/bold}{/highlight}을 가지고 있다면, 내게 도움을 청하는 것이 최고의 약발!"

    UISignalShowWithCCB("UI_Common/ui_btn2_032_01", "btn_club_celeb_call") -- 춤꾼 소개 버튼을 빨간 박스로 표시
    Wait(2)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018011))  -- "나의 인맥은 마치 금맥 위의 금광\n어떤 춤꾼이든 이 버튼이면 클럽으로 금방"
    UISignalHide()
    
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018012))  -- "소개받은 춤꾼과 함께 춤을 즐기니!\n흥겨움이 마치 올리브를 곁들인 마티니!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018013))  -- "DJ가 왜 라임질이냐는 질문은 사절!\n디제잉 비트와 랩은 찰떡궁합이라는 유력한 가설!"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(820018014))  -- "새로운 크루가 필요하면 내게로!\n난 뭘 하든 언제나 제대로!"

    -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)
    QuestComplete()
    QuestReward()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterAddNPC(148))

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI에 머물러 있는 상태
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 마을 갱신 시, 클럽DJ 표시
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(148), 32*40, 20*40)
        
        TownCharacterAction(TownCharacterGetNPC(148), "cheer_01")
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(148), "DANCER_TALK")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(148), 610002)
    end
    -- 춤꾼 교체 팝업 생성 시, 춤꾼 교체 버튼 해금
    if OnGameAction("OnBeforePopupCreate/PopupTownClub") then
        UnlockQuestContents()
    end
     -- 클럽DJ 캐릭터 줌인 시, 퀘스트 진행 시작
    if OnGameAction("OnAfterPopupEntered/PopupTownClub") then
        ScriptOnQuest()
    end
end


-- PRELOAD_END
-- 퀘스트 다시하기
if OnQuestReplay() then
    --TODO
end
