-- 댄소나이트 바꿔드립니다.(820022) -- 진입형 퀘스트
-- version("0.36.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520035)  -- 환전소 관련 기능을 열어줌
end



-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

--유저가 재야의 환전상을 터치해서 줌인한 후 [환전] 버튼 누르면 진행(재화 상품 목록 화면으로 전환하지 않고 캐릭터 줌인 상태에서 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 환전상이 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [환전] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음

-- PRELOAD_BEGIN

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    -- SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(70) --=BGM=Theme_Bank

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022001))  -- "화폐라는 것은 곧 사람들 사이의 약속입니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022002))  -- "일부 사람들이라도 가치가 있다고 믿지 않으면, 그 화폐는 이미 아무 것도 아닌 것이지요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022003))  -- "즉, 화폐는 신뢰의 상징이고, 저는 그런 신뢰를 다루는 전문가라는 말씀입니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022004))  -- "따라서, 너무나도 당연히 전 아주 믿을 만한 사람이구요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022005))  -- "댄스빌에서 사람들이 가치를 약속한 화폐는 {highlight}{bold}댄소나이트{/bold}{/highlight}와 {highlight}{bold}골드{/bold}{/highlight}랍니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022006))  -- "그 두 가지 중 무언가가 필요할 때, 제가 도움을 드릴 수 있습니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022007))  -- "{highlight}{bold}외부 화폐{/bold}{/highlight}를 {highlight}{bold}댄소나이트{/bold}{/highlight}로, {highlight}{bold}댄소나이트{/bold}{/highlight}를 {highlight}{bold}골드{/bold}{/highlight}로의 교환은 여기서만 가능하기 때문이지요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022008))  -- "저는 교환 과정에서 아주아주 약간의 사리사욕만..."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_silly")
    Wait(1.5)

    -- PushPopupTownExchanger(147)
    
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022009))  -- "교환하는 방법은 아주 간단합니다. {highlight}{bold}환전{/bold}{/highlight} 버튼을 이용하면 되지요."

    ::jmp_btn_exchange::  --환전 버튼을 누르도록 유도
    RequireClickWithCCB("UI_common/ui_btn2_012_05", "btn_shop_bank")  --환전 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022010))  -- "신뢰의 아이콘인 저를 믿고 {highlight}{bold}환전{/bold}{/highlight} 버튼을 한번 눌러보십시오."
        goto jmp_btn_exchange  --환전 버튼을 누르도록 유도
    end
    PushSceneShopExchange("dv_tab_btn_dsn")
    --댄소나이트 탭이 선택된 상태의 환전소 화면으로 전환(정상적으로 환전소 진입 시에는 특별상품 탭이 선택된 상태)
    Wait(0.5)
    
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022011))  -- "이곳에는 {highlight}{bold}댄소나이트{/bold}{/highlight} 환전 상품을 준비해두었습니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022012))  -- "외부에서 가져온 화폐를 댄소나이트로 바꿔 사용하실 수 있지요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022013))  -- "신뢰의 아이콘인 제가 화폐의 가치에 맞는 충분한 양의 댄소나이트를 드리니, 의심따윈 버리셔도 됩니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022014))  -- "그리고 댄소나이트를 충분히 가지고 계시다면..."

    ::jmp_tab_gold::  --골드 탭을 누르도록 유도
    RequireButtonWithCCB("UI_exchange_shop/ui_shop_exchange", "dv_tab_btn_gold")  --골드 탭을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022015))  -- "신뢰의 아이콘인 저를 믿고 {highlight}{bold}골드{/bold}{/highlight} 탭을 한번 눌러보십시오."
        goto jmp_tab_gold  --골드 탭을 누르도록 유도
    end
    Wait(0.5)
    
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022016))  -- "이곳에서는 댄소나이트를 {highlight}{bold}골드{/bold}{/highlight}로 바꿔드리고 있지요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022017))  -- "골드는 항상 풍족하게 준비해둘 테니 언제든지 댄소나이트만 들고 오시면 됩니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022018))  -- "그런데 사실 제가 아주아주 추천드리고 싶은 건 따로 있습니다."

    ::jmp_tab_special::  --특별상품 탭을 누르도록 유도
    RequireButtonWithCCB("UI_exchange_shop/ui_shop_exchange", "dv_tab_btn_special") --특별상품 탭을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022019))  -- "신뢰의 아이콘인 저를 믿고 {highlight}{bold}특별 상품{/bold}{/highlight} 탭을 한번 눌러보십시오."
        goto jmp_tab_special  --특별상품 탭을 누르도록 유도
        end
    Wait(0.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022020))  -- "이곳에서는 {highlight}{bold}혜택이 남다른 상품{/bold}{/highlight}을 만나실 수 있습니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022021))  -- "고객님들이 다시 찾아주실 거라는 믿음이 없다면 결코 존재할 수 없는 후한 구성이지요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022022))  -- "이렇게 팔아서 아주아주 약간의 사리사욕을 챙길 게 있냐구요? 그런 건 염려하지 않으셔도 됩니다."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022023))  -- "이윤을 남기려 하면 신뢰를 잃고, 신뢰를 남기려 하면 이윤은 따라오는 법이니까요."
    DialogOpen(147, STR_NPC(147), "Characters/npc_shop_exchange_001", STR_QUEST_TEXT(820022024))  -- "우리 환전소의 상품들이 [유저의 닉네임] 님의 앞날에 도움이 되길 바랄 뿐입니다."

    Wait(0.5)

    QuestComplete()
    QuestReward()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterAddNPC(147))

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI(재화 상품 목록)에 머물러 있는 상태
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    -- 마을 갱신 시, 환전상 표시
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(147), -21*40, 33*40)
        TownCharacterAction(TownCharacterGetNPC(147), "cheer_01")
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(147), "DANCER_TALK")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(147), 610002)
    end

    -- 환전상 팝업 생성 시, 환전 버튼 해금
    if OnGameAction("OnBeforePopupCreate/PopupTownExchanger") then
        UnlockQuestContents()
    end
    -- 환전상 팝업 진입 시, 환전 버튼에 New표시
    if OnGameAction("OnAfterPopupEntered/PopupTownExchanger") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_05", "btn_shop_bank", "btn_shop_bank/iconNew", 52, 30)
    end

    -- 환전 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownExchanger/btn_shop_bank") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_012_05", "btn_shop_bank", "btn_shop_bank/iconNew")
        ScriptOnQuest()
    end
end



-- PRELOAD_END

--퀘스트 다시하기
if OnQuestReplay() then
 	--TODO
end
