-- 당신의 명예를 삽니다.(820023) -- 일반형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520302)  -- 명예 상점 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

--유저가 손님 가려받는 상인을 터치해서 줌인한 후 [물건 보기] 버튼 누르면 진행(상품 목록 화면으로 전환한 뒤 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 손님 가려받는 상인이 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [물건 보기] 버튼에 NEW 표시
--진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음


local function ScriptOnQuest()

      -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023001))  -- "오호라, 낯익은 얼굴이군요. [유저의 닉네임] 님이시죠?"
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023002))  -- "등장하자마자 강한 인상을 남기고 {highlight}{bold}아카데미 마스터{/bold}{/highlight}가 된 정체불명의 춤꾼이라..."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023003))  -- "후훗. 그 정도면 거래를 틀 정도의 명성은 충분한 것 같군요."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023004))  -- "앞으로 손님으로 대해드리도록 하겠습니다. 뭐, 무척이나 반가운 정도의 손님은 아니지만..."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023005))  -- "일단 저에게 '손님'이라는 말을 들었다는 것만으로도 뿌듯해하셔야 할 겁니다."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023006))  -- "전 명성이 뛰어난 춤꾼과만 거래를 하기 때문이죠."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023007))  -- "{highlight}{bold}명예 점수{/bold}{/highlight}를 쌓아서 오시면, 아주 귀중한 물건을 빌려드리겠습니다."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023008))  -- "역대 전설춤꾼들이 썼다는 귀하디 귀하고 신비로운 물건들을."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023009))  -- "물건들의 모양과 그 물건들이 가진 특수한 기능들을 잘 확인하고,"
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023010))  -- "아카데미 어디에든 {highlight}{bold}설치{/bold}{/highlight}하기만 하면 바로 효과가 나타나죠."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023011))  -- "설치는 인테리어 상점의 물건을 설치하는 것과 같은 방식이니 어렵지 않을 겁니다."
    DialogOpen(149, STR_NPC(149), "Characters/npc_shop_honor_mask_001", STR_QUEST_TEXT(820023012))  -- "언젠가, 전설춤꾼들의 의지가 깃든 이 물건들의 진정한 주인이 되시길 빌어봅니다."
    
    Wait(0.5)
    
      -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI(상품 목록)에 머물러 있는 상태
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    -- 마을 진입 시 명예 상인 표시
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(149), 14*40, 43*40) -- 560, 1720
        TownCharacterSetIconSetTimeStamp(TownCharacterAddNPC(149), "DANCER_TALK")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(149), 610002)
    end
    -- 물건 보기에 new 표시
    if OnGameAction("OnAfterPopupEntered/PopupTownHonorShop") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_06", "btn_shop_honor", "btn_shop_honor/iconNew", 52, 30)
    end

    -- 물건 보기 클릭 시 new 표시 제거, 퀘스트 진행
    if OnGameAction("OnUIClick/PopupTownHonorShop/btn_shop_honor") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_012_06", "btn_shop_honor", "btn_shop_honor/iconNew")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(149), 612092)
        ScriptOnQuest()
    end
end



