-- 춤요정과 댄소나이트(820035) -- 스토리
-- version("0.31.00")
  
if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end


local function UnlockQuestContents()
    UnlockStartQuestMode()
end

  -- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
    --TODO
    return true
end


local function textCheckQuestAppear()
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035001))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}는 우리에게 생명력, 그 자체야."
end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 
	

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    QuestReward()
    GoTown()
end

local function ScriptOnQuestAppear()    
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end
    
    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
          -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(117)
    

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_shocking")
    Wait(1.5)
	
    -- 대사 스킵
	AddQuestSkipButton()

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035002))  -- "음? 뭐지 그 눈빛은?"
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035003))  -- "'크기와 날개를 봐선 요정인 것 같은데 생긴 건 전혀...'라고 생각하는 거지?"
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035004))  -- "요정은 모두 깜찍하고 예쁘다는 편견 같은 걸 가지면 안 돼."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035005))  -- "어떤 생태계든 다양한 개체들이 있어야 균형이 맞는 거라고."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035006))  -- "나는 그냥 흔하디 흔한 {highlight}{bold}춤요정{/bold}{/highlight} 중 하나일 뿐이니 말이야."

    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035007))  -- "음... {highlight}{bold}춤요정{/bold}{/highlight}이 뭔지 전혀 모르는 표정이군."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035008))  -- "우리는 앙증맞은 크기와 날개, 항상 춤을 추는 습성 때문에 {highlight}{bold}춤요정{/bold}{/highlight}이라 불리지."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035009))  -- "{highlight}{bold}최초의 춤요정{/bold}{/highlight}들은 {highlight}{bold}하늘에서 떨어졌다{/bold}{/highlight}고 하던데..."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035010))  -- "더 자세히 알고 싶으면 {highlight}{bold}가디 여왕{/bold}{/highlight}님께 가보는 게 좋을 거야. 여왕님은 춤요정의 역사에 대해 모르는 것이 없으시거든."
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035011))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}를 워낙 소중히 여기시는 분이라 습관처럼 {highlight}{bold}댄소나이트{/bold}{/highlight}를 요구하시곤 하는데, 그럴 땐 그냥 가만히 있으면 돼."
    
    TownCharacterSetEmot(TownCharacterGetUser(), "Characters/Emoticon_silly")
    Wait(1.5)
    
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035012))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}를 왜 그렇게 소중하게 여기냐고?"

     --춤추는 사람의 머리에서 댄스파가 나오는 이미지 등장
    AnimationAdd("event_memory_05_01", "Characters/event_memory_05_01")
    AnimationSetFullScreen("event_memory_05_01")
	AnimationPlay( "event_memory_05_01")
	SoundPlayEffect(629065) --=SE=Ani_HumanDanceWave
	Wait(4)
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035013))  -- "사람들이 춤 출 때 나오는 {highlight}{bold}댄스파{/bold}{/highlight}라는 뇌파가 우리 {highlight}{bold}춤요정{/bold}{/highlight}들에게는 생명력이 되는데..."
	
    --춤추는 사람의 머리에서 댄스파가 나오는 이미지 사라짐
	AnimationRemove( "event_memory_05_01")
    --돌에 댄스파가 들어가 댄소나이트가 되는 이미지 등장
    AnimationAdd("event_memory_05_02", "Characters/event_memory_05_02")
    AnimationSetFullScreen("event_memory_05_02")
	AnimationPlay( "event_memory_05_02")
    SoundPlayEffect(629068) --=SE=Ani_StoneToDS
    Wait(5)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035014))  -- "특정 성분을 지닌 돌이 {highlight}{bold}댄스파{/bold}{/highlight}에 지속적으로 노출되면 바로 {highlight}{bold}댄소나이트{/bold}{/highlight}가 되는 거야."

    --돌에 댄스파가 들어가 댄소나이트가 되는 이미지 사라짐
	AnimationRemove( "event_memory_05_02")
    --댄소나이트에서 댄스파가 나오는 이미지 등장
    AnimationAdd("event_memory_05_03", "Characters/event_memory_05_03")
    AnimationSetFullScreen("event_memory_05_03")
	AnimationPlay( "event_memory_05_03")
	SoundPlayEffect(629063) --=SE=Ani_DSWave
    Wait(4)

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035015))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}는 소량이지만 {highlight}{bold}댄스파{/bold}{/highlight}를 발산하기 때문에 우리 {highlight}{bold}춤요정{/bold}{/highlight}들에게는 매우 귀중한 존재지."

    --댄소나이트에서 댄스파가 나오는 이미지 사라짐
	AnimationRemove( "event_memory_05_03")

    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035016))  -- "그러니 춤요정들의 보호자이신 가디 여왕님께서 탐을 내실만도 하지 않겠어?"
    DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035017))  -- "{highlight}{bold}가디 여왕{/bold}{/highlight}님은 요즘 주로 {highlight}{bold}댄스게이트{/bold}{/highlight} 앞에 계시니까 그 쪽으로 가보는 게 좋을 거야."
    Wait(0.5)
        
    -- 독백, 퀘스트 완료
    MonologOpen(STR_QUEST_TEXT(820035018))  -- "댄스게이트 앞의 가디 여왕에게로..."
    Wait(2)
    MonologClose()
    Wait(1)
    ScenarioEndingShow()  -- "[춤요정과 댄소나이트] 퀘스트 완료"
	QuestStart()
    QuestComplete()
    ScriptOnQuestComplete()
    QuestReward()
	GoTown()
end

    
local function ScriptOnQuestRunning()
    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end
    
    FullLoad()  -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    if CheckQuestProgress(10106, 1) then
        SceneTownSetStateEmpty()
        QuestComplete()
        ScriptOnQuestComplete()
        return
    end
end  



-- PRELOAD_BEGIN
-- 흔한 춤 요정 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(117))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(117))
        TownCharacterSetQuest(TownCharacterGetNPC(117))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(117)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(117))
        --DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035020))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}는 우리에게 생명력, 그 자체야."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(117)
    end
        
    if OnClickQuestTab(TownCharacterGetNPC(117)) then
        --DialogOpen(117, STR_NPC(117), "Characters/npc_017", STR_QUEST_TEXT(820035020))  -- "{highlight}{bold}댄소나이트{/bold}{/highlight}는 우리에게 생명력, 그 자체야."
		textCheckQuestAppear()
	end
    
    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end
    
end

-- PRELOAD_END

--퀘스트 다시하기
if OnQuestReplay() then
    --TODO
end
