-- 사라진 전설 춤꾼(820042) -- 일반형 퀘스트
-- version("0.40.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520036)  -- 호칭/자격증 기능 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

--유저가 유저 캐릭터를 터치하거나, 유저 캐릭터 바로가기 버튼을 누르면 유저 캐릭터 줌인 상태에서 스크립트 진행
--이 퀘스트를 진행 가능한 상태가 되면, 유저 캐릭터 바로가기 버튼에 new 표시

local function ScriptOnQuest( is_push_popup)

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents()  -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042001))   -- "앗! [유저의 닉네임] 님! 반가워요! 광장의 모든 사람에게 감동을 안겨주는 춤이라니! 정말 대단한 광경이었어요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042002))  -- "곧 {highlight}{bold}전설춤꾼{/bold}{/highlight}이 될지도 모르는 분과 이렇게 마주서다니!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042003))  -- "그게 무슨 말이냐구요? {highlight}{bold}전설춤꾼{/bold}{/highlight}은 춤꾼들의 결사체인 {highlight}{bold}춤꾼협회{/bold}{/highlight}의 우두머리에요!"

    RemoveQuestSkipButton()
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042004))  -- "그런데 얼마 전부터 {highlight}{bold}전설춤꾼{/bold}{/highlight}이 사라졌다는 이야기가 돌고 있거든요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042005))  -- "{highlight}{bold}자격증{/bold}{/highlight}이나 {highlight}{bold}호칭{/bold}{/highlight}을 획득하면 푸짐한 보상을 주기 시작한 것도..."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042006))  -- "차기 {highlight}{bold}전설춤꾼{/bold}{/highlight} 재목을 찾기 위한 작업이라는 말도 있더라구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042007))  -- "[nickname] 님의 실력이라면 자격증이랑 호칭을 많이 모아 전설춤꾼 후보가 되실 수 있을 거에요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042008))  -- "아, 아직 자격증이나 호칭이 익숙치 않다구요? 그렇다면 제가 도와드릴 수 있는 영광을!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042009))  -- "먼저 [nickname] 님의 {highlight}{bold}자격증{/bold}{/highlight}을 확인해볼까요?"

    if is_push_popup == 1 then
        PushPopupTownUser(1)
    end

    ::jmp_btnAch::
    RequireButtonWithCCB("UI_common/ui_btn2_003_01", "btn_license")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042010))  -- "{highlight}{bold}자격증{/bold}{/highlight} 버튼을 눌러보세요."
        goto jmp_btnAch
    end
    
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042011))  -- "이곳은 지금까지 획득하신 자격증을 볼 수 있는 공간이랍니다."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042012))  -- "경험이 많거나 능력이 뛰어난 춤꾼들일 수록 대체로 자격증이 많죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042013))  -- "정말 훌륭한 춤꾼이 되면 {highlight}{bold}전설춤꾼 후보{/bold}{/highlight}가 될 수 있는 자격증을 준다는 소문이에요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042014))  -- "이제 자격증보다 실용적이고 재미있는 {highlight}{bold}호칭{/bold}{/highlight}을 구경해볼까요?"
    
    ::jmp_btnBack::  --뒤로 가기 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_010_03", "btn_backward")  --뒤로 가기 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "", STR_QUEST_TEXT(820042015))  -- "{highlight}{bold}뒤로 가기{/bold}{/highlight} 버튼을 눌러 호칭을 구경하러 가보자구요."
        goto jmp_btnBack  --뒤로 가기 버튼 누르도록 유도
    end
    
    ::jmp_btn_title_edit::  --유저의 닉네임 옆에 있는 호칭 버튼 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_user_info_01", "btn_title_edit")  --유저의 닉네임 옆에 있는 호칭 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042016))  -- "{highlight}{bold}호칭{/bold}{/highlight} 버튼을 눌러보세요."
        goto jmp_btn_title_edit  --유저의 닉네임 옆에 있는 호칭 버튼 누르도록 유도
    end
    
      -- 자격증/호칭 화면
    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042017))  -- "여기에서는 [유저의 닉네임] 님께서 획득하신 호칭들을 한눈에 파악할 수 있죠."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042018))  -- "획득한 호칭들 중, 마음에 드는 것을 선택해서 {highlight}{bold}닉네임 앞{/bold}{/highlight}에 달 수 있어요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042019))  -- "자신의 춤이나 의상에 어울리는 호칭, 아무나 얻기 힘든 호칭을 달면 얼마나 뿌듯하다구요."
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042020))  -- "특정 조건을 채우면 춤꾼협회 {highlight}{bold}요원{/bold}{/highlight}이 그냥 주는 거니까 안 받을 이유가 없겠죠?"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042021))  -- "[유저의 닉네임] 님은 춤꾼협회 요원들을 자주 만나게 되겠네요. 워낙 실력이 출중하신 데다 주목까지 받으셨으니까요!"
    DialogOpen(111, STR_NPC(111), "Characters/npc_goodguy_001", STR_QUEST_TEXT(820042022))  -- "[nickname] 님께서는 꼭 {highlight}{bold}전설춤꾼{/bold}{/highlight} 후보가 되실 거에요! 제 예민한 촉이 그렇게 말하고 있거든요!"
    Wait(0.5)
    
      --퀘스트 완료
    Wait(1)

     -- 퀘스트 시작/완료
    QuestComplete()  --진입 튜토리얼은 마을로 돌아가지 않고 해당 UI에 머물리 있는 상태
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterGetUser())
end

if CheckQuestAppear() then
    -- 마을/댄스비전 진입 시, 유저 캐릭터 바로가기 버튼에 new 표시
    if OnTownRefresh() or OnGameAction("OnAfterSceneEntered/SceneDanceVision") then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew", 29, 41)
        UIShowWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
    end
end

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    -- 마을 갱신 시, 유저 캐릭터에 표시
    if OnTownRefresh() then
        TownCharacterAction( TownCharacterGetUser(), "cheer_01")
        TownCharacterSetIconSetTimeStamp( TownCharacterGetUser(), "DANCER_TALK")
        TownCharacterSetDanceIdle( TownCharacterGetUser(), 610002)
    end
    
    if OnGameAction("OnBeforeSwapScene/SceneMyInfo") then
        UnlockQuestContents()
    end

    -- 유저 캐릭터 팝업 클릭 시, 퀘스트 진행
    if OnGameAction("OnAfterPopupEntered/PopupTownUser") or OnGameAction("OnAfterSceneEntered/SceneMyInfo") then
        is_push_popup = 0
        if OnGameAction("OnAfterPopupEntered/PopupTownUser") then
            ScriptTownZoomInCharacter( TownCharacterGetUser())
            PushPopupTownUser(1)
            is_push_popup = 1
        end

        UIRemoveNewIconWithCCB("UI_common/ui_btn2_001_01", "btn_myavt", "btn_myavt/iconNew")
        UIHideWithCCB( "UI_common/ui_icon_new5_main_topbar", "icon_new_ByCCB")
        RefreshNewCount()
        TownCharacterRemoveIcon( TownCharacterGetUser())
        ScriptOnQuest(is_push_popup)
    end
end
