-- 전설을 빚는 사나이(820053)  -- 진입형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520301)  -- 재야의 춤선생
end

  --진입 튜토리얼의 경우, 어두운 화면에 퀘스트 제목 뜨는 과정 없음


-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO

    return true
end


local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(71) --=BGM=Character_Dancemasterbgm

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    QuestStart()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053001))  -- "음... 오호... 묘하군..."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_question")  --유저 캐릭터 머리 위에 물음표
    Wait(1.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053002))  -- "특별히 현란한 기술을 쓰는 것도 아닌데... 왜 춤을 잘 춘다는 생각이 드는 거지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053003))  -- "혹시 춤을 배운 적이 있어?"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")  --유저 캐릭터 머리 위에 "...."
    Wait(1.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053004))  -- "춤을 배운 적도 없다고? 오호.. 오랜만에 보는 재능이군, 그래."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053005))  -- "아, 내가 누구냐고? 나로 말할 것 같으면 말이지..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053006))  -- "댄스빌 최고의 춤꾼인 전설춤꾼의 제자가 되어 춤을 배우고! 제자를 길러 그다음 전설춤꾼으로 키워낸!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053007))  -- "그야말로 전설적인 춤선생이란 말씀!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053008))  -- "그리고 그런 전설적인 인물이 바로 지금! 널 제자로 삼기로 마음을 먹었지!"
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_exclamation")  --유저 캐릭터 머리 위에 느낌표
    Wait(1.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053009))  -- "무척이나 영광스럽겠지만 너무 오래 들떠있지는 말라고."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053010))  -- "내 제자라는 타이틀이 짊어지는 무게는 결코 가볍지 않거든!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053011))  -- "열심히 해서 내 명성에 금이 가지 않도록 해줘."

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_silly")
    Wait(1.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053012))  -- "내가 워낙 대단한 사람이라 마음의 준비가 필요할 테니 당장 강요하지는 않을게."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053013))  -- "하지만 나 같은 사람을 스승으로 삼을 수 있는 기회는 쉽게 오지 않으니 빨리 결정하는 게 좋을 거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053014))  -- "자, 이제 나의 예비 제자님이 되었으니 특권을 하나 주도록 하지."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053015))  -- "내가 직접 개발한 {highlight}{bold}춤기술{/bold}{/highlight}을 배울 수 있는 어마어마한 특권을!"
    
    ::jmp_click_158::
    RequireSceneTownCharacterClick(TownCharacterGetNPC(158))
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053016))  -- "아무한테나 안 가르쳐주는 건데..."
        goto jmp_click_158
    end
    ScriptTownZoomInCharacter(TownCharacterGetNPC(158))
    PushPopupTownDancingMaster(158)
    UIShowWithCCB("UI_common/ui_btn2_014_01", "btn_shop_danceskill")
    Wait(0.5)

    ::jmp_btn_shop_danceskill::  --[춤기술] 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_common/ui_btn2_014_01", "btn_shop_danceskill")  --[춤기술] 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053016))  -- "아무한테나 안 가르쳐주는 건데..."
        goto jmp_btn_shop_danceskill  --[춤기술] 버튼을 누르도록 유도
    end

    Wait(0.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053017))  -- "그냥 신체의 위치만 이동시키는 영혼없는 움직임은 이제 그만!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053018))  -- "움직임 하나하나에 생명력을 불어 넣는 {highlight}{bold}춤 기술{/bold}{/highlight}들이 바로 여기에!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053019))  -- "전설춤꾼을 키워낸 바로 그 비법!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053020))  -- "여기 있는 {highlight}{bold}춤 기술{/bold}{/highlight}을 배우면 춤을 만들 때 바로 써먹을 수 있어."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053021))  -- "물론 당연하게도, {highlight}{bold}춤 기술{/bold}{/highlight}을 배우려면 비용은 지불해야되고 말이야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053022))  -- "설마... 이 비용이 비싸다고 생각한다거나 뭐 그런 건 아니지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053023))  -- "다른 사람들은 사정해도 안 가르쳐주는 건데 특별히 가르쳐주는 거니까 비용에 연연하지 말라고."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820053024))  -- "난 오로지 나의 제자 님을 훌륭한 춤꾼으로 만들어야겠다는 생각 밖에 없는 사람이니까. 하하하하."

    --ScenarioEndingShow()
    Wait(0.5)
 
    QuestComplete()
    QuestReward()

    -- 동작을 복구
    TownCharacterSetDanceRestore( TownCharacterAddNPC(158))

    --진입 튜토리얼이 끝나면 마을로 돌아가지 않고 해당 UI(배울 수 있는 춤/음악 목록)에 머물러 있는 상태
end


--유저가 재야의 춤선생을 터치해서 줌인한 후 [춤/음악] 버튼 누르면 진행(춤/음악 목록 화면으로 전환하지 않고 캐릭터 줌인 상태에서 진행)
--이 퀘스트를 진행 가능한 상태가 되면, 재야의 춤선생이 아주 눈에 띄는 동작으로 파닥거림(유저에게 나를 봐달라는 느낌으로), [춤/음악] 버튼에 NEW 표시

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetDanceIdle(TownCharacterGetNPC(158), 610002)   -- 파닥파닥
        TownCharacterSetIconSetTimeStamp(TownCharacterGetNPC(158), "DANCER_TALK")
    end

    -- 재야의 춤꾼 팝업 진입 시, 전수 버튼 및 New 아이콘 표시
    if OnGameAction("OnAfterPopupEntered/PopupTownDancingMaster") then
        UIShowWithCCB("UI_common/ui_btn2_014_01", "btn_shop_danceskill")
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_014_01", "btn_shop_danceskill", "btn_shop_danceskill/iconNew", 52, 30)
    end

    -- 춤/음악 전수 버튼 클릭 시
    if OnGameAction("OnBlockUIClick/PopupTownDancingMaster/btn_shop_danceskill") then
        UIRemoveNewIconWithCCB("UI_common/ui_btn2_014_01", "btn_shop_danceskill", "btn_shop_danceskill/iconNew")
        TownCharacterSetDanceIdle(TownCharacterGetNPC(158), 612129)
        ScriptOnQuest()
    end
end

