  -- 스승의 사랑(820056)  -- 일반형 퀘스트
-- version("0.31.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520023) -- 동선 그리기
end

local function CheckQuestStartReq()

    if CheckQuestManagerDummy() then
        return true
    end

    if not CheckHasLicence(710280) then
        PushPopupConfirm(STR_QUEST_TEXT(820056001))  -- "요원에게서 [동선 그리기] 자격증을 획득해야 진행할 수 있는 퀘스트에요."

        return false
    end

    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
	DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056002))  -- "동선 쉽게 잡는 방법을 알려줄까?"
end

local function textQuestReplay()
	DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056002))  -- "동선 쉽게 잡는 방법을 알려줄까?"
end 



local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(71) --=BGM=Character_Dancemasterbgm
      -- 퀘스트 인트로
    ScenarioIntroShow(158)  --재야의 춤선생이 아직 없어 도 닦는 할아버지를 임시로 사용

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056003))  -- "제자님, 나한테 뭐 할 말 있지 않아?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056004))  -- "아까 슬쩍 보니 {highlight}{bold}요원{/bold}{/highlight}에게서 {highlight}{bold}자격증{/bold}{/highlight}을 하나 받는 것 같던데..."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056005))  -- "그렇다면 뭔가 새로운 기술을 사용할 수 있게 되었다는 이야기겠지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056006))  -- "그렇다면 그 기술의 사용법을 알아야 하니 내가 필요할 테고!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056007))  -- "자, 어떤 가르침이 필요한지 이 스승님께 당당하게 요구를 해봐!"

    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056008))  -- "스, 스토킹이라니! 제자를 아끼는 스승의 사랑을 그런 식으로 매도하다니!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056009))  -- "하지만 괜찮아. 모름지기 스승은 그런 제자의 모자람도 감싸안아야 하니까."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056010))  -- "어디 보자... 오, {highlight}{bold}동선 그리기{/bold}{/highlight} 자격증이었군."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056011))  -- "좋아. 그럼 본격적으로 제자에게 사랑을 베풀어볼까?"
    
      --새 춤의 위치 편집 화면으로(4프레임 짜리 2인 춤이 있고, 미리 보기에 재야의 춤선생 캐릭터가 등장. 유저의 데이터를 사용하지 않는 재야의 춤선생의 춤 편집 화면.)
    PushSceneDanceMoveWithID(612054)

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056012))  -- "그동안 동선은 프레임마다 일일이 위치를 지정해서 만들었을 거야. 그렇지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056013))  -- "하지만 그건 너무 귀찮아. 고수들은 그렇게 동선을 만들지 않지."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056014))  -- "다만 동선을 거침없이 {highlight}{bold}한 번에 주욱{/bold}{/highlight} 그릴 뿐!"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056015))  -- "그 전에 먼저 동선을 정하고 싶은 프레임 구간을 선택해야 돼."
    
    UIListScrollLock("uiFrames", 1)
    RequireDragUI("frmPos1", 0, 70)  --손가락이 등장, 첫 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 0)
    RequireDragUI("frmPos4", 0, 70)  --손가락이 등장, 4번째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 0)
    SceneDanceSelectFrameMulti(4, 0)
    UIListScrollLock("uiFrames", 0)
    -- RequireDragFromTo(0, -10, 0, 10)  --손가락이 등장, 첫 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    -- RequireDragFromTo(0, -10, 0, 10)  --손가락이 등장, 4번째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    Wait(2)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056016))  -- "동선 만들 구간을 선택했으니 이제 {highlight}{bold}동선 그리기{/bold}{/highlight} 버튼을 눌러봐."

    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_draw_move")  --동선 그리기 버튼 등장
    ::jmp_btnDraw::  --동선 그리기 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_draw_move")  --동선 그리기 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056017))  -- "동선 만들 구간을 선택했으니 {highlight}{bold}동선 그리기{/bold}{/highlight} 버튼을 눌러봐."
        goto jmp_btnDraw  --동선 그리기 버튼 누르도록 유도
    end
    Wait(1.5)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056018))  -- "이제 그리고 싶은 동선을 {highlight}{bold}손가락으로 주욱{/bold}{/highlight} 그리기만 하면 돼."
    
    DescriptionBarShow(STR_QUEST_TEXT(820056019))  -- "손가락으로 동선을 그려보세요"
    
      --손 모양이 등장, 손가락을 바닥에 대고 원을 그린 다음 손가락을 떼는 동작을 반복
      --유저가 손가락을 댔다가 일정 길이(협의 필요) 이상을 움직인 후 떼면 유저가 그린 선에 맞게 동선이 잡히고, 아래의 스크립트 진행
    SignalDragPathShow(-160, 100, -160, -80, 160, -80, 160, 100) -- x, y 좌표의 반복, 짝수개로 몇개가 되던지 상관 없다
    RequireSceneDanceMoveDrawMode(100)
    DescriptionBarHide()
    SignalDragPathHide()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056020))  -- "잘했어. 스승이 훌륭하니 제자도 아주 잘 따라오는군."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056021))  -- "자, {highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러 결과물을 확인해볼까?"
    
    ::jmp_btnPlay::  --플레이 버튼을 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause")  --플레이 버튼을 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056021))  -- "자, {highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러 결과물을 확인해볼까?"
        goto jmp_btnPlay  --플레이 버튼을 누르도록 유도
    end
    Wait(1.5)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056022))  -- "손가락으로 그린 선을 따라 인형이 잘 움직이지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056023))  -- "이 방법만 알면 전처럼 귀찮게 인형의 위치를 하나하나 지정해주지 않아도 돼."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056024))  -- "오늘도 내 덕분에 좋은 거 하나를 배워가는군."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "항상 스승의 사랑에 감사할 줄 아는 제자가 되도록."
    
    Wait(0.5)

      -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[스승의 사랑] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()
    GoTown()

end

-- PRELOAD_BEGIN

-- 재야의 춤선생 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end

-- PRELOAD_END

if OnQuestReplay() then
    TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
    ScriptTownMoveToSide(TownCharacterGetNPC(158))
    --DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(820056025))  -- "동선 쉽게 잡는 방법을 알려줄까?"
    textQuestReplay()
	PushPopupTownNpcWithSelectBox(158)
end
