  -- 가면 쓴 자의 메시지(820058)  -- 일반형 퀘스트
-- version("0.37.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()

end

local function textCheckQuestRunning()

end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()
	DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058001))  -- "춤은 또다른 춤의 재료이기도 해요."
end

local function textQuestReplay()
	DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058001))  -- "춤은 또다른 춤의 재료이기도 해요."
end 




local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 마을 UI 감추기
    SceneTownSetStateEmpty()

    SoundPlay(9) --=BGM=Event_Quest_common

      -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058002))  -- "안녕하세요? [유저의 닉네임] 님 이시죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058003))  -- "전 일정 기간 계약을 맺고 심부름을 해주는 프로 심부름꾼이에요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058004))  -- "이미 이쪽 업계에서는 꽤 알려져있죠."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058005))  -- "특히 최근 계약은 조건이 괜찮았어요. 한 달에 막대 과자 열 봉지. 어마어마하죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058006))  -- "그만큼 제 심부름 수행 능력을 높이 평가 받고 있다는 거겠죠. 훗."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058007))  -- "오늘은 {highlight}{bold}괴상한 가면을 쓴 아저씨{/bold}{/highlight}의 부탁으로 왔어요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058008))  -- "음산하고 신비로우면서도 어딘가 모자라보이는... 특이한 아저씨였는데..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058009))  -- "짤막한 춤 하나를 전달해달라더라구요. 앞으로 춤 만들 때 써먹기 좋을 거라고."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058010))  -- "어떤 춤인지 보여드릴까요?"
    
    PushSceneDanceList("[611324, 611325, 611326]")  --유저의 데이터를 사용하지 않는 과자가 제일 좋은 아이의 춤 목록 화면으로 전환
      --2개의 춤이 있는데, 첫번 째 춤은 인상좋은 청년과 유사한 부드러운 동작의 4프레임 짜리 춤
      --두번 째 춤은 첫번째 춤의 앞 두 프레임을 뒤에 두 프레임에 복사해서 붙였을 때 아주 잘 어울리는 4프레임 짜리 춤

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058011))  -- "제일 앞에 있는 게 말씀드렸던 그 춤이에요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058012))  -- "동작이 무난해서 여기저기 가져다 써도 잘 어울릴 것 같죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058013))  -- "저런 춤은 자세 몇 개를 {highlight}{bold}복사{/bold}{/highlight}한 뒤에 다른 춤에 {highlight}{bold}붙여넣어서{/bold}{/highlight} 쓰면 딱이거든요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058014))  -- "다른 춤의 자세를 재료로 써서 새로운 춤 만드는 게 얼마나 재미있다구요~"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058015))  -- "고객 님께 최고의 만족감을 드리는 것 또한 심부름꾼의 숙명!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058016))  -- "제가 그 재미를 느낄 수 있도록 도와드리죠!"
    
    ::jmp_item1::  --첫번 째 춤 터치하도록 유도
    RequireClick("611324")  --첫번 째 춤 터치하도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058017))  -- "제가 도와드릴게요!"
        goto jmp_item1
    end

    PushSceneDanceMoveWithID(611324)

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058018))  -- "이 춤에서 무난한 자세 몇 개를 선택해서 다른 춤에 써보는 거에요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058019))  -- "초반 동작이 무난하게 써먹기 좋을 것 같은데, 어때요? 괜찮죠?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058020))  -- "그럼 앞의 두 프레임을 선택해볼까요?"

    UIListScrollLock("uiFrames", 1)
    RequireDragUI("uiFrame1", 0, 70)  --손가락이 등장, 첫 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 1)
    RequireDragUI("uiFrame2", 0, 70)  --손가락이 등장, 2번째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(1, 1)
    SceneDanceSelectFrameMulti(2, 1)
    UIListScrollLock("uiFrames", 0)
    Wait(2)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058021))  -- "선택한 자세들을 다른 춤에 쓰려면 {highlight}{bold}복사{/bold}{/highlight} 버튼을 눌러야 돼요."

    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_copy")
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_cut")
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_paste")
    ::jmp_btnCopy::  --복사 버튼 누르도록 유도
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_copy")  --복사 버튼 누르도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058022))  -- "자세들을 선택했으니 {highlight}{bold}복사{/bold}{/highlight} 버튼을 누르면 돼요!"
        goto jmp_btnCopy
    end

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058023))  -- "이제 복사한 걸 써먹을 다른 춤으로 이동해야겠죠?"
    
    ::jmp_btnBack::  --뒤로 가기 버튼 누르도록 유도
    if CheckUnlock(520013) then
         RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_backward") 
    else RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_backward")  --뒤로 가기 버튼 누르도록 유도
    end

    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058023))  -- "이제 복사한 걸 써먹을 다른 춤으로 이동해야겠죠?"
        goto jmp_btnBack
        end
    
    ::jmp_item2::  --두번 째 춤 목록 터치하도록 유도
    RequireClick("611325")  --두번 째 춤 목록 터치하도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058023))  -- "이제 복사한 걸 써먹을 다른 춤으로 이동해야겠죠?"
        goto jmp_item2
    end
    
    PushSceneDanceMoveWithID(611325)

    UIDisableWithCCB("UI_dance/ui_btn2_030_01", "btn_setting")

    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_copy")
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_cut")
    UIShowWithCCB("UI_dance/ui_btn2_030_01", "btn_paste")

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058024))  -- "아까 선택한 자세들을 어디에 넣으면 자연스러울까요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058025))  -- "뒷부분에 넣으면 괜찮을 것 같다구요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058026))  -- " 그럼 [유저의 닉네임] 님을 믿고 뒤의 두 프레임에 아까 그 자세들을 {highlight}{bold}붙여넣어{/bold}{/highlight} 보자구요!"
    
    UIListScrollLock("uiFrames", 1)
    RequireDragUI("uiFrame3", 0, 70)  --손가락이 등장, 3번 째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(3, 1)
    RequireDragUI("uiFrame4", 0, 70)  --손가락이 등장, 4번 째 프레임을 누른 상태에서 위로 이동 후 손을 떼는 연출을 반복적으로 보여주어 드래그 유도
    SceneDanceSelectFrameMulti(3, 1)
    SceneDanceSelectFrameMulti(4, 1)
    UIListScrollLock("uiFrames", 0)
    Wait(1)
    
    ::jmp_btnPaste::  --붙여넣기 버튼 터치하도록 유도
    RequireButtonWithCCB("UI_dance/ui_btn2_030_01", "btn_paste")  --붙여넣기 버튼 터치하도록 유도
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058027))  -- "뒷부분에 아까 그 자세들을 붙여넣어 보자구요!"
        goto jmp_btnPaste
        end
    Wait(2)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058028))  -- "아까 두 프레임의 자세를 그대로 이 춤 뒷부분에 딱 옮겼어요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058029))  -- "원래 춤이랑 잘 이어질까요? 궁금하니까 어서 봐요!"
    
    ::jmp_btnPlay::

    if CheckUnlock(520013) then
        RequireButtonWithCCB("UI_dance/ui_dance_02", "btn_play_pause") 
    else RequireButtonWithCCB("UI_dance/ui_dance_01", "btn_play_pause")  --뒤로 가기 버튼 누르도록 유도
    end
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058030))  -- "{highlight}{bold}▶{/bold}{/highlight} 버튼을 눌러보세요."
        goto jmp_btnPlay
        end
    Wait(3)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058031))  -- "역시! 원래 같은 춤인 것처럼 딱이에요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058032))  -- "이 정도라면 {highlight}{bold}여러 춤의 자세들을 조합{/bold}{/highlight}해서 새로운 춤을 만드는 것도 가능하겠어요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058033))  -- "한 걸음 발전하신 모습을 보니, 심부름꾼으로서의 사명을 다 한 것 같아 뿌듯하네요."
    
    GoSceneTown()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058034))  -- "또 제가 필요한 일이 있으면 언제든지 찾아주세요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058035))  -- "그럼 전 저를 필요로 하는 또 다른 사람들을 만나러 이만 가볼게요~"
    
    TownCameraZoomIn(TownCharacterGetNPC(1), -1*40, 50, 2)
    TownCharacterWalkToCharacter(TownCharacterGetNPC(113),TownCharacterGetNPC( 1), -10*40, 0*40)  -- 걸어서 화면 오른쪽으로 사라짐
    Wait(4)
    TownCharacterRunToCharacter(TownCharacterGetNPC(113),TownCharacterGetNPC( 1), -2*40, 0*40)  -- 뛰어서 원래 있던 자리로 돌아옴
    Wait(3)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058036))  -- "아, 깜빡하고 전달 안 한 말이 있었네요."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058037))  -- "아까 그 이상한 가면을 쓴 음산하고 신비롭고 어딘가 모자라보이는 아저씨가..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058038))  -- "'{highlight}{bold}지켜보고 있다. 빨리 춤 실력을 되찾는 게 좋을 거야.{/bold}{/highlight}'라는 말을 전해달라고..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058039))  -- "가면 때문에 잘 보이진 않았지만 기분 나쁘게 웃고 있는 게 틀림없었어요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "자세한 건 잘 모르겠지만 이상한 사람인 것 같으니 조심하시길."

    Wait(0.5)

    -- 독백, 퀘스트 완료
    -- MonologOpen("")
    Wait(1)
    ScenarioEndingShow()  -- "[가면 쓴 자의 메시지] 퀘스트 완료"

      --과자가 제일 좋은 아이의 춤 목록에 있던 춤 중 맨 앞에 있던 춤을 우편함으로 전달
      --춤은 바로 쓸 수 있는 완성품이고, 유저가 수정 가능
      -- 퀘스트 시작/완료/보상
    QuestStart()
    QuestComplete()
    QuestReward()

    GoTown()
end

-- 퀘스트 NPC가 돌아다니고 있다.
if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(113)) -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(113))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(113)) -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(113))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        ScriptTownMoveToTownSquare(TownCharacterGetNPC(113)) -- 대사가 없이 바로 이동
        -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(113))  -- 넓은 장소가 필요하므로 무조건 광장으로 이동
        -- ScriptTownMoveToSide(TownCharacterGetNPC(113))
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
        textCheckQuestAll()
		PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
		textCheckQuestAll()
	end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end

end

if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(113))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
    TownCharacterSetQuest(TownCharacterGetNPC(113))

    ScriptTownMoveToTownSquare(TownCharacterGetNPC(113)) -- 대사가 없이 바로 이동
    -- ScriptTownMoveToOtherPlace(TownCharacterGetNPC(113)) -- 넓은 장소가 필요함으로 무조건 광장으로 이동
    -- ScriptTownMoveToSide(TownCharacterGetNPC(113))
    --DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(820058040))  -- "춤은 또다른 춤의 재료이기도 해요."
	textQuestReplay()
    PushPopupTownNpcWithSelectBox(113)
end

