-- 저작권 안내(820061) -- 저작권 설명
-- version("0.31.00")

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    -- 기존의 배경음 백업
    SoundGetDvmBase64()

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlayBGM(629055) --=BGM=Character_Ari_evil

    QuestStart()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061001))   -- "잠깐!! [유저의 닉네임]님! 공유하시기 전에 알려드릴 것이 있습니다!"
	
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061002))   -- "혹시 저작물이란 것이 무엇인지 알고 계십니까?"
	
	-- 독백
    MonologOpen(STR_QUEST_TEXT(820061003))  -- "1. 저작권?"
    Wait(1)
    MonologClose()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061004))   -- "저작물이란 인간의 사상 또는 감정을 표현한 창작물을 말하는 것입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061005))   -- "저작물이 보호를 받기 위해서는 창작성이 요구됩니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061006))   -- "창작성이란 남의 것을 베끼지 않고 자신의 독자적인 사상 또는 감정의 표현을 담고 있음을 의미하는 것입니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061007))   -- "본인이 창작한 저작물에 대하여 저작권을 갖게 되는데, 이는 복제권, 공연권, 송신권, 전시권, 배포권, 대여권, 공표권, 성명표시권, 동일성유지권 등을 포함하게됩니다."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061008))   -- "우리는 저작자의 허락 없이 저작물을 사용하거나 권리를 포함한 저작자의 저작권을 침해하면 안됩니다. 침해 시 법적 제재를 받을 수 있다는 것을 명심하십시오."
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061009))   -- "혹시 더 궁금하신 부분이 있으신가요?"
    DialogOpen(110, STR_NPC(110), "Characters/npc_agent_veteran_001", STR_QUEST_TEXT(820061010))   -- "역시 이 정도로는 부족하겠죠? 갑자기 바쁜 일이!! 나머지 설명은 신입요원에게 들으시길 바랍니다. 그럼 저는 이만!"
	
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061011))  -- "하~ 선배님은 늘 이런식이라니까!! 제가 조금 더 자세한 내용을 알려드릴게요~ 우선 음악저작물에 대해 알려드리죠!"
 
	-- 독백
    MonologOpen(STR_QUEST_TEXT(820061012))  -- "2. 음악저작물"
    Wait(1)
    MonologClose()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061013))  -- "음악저작물이란 클래식, 팝송, 가요 등 음악에 속하는 모든 저작물을 말하는 것이에요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061014))  -- "음악저작물의 저작권자는 작사자, 작곡자, 편곡자가 있죠!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061015))  -- "저작권자 허락 없는 저작물을 이용하는 경우 설령 비영리를 목적으로 하거나 출처를 밝힌다고 할지라도 저작권 침해로서 법적 책임이 면제되지는 않아요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061016))  -- "저작권자에게 허락을 받지 않고 UGC 제작에 음악저작물을 이용하는 것은 저작권 침해행위가 되기때문에 꼭 허락을 받아주세요~"

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061017))  -- "다음은 리메이크에 대한 것을 알려드려야겠군요!"
	
	-- 독백
    MonologOpen(STR_QUEST_TEXT(820061018))  -- "3. 리메이크"
    Wait(1)
    MonologClose()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061019))  -- "리메이크는 원곡을 이용해야 하고 또 원곡을 변형하게 되므로, 원곡의 저작권자의 복제권과 2차적저작물작성권(동일성유지권)을 침해하게 되요. 따라서 리메이크를 하는 경우에도 반드시 원곡 저작권자로부터 리메이크에 대한 동의를 받으셔야 해요~"

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061020))  -- "다음으로 설명드릴 것은 패러디!!"
	
	-- 독백
    MonologOpen(STR_QUEST_TEXT(820061021))  -- "4. 패러디"
    Wait(1)
    MonologClose()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061022))  -- "저작권법에 따라 적법한 패러디가 되기 위해서는 비평 목적이 있어야 하고, 정당한 범위 안에서, 공정한 관행에 따라 원작을 이용하셔야 해요~"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061023))  -- "원곡의 특징을 흉내 내어 단순히 웃음을 자아내는 정도는 패러디로 볼 수 없죠!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061024))  -- "거의 전적인 차용이나 토씨 하나 바꾸지 아니한 복제일 경우에는 아무리 패러디의 성격을 갖추었다고 하더라도 저작권법상 자유이용이 허용되지 않는다는 사실을 기억하세요~"

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061025))  -- "모두 알려드렸나? 아! 마지막으로 한가지 더 알려드릴 내용이 남았네요. 바로 안무에요~"
 
 	-- 독백
    MonologOpen(STR_QUEST_TEXT(820061026))  -- "5. 안무"
    Wait(1)
    MonologClose()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

	DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061027))  -- "안무는 사람의 몸짓이나 동작에 의해 사상이나 감정을 표현한 것으로 연극저작물로 보호를 받게 되요."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061028))  -- "저작자로서 저작권을 갖고, 그 안무를 직접 공연, 기획한 자는 실연자가 되어 실연 자체에 대한 복제권과 방송권 같은 저작인접권을 갖게되는 것이죠!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061029))  -- "저작물 안무는 연속 동작을 통해 사상이나 감정이 포함된 하나의 극을 표현하는 전체가 그 보호 대상이 되는 것이죠."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061030))  -- "하지만 사상이나 감정이 포함돼 있지 않은 단순한 개별 동작 하나 하나는 법적 보호가 어렵다고 할 수 있어요."

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061031))  -- "이상 설명을 마칠게요."

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061032))  -- "다른 사람의 권리를 지켜줄 때 나의 권리도 보호 받을 수 있다는 것은 너무 당연한 것이겠죠?"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(820061033))  -- "[유저의 닉네임]님은 잘 지켜주실 것이라고 믿어요!!"

    
    -- 퀘스트 완료
    Wait(1)

    -- 퀘스트 시작/완료/보상(진입 튜토리얼은 완료, 보상 팝업 안 뜸)

    QuestComplete()
    QuestReward()

    -- 백업했던 배경음 플레이하고 제거
    SoundPlayBGMBase64()
    SoundClearBase64()

    RestoreQuestReal()
end

-- PRELOAD_BEGIN

-- 유저가 옵션>저작권 누르면 진행

if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnGameAction("OnUIClick/PopupSetting/btn_copyright") then
        ScriptOnQuest()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
