-- 누군가로부터의 계시(820062) -- 메인/스토리 퀘스트 끝났으니 알아서 놀거라 
-- version("0.38.00")

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
      --TODO
    return true
end

local function ScriptOnQuest()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlayBGM(629054) --=BGM=Character_Mr.CABA

    --QuestStart()

    -- 스킵 버튼 활성화
    AddQuestNoBreakSkipButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(820062001))  -- "아, 자네로군."
    TownCharacterSetExpression(TownCharacterGetNPC(101), "Smile")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820062002))  -- "마침 잘 왔네. 그렇지 않아도 알려줄 게 있었거든."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820062003))   -- "자네에게 당분간 메인 퀘스트라고 할 만한 큰일은 없을 거야. 물론 그 당분간이 그리 길지는 않겠지만."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820062004))  -- "그러니 한동안은 천천히 이곳에서의 생활을 즐기게."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(820062005))  -- "춤이나 음악을 만든다든지, 댄스비전을 구경한다든지, 공원에 놀러 간다든지, 아카데미를 꾸민다든지, 쇼핑을 한다든지..."
    TownCharacterSetExpression(TownCharacterGetNPC(101), "Laugh")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(820062006))  -- "댄스빌에는 워낙 즐길 거리가 많으니 지루하진 않을 거야. 하하하."
    TownCharacterSetExpression(TownCharacterGetNPC(101), "BeSurprised")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(820062007))  -- "자네에게 당분간 별일이 없을 거라는 사실을 어떻게 알았냐고?"
    TownCharacterSetExpression(TownCharacterGetNPC(101), "Scare")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009", STR_QUEST_TEXT(820062008))  -- "음... 그건... 댄스빌을 창조한 누군가에게 받은 계시 같은 거랄까..."
    TownCharacterSetExpression(TownCharacterGetNPC(101), "Laugh")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_009", STR_QUEST_TEXT(820062009))  -- "대답하기 곤란하니까 너무 깊이 묻지는 말게. 하하하."
    
    -- 퀘스트 완료
    Wait(1)
    GoTown()
end

-- PRELOAD_BEGIN

-- 카바네 집 앞에 카바 서있음
-- 머리 위에는 회색 화살표(UI_common / ui_bloon_quest_5.ccb)


-- 유저가 카바 터치하면 진행(퀘스트 버튼 누르는 과정 없이 바로 진행)
if CheckQuestAppear() or CheckQuestRunning() or CheckQuestComplete() then
    if OnTownRefresh() then
        -- 카바 등장
        TownCharacterStandAt(TownCharacterAddNPC(101), -12*40, 53*40)
        TownCharacterSetIcon(TownCharacterGetNPC(101), "Infinity_Quest")
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestStart() then
        ScriptOnQuest()
    end
end

-- PRELOAD_END

if OnQuestReplay() then
  --TODO
end
