  -- 손녀의 춤(830025)  -- 진행형 퀘스트
-- version("0.48.00")
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520002)  -- 아카데미 관련 기능을 열어줌
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
    UnlockContents(520009)  -- 장애물 제거 관련 기능을 열어줌
    UnlockContents(520010)  -- 춤/음악 배우기 관련 기능을 열어줌
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520012)  -- 춤꾼 영입 기능을 열어줌
    UnlockContents(520013)  -- 군무 제작 기능을 열어줌
    UnlockContents(520302)  -- 명예 상점 기능을 열어줌
    UnlockContents(520016)  -- NPC호감도 관리 기능을 열어줌
end

-- 퀘스트 시작 조건 검사
local function CheckQuestStartReq()
	--TODO
    return true
end

local function textCheckQuestAppear()
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025001))  -- "우리 불쌍한 손녀딸을 어쩌면 좋누..."
end

local function textCheckQuestRunning()
	DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025002))  -- "기가 죽어있는 내 손녀딸에게 말을 걸어보게."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 

local function ScriptOnQuestComplete()
-- 퀘스트 시작/완료/보상
    QuestReward()
    GoTown()
end

local function ScriptOnQuestAppear()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(114)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025003))  -- "에구에구... 하늘도 무심하시지..."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025004))  -- "내 손녀딸은 춤추는 걸 무척 좋아한다네."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025005))  -- "그런데 춤을 추는 데 소질은 그다지 없나봐..."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025006))  -- "매일 친구들에게 놀림을 받아서 항상 기가 푹 죽어있지 뭔가."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025007))  -- "자네같이 유명한 춤꾼이 손녀딸 뮤직비디오에 {highlight}{bold}별점{/bold}{/highlight}을 후하게 줘서 응원해준다면 그 아이가 기운을 차리지 않을까 싶은데"
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025008))  -- "에잉... 늙은이가 주책 맞게 무슨 말을 하는 건지, 허허. 신경 쓰지 말게... 아... 불쌍한 우리 손녀딸..."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_sweat")
    Wait(1.5)
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025009))  -- "아, 글쎄 괜찮대도? 뭐... 자네가 응원해주지 않으면 의욕 없고 의미 없는 나날을 보내기 밖에 더 하겠나..."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025010))  -- "...손가락 몇 번 휙휙하면 끝나는 걸 안 하려니 괜히 마음이 찜찜하고 그렇지?"
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025011))  -- "어떻게, 한 번 해볼텨? 역시 그게 좋겠다 싶지?"
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025012))  -- "좋아, 그럼 저기 내 손녀딸에게 말을 걸어보게."
    
    QuestStart()
    GoTown()
end

local function ScriptOnQuestRunning()

    -- 퀘스트 시작 조건 검사
    if not CheckQuestStartReq() then
        return
    end

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- ScriptTownMoveToSide(TownCharacterGetNPC(115))
    PushPopupTownDiscouragedGirl(115)

	UIHide("btn_info_mv")
    -- UIHide("uiRightButtons")
    -- UIHide("uiBottomButtons")
    -- UIHide("uiProfileBox")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025013))  -- "[유저의 닉네임] 님도 제 춤이 형편없다고 놀리러 오신 건가요?"
    DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025014))  -- "다들 그래요... 제 춤은 그저 팔 다리를 휘적대는 것일 뿐이라고..."
    DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025015))  -- "이런 춤으로 만든 뮤비에 높은 {highlight}{bold}별점{/bold}{/highlight}을 줄 사람은 아무도 없을 거야! 아무도 없어!"
    DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025016))  -- "[유저의 닉네임] 님도 제 뮤비에 줄 {highlight}{bold}별점{/bold}{/highlight} 따위는 없다고 생각하시죠?"
    DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025017))  -- "그래요... 제 춤이 그렇죠, 뭐..."
    
    UIShow("btn_info_mv")
    ::jmp_btnMVList::
    RequireClick("btn_info_mv")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025018))  -- "억지로 좋아하는 척 하지 않으셔도 돼요..."
        goto jmp_btnMVList
    end

      --기죽은 소녀의 뮤비 정보 필요
    PushSceneMVList("[600001, 600002]", 115, 6)

    ::jmp_btnMVListItem::
    RequireClick("MVListItem")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025018))  -- "억지로 좋아하는 척 하지 않으셔도 돼요..."
        goto jmp_btnMVListItem
    end
    
    PushSceneMVDetailDummy(600001, 115, 6);

    -- 진행조건 : 별점 5점주기
    -- RequireDragFromTo(200, 0, 350, 0)

    ::jmp_rateStar5::
    RequireClickWithCCB("UI_common/ui_dv_03_mv_03", "btn_rating")
    if RequireCheckResult("OutOfTouch") then
        DialogOpen(115, STR_NPC(115), "Characters/npc_020_01", STR_QUEST_TEXT(830025018))  -- "억지로 좋아하는 척 하지 않으셔도 돼요..."
        goto jmp_rateStar5
    end
    
    -- 별점 주기 팝업
    PushPopupRatingMVCurrent()
    
    -- 최대 별점 선택 유도
    ::jmp_rateStar6::
    star_x = UIGetXWithCCB("UI_common/ui_dv_04_rating", "rating_star_5");
    star_y = UIGetYWithCCB("UI_common/ui_dv_04_rating", "rating_star_5");
    RequireTouchAreaBlockEvent(star_x-30, star_x+30, star_y-30, star_y+30);
    if RequireCheckResult("TouchOutOfArea") then
        goto jmp_rateStar6
    end
    
    --[[ 별점 팝업 나가기 유도
    ::jmp_rateStar7::
    RequireHiddenTouchAreaBlockEvent(300 - 100, 300 + 100, 200 - 100, 200 + 100)
    if RequireCheckResult("TouchOutOfArea") then
        goto jmp_rateStar7
    end
    ]]
    Wait(1)
      
    -- 별점 5로 변경하고 팝업 나가기
    SceneMVRateStar(5)
    PopPopup()

    SendSingularLog(7) -- id 7 : First_DV_Star

    --캐릭터를 [기죽은 소녀]에서 [기살아난 소녀]로 교체
    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(116, STR_NPC(116), "Characters/npc_020_02", STR_QUEST_TEXT(830025019))  -- "정말 제 춤이 마음에 드시는 거에요?"
    DialogOpen(116, STR_NPC(116), "Characters/npc_020_02", STR_QUEST_TEXT(830025020))  -- "제 춤에 높은 별점을 준 사람은 할머니 외에는 [유저의 닉네임] 님이 처음이에요!"
    DialogOpen(116, STR_NPC(116), "Characters/npc_020_02", STR_QUEST_TEXT(830025021))  -- "이제 어딜 가도 당당하게 제 춤을 자랑할 거에요"
    DialogOpen(116, STR_NPC(116), "Characters/npc_020_02", STR_QUEST_TEXT(830025022))  -- "고마워요. [유저의 닉네임] 님!"

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[손녀의 춤] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
    QuestComplete()
    ScriptOnQuestComplete()
end





-- PRELOAD_BEGIN

-- 퀘스트 NPC가 돌아다니고 있다.
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        --DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025021))  -- "우리 불쌍한 손녀딸을 어쩌면 좋누..."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(114)
    end

    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        --DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025021))  -- "우리 불쌍한 손녀딸을 어쩌면 좋누..."
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(114))
        TownCharacterRoamInTown(TownCharacterAddNPC(115))
        TownCharacterSetIcon(TownCharacterGetNPC(115), "Quest_Common_Appear")
        TownCharacterSetQuest(TownCharacterGetNPC(115))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        --DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025022))  -- "기가 죽어있는 내 손녀딸에게 말을 걸어보게."
        textCheckQuestRunning()
		GoTown()
    end

    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        --DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(830025022))  -- "기가 죽어있는 내 손녀딸에게 말을 걸어보게."
		textCheckQuestRunning()
	end

    if OnTownCharacterClick(TownCharacterGetNPC(115)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(115))
        PushPopupTownNpcWithSelectBox(115)
    end

    if OnClickQuestTab(TownCharacterGetNPC(115)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        --캐릭터를 [기죽은 소녀]에서 [기살아난 소녀]로 교체
        TownCharacterRoamInTown(TownCharacterAddNPC(116))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(116))
        TownCharacterSetQuest(TownCharacterGetNPC(116))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(116)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(116))
        PushPopupTownNpcWithSelectBox(116)
    end

    if OnClickQuestTab(TownCharacterGetNPC(116)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end

if OnQuestReplay() then

    --TODO

end

-- PRELOAD_END
