-- 너도 못 할걸?(870026)  -- 조건형 퀘스트
-- version("0.48.00")
-- 눈썰미 안 좋은 청년 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026001))  -- "우리 엄마가 나 춤 잘 춘다 그랬는데... 왜 춤 배우기가 이리 어려울까요?"
end

local function textCheckQuestRunning()
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026002))  -- "다른 춤꾼의 {highlight}{bold}춤{/bold}{/highlight}을 [progress20104]회만 배우시면 인정해드릴게요."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 




local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(131)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026003))  -- "보기에는 쉬워 보이는데, 막상 배우려면 어려운 춤이 너무 많아요."
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026004))  -- "그렇다고 제가 춤에 소질이 없는 건 진짜 아니거든요?"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026005))  -- "춤에 천부적인 재능이 있다는 말을 많이 들었단 말이에요! 우리 엄마한테서..."
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026006))  -- "아마 저는 워낙 창조적인 성격이라 따라 하는 건 저랑 맞지 않나 봐요."
    
    TownCharacterSetEmot(TownCharacterGetNPC(1), "Characters/Emoticon_unanser")
    Wait(1.5)

    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026007))  -- "설마 지금 제 말이 변명이라고 생각하시는 건 아니죠?"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026008))  -- "정말 춤 잘 추는 거랑 잘 따라하는 거랑은 별개라니까요?"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026009))  -- "[유저의 닉네임] 님도 다른 춤꾼의 춤을 한 번 배워보시면 아실 거에요."
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026010))  -- "춤은 잘 추시지만 따라 하기는 쉽지 않으실 걸요?"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026011))  -- "다른 춤꾼의 {highlight}{bold}춤{/bold}{/highlight}을 [progress20104]회 배우시면 인정해드릴게요."

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
       QuestStart()
       GoTown()
    end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026012))  -- "[유저의 닉네임] 님은 춤도 잘 추시고 배우는 것도 잘 하시는구나..."
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026013))  -- "좋아요! 저도 열심히 연습해서 눈썰미를 키우겠어요!"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026014))  -- "그래도 안 되면 세상의 모든 춤을 다 연습해버리죠 뭐!"
    DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026015))  -- "정상에서 만나자구요."

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[너도 못 할걸?] 퀘스트 완료"

    QuestReward()
    GoTown()
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(131))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(131))
        TownCharacterSetQuest(TownCharacterGetNPC(131))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(131)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(131))
        --DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026014))  -- "우리 엄마가 나 춤 잘 춘다 그랬는데... 왜 춤 배우기가 이리 어려울까요?"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(131)
    end

    if OnClickQuestTab(TownCharacterGetNPC(131)) then
        --DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026014))  -- "우리 엄마가 나 춤 잘 춘다 그랬는데... 왜 춤 배우기가 이리 어려울까요?"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(131))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(131))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(131))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(131)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(131))
        --DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026015))  -- "다른 춤꾼의 {highlight}{bold}춤{/bold}{/highlight}을 [progress20104]회만 배우시면 인정해드릴게요."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20104)
        PushPopupTownNpcWithSelectBox(131)
    end

    if OnClickQuestTab(TownCharacterGetNPC(131)) then
        --DialogOpen(131, STR_NPC(131), "Characters/npc_012", STR_QUEST_TEXT(870026015))  -- "다른 춤꾼의 {highlight}{bold}춤{/bold}{/highlight}을 [progress20104]회만 배우시면 인정해드릴게요."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(131))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(131))
        TownCharacterSetQuest(TownCharacterGetNPC(131))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(131)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(131))
        PushPopupTownNpcWithSelectBox(131)
    end

    if OnClickQuestTab(TownCharacterGetNPC(131)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end
