-- 어른들은 몰라요(870028)  -- 조건형 퀘스트
-- version("0.48.00")
-- 불만 많은 아이 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end


local function textCheckQuestAppear()
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028001))  -- "어려도 별점을 달 권리 정도는 있는 거잖아요!"
end

local function textCheckQuestRunning()
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028002))  -- "다른 춤꾼의 뮤비에 별점을 [progress20102]회 더 주셔야죠!"
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 


local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(127)
    
    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028003))  -- "정말 어른들은 너무해요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028004))  -- "아이들 무시해도 한참 무시한다니까요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028005))  -- "보는 춤마다 이렇다 저렇다 평가를 했더니..."
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028006))  -- "어린 게 뭘 안다고 평가하냐며 혼을 내지 뭐에요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028007))  -- "어리면 좋고 싫은 것도 없는 줄 아나봐! 흥!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028008))  -- "다른 춤꾼들의 춤을 평가하면서 내 춤도 발전하고 그런거지! 안 그래요?"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028009))  -- "[유저의 닉네임] 님도 다른 춤꾼들의 뮤비를 {highlight}{bold}별점{/bold}{/highlight}으로 평가 해보세요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028010))  -- "[progress20102]회 정도만 해보면 그게 얼마나 재미있고 도움이 되는지 알게 될 걸요?"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028011))  -- "그리고 나서 오늘 평가한 춤에 대해서 같이 이야기해보자구요!"

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end


local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028012))  -- "역시 [유저의 닉네임] 님은 꼬마라고 절 무시하지 않네요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028013))  -- "제 친구로 인정해드릴게요! 히히."

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[어른들은 몰라요] 퀘스트 완료"

    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        --DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028012))  -- "어려도 별점을 달 권리 정도는 있는 거잖아요!"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
        --DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028012))  -- "어려도 별점을 달 권리 정도는 있는 거잖아요!"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(127))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        --DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028013))  -- "다른 춤꾼의 뮤비에 별점을 [progress20102]회 더 주셔야죠!"
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20102)
        PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
        --DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(870028013))  -- "다른 춤꾼의 뮤비에 별점을 [progress20102]회 더 주셔야죠!"
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end
-- PRELOAD_END
