-- 관심을 주세요(870029)  -- 조건형 퀘스트
-- version("0.48.00")
-- 사려 깊은 소녀 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029001))  -- "소외된 춤꾼들이 힘을 내도록 별점을 달아주세요."
end

local function textCheckQuestRunning()
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029002))  -- "다른 유저의 뮤비에 {highlight}{bold}별점{/bold}{/highlight}을 [progress20102]회만 더 주면 행복한 댄스빌의 밑거름이 될 거에요."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 




local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(130)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029003))  -- "근래 실력이 뛰어난 춤꾼이 참 많이 나오는 것 같아요."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029004))  -- "좋은 일이기는 한데... 그래서 반대로 관심을 못 받는 춤꾼들도 점점 늘어가고 있죠."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029005))  -- "열심히 만든 뮤비를 아무도 봐주지 않는다니... 생각만 해도 안타까워요."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029006))  -- "그런 어려움에 빠진 춤꾼을 도와줄 방법이 없을까..."
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029007))  -- "아! [유저의 닉네임] 님처럼 유명한 춤꾼이 뮤비를 평가해주면 그 춤꾼들도 외롭지 않을 거에요!"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029008))  -- "그럼 밝고 희망찬 댄스빌을 위해! 다른 춤꾼들의 뮤직비디오에 {highlight}{bold}별점{/bold}{/highlight}을 [progress20102]회만 줄까요?"

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029009))  -- "잘 하셨어요! [유저의 닉네임] 님께서 관심을 준 춤꾼들이 의욕을 되찾았을 거에요!"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029010))  -- "[유저의 닉네임] 님도 좋은 뮤직비디오 많이 보여주세요~"
    
    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[관심을 주세요] 퀘스트 완료"

    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029009))  -- "소외된 춤꾼들이 힘을 내도록 별점을 달아주세요."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029009))  -- "소외된 춤꾼들이 힘을 내도록 별점을 달아주세요."
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(130))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029010))  -- "다른 유저의 뮤비에 {highlight}{bold}별점{/bold}{/highlight}을 [progress20102]회만 더 주면 행복한 댄스빌의 밑거름이 될 거에요."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20102)
        PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        --DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(870029010))  -- "다른 유저의 뮤비에 {highlight}{bold}별점{/bold}{/highlight}을 [progress20102]회만 더 주면 행복한 댄스빌의 밑거름이 될 거에요."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        PushPopupTownNpcWithSelectBox(130)
    end

    if OnClickQuestTab(TownCharacterGetNPC(130)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
-- PRELOAD_END
