-- 직접 부딪혀봐(870030)  -- 조건형 퀘스트
-- version("0.48.00")
-- 실전을 중시하는 남자 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030001))  -- "진정한 춤꾼이 되고 싶다면 일단 뮤비를 많이 만들어서 공개해보는 게 정답이지!"
end

local function textCheckQuestRunning()
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030002))  -- "{highlight}{bold}뮤직비디오{/bold}{/highlight}를 {highlight}{bold}하나{/bold}{/highlight}만 만들어서 공개해봐. 그리 어려운 일도 아니잖아?"
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 


local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(128)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030003))  -- "춤을 잘 추려면 어떻게 해야 되는지 알아?"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030004))  -- "뭐 어려운 거 없어. {highlight}{bold}뮤직비디오{/bold}{/highlight}를 많이 만들어 {highlight}{bold}공개{/bold}{/highlight}해보는 게 제일이지!"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030005))  -- "그래야 내 춤이 어디가 좋고 어디가 문제인지를 바로 알 수 있거든!"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030006))  -- "혼자서만 연습하면 내 춤과 음악을 다른 춤꾼들이 어떻게 생각할지 알 수가 없잖아?"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030007))  -- "그런 의미에서 지금 당장 {highlight}{bold}뮤직비디오{/bold}{/highlight}를 하나 만들어서 {highlight}{bold}공개{/bold}{/highlight}해보는 게 어때?"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030008))  -- "분명히 큰 경험이 될 거야! 내가 보장하지!"

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030009))  -- "그래. 그렇게 직접 부딪혀 가면서 배우는 거야, 춤과 음악은!"
    DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030010))  -- "앞으로도 뮤직비디오 촬영과 공개는 과감하게! 알겠지?"

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[직접 부딪혀봐] 퀘스트 완료"

    QuestReward()
    GoTown()
end


-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuest(TownCharacterGetNPC(128))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        --DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030009))  -- "진정한 춤꾼이 되고 싶다면 일단 뮤비를 많이 만들어서 공개해보는 게 정답이지!"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(128)
    end

    if OnClickQuestTab(TownCharacterGetNPC(128)) then
        --DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030009))  -- "진정한 춤꾼이 되고 싶다면 일단 뮤비를 많이 만들어서 공개해보는 게 정답이지!"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(128))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        --DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030010))  -- "{highlight}{bold}뮤직비디오{/bold}{/highlight}를 {highlight}{bold}하나{/bold}{/highlight}만 만들어서 공개해봐. 그리 어려운 일도 아니잖아?"
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20101)
        PushPopupTownNpcWithSelectBox(128)
    end

    if OnClickQuestTab(TownCharacterGetNPC(128)) then
        --DialogOpen(128, STR_NPC(128), "Characters/npc_015", STR_QUEST_TEXT(870030010))  -- "{highlight}{bold}뮤직비디오{/bold}{/highlight}를 {highlight}{bold}하나{/bold}{/highlight}만 만들어서 공개해봐. 그리 어려운 일도 아니잖아?"
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(128))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(128))
        TownCharacterSetQuest(TownCharacterGetNPC(128))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(128)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(128))
        PushPopupTownNpcWithSelectBox(128)
    end

    if OnClickQuestTab(TownCharacterGetNPC(128)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end
end
-- PRELOAD_END
