-- 진정한 자기 발전(870031)  -- 조건형 퀘스트
-- version("0.48.00")
-- 도 닦는 할아버지 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표.

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031001))  -- "스스로의 발전을 위해서도 팬이 되어보는 것은 반드시 필요한 것이지."
end

local function textCheckQuestRunning()
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031002))  -- "그저 마음이 동하는 뮤직비디오를 골라 {highlight}{bold}팬 되기{/bold}{/highlight}를 [progress20103]회만 하면 된다네."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 




local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(129)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031003))  -- "자네는 진정한 자기 발전이 무엇이라고 생각하나?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031004))  -- "춤 연습에만 죽도록 매진하는 것?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031005))  -- "뮤직비디오를 통해 명성을 쌓는 것?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031006))  -- "허허허. 뭐, 그것도 괜찮겠지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031007))  -- "하지만 말일세. 발전은 내가 완벽하지 않음을 인정하는 것에서 시작되는 법이야."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031008))  -- "그러면 자연히 나의 장점과 단점, 다른 이들의 장점과 단점을 편견 없이 볼 것이고..."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031009))  -- "굳이 애쓰지 않아도 그들의 장점이 나에게 옮겨와 단점을 보완하게 되지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031010))  -- "자네도 그런 기분을 느껴보고 싶은가? 그렇다면..."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031011))  -- "마음을 비우고 순수한 눈으로 보게. 그리고 마음에 드는 뮤직비디오를 찾아."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031012))  -- "그런 멋진 뮤직비디오를 만든 춤꾼의 {highlight}{bold}팬{/bold}{/highlight}이 되어보는 걸세."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031013))  -- "{highlight}{bold}팬 되기{/bold}{/highlight}가 자기 발전과 무슨 상관이 있냐고?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031014))  -- "허허허. 글쎄. 무슨 상관이 있을까?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031015))  -- "속는 셈 치고 다른 춤꾼 [progress20103]명의 {highlight}{bold}팬{/bold}{/highlight}이 되어보게."

    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end


local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031016))  -- "다른 사람의 팬이 되었다는 것은 남을 인정했다는 것."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031017))  -- "이는 곧 뭔가를 배울 수 있는 마음 가짐이 되었다는 것이지."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031018))  -- "자네는 한 단계 더 발전할 기회를 얻은 걸세. 축하하네."

    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[진정한 자기 발전] 퀘스트 완료"

    QuestReward()
    GoTown()
end

-- PRELOAD_BEGIN

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031017))  -- "스스로의 발전을 위해서도 팬이 되어보는 것은 반드시 필요한 것이지."
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031017))  -- "스스로의 발전을 위해서도 팬이 되어보는 것은 반드시 필요한 것이지."
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031018))  -- "그저 마음이 동하는 뮤직비디오를 골라 {highlight}{bold}팬 되기{/bold}{/highlight}를 [progress20103]회만 하면 된다네."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20103)
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        --DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(870031018))  -- "그저 마음이 동하는 뮤직비디오를 골라 {highlight}{bold}팬 되기{/bold}{/highlight}를 [progress20103]회만 하면 된다네."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
-- PRELOAD_END
