-- 언제나 해답은 배우기(870034)  -- 조건형 퀘스트
-- version("0.48.00")
-- 명쾌한 소녀 NPC가 마을을 돌아다니고 있다. 머리 위에 빨간색 느낌표. 139 15

local function UnlockQuestContents()
end

local function textCheckQuestAppear()
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034001))  -- "악기도 배울 수 있는 거 아시죠?"
end

local function textCheckQuestRunning()
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034002))  -- "다른 춤꾼의 {highlight}{bold}악기{/bold}{/highlight}를 [progress20106]회만 배워보세요."
end

local function textCheckQuestComplete()

end 

local function textCheckQuestAll()

end

local function textQuestReplay()

end 



local function ScriptOnQuestAppear()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(139)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034003))  -- "요즘 음악을 이것저것 만들다보니, 상점에 파는 악기로는 뭔가 부족하더라구요!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034004))  -- "제가 원하는 부분에 적절한 소리가 딱! 나와줘야 되는데 말이에요."
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034005))  -- "게다가 전 아직 경험이 별로 없는 춤꾼이다 보니 악기 소리를 바꿀 능력도 없지 않겠어요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034006))  -- "하지만! 전 늘 그랬듯이 해답을 찾아내죠!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034007))  -- "그리고 그 해답은 언제나 배우기에 있고 말이죠!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034008))  -- "실력 있는 춤꾼들의 조율을 받은 악기들이 댄스비전에 널리고 널렸으니까요!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034009))  -- "마음에 드는 악기 소리가 있다 싶으면 그걸 배워다가 내 음악에 사용하면 된다는 말씀!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034010))  -- "좋은 건 같이 해야 더 빛을 발하는 법이니, [유저의 닉네임] 님도 말 나온 김에 당장 해보실래요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034011))  -- "다른 춤꾼들의 뮤비를 둘러보고 마음에 드는 {highlight}{bold}악기{/bold}{/highlight}를 찾아서 [progress20106]회 배워보세요."
    
    RemoveQuestSkipButton()

    if not CheckQuestExpired() then
        QuestStart()
        GoTown()
     end
end

local function ScriptOnQuestRunning()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

end

local function ScriptOnQuestComplete()

    FullLoad() -- 리소스 로딩
    UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034012))  -- "악기 상점에서 보던 것들과는 차원이 다른 악기들이 많죠?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034013))  -- "앞으로도 {highlight}{bold}배우기{/bold}{/highlight} 기능을 적극 이용하시는 거, 아시죠?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034014))  -- "즐겁자고 만드는 뮤직비디오인데 스트레스 받으면서 내가 다 만들 필요는 없으니까요."
    
    -- 독백, 퀘스트 완료
    Wait(1)
    ScenarioEndingShow() -- "[언제나 해답은 배우기] 퀘스트 완료"

    QuestReward()
    GoTown()
end


if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034013))  -- "악기도 배울 수 있는 거 아시죠?"
        textCheckQuestAppear()
		PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034013))  -- "악기도 배울 수 있는 거 아시죠?"
		textCheckQuestAppear()
	end

    if OnClickQuestStart() then
        ScriptOnQuestAppear()
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuestBlocked(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034014))  -- "다른 춤꾼의 {highlight}{bold}악기{/bold}{/highlight}를 [progress20106]회만 배워보세요."
        textCheckQuestRunning()
		SetQuestProgressComplete_Dummy(20106)
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        --DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(870034014))  -- "다른 춤꾼의 {highlight}{bold}악기{/bold}{/highlight}를 [progress20106]회만 배워보세요."
		textCheckQuestRunning()
	end

    if OnClickQuestStart() then
        ScriptOnQuestRunning()
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
    end

    if OnClickQuestStart() then
        ScriptOnQuestComplete()
    end

end
