-- 주목해, 나를!(880023) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
    end


elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023001))  -- "모처럼 클럽에 가는데~\n다들 나를 주목해야 하지 않겠어요?\n훗, 여성들이 배우고 싶어 하는 클럽 춤을 알려드릴까요?~"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(126)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023002))  -- "여성들이 가장 배우고 싶어 하는 클럽에서 핫한 춤은?\n바로바로~ '골반 춤'~!\n그런데.. 골반이 뭐죠? 하하... (눈물)"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023003))  -- "그래요! 우리 모두 골반은 없지만!\n그래도 괜찮아요!\n핫한 춤을 안 춰볼 순 없죠!"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023004))  -- "좌, 우로 흔들 흔들 하면 어떻게든 되지 않겠어요?\n한번 해보자구요!"
    end

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023005))  -- "골반을 흔드는 느낌이 잘 살려면~\n치마 정도는 입어줘야겠죠?~"

    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202219)  
    

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023006))  -- "오~케이! 어서 춰보죠!"

    RequireSceneDanceCorrection()
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023007))  -- "왼쪽으로 업!\n오른쪽으로 업!\n우린 핫해질 수 있어요!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023008))  -- "오~ 조금 핫해 보이는데요?\n마치 골반이 있는 듯한 느낌!"
    
    GoSceneTown()
    TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612349)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202219)  
    
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023009))  -- "다 내 덕분이라구요, 호호!\n그럼 다음에 또 봐요~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    -- 퀘스트 인트로
    ScenarioIntroShow(126)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023002))  -- "여성들이 가장 배우고 싶어 하는 클럽에서 핫한 춤은?\n바로바로~ '골반 춤'~!\n그런데.. 골반이 뭐죠? 하하... (눈물)"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023003))  -- "그래요! 우리 모두 골반은 없지만!\n그래도 괜찮아요!\n핫한 춤을 안 춰볼 순 없죠!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023004))  -- "좌, 우로 흔들 흔들 하면 어떻게든 되지 않겠어요?\n한번 해보자구요!"

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023005))  -- "골반을 흔드는 느낌이 잘 살려면~\n치마 정도는 입어줘야겠죠?~"
    end
    ]]--

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612349, 0)
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023007))  -- "왼쪽으로 업!\n오른쪽으로 업!\n우린 핫해질 수 있어요!"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023010))  -- "오~ 조금 핫해 보이는데요? 마치 골반이 있는 듯한 느낌!"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023011))  -- "다 내 덕분이라구요, 호호! 그럼 다음에 또 봐요~"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023012))  -- "음? 치마가 없으면 무슨 소용이람?!"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880023013))  -- "흥~ 최신 유행에 관심이 없군요?\n시시하네~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end







-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612349, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end






