-- 정열의 카바(880033) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
    end



elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        -- 스킵 버튼 활성화
        AddQuestSkipButton()
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        -- 스킵 버튼 활성화
        AddQuestSkipButton()
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033001))  -- "날씨가 화창하니 기분이 참 좋죠?\n음~ 햇빛도 따뜻하고~\n오늘 같은 중요한! 기념일에 꼭 어울리는 날씨네요~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033002))  -- "제 남편 카바에게 기념일에 걸맞은 선물을 하고 싶은데,\n무엇을 하면 좋을까요?"
    end

end


if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033003))  -- "무슨 기념일이냐구요? 호호, 말하기 부끄럽지만~\n카바와 함께 춤을 추며 서로를 향한 불타는 마음을\n확인한 지 딱 6200일이 된 날이랍니다~"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880033004))  -- "그이는 참... 정열적이었죠..!\n내 손을 잡고 능숙하게 리드하던 그이의\n날렵한 몸놀림과 녹아내릴 것만 같은 뜨거운 시선!"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(880033005))  -- "으음.. 하지만 너무나 오래된 일이라 더 이상은\n잘 기억이 나질 않네요..\n내가 무슨 옷을 입었더라~~"
    end


        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880033006))  -- "뭔가.. 의상이 화려했던 것만 같은데 말이죠..\n흠~ 대충 이런 의상이려나..?"


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202220)  

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880033007))  -- "아항~ 비슷한 것 같네요~\n이런 드레스를 입고 어떤 춤을 췄던 것 같은데.."

    RequireSceneDanceCorrection()
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033008))  -- "홍홍 기억이 잘 안 나네~\n뭔가 스텝이라도 본다면 기억이 날 것 같은데~"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033009))  -- "아?? 맞아요! 살짝 기억이 났어요!\n원,투, 차차차!~\n둘이서 손을 잡았다 떼고 빙그르르 돌고~"

    GoSceneTown()
    TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612351)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202220)   
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033010))  -- "정말 고마워요! 그때가 생각나서 잠시나마 설레는걸요?\n오늘 카바에게도 그날 우리의 추억을 선물하고 싶어요!\n우리에게 어울리는 커플 의상을 사러 가야겠네요!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    -- 퀘스트 인트로
    ScenarioIntroShow(103)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033003))  -- "무슨 기념일이냐구요? 호호, 말하기 부끄럽지만~\n카바와 함께 춤을 추며 서로를 향한 불타는 마음을\n확인한 지 딱 6200일이 된 날이랍니다~"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_004", STR_QUEST_TEXT(880033004))  -- "그이는 참... 정열적이었죠..!\n내 손을 잡고 능숙하게 리드하던 그이의\n날렵한 몸놀림과 녹아내릴 것만 같은 뜨거운 시선!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(880033005))  -- "으음.. 하지만 너무나 오래된 일이라 더 이상은\n잘 기억이 나질 않네요..\n내가 무슨 옷을 입었더라~~"

    --[[
    if CheckQuestStart() then
    else
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033006))  -- "뭔가.. 의상이 화려했던 것만 같은데 말이죠..\n흠~ 대충 이런 의상이려나..?"
    end
    ]]--

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612351, 0)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033008))  -- "홍홍 기억이 잘 안 나네~\n뭔가 스텝이라도 본다면 기억이 날 것 같은데~"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033009))  -- "아?? 맞아요! 살짝 기억이 났어요!\n원,투, 차차차!~\n둘이서 손을 잡았다 떼고 빙그르르 돌고~"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880033010))  -- "정말 고마워요! 그때가 생각나서 잠시나마 설레는걸요?\n오늘 카바에게도 그날 우리의 추억을 선물하고 싶어요!\n우리에게 어울리는 커플 의상을 사러 가야겠네요!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(880033011))  -- "전 그날 입었던 의상을 생각하며 기억을 떠올리거든요~\n이런~ 지금은 아~무 생각도 안 나네요~"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880033012))   -- "아이 참~\n[nickname]님 덕분에 답답해지기만 했네요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612351, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

