-- 쉬운 춤(880042) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"

    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"

    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then

        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"
        PushPopupTownNpcWithSelectBox(112)

    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042001))  -- "어! 춤 잘 추는 분이다!\n헤헤! 안녕하세요?\n만나게 되면 하고 싶은 말이 있었어요!"

    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042002))  -- "저도 커서 카바 아저씨처럼\n춤 잘 추는 어른이 될 거예요!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042003))  -- "그런데... 왜 이렇게 몸이 말을 안 듣는 건지.. 힝...\n...여기 조금만 움직여 주시면 안 돼요?"
    end


        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042004))  -- "별다른 준비하실 필요 없어요!"

    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042005))  -- "어서 알려주세요~~"

    RequireSceneDanceCorrection()
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042006))  -- "음.. 제가 생각하는 동작이 있어요!\n자세를 그대로 맞춰주시면 돼요!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042007))  -- "맞아요! 이게 내가 생각했던 동작이에요!\n해파리를 보고 영감을 받았죠!\n멋지죠? 헤헤."

    GoSceneTown()
    TownCharacterSetDanceIdle(TownCharacterAddNPC(112), 612355)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042008))  -- "도와줘서 고마워요!\n저도 꼭 [nickname] 님처럼 실력 있는 춤꾼이 될게요!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()

end

-- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    ScenarioIntroShow(112)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042002))  -- "저도 커서 카바 아저씨처럼\n춤 잘 추는 어른이 될 거예요!"
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042003))  -- "그런데... 왜 이렇게 몸이 말을 안 듣는 건지.. 힝...\n...여기 조금만 움직여 주시면 안 돼요?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612355, 0)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042006))  -- "음.. 제가 생각하는 동작이 있어요!\n자세를 그대로 맞춰주시면 돼요!"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042007))  -- "맞아요! 이게 내가 생각했던 동작이에요!\n해파리를 보고 영감을 받았죠!\n멋지죠? 헤헤."
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042008))  -- "도와줘서 고마워요!\n저도 꼭 [nickname] 님처럼 실력 있는 춤꾼이 될게요!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then

    -- DialogOpen(112, "몸이 뻣뻣한 아이", "Characters/npc_006", "(없음)")
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880042009))  -- "앗..! 이럴 수가..\n추, 충격적이네요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612355, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

