-- 창작의 고통(880043) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043001))  -- "혹시, 음악을 제작하는 법이 어렵지 않나?\n그 고통.. 나도 이해한다네."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043002))  -- "나도 음악에 맞추어 춤을 추는 것은 자신 있지만\n나를 위한 음악을 내가 직접 만들 때는 많이 헤맨다네."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043003))  -- "항상 창작의 늪에서 빠져 고뇌하다가,\n내 자랑스러운 딸, 아리에게 도움을 받곤 하지. 후후..\n아리에게 기초적인 것은 다 배웠으니, 내가 도와주겠네!"
    end


        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043004))  -- "이것만 있으면 무난하게 완성되더군!"

    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880043005))  -- "오! 준비했군!\n음악을 만들러 가보지!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043006))  -- "음악 제작이 생각보다 어렵지 않다네~\n테두리가 빛나는 노트만 톡, 톡 찍고,\n좌, 우로 슥~슥~ 음의 높이만 맞추면 되니 말일세!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880043007))  -- "아! 그리고, 음 높이를 설정하면  음의 길이와 음의 크기도 한번 설정해보게나!  사소한 차이로 음악의 느낌이 훨씬 풍부해진다는군!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043008))  -- "노트들 왼쪽의 음 높이 아이콘 밑에 있는 '음 길이 아이콘'이나 '음 크기 아이콘'을 누른 후에  또 좌,우로 슥 슥~ 설정하면 된다네. 어서 해보게."
    RequireMusicFollowButton()
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043009))  -- "하하, 어떤가.\n음악을 만든다는 것이 이토록 간단하다니, 놀랍지?"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629005)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880043010))  -- "또 무언가 자네에게 일이 생긴 것 같으면\n찾아오겠네!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043011))  -- "재촉하지 않을 테니 천천히 준비하게나."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880043012))  -- "아니!? 자네 지금 나와 내 딸 아리를 무시하는 건가?\n기분이 나쁘군!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end





-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(101)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()


         DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880043002))  -- "나도 음악에 맞추어 춤을 추는 것은 자신 있지만\n나를 위한 음악을 내가 직접 만들 때는 많이 헤맨다네."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043003))  -- "항상 창작의 늪에서 빠져 고뇌하다가,\n내 자랑스러운 딸, 아리에게 도움을 받곤 하지. 후후..\n아리에게 기초적인 것은 다 배웠으니, 내가 도와주겠네!"
 
    --[[
    if CheckQuestStart() then
    else
         DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043004))  -- "이것만 있으면 무난하게 완성되더군!"
         
    end

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880043005))  -- "오! 준비했군!\n음악을 만들러 가보지!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043006))  -- "음악 제작이 생각보다 어렵지 않다네~\n테두리가 빛나는 노트만 톡, 톡 찍고,\n좌, 우로 슥~슥~ 음의 높이만 맞추면 되니 말일세!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880043007))  -- "아! 그리고, 음 높이를 설정하면  음의 길이와 음의 크기도 한번 설정해보게나!  사소한 차이로 음악의 느낌이 훨씬 풍부해진다는군!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043008))  -- "노트들 왼쪽의 음 높이 아이콘 밑에 있는 '음 길이 아이콘'이나 '음 크기 아이콘'을 누른 후에  또 좌,우로 슥 슥~ 설정하면 된다네. 어서 해보게."
    RequireMusicFollowButton()
    
      DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880043009))  -- "하하, 어떤가.\n음악을 만든다는 것이 이토록 간단하다니, 놀랍지?"
      
      Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880043010))  -- "또 무언가 자네에게 일이 생긴 것 같으면\n찾아오겠네!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end

