-- 짝꿍이 되어줘(880051) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))

    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()

          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
        PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
    end
    

elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
        PushPopupTownNpcWithSelectBox(127)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(127)) then
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))

    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
        PushPopupTownNpcWithSelectBox(127)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(127)) then
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051001))  -- "아 왜 내 짝은 춤을 못 추는 거야?\n속상해 정말!"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad()  -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
          -- 퀘스트 인트로
        ScenarioIntroShow(127)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051002))  --   -- "학교에서 짝꿍이랑 같이 춤을 추라고 했거든요?\n근데 짝꿍이 몸이 아주 뻣뻣해요!"
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051003))  -- "그리고 심지어 심각한 박치라고요!\n저 혼자 추는 게 더 나을 것 같은 느낌.."
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051004))  --   -- "걔가 앞에 앉아서 고개를 슬쩍 슬쩍하면,\n제가 뒤에서 그에 맞춰 쳐다보면 되는데.."
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051005))  -- "박자를 자꾸 틀리더라구요!\n에휴 속터져...\n[nickname]님이 한번 해보실래요?"
    end
    

        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051006))  -- "일단 이렇게 입어야 해요."

    
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    
    TownCharacterWearClothes(TownCharacterGetNPC(127), 202321)
    TownCharacterWearClothes(TownCharacterGetNPC(127), 201217)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203066)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201207)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202301)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 가만히 있기

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051007))  -- "앗, 입고 오셨네요?!\n저도 입고 왔어요!!\n알려드릴게요."
    
    RequireSceneDanceCorrection()
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051008))  -- "앉아있다가 천천히 일어나서\n덩실덩실 춤추는 거예요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051009))  -- "맞아요! 이거에요!"
    
    GoSceneTown()
    
    TownCharacterStandAt(TownCharacterGetNPC(127), 0*40, 40*40)
    TownCharacterStandAt(TownCharacterGetNPC(1), 0*40, 39*40)
    TownCameraZoomIn(TownCharacterGetNPC(127), 0*40, 0*40, 2.0)

    TownCharacterWearClothes(TownCharacterGetNPC(127), 202321)  --남자한복
    TownCharacterWearClothes(TownCharacterGetNPC(127), 201217)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203066)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201207)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202301)
    TownCharacterActionByID(TownCharacterGetNPC(127), 612671)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051010))  -- "이거야 이거!\n이렇게 하는 건데,\n왜 못하는 걸까요?"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051011))  -- "휴.. 그래도 제대로 해보니\n속이 다 시원하네요.\n내 짝도 좀 이렇게 해야할텐데.."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
      -- GoTown()

end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(127)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051002))  --   -- "학교에서 짝꿍이랑 같이 춤을 추라고 했거든요?\n근데 짝꿍이 몸이 아주 뻣뻣해요!"
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051003))  -- "그리고 심지어 심각한 박치라고요!\n저 혼자 추는 게 더 나을 것 같은 느낌.."
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051004))  --   -- "걔가 앞에 앉아서 고개를 슬쩍 슬쩍하면,\n제가 뒤에서 그에 맞춰 쳐다보면 되는데.."
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051005))  -- "박자를 자꾸 틀리더라구요!\n에휴 속터져...\n[nickname]님이 한번 해보실래요?"
    
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051006))  -- "일단 이렇게 입어야 해요."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612670, 0)
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051008))  -- "앉아있다가 천천히 일어나서\n덩실덩실 춤추는 거예요~"
   
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051009))  -- "맞아요! 이거에요!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051012))  -- "응? 아직 그대로시네요?\n역할에 맞는 옷이 있어야 한다구요."
    GoTown()
    
end

if OnQuestGiveUp() then

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880051013))  -- "아~ 정말~\n답답해라~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612670, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
