-- 장신구만 잘 착용해도(880052) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
    end
    

elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052001))  -- "[nickname]님! 재미있는 생각이 났어요!\n들어보실래요!?"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052002))  --   -- "심부름 다녀오다가, 마을의 어떤 할아버지가\n웬 이상한 가면을 쓰고 춤을 추시는 걸 봤어요!\n그리고 저는 깨달았죠!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052003))  --   -- "아! 간단한 동작이라도\n뭔가를 머리에 쓰거나 손에 들면\n굉장히 재미있어질 수 있구나!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052004))  -- "그래서요, [nickname]님!\n긴 천이 달린 모자를 쓰는 거예요!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052005))  -- "그리고 고개를 이리저리 흔들면\n천이 빙글 빙글 돌아가겠죠!?"
    end
    
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052006))  -- "마침 이런 모자가 옷 가게에 있는 거 봤어요!"
    
    PushPopupCollectionNeed()
    
end


if OnClickCollectionQuestPopupOk() then
    
    SetCostumeCollectionNeeds()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052007))  -- "와~~ 오셨다!\n기다리고 있었어요!"
    
    RequireSceneDanceCorrection()
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052008))  -- "그냥 고개만 돌리면 심심하니까,\n손뼉이라도 쳐볼까요?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052009))  -- "와~~ 보기만 해도 되게 신나요!"
    
    GoSceneTown()
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201201)
    TownCharacterActionByID(TownCharacterGetNPC(113), 612606)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201201)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052010))  -- "재밌죠!?\n음.. 뭔가 더 응용하면\n재밌는 게 많을 것 같은데...\n지금은 더 생각이 안 나네요, 헤헤."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052011))  -- "좀 더 생각해서 다음에 올게요!\n같이 해주셔서 감사해요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(113)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052002))  --   -- "심부름 다녀오다가, 마을의 어떤 할아버지가\n웬 이상한 가면을 쓰고 춤을 추시는 걸 봤어요!\n그리고 저는 깨달았죠!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052003))  --   -- "아! 간단한 동작이라도\n뭔가를 머리에 쓰거나 손에 들면\n굉장히 재미있어질 수 있구나!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052004))  -- "그래서요, [nickname]님!\n긴 천이 달린 모자를 쓰는 거예요!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052005))  -- "그리고 고개를 이리저리 흔들면\n천이 빙글 빙글 돌아가겠죠!?"
    
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052006))  -- "마침 이런 모자가 옷 가게에 있는 거 봤어요!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612606, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052008))  -- "그냥 고개만 돌리면 심심하니까,\n손뼉이라도 쳐볼까요?"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052009))  -- "와~~ 보기만 해도 되게 신나요!"
    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052012))  -- "응? 모자를 가져오셔야죠!"
    GoTown()
    
end

if OnQuestGiveUp() then

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880052013))  -- "잉.. 관심 없으시다구요?\n알겠어요.. 혼자 해볼게요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612606, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

