-- 내 박자와 한몸이 되어(880054) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))

    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()

          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
        PushPopupTownNpcWithSelectBox(129)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
    end
    

elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
        PushPopupTownNpcWithSelectBox(129)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054001))  -- "자네, 악기를 두드리며 춤춰본 적이 있나?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054002))  --   -- "악기를 손에 들거나 허리춤에 차서\n직접 두드리며 춤을 추면,\n그냥 춤을 출 때보다 훨씬 더 흥이 난다네."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054003))  --   -- "내가 두드리는 박자에 맞춰 춤을 추니,\n그 어떤 춤이더라도 흥겹기 마련이지.\n어떤가. 자네도 한번 춰보지 않겠나?"
    end
    

        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054004))  -- "허리춤에 악기가 달린 의상과\n악기를 두드릴 손 장식을 가지고 오시게나."

    
    PushPopupCollectionNeed()
    
end

if OnClickCollectionQuestPopupOk() then
    
    SetCostumeCollectionNeeds()

    TownCharacterWearClothes(TownCharacterGetNPC(1), 202292)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205151)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054005))  -- "오, 준비해왔군."
    
    RequireSceneDanceCorrection()
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054006))  -- "다리와 손을 빠르게 놀려보는 걸세."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054007))  -- "오오, 잘하는구먼.\n어떤가. 그럴싸하지?"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202292)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205151)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054008))  -- "보는 나까지 흥겨워지는 구먼. 허허."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
      -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(129)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054002))  --   -- "악기를 손에 들거나 허리춤에 차서\n직접 두드리며 춤을 추면,\n그냥 춤을 출 때보다 훨씬 더 흥이 난다네."
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054003))  --   -- "내가 두드리는 박자에 맞춰 춤을 추니,\n그 어떤 춤이더라도 흥겹기 마련이지.\n어떤가. 자네도 한번 춰보지 않겠나?"
    
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054004))  -- "허리춤에 악기가 달린 의상과\n악기를 두드릴 손 장식을 가지고 오시게나."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612618, 0)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054006))  -- "다리와 손을 빠르게 놀려보는 걸세."

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054007))  -- "오오, 잘하는구먼.\n어떤가. 그럴싸하지?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054009))  -- "악기가 없으면 이번에 알려줄 춤이\n무의미할 것 같네만.."
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880054010))  -- "저런..\n악기를 두드리면서도 활용한다는 것을\n알려주고 싶었네만.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612618, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

