-- 흥겨운 장단(880055)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055001))   -- "히잉... 어렵다 어려워...."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055002))  -- "학교에서 짝이랑 무슨 춤을 추라고\n했는데 약간 어렵네요..."
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055003))  -- "쉬운 장단이 있다면 좀 더 춤을 쉽게 익힐 수 있을 것 같아요..!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055004))              -- "[nickname]님이 춤 박자에 맞는 간단한 장단을\n좀 알려주시겠어요?"
    end


        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055005))   -- "움...\n장단은 이 악기로 맞추는 게\n쉬울 것 같아요!"

    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055006))  -- "네네! 이 악기요!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055007))  -- "대충.. 이런 박자였어요!"
    RequireMusicFollowButton()
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055008))   -- "앗, [nickname]님이 연주하시니까\n뭔가 귀에 쏙 쏙 박히고\n왠지 박자감이 잘 느껴지는 느낌?"

    GoSceneTown()
    SoundPlay(music_id)
    --SoundPlayMusicData(629007)

    TownCharacterSetDanceIdle(TownCharacterAddNPC(112), 612670)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055009))   -- "우와! 고마워요, [nickname]님!\n흥겨워서 춤이 저절로 막 춰져요!\n역시 [nickname]님은 대단해요!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055010))   -- "[nickname]님, 악기가 없으면 장단을\n만들어 볼 수 없을 것 같아요.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055011))  -- "힝.. 큰일 났다..\n짝꿍한테 또 혼나겠네.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end






-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(112)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055002))  -- "학교에서 짝이랑 무슨 춤을 추라고\n했는데 약간 어렵네요..."
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055003))  -- "쉬운 장단이 있다면 좀 더 춤을 쉽게 익힐 수 있을 것 같아요..!"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055004))              -- "[nickname]님이 춤 박자에 맞는 간단한 장단을\n좀 알려주시겠어요?"
        
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055005))   -- "움...\n장단은 이 악기로 맞추는 게\n쉬울 것 같아요!"
         
    end

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055006))  -- "네네! 이 악기요!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055007))  -- "대충.. 이런 박자였어요!"
    RequireMusicFollowButton()
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055008))   -- "앗, [nickname]님이 연주하시니까\n뭔가 귀에 쏙 쏙 박히고\n왠지 박자감이 잘 느껴지는 느낌?"
      
      Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880055009))   -- "우와! 고마워요, [nickname]님!\n흥겨워서 춤이 저절로 막 춰져요!\n역시 [nickname]님은 대단해요!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


