-- 시선을 사로잡는 화려함(880062) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062001))  -- "아름다운 손 장식을 사용해서 추는 춤으로\n사람들의 시선을 사로잡을 수 있을 것 같은데.."
        PushPopupTownNpcWithSelectBox(103)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062002))  -- "아름다운 손 장식을 사용해서 추는 춤으로 사람들의 시선을 사로잡을 수 있을 것 같은데.."
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062002))  -- "아름다운 손 장식을 사용해서 추는 춤으로 사람들의 시선을 사로잡을 수 있을 것 같은데.."
        PushPopupTownNpcWithSelectBox(103)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062002))  -- "아름다운 손 장식을 사용해서 추는 춤으로 사람들의 시선을 사로잡을 수 있을 것 같은데.."
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062002))  -- "아름다운 손 장식을 사용해서 추는 춤으로 사람들의 시선을 사로잡을 수 있을 것 같은데.."
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062002))  -- "아름다운 손 장식을 사용해서 추는 춤으로 사람들의 시선을 사로잡을 수 있을 것 같은데.."
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062003))  --   -- "춤출 때 의상도 중요하지만,\n손에 적당한 장신구를 들고 춤을 추면\n춤이 한층 더 화려해지는 걸 아나요?"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880062004))  -- "여러 뮤비 중에 단연 눈에 띌지도?\n네~? 못 믿겠다고요~?"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062005))  --   -- "그러지 말고 한번 제 말을 믿어보세요~\n제가 눈에 띄는 춤을 알려드릴 테니까요!"
    end
    

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062006))  -- "화려하죠?\n이 장신구면 적당하겠네요!"

    
    PushPopupCollectionNeed()
    
end


if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205153)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062007))  -- "호호, 잘 가져왔어요."
    
    RequireSceneDanceCorrection()
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062008))  -- "분명 눈에 띌 꺼예요!\n나를 믿어봐요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062009))  -- "어때요!\n이 동작에 아까 그 부채만 든다면,\n무척 화려할 거예요!"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205153)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062010))  -- "어머~~\n너무 예쁘다~\n거봐요~ 제 말이 맞죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062011))  -- "후훗, 제 말을 믿고\n끝까지 따라줘서 고마워요~\n나도 사러 가야겠다~~"
    
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(103)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062003))  --   -- "춤출 때 의상도 중요하지만,\n손에 적당한 장신구를 들고 춤을 추면\n춤이 한층 더 화려해지는 걸 아나요?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880062004))  -- "여러 뮤비 중에 단연 눈에 띌지도?\n네~? 못 믿겠다고요~?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062005))  --   -- "그러지 말고 한번 제 말을 믿어보세요~\n제가 눈에 띄는 춤을 알려드릴 테니까요!"
    
      --[[
    if CheckQuestStart() then
    else
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062006))  -- "화려하죠?\n이 장신구면 적당하겠네요!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612610, 0)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880062008))  -- "분명 눈에 띌 꺼예요!\n나를 믿어봐요~"
          
	-- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880062009))  -- "어때요!\n이 동작에 아까 그 부채만 든다면,\n무척 화려할 거예요!"
    SetCollectionData()

    
    ScenarioEndingShow()
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_007", STR_QUEST_TEXT(880062012))  -- "음.. 평범한 걸론\n눈에 잘 띄지 않을 거예요.."
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(880062013))  -- "아앗?\n저를 못 믿는 건가요?\n너무해..!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612610, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

