-- 빙글 빙글 우산 돌리기(880063) 제작 퀘스트
-- version("0.31.00")

if CheckQuestAppear() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
        PushPopupTownNpcWithSelectBox(162)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(162)) then
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
    end
    
    
    elseif CheckQuestRunning() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))
        
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
        PushPopupTownNpcWithSelectBox(162)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(162)) then

        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
    end
    
    elseif CheckQuestComplete() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(162))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(162))
        TownCharacterSetQuest(TownCharacterGetNPC(162))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(162)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(162))

        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
        PushPopupTownNpcWithSelectBox(162)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(162)) then

        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063001))  -- "옷가게에 화려한 우산이 있더라공.\n우산을 빙빙 돌리는 춤이 생각났는뎅. 볼랭?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad()  -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(162)

        TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
        TownCharacterActionByID(TownCharacterAddNPC(162), 612607)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063002))  --  -- "나 꽤 잘하는 것 같징?\n사람들을 모아두고 우산 춤을 춰볼까행.\n여러 명이서 춰도 멋질 거양."
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063003))  --  -- "[nickname]씨도 함께 해보지 않을랭?\n생각보다 쉬웡.\n그냥 부드럽게 빙빙 돌리면 된다궁~"
    end

        TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
        DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063004))  -- "가서 나랑 같은 우산을 좀 가져와볼랭?"
    
    PushPopupCollectionNeed()
    
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205155)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063005))  -- "오옹 맞앙. 이 우산이양."
    
    RequireSceneDanceCorrection()
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063006))  -- "손동작을 유연하게 해야 행~"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063007))  -- "그랭 맞앙! 이거양!"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205155)
    TownCharacterActionByID(TownCharacterAddNPC(162), 612607)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063008))  -- "재밌징~~~\n역시 손에 뭔가 들고 추는 춤이\n재밌는 것 같앙~~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

-- 춤 편집
if OnClickCollectionEdit() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    -- 퀘스트 인트로
    ScenarioIntroShow(162)
    
    
    TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
    TownCharacterActionByID(TownCharacterAddNPC(162), 612607)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063002))  --  -- "나 꽤 잘하는 것 같징?\n사람들을 모아두고 우산 춤을 춰볼까행.\n여러 명이서 춰도 멋질 거양."
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063003))  --  -- "[nickname]씨도 함께 해보지 않을랭?\n생각보다 쉬웡.\n그냥 부드럽게 빙빙 돌리면 된다궁~"
    
    --[[
     if CheckQuestStart() then
     else
     
     TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
     DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063004))  -- "가서 나랑 같은 우산을 좀 가져와볼랭?"
     end
     ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612607, 0)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063006))  -- "손동작을 유연하게 해야 행~"

    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063007))  -- "그랭 맞앙! 이거양!"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063009))  -- "안됑. 우산이 없잖앙."
    GoTown()
    
end



if OnQuestGiveUp() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(162), 205155)
    DialogOpen(162, STR_NPC(162), "Characters/npc_mustchemaster_001", STR_QUEST_TEXT(880063010))  -- "으응??\n[nickname]씨, 관심이 없는 거양??"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612607, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
