-- 강렬하고도 화려한 무예(880064) 제작 퀘스트
-- version("0.50.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
        PushPopupTownNpcWithSelectBox(130)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
    end
    
    
    elseif CheckQuestRunning() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
        PushPopupTownNpcWithSelectBox(130)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
    end
    
    elseif CheckQuestComplete() then
    
    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(130))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(130))
        TownCharacterSetQuest(TownCharacterGetNPC(130))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(130)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(130))
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
        PushPopupTownNpcWithSelectBox(130)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(130)) then
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064001))  -- "흠흠. 제 특기가 있는데..\n한번 들어보실래요?"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(130)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064002))  -- "[nickname]님은 특기가 있나요?\n뭐.. 잘 추는 춤이라던지?\n특별히 잘 하는 동작이 있다던지?"
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064003))  -- "저는... 긴 장검을 들고 춤을 추는,\n'검무'를 잘 춘답니다!\n검무라니, 왠지 멋있죠?"
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064004))  -- "검무는 말이죠!\n우주의 변화 원리를 몸과 마음에 적용해\n단전에서 발현되는 '기 에너지'를,"
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064005))  --  -- "빠르고 느리게 또, 매우 무겁거나\n가볍게 표현한답니다!\n재밌을 것 같지 않나요? "
        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064006))  -- "혹시 흥미가 생기셨다면, 배워보실래요?\n제가 일부 동작을 알려드릴게요!\n걱정마세요~ 위험하지 않으니까요~"
        
    end
    

        DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064007))  -- "검무를 추려면 검이 있어야겠죠?\n장검 한 자루를 가져오세요!"

    
    PushPopupCollectionNeed()
    
end


if OnClickCollectionQuestPopupOk() then
    
    SetCostumeCollectionNeeds()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205154)
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064008))  -- "가져오셨군요!\n그렇게 위험하지는 않지만..\n휘두르지는 마세요."
    
    RequireSceneDanceCorrection()
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064009))  -- "역동과 정지의 원리로 표현해보는 거예요!"
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064010))  -- "처음이신데, 자세가 제법 그럴듯한데요?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205154)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064011))  -- "잘 하셨어요!\n좀 더 다양한 동작을 연습하시면\n충분히 더 멋진 춤을 만드실 것 같네요! "
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064012))  -- "아, 다치지 않게 주의하시구요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

-- 춤 편집
if OnClickCollectionEdit() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    
    -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    -- 퀘스트 인트로
    ScenarioIntroShow(130)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064002))  -- "[nickname]님은 특기가 있나요?\n뭐.. 잘 추는 춤이라던지?\n특별히 잘 하는 동작이 있다던지?"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064003))  --  -- "저는... 긴 장검을 들고 춤을 추는,\n'검무'를 잘 춘답니다!\n검무라니, 왠지 멋있죠?"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064004))  -- "검무는 말이죠!\n우주의 변화 원리를 몸과 마음에 적용해\n단전에서 발현되는 '기 에너지'를,"
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064005))  -- "빠르고 느리게 또, 매우 무겁거나\n가볍게 표현한답니다!\n재밌을 것 같지 않나요? "
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064006))  -- "혹시 흥미가 생기셨다면, 배워보실래요?\n제가 일부 동작을 알려드릴게요!\n걱정마세요~ 위험하지 않으니까요~"
    
    --[[
     if CheckQuestStart() then
     else
     DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064007))  -- "검무를 추려면 검이 있어야겠죠?\n장검 한 자루를 가져오세요!"
     end
     ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612616, 0)
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064009))  -- "역동과 정지의 원리로 표현해보는 거예요!"
    
    -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
    -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064010))  -- "처음이신데, 자세가 제법 그럴듯한데요?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064013))  -- "검을 잡아봐야 그 감을 익힐 수 있겠죠?"
    GoTown()
    
end


if OnQuestGiveUp() then
    
    DialogOpen(130, STR_NPC(130), "Characters/npc_010", STR_QUEST_TEXT(880064014))  -- "앗.. 생각보다 위험하지 않은데.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612616, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

