-- 최신 유행가(880072)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
                DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
              DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
              DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
               DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072001))    -- "[nickname]님 그 음악 아세요?\n요새 엄청 유행하는 그 음악이오!\n저도 부르고 싶은데... 좀 알려주시면 안 돼요?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)
        
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072002))   -- "그.. 음은 기억나요!\n이런 음이었어요.\n한번 들어보실래요?"
    end

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072003))   -- "이 악기가 필요해요!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072004))   -- "앗, 가져오셨군요!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072005))  -- "이런 음이에요!"
    RequireMusicFollowButton()

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072006))   -- "어 맞아요, 이 음악이에요!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629035)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072007))   -- "우왕! 고마워요 [nickname]님!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072008))   -- "음. 아직 준비가 안되셨네요..\n기다릴게요~"
    GoTown()

end


if OnQuestGiveUp() then

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072009))  -- "엣? 곤란하시다구요?\n힝.. 알겠어요.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end






-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(112)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072002))   -- "그.. 음은 기억나요!\n이런 음이었어요.\n한번 들어보실래요?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072003))   -- "이 악기가 필요해요!"
         
    end

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072004))   -- "앗, 가져오셨군요!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072005))  -- "이런 음이에요!"
    RequireMusicFollowButton()
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072006))   -- "어 맞아요, 이 음악이에요!"
      
      Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880072007))   -- "우왕! 고마워요 [nickname]님!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


