-- 너무도 유명한 춤(880073) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
                DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
          DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
        PushPopupTownNpcWithSelectBox(101)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073001))  -- "댄스빌에서 유명한 춤이 있지.\n바로 내가 만들어낸."
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)

        TownCharacterSetDanceIdle(TownCharacterAddNPC(101), 612669)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073002))  --   -- "어떤가! 정말 재미있어 보이지?\n이 춤을 추고 댄스비전에 뮤직비디오를\n찍어 올렸더니, 금세 유행이 되었다네!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073003))  -- "카, 카, 카, 카, 카바 스타일~\n자네도 한번 춰보지 않겠나?"
    end

	DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880073004))  -- "선글라스를 착용하면 더 멋있다네!"
    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then
    
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203702)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880073005))  -- "음, 완벽하군."
    
    RequireSceneDanceCorrection()
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073006))  -- "이 춤이 왜 유행하게 되었는지\n한번 자네가 직접 춰 보세나!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073007))  -- "정말 쉽고 신나는 춤이지?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203702)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(101), 203702)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(101), 612669)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_003", STR_QUEST_TEXT(880073008))  -- "유행하는 춤은, 다 이유가 있다네.\n쉽고, 특이하고, 중독성 있어야 하지!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073009))  -- "추고, 또 춰도 질리지 않다니!\n하하! 내가 만들었지만\n정말 완벽한 춤이야! 안그런가?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(101)
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(101), 612669)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073002))  --   -- "어떤가! 정말 재미있어 보이지?\n이 춤을 추고 댄스비전에 뮤직비디오를\n찍어 올렸더니, 금세 유행이 되었다네!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073003))  -- "카, 카, 카, 카, 카바 스타일~\n자네도 한번 춰보지 않겠나?"
   
    
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880073004))  -- "선글라스를 착용하면 더 멋있다네!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612669, 0)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880073006))  -- "이 춤이 왜 유행하게 되었는지\n한번 자네가 직접 춰 보세나!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_008", STR_QUEST_TEXT(880073007))  -- "정말 쉽고 신나는 춤이지?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880073010))  -- "잠시.. 준비가 아직 덜 된 것 같네만."
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004", STR_QUEST_TEXT(880073011))  -- "아, 지금은 좀 바쁜가?\n아쉽군. 춰보면 정말 재미있을 텐데."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612669, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
