-- 유행은 돌고 돌아(880074) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
        PushPopupTownNpcWithSelectBox(126)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(126)) then
            
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
                
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
            
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074001))  -- "요새 제일 핫한 아이돌 그룹이 누구게요~?"
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(126)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074002))  --   -- "뭐죠, 마치 '무슨 소리냐'는 그 표정은? \n헛. 설마 댄스빌에서 가장 유명한\n아이돌 그룹을 모르는 거예요!?"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074003))  -- "으아.. '아이티즈'를 모른다구요!?\n맙소사.... 아주 트렌드랑은 담을 쌓았군요?..."
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074004))  -- "엄청 멋지고 예쁜 춤요정들로 이루어진\n3인조 혼성 댄스 그룹인데..\n가디 여왕님의 동생, '구디'님이 리더이고,"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074005))  --   -- "그 외 멤버들로 랩퍼 '디지'와 보컬 '벨리'가 있죠!\n그들은 '복고 댄스'를 춰서 유명해졌어요~"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074006))  -- "그들 덕분에 복고 댄스가 다시 재유행인...데...\n....안되겠네~ 제가 좀 알려줄게요!"
        
    end
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074007))  -- "이건 그들이 자주 입는 옷이에요!\n철 지난 것 같지만, 최신 유행이죠!\n어서 입어보세요~"

    
    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then
    
    SetCostumeCollectionNeeds()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202308)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074008))  -- "후훗. 이거에요. 이거."
    
    RequireSceneDanceCorrection()
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074009))  -- "팔 동작이 좀 복잡하니 잘 보세요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074010))  -- "생각보다 잘 하시는데요?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202308)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612536)
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074011))  -- "이 춤으로 전 국민을 사로잡았어요~\n정말 중독성 있죠?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(126)
    
            TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074002))  --   -- "뭐죠, 마치 '무슨 소리냐'는 그 표정은? \n헛. 설마 댄스빌에서 가장 유명한\n아이돌 그룹을 모르는 거예요!?"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074003))  -- "으아.. '아이티즈'를 모른다구요!?\n맙소사.... 아주 트렌드랑은 담을 쌓았군요?..."
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074004))  -- "엄청 멋지고 예쁜 춤요정들로 이루어진\n3인조 혼성 댄스 그룹인데..\n가디 여왕님의 동생, '구디'님이 리더이고,"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074005))  --   -- "그 외 멤버들로 랩퍼 '디지'와 보컬 '벨리'가 있죠!\n그들은 '복고 댄스'를 춰서 유명해졌어요~"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074006))  -- "그들 덕분에 복고 댄스가 다시 재유행인...데...\n....안되겠네~ 제가 좀 알려줄게요!"
    
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074007))  -- "이건 그들이 자주 입는 옷이에요!\n철 지난 것 같지만, 최신 유행이죠!\n어서 입어보세요~"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612536, 0)
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074009))  -- "팔 동작이 좀 복잡하니 잘 보세요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074010))  -- "생각보다 잘 하시는데요?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074012))  -- "요새 핫한 의상이라구요~\n트렌드를 따라야죠~"
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880074013))  -- "... [nickname]님은\n관심이 없는 게 참 많네요?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612536, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end







