-- 헤드 스핀(880081) 제작 퀘스트
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
        PushPopupTownNpcWithSelectBox(158)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081001))  -- "내가 젊었을 땐, 땅에 머리 대고 돌고\n아주 난리도 아니었다니까. 하하!"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(158)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081002))  -- "팽이처럼 빙글 빙글 몇 시간이고\n지치지 않고 돌던 때가 그립군...."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081003))  -- "빙글 빙글 돌면서 잠도 잤다구 하하!\n물론, 믿거나 말거나지만."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081004))  -- "자네가 나대신 한번 해볼 텐가?\n물론, 내가 잘 알려주겠네.\n아! 머리는 걱정 말고. 다치지는 않네 하하!"
    end
    
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081005))  -- "정 그렇게 머리가 다칠게 걱정이라면\n이 헬멧을 준비하는 건 어떤가?\n신경 안 쓰고 열심히 돌릴 수 있을 거라고."

    
    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then
    
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201216)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081006))  -- "헤드 스핀 하기 딱 좋아 보이는군!"
    
    RequireSceneDanceCorrection()
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081007))  -- "머리와 몸의 기울기를 돌려 뒤집고\n'뒤돌기'를 이용해 빙글 빙글 도는 거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081008))  -- "한번 그렇게 뒤집은 후, 이후의 프레임들은\n복사-붙여넣기 하면 쉽지!"  
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081009))  -- "너무 긴장하지 말라고~\n그냥 몸과 머리를 뒤집는 게 다인 걸, 하하.\n한번 해봐."  
    
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081010))  -- "어때?\n너무 쉬워서 말문이 막히지?"
    
    GoSceneTown()
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201216)
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081011))  -- "이야~ 잘도는 걸?\n근데 너무 오래 돌면 속이 안 좋을 테니\n적당히 돌라고~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(158)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081002))  -- "팽이처럼 빙글 빙글 몇 시간이고\n지치지 않고 돌던 때가 그립군...."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081003))  -- "빙글 빙글 돌면서 잠도 잤다구 하하!\n물론, 믿거나 말거나지만."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081004))  -- "자네가 나대신 한번 해볼 텐가?\n물론, 내가 잘 알려주겠네.\n아! 머리는 걱정 말고. 다치지는 않네 하하!"

    
     --[[
    if CheckQuestStart() then
    else
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081005))  -- "정 그렇게 머리가 다칠게 걱정이라면\n이 헬멧을 준비하는 건 어떤가?\n신경 안 쓰고 열심히 돌릴 수 있을 거라고."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612522, 0)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081007))  -- "머리와 몸의 기울기를 돌려 뒤집고\n'뒤돌기'를 이용해 빙글 빙글 도는 거야."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081008))  -- "한번 그렇게 뒤집은 후, 이후의 프레임들은\n복사-붙여넣기 하면 쉽지!"  
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081009))  -- "너무 긴장하지 말라고~\n그냥 몸과 머리를 뒤집는 게 다인 걸, 하하.\n한번 해봐."  

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081010))  -- "어때?\n너무 쉬워서 말문이 막히지?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081012))  -- "뭐. 첫 시도는 헬멧을 착용하는 것이 좋겠지."
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880081013))  -- "응? 아무래도 머리 다칠까 봐\n두려운가 보군."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612522, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

