-- 멋진 춤을 추고 싶은 이유(880083) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(122))
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
        PushPopupTownNpcWithSelectBox(122)
    end

    if OnClickQuestTab(TownCharacterGetNPC(122)) then
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(122))
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
        PushPopupTownNpcWithSelectBox(122)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(122)) then
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(122))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(122))
        TownCharacterSetQuest(TownCharacterGetNPC(122))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(122)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(122))
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
        PushPopupTownNpcWithSelectBox(122)
    end

    if OnClickQuestTab(TownCharacterGetNPC(122)) then
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083001))  -- "머, 멋진 춤을 알려주시면 안 될까요..?\n아리에게 보여주고 싶어요..."
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(122)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083002))  --   -- "저, 저도 아리 앞에서 멋진 춤을 추고 싶은데..\n어떤 게 멋진 춤인지 모르겠어요..."
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083003))  -- "그, 그래서 말인데, [nickname]님이\n시범을 좀 보여주시겠어요...?\n열심히 따라 할게요..!"

        
    end
    
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083004))  -- "자, 잠시만요.\n짧은 춤 말고, 좀 긴 춤을 추고 싶어요.."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
  
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083005))  -- "저도 준비됐어요!\n그럼 이제.. 어서 보여주세요..!"
    
    RequireSceneDanceCorrection()
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083006))  -- "걱정 마세요..!\n보고, 따라 하는 건... 자신 있어요..!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083007))  -- "음..!! 엄청 파워 넘치네요..!"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(122), "copy")
    TownCharacterAction(TownCharacterGetNPC(1), "copy")    
    
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083008))  -- "어.. 어떤가요?\n저도 멋있나요...?\n아, 아리가 좋아해 줄까요?"
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083009))  -- "아! 어, 어쨌든 제게\n시간 내주셔서 감사합니다..!"
    
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(122)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083002))  --   -- "저, 저도 아리 앞에서 멋진 춤을 추고 싶은데..\n어떤 게 멋진 춤인지 모르겠어요..."
        DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083003))  -- "그, 그래서 말인데, [nickname]님이\n시범을 좀 보여주시겠어요...?\n열심히 따라 할게요..!"

    
     --[[
    if CheckQuestStart() then
    else
     DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083006))  -- "걱정 마세요..!\n보고, 따라 하는 건... 자신 있어요..!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612612, 0)
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083006))  -- "걱정 마세요..!\n보고, 따라 하는 건... 자신 있어요..!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083007))  -- "음..!! 엄청 파워 넘치네요..!"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end



if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083010))  -- "저.. 저는 준비했는데...\n[nickname]님은.. 아직이시네요.."
    GoTown()
    
end

if OnQuestGiveUp() then

    DialogOpen(122, STR_NPC(122), "Characters/npc_018", STR_QUEST_TEXT(880083011))  -- "아앗.. 거절하시다니.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end


-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612612, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

