-- 춤 기술(880092) 제작 퀘스트
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
        PushPopupTownNpcWithSelectBox(158)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(158))
        TownCharacterSetQuest(TownCharacterGetNPC(158))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(158)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(158))
        SoundPlay(71) --=BGM=Character_Dancemasterbgm
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
        PushPopupTownNpcWithSelectBox(158)
    end

    if OnClickQuestTab(TownCharacterGetNPC(158)) then
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092001))  -- "혹시 관절을 힘 있게 툭, 툭\n튕기듯이 추는 춤도 아나?"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(158)

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092002))  --   -- "제자님이 생각하는 그 춤 맞아.\n왜, 요새 마을의 춤바람 난 놈이\n돌아다니며 추는 춤 말이야."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092003))  -- "뭐.. 본인이 춤을 만들었다 하지만\n사실 아니야. 내가 원조라고."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092004))  -- "내가 아주 잠깐 추는 걸 보고\n내 '절도 있게' 기술을 '절도'해간 거지!!\n아주 도둑놈이 따로 없다니까.."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092005))  -- "하지만 '절도 있게' 를 사용한\n완벽한 동작은 아직 터득하지 못했을 거야..\n제자님은 특별히 더 자세히 알려주지."
        
    end
    
 
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092006))  -- "어디 보자...\n내가 알려줄 춤을 추려면...\n이 자격증이 있어야겠군!"

    PushPopupCollectionNeed()

end


if OnClickCollectionQuestPopupOk() then
    
  
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092007))  -- "음, 역시 내 제자님이군.\n갖고 있을 줄 알았지."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092008))  -- "아주 간단한 동작이니, 그리 어렵지는 않을 거라고.\n관절들을 '절도 있게'로 바꾸는 걸 잊지 마."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092009))  -- "어떤가..!\n기술을 사용하니 느낌이 많이 다르지?"
    
    GoSceneTown()
    
    TownCharacterAction(TownCharacterGetNPC(1), "copy")

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092010))  -- "크핫핫!\n역시 내 제자님이야.\n습득하는 속도가 남다르다니까."
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092011))  -- "만들고자 하는 춤의 느낌을 잘 생각해서\n적절한 기술을 사용한다면, 그루브가 살아있는\n멋진 춤을 출 수 있다는 거. 알겠지?"
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092012))  -- "춤 바람난 놈보다 더 멋진 춤을\n추도록 해봐!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(158)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092002))  --   -- "제자님이 생각하는 그 춤 맞아.\n왜, 요새 마을의 춤바람 난 놈이\n돌아다니며 추는 춤 말이야."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092003))  -- "뭐.. 본인이 춤을 만들었다 하지만\n사실 아니야. 내가 원조라고."

    -- 스킵 버튼 비활성화
    RemoveQuestSkipButton()

        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092004))  -- "내가 아주 잠깐 추는 걸 보고\n내 '절도 있게' 기술을 '절도'해간 거지!!\n아주 도둑놈이 따로 없다니까.."
        DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092005))  -- "하지만 '절도 있게' 를 사용한\n완벽한 동작은 아직 터득하지 못했을 거야..\n제자님은 특별히 더 자세히 알려주지."

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092007))  -- "음, 역시 내 제자님이군.\n갖고 있을 줄 알았지."
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612553, 0)
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092008))  -- "아주 간단한 동작이니, 그리 어렵지는 않을 거라고.\n관절들을 '절도 있게'로 바꾸는 걸 잊지 마."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092009))  -- "어떤가..!\n기술을 사용하니 느낌이 많이 다르지?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092013))  -- "내 제자라면 이 자격증을 당연히\n갖고 있어야 하지 않겠어?"

    
    GoTown()
    
end


if OnQuestGiveUp() then

    DialogOpen(158, STR_NPC(158), "Characters/npc_002", STR_QUEST_TEXT(880092014))  -- "이런, 이런.. 쉬운 것만 습득하려는\n습관은 좋지 않은 거야, 제자님."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612553, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end







