-- 강함을 만드는 부드러움(880102) 제작 퀘스트
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586) 
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")      
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
        
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
                
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
        PushPopupTownNpcWithSelectBox(153)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
        TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102001))  -- "원~ 투~ 부드럽게~~  턴~\n크 좋았어.."
    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(153)

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102002))  --   -- "앗!! 어, 언제부터 보셨죠!?\n크흠.. 미용실 원장이 추길래 따라 해본 거예요.\n어디 가서 말하지는 마셨으면.."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102003))  -- "부드럽고 유연한 동작도 익혀야, 파워풀한\n동작에서 미묘하고도, 좀 더 섬세한 부분까지\n표현할 수 있다고요! 하하!"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102004))  -- "...그, 그렇게 빤히 보지 마세요!\n[nickname]님도 한번 춰보시죠?!\n제가 잘 알려드릴 테니!"
                   
        
    end

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102005))  -- "이 옷을 추천해드리죠.\n유연한 동작을 하기 좋더라고요.\n믿고 한번 입어보시죠 ~"

    
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202311)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102006))  -- "자, 이제 춰보실까요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102007))  -- "부드럽게~ 턴~!\n유연하게 움직여보세요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102008))  -- "어때요, 섬세하게 표현하는 것이\n생각보다는 힘들죠?"
    
    GoSceneTown()
    
    TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612586)  
    TownCharacterAction(TownCharacterGetNPC(1), "copy") -- 유저가 방금 만든 춤을 춤
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202311)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102009))  -- "몇 번 하다 보면 금방 익숙해질 거예요!\n저도 좀 더 연습이 필요하니, 그럼 전 이만~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(31) --=BGM=Event_Quest_making
      -- 퀘스트 인트로
    ScenarioIntroShow(153)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히

        -- 스킵 버튼 활성화
        AddQuestSkipButton()

        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102002))  --   -- "앗!! 어, 언제부터 보셨죠!?\n크흠.. 미용실 원장이 추길래 따라 해본 거예요.\n어디 가서 말하지는 마셨으면.."
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102003))  -- "부드럽고 유연한 동작도 익혀야, 파워풀한\n동작에서 미묘하고도, 좀 더 섬세한 부분까지\n표현할 수 있다고요! 하하!"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102004))  -- "...그, 그렇게 빤히 보지 마세요!\n[nickname]님도 한번 춰보시죠?!\n제가 잘 알려드릴 테니!"
        

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102006))  -- "자, 이제 춰보실까요?"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612586, 0)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102007))  -- "부드럽게~ 턴~!\n유연하게 움직여보세요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102008))  -- "어때요, 섬세하게 표현하는 것이\n생각보다는 힘들죠?"
    SetCollectionData()
    
    ScenarioEndingShow()
    PopScene()
end

if OnClickCollectionQuestPopupClose() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102010))  -- "아니요.\n아직 준비가 되지 않았어요."

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01") -- 유저 동작 가만히
  
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880102011))  -- "그래요?! 바쁘시다고요!?\n그럼 할 수 없죠, 뭐! 하하!\n근데.. 입단속은 잘해주실거죠?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612586, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
