-- 슈퍼 모델(880112)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

        
        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

        PushPopupTownNpcWithSelectBox(103)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(103)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(103))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(103))
        TownCharacterSetQuest(TownCharacterGetNPC(103))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(103)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(103))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

        PushPopupTownNpcWithSelectBox(103)
    end

    if OnClickQuestTab(TownCharacterGetNPC(103)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112001))  -- "쇼핑하기 좋은 날이죠?\n옷가게에 새로 들어온 옷들이 다\n너무 내 취향이던데~"

    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(103)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112002))   -- "새 의상을 입고 뮤직비디오를 촬영해야죠!\n댄스비전에 예쁜 내 모습을 올리려고\n다~ 사버렸어요~ 호호!"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880112003))     -- "뮤직비디오 찍을 때 내 뉴~ 옷을 입고 \n그럴싸한 모델 포즈를 취해보고 싶은데~\n막상 해보려니 잘 생각이 안나서.."
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112004))   -- "괜찮은 포즈 한번만 보여줄래요?"

    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880112005))   -- "잠시만요~ 포즈를 취할 때마다\n사진을 찍을 카메라와 멋진 의상이 있어야죠~\n준비 좀 부탁할게요~"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202312)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205160)    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112006))   -- "앗! 가져오셨네요~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112007))  -- "사진을 찍으려면 포즈를 몇 초간\n유지해야 하는 거 알죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112008))  -- "복사-붙여넣기 기능을 이용해서\n첫 프레임의 자세를 계속 유지해보도록 해요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112009))   -- "어머어머, 딱 마음에 드네요!\n굉장히 센세이션 한걸요?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202312)
    TownCharacterUnwearClothes(TownCharacterGetNPC(1), 205160)
    TownCharacterSetDanceIdle(TownCharacterAddNPC(103), 612805)
    TownCharacterWearClothes(TownCharacterGetNPC(103), 205160)        
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112010))   -- "정말 멋있어요~!\n자~ 찍습니다~\n하나~ 둘~!"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112011))   -- "멋진 포즈를 알려줘서 고마워요~ 이건 선물~~\n아까 어울릴 것 같아서 하나 샀어요~\n이쁘게 하고 다녀요~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(103)
    
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
 
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112002))    -- "새 의상을 입고 뮤직비디오를 촬영해야죠!\n댄스비전에 예쁜 내 모습을 올리려고\n다~ 사버렸어요~ 호호!"
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_005", STR_QUEST_TEXT(880112003))   -- "뮤직비디오 찍을 때 내 뉴~ 옷을 입고 \n그럴싸한 모델 포즈를 취해보고 싶은데~\n막상 해보려니 잘 생각이 안나서.."
        DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112004))   -- "괜찮은 포즈 한번만 보여줄래요?"

    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612572, 0)
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112007))  -- "사진을 찍으려면 포즈를 몇 초간\n유지해야 하는 거 알죠?"
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_001", STR_QUEST_TEXT(880112008))  -- "복사-붙여넣기 기능을 이용해서\n첫 프레임의 자세를 계속 유지해보도록 해요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_002", STR_QUEST_TEXT(880112009))   -- "어머어머, 딱 마음에 드네요!\n굉장히 센세이션 한걸요?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_003", STR_QUEST_TEXT(880112012))    -- "응? 아직 준비가 안되셨네요~"

    
    GoTown()
    
end


if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(103, STR_NPC(103), "Characters/npc_shyaba_006", STR_QUEST_TEXT(880112013))    -- "앗..! 거절하시다니...\n지금은 좀 바쁘신가봐요..?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612572, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
