-- 폴짝 폴짝 개구리(880121)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        
          -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
        TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)        
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))   -- "개구리는 이렇게 뛰는 거 아니에요?"
       
        PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
      TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)          
      DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))   -- "개구리는 이렇게 뛰는 거 아니에요?"
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
    TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)                
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))   -- "개구리는 이렇게 뛰는 거 아니에요?"

        PushPopupTownNpcWithSelectBox(127)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(127)) then
    TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)            
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))   -- "개구리는 이렇게 뛰는 거 아니에요?"
    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(127))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(127))
        TownCharacterSetQuest(TownCharacterGetNPC(127))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(127)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(127))
    TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)            
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))   -- "개구리는 이렇게 뛰는 거 아니에요?"

        PushPopupTownNpcWithSelectBox(127)
    end

    if OnClickQuestTab(TownCharacterGetNPC(127)) then
    TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)            
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121001))  -- "개구리는 이렇게 뛰는 거 아니에요?"
    end
    
end


if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(127)

    TownCharacterSetDanceIdle(TownCharacterAddNPC(127), 612530)        
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121002))   -- "아무리 생각해도 이렇게 뛰는 게 맞는데..!\n애들이 자꾸 아니래요!!"
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121003))    -- "개구리는 어떻게 점프하는 거죠?\n좀 보여주세요!!"
    end

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121004))   -- "이거! 이거 있어야 해요!\n이 위에서 뛰어야 정말 개구리 같을 테니까!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121005))   -- "네! 이제 보여주세요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121006))  -- "어서 보여주세요.\n나도 이렇게 잘 뛰는데!\n대체 나랑 다른게 뭔데요??"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121007))   -- "아... 내가 뛴 거랑은 조금 다르긴 하네~"
    
    GoSceneTown()
       
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(144), "copy")    
 
 
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121008))  -- "이제 알겠어요!\n흥! 고마워요!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(127)
    
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121002))   -- "아무리 생각해도 이렇게 뛰는 게 맞는데..!\n애들이 자꾸 아니래요!!"
        DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121003))    -- "개구리는 어떻게 점프하는 거죠?\n좀 보여주세요!!"

    
     --[[
    if CheckQuestStart() then
    else
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121005))   -- "네! 이제 보여주세요!"
    end
    ]]
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612518, 0)
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121006))  -- "어서 보여주세요.\n나도 이렇게 잘 뛰는데!\n대체 나랑 다른게 뭔데요??"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121007))    -- "아... 내가 뛴 거랑은 조금 다르긴 하네~"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121009))   -- "응?! 이게 있어야 한다구요!!"
    GoTown()
end

if OnQuestGiveUp() then
    DialogOpen(127, STR_NPC(127), "Characters/npc_009", STR_QUEST_TEXT(880121010))   -- "우 씨.. 거절하다니..!\n솔직히 말해봐요!\n개구리 어떻게 뛰는지 모르죠!?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

-- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612518, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

