-- 다이어트를 향한 결심(880132)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"
        
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"

        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"

        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"

        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132001))     -- "[nickname]님!!!! 저 어떡해요? 으아앙!!"


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132002))      -- "학교에서 건강 검진을 해서 체중을 쟀는데..\n글쎄 저보고..... 소아 비만이래요!!!!!!!!!!!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132003))     -- "의사 선생님이 군것질을 되도록 하지 말라고\n하셨는데...! 말도 안 돼~~ 으앙!!\n과자를 안 먹고 어떻게 살아요? 엉엉..."
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132004))     -- "누나가 벌써 집에 있던 내 소중한 과자들을\n다 갖다 버렸는데... "
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132005))     -- "정말 인생의 즐거움을 모두 잃은 느낌이에요...\n과자를 먹으면서도 살 뺄 수 있는 좋은 방법이 없을까요?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132006))     -- "네? 더 격렬히 춤을 추라구요?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132007))             -- "어? 좋은 생각인데요!?\n뭐 괜찮은 춤을 추천해주실 수 있어요?\n저 정말 열심히 출게요!!"
        
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880132008))    -- "저 정말 결심했어요!\n제 결심을 표현하기 위해 머리에 띠도 둘러야겠어요!!\n[nickname]님도 동참해 주세요!"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201215)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201215)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132009))     -- "어때요! 저의 확고함이 느껴지죠! 헤헤!\n어서 격렬한 춤을 추천해주세요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132010))     -- "엄청 격렬해도 좋아요!\n살이 빠져서 과자를 많이 먹을 수 있다면!!!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132011))  -- "이, 이게 춤?!?!!..\n이렇게 하면.. 살이 빠지는 건가요!\n그럼 과자를 많이 먹을 수 있는 거죠..?!"
        
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201215)
    TownCharacterWearClothes(TownCharacterGetNPC(113), 201215)
    TownCharacterAction(TownCharacterGetNPC(113), "copy")    
        
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132012))     -- "[nickname]님! 저 어때요??\n좀만 하면 금방 빠지겠죠!?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132013))     -- "[nickname]님 덕분에 과자를 계속 먹어도 되겠네요!\n정말 감사해요!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132002))      -- "학교에서 건강 검진을 해서 체중을 쟀는데..\n글쎄 저보고..... 소아 비만이래요!!!!!!!!!!!"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132003))     -- "의사 선생님이 군것질을 되도록 하지 말라고\n하셨는데...! 말도 안 돼~~ 으앙!!\n과자를 안 먹고 어떻게 살아요? 엉엉..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132004))     -- "누나가 벌써 집에 있던 내 소중한 과자들을\n다 갖다 버렸는데... "
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132005))     -- "정말 인생의 즐거움을 모두 잃은 느낌이에요...\n과자를 먹으면서도 살 뺄 수 있는 좋은 방법이 없을까요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132006))     -- "네? 더 격렬히 춤을 추라구요?"
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132007))            -- "어? 좋은 생각인데요!?\n뭐 괜찮은 춤을 추천해주실 수 있어요?\n저 정말 열심히 출게요!!"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612592, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132010))    -- "엄청 격렬해도 좋아요!\n살이 빠져서 과자를 많이 먹을 수 있다면!!!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132011))   -- "이, 이게 춤?!?!!..\n이렇게 하면.. 살이 빠지는 건가요!\n그럼 과자를 많이 먹을 수 있는 거죠..?!"
    SetCollectionData()
    
    PopScene()
end

local function DanceEdit()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880132014))     -- "앗..! 안돼요!\n그냥 추면 다이어트를 향한\n제 확고함이 느껴지지 않잖아요..!!"

    
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880132015))    -- "힝.... 지금은 바쁘신 건가요?\n알겠어요... 알려주시기 전까지는\n과자를 조금 줄여봐야죠 뭐.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612592, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
