-- 예뻐지기 위한 노력(880133)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()        
        -- 유저가 npc 옆으로 걸어감          
        ScriptTownMoveToSide(TownCharacterGetNPC(126))        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"     
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"
    end    
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"
        PushPopupTownNpcWithSelectBox(126)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"
    end
    
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133001))     -- "예쁜 춤 라인을 가지고 싶다면\n몸매 관리는 필수죠~"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(126)
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133002))      -- "제 생각엔, 춤 라인이 예쁘려면\n어느 정도 몸매가 예뻐야 한다고 생각해요~"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133003))     -- "트렌드를 선도하는 이 몸에게 관리는 필수죠!~\n자! 저처럼 따라 해보세요~\n예쁜 바디라인을 갖게 해줄게요~"
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
	DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880133004))    -- "잠깐~!\n나의 현재 바디라인이 잘 보이도록\n옷을 갖춰 입는 게 중요해요~"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202317)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201214)    
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202317)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 201214)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133005))     -- "앗 좋아요~!\n바디라인이 잘 드러나네요!\n이제 춰볼까요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133006))     -- "자! 어서 따라 해보세요!\n하나, 둘! 하나, 둘!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880133007))    -- "굿 굿! 아주 좋아요!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202317)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201214)    
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202317)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 201214)
    TownCharacterAction(TownCharacterGetNPC(126), "612604")    
        
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133008))     -- "어때요!\n예쁜 몸매 만들기 참 쉽죠!?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(126)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133002))      -- "제 생각엔, 춤 라인이 예쁘려면\n어느 정도 몸매가 예뻐야 한다고 생각해요~"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133003))     -- "트렌드를 선도하는 이 몸에게 관리는 필수죠!~\n자! 저처럼 따라 해보세요~\n예쁜 바디라인을 갖게 해줄게요~"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612604, 0)
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133006))    -- "자! 어서 따라 해보세요!\n하나, 둘! 하나, 둘!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133007))  -- "굿 굿! 아주 좋아요!"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880133009))     -- "음 어울리는 복장을 갖춰 입어야죠~"

    
    GoTown()
    
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880133010))    -- "음~ 그래요?\n예쁜 몸매에는 관심이 없나 봐요?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612604, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
