-- 신나는 에어로빅(880134)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
        TownCharacterSetQuest(TownCharacterGetNPC(119))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        PreLoad()


        ScriptTownMoveToSide(TownCharacterGetNPC(119))
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
        PushPopupTownNpcWithSelectBox(119)
    end

    if OnClickQuestTab(TownCharacterGetNPC(119)) then
         DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
        TownCharacterSetQuest(TownCharacterGetNPC(119))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
                DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
        PushPopupTownNpcWithSelectBox(119)
    end

    if OnClickQuestTab(TownCharacterGetNPC(119)) then
              DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
        TownCharacterSetQuest(TownCharacterGetNPC(119))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
              DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
        PushPopupTownNpcWithSelectBox(119)
    end

    if OnClickQuestTab(TownCharacterGetNPC(119)) then
               DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134001))    -- "오호~ 오랜만이네?\n혹시, 에어로빅이라고 알아?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(119)
        
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134002))   -- "아니~ 내가 말이야, 요새 살이 쪼금 쪄서\n운동을 시작했거든~\n 바로 '에어로빅' 을 말이지~"
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134003))   -- "활동적으로 움직이다 보니 조금씩 살이\n빠지는 것 같아~! 이러다 금~방\n처녀적 몸매로 돌아가겠어! 오홍홍!"
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134004))  -- "응? [nickname]도 약간 군살이 있어 보이는데?\n어때. 내가 신나는 음악을 알려줄 테니\n한번 춤춰봐~ 잘 출 필요 없어~"
    end

	DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134005))   -- "이거~! 이게 있어야 해~~\n이 소리만 들리면 신나서 정신없이\n춤을 추게 된다니까~"
	PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134006))   -- "오 가져왔네~!?\n어서 음악을 만들어 보자구~"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134007))  -- "좋아, 잘 봐~"
    RequireMusicFollowButton()

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134008))   -- "됐다!\n어때? 듣기만 해도 막 에어로빅을 추고 싶어서\n몸이 들썩들썩하지?"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629006)
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134009))   -- "어서 안 뛰고 뭐 해~!\n노래에 맞춰서 열심히 춤춰보라구~!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134010))   -- "기다려봐!\n아직 준비가 안된 것 같은데.."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134011))  -- "에잉~ 같이 해보지그래~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(119)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134002))   -- "아니~ 내가 말이야, 요새 살이 쪼금 쪄서\n운동을 시작했거든~\n 바로 '에어로빅' 을 말이지~"
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134003))   -- "활동적으로 움직이다 보니 조금씩 살이\n빠지는 것 같아~! 이러다 금~방\n처녀적 몸매로 돌아가겠어! 오홍홍!"
        DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134004))  -- "응? [nickname]도 약간 군살이 있어 보이는데?\n어때. 내가 신나는 음악을 알려줄 테니\n한번 춤춰봐~ 잘 출 필요 없어~"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134005))   -- "이거~! 이게 있어야 해~~\n이 소리만 들리면 신나서 정신없이\n춤을 추게 된다니까~"
         
    end

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134006))   -- "오 가져왔네~!?\n어서 음악을 만들어 보자구~"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134007))  -- "좋아, 잘 봐~"
    RequireMusicFollowButton()
    
    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134008))   -- "됐다!\n어때? 듣기만 해도 막 에어로빅을 추고 싶어서\n몸이 들썩들썩하지?"
      
      Wait(0.5)

    DialogOpen(119, STR_NPC(119), "Characters/npc_016", STR_QUEST_TEXT(880134009))   -- "어서 안 뛰고 뭐 해~!\n노래에 맞춰서 열심히 춤춰보라구~!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end




