-- 한밤의 괴물(880141)
-- version("0.61.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()        
        -- 유저가 npc 옆으로 걸어감          
        ScriptTownMoveToSide(TownCharacterGetNPC(113))        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))  -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))   -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))   -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
        PushPopupTownNpcWithSelectBox(113)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))  -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(113))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(113))
        TownCharacterSetQuest(TownCharacterGetNPC(113))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(113)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(113))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))  -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
        PushPopupTownNpcWithSelectBox(113)
    end

    if OnClickQuestTab(TownCharacterGetNPC(113)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141001))  -- "으으.. 무서워!! \n [nickname]님!!! \n어떡하죠!!? 너무 무서워요.."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(113)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141002))      -- "제가 예민해서 겁이 좀 많은 편인데..\n그런데 말이에요.. 어젯밤에.. 광장에서..\n굉장히 이상한 사람을 보았어요. 끄앙!!!.. "
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141003) )   -- "마치 사람이 아닌 것처럼...\n해괴하게 걸었단 말이에요..!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141004) )   -- "아 지금 생각해보니.. \n역시 사람이 아니었던 걸까!?!?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141005) )        -- "응!? [nickname]님 그 못 믿겠다는\n얼굴은 뭐죠!?! 정말이에요!\n이렇게 이렇게 걸었다니까요??"
	end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880141006))   -- "아이 참.. 생생한 전달을 위해\n한번 보여드릴게요!\n제가 더 자세히 알려드릴 수 있어요!!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201210)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141007))   -- "앗!! 맞아요!! 이거예요!!\n으으... 다시 봐도 무섭다.."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141008))    -- "이.. 렇게..! 이렇게..!!\n한번 봐주세요..!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880141009))     -- "어때요!? 정말 이상하지 않나요!?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201210)
        
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141010))  -- "끄앙~~ \n이제 그만하셔도 괜찮은데..."
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141011))   -- "[nickname]님도 만나지 않게 조심하세요..!!\n밤늦게 돌아다니지 마시고요~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(113)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141002))      -- "제가 예민해서 겁이 좀 많은 편인데..\n그런데 말이에요.. 어젯밤에.. 광장에서..\n굉장히 이상한 사람을 보았어요. 끄앙!!!.. "
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141003) )   -- "마치 사람이 아닌 것처럼...\n해괴하게 걸었단 말이에요..!"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141004) )   -- "아 지금 생각해보니.. \n역시 사람이 아니었던 걸까!?!?"
        DialogOpen(113, STR_NPC(113), "Characters/npc_001",STR_QUEST_TEXT(880141005) )        -- "응!? [nickname]님 그 못 믿겠다는\n얼굴은 뭐죠!?! 정말이에요!\n이렇게 이렇게 걸었다니까요??"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612583, 0)
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141008))   -- "이.. 렇게..! 이렇게..!!\n한번 봐주세요..!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880141009))     -- "어때요!? 정말 이상하지 않나요!?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(113, STR_NPC(113), "Characters/npc_001", STR_QUEST_TEXT(880141012))   -- "앗... 아직 마음의 준비가 안되셨다구요!?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(113, STR_NPC(113), "Characters/npc_001",  STR_QUEST_TEXT(880141013))   -- "[nickname]님..!\n제 얘기를 안 믿으시는 건가요..!!\n진짠데... 힝.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612583, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
