-- 수상한 사람(880142)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
        PushPopupTownNpcWithSelectBox(133)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
    end    
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(133))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(133))
        TownCharacterSetQuest(TownCharacterGetNPC(133))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(133)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(133))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
        PushPopupTownNpcWithSelectBox(133)
    end

    if OnClickQuestTab(TownCharacterGetNPC(133)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142001))     -- "혹시 이 근처에서 수상한 사람을 못 보셨나요?!"
    end
end

if OnClickQuestStart() then    
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(133)
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142002))      -- "이상한 사람이 있다는 얘기를 듣고\n이 근방을 조사하는 중이에요!"
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142003))     -- "굉장히 무섭게 생기고.... 또.... 음."
        DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142004))       -- "걸음걸이가 사람 같지는 않다고 하던데..\n음... 어떻다고 했더라.. \n말로는 설명하기 어렵네요 한번 보시죠!"
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880142005))      -- "흐음. 이런 복장을 입었다고 했어요.\n재연을 위해 한번 준비해주실래요?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201210)
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142006))   -- "음.. 꽤 무섭네요.\n자, 그럼 재연해볼까요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142007))     -- "음.. 이렇게라고 했던가..?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880142008))    -- "어떻습니까? 이런 걸음을 한 사람을\n보신 기억이 있나요?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201210)
        
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142009))    -- "이렇게 다시 보니, 마치 춤 같기도 하군요!?\n흠... 아무래도 좀 더 수색해봐야겠네요..\n도움을 주셔서 감사합니다."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(133)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142002))      -- "이상한 사람이 있다는 얘기를 듣고\n이 근방을 조사하는 중이에요!"
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142003))     -- "굉장히 무섭게 생기고.... 또.... 음."
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142004))       -- "걸음걸이가 사람 같지는 않다고 하던데..\n음... 어떻다고 했더라.. \n말로는 설명하기 어렵네요 한번 보시죠!"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612605, 0)
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142007))    -- "음.. 이렇게라고 했던가..?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142008))  -- "어떻습니까? 이런 걸음을 한 사람을\n보신 기억이 있나요?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001", STR_QUEST_TEXT(880142010))     -- "음~~ 이 상태로라면 단서를 찾기\n어려울 것 같은데요~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(133, STR_NPC(133), "Characters/npc_agent_new_001",  STR_QUEST_TEXT(880142011))    -- "바쁘시군요. 알겠습니다!\n나중에 뵙죠. 몸조심하세요!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612605, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

