-- 모두의 주목을 한몸에!(880153)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
        PushPopupTownNpcWithSelectBox(139)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(139))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(139))
        TownCharacterSetQuest(TownCharacterGetNPC(139))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(139)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(139))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
        PushPopupTownNpcWithSelectBox(139)
    end

    if OnClickQuestTab(TownCharacterGetNPC(139)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153001))     -- "시원~ 시원한 동작으로 모든 사람들의\n주목을 받을 수 있는 춤이 뭘까요?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(139)
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153002))      -- "널따란 무대와 화려한 조명!\n커다란 스피커에서 신나는 음악이 흘러나오고\n그 위에서 신나게 춤을 추는 거예요!"
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153003))     -- "그럼 보는 사람들 모두\n집중하지 않을 수 없겠죠? 후훗!\n함께 해보실래요?"
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153004))        -- "자! 그럼 제가 알려드릴게요!\n저를 따라 해보세요!"
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(139, STR_NPC(139), "Characters/npc_013",  STR_QUEST_TEXT(880153005))    -- "자 그럼 아까 말씀드린,\n널따란 무대! 화려한 조명!\n커다란 스피커를 준비하세요!"

	PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153006))     -- "오케이! 좋아요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153007))     -- "자!\n시작해볼까요!?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(139, STR_NPC(139), "Characters/npc_013",  STR_QUEST_TEXT(880153008))    -- "예~!\n어때요! 신나죠?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(139), 612517)
        
        DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153009))     -- "댄스비전에서 분명 많은 사람의\n주목을 받을 수 있을 거라고 생각해요!\n자 그럼, [nickname]님 파이팅!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
	-- 퀘스트 인트로
    ScenarioIntroShow(139)
    
	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153002))      -- "널따란 무대와 화려한 조명!\n커다란 스피커에서 신나는 음악이 흘러나오고\n그 위에서 신나게 춤을 추는 거예요!"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153003))     -- "그럼 보는 사람들 모두\n집중하지 않을 수 없겠죠? 후훗!\n함께 해보실래요?"
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153004))        -- "자! 그럼 제가 알려드릴게요!\n저를 따라 해보세요!"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612517, 0)
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153007))    -- "자!\n시작해볼까요!?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153008))  -- "예~!\n어때요! 신나죠?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(139, STR_NPC(139), "Characters/npc_013", STR_QUEST_TEXT(880153010))     -- "앗! 잠시만요~\n아직 뭔가 부족한 것 같지 않아요?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(139, STR_NPC(139), "Characters/npc_013",  STR_QUEST_TEXT(880153011))    -- "음~ 오케이!\n집중 받는 걸 싫어하시는구나~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612517, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

