-- 가끔은 현란하게(880161)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"
        
        PushPopupTownNpcWithSelectBox(202)
    end

    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"

        PushPopupTownNpcWithSelectBox(202)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(202))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(202))
        TownCharacterSetQuest(TownCharacterGetNPC(202))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(202)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(202))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"

        PushPopupTownNpcWithSelectBox(202)
    end

    if OnClickQuestTab(TownCharacterGetNPC(202)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161001))   -- "흠. 소문 들었어.\n네가 그 유명한 [nickname]야?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(202)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(202), 612539)    
        
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161002))      -- "쉿. 날 만난건 비밀이야~\n몰래 빠져나온 거라구.\n뭐 좀 물어보고 싶어서 말이야."
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161003))      -- "응? 누구냐고?.. 진심이야?\n나를 정말 모른다고? 하하....\n댄스빌에 날 모르는 사람은 거의 없을 텐데.."
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161004))      -- "음... 그래. 뭐.. 모르면 모르는 대로 괜찮아.\n더 유명해질 수 있도록 노력해야겠지!\n그래서 말인데.. 지금 내 춤 어때? "
        DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161005))      -- "뛰어난 춤꾼이 있다고 해서 찾아왔는데~\n네가 한번 춰보고, 느낌을 말해주지 않을래?\n나의 춤에 대한 평가를 듣고 싶어!"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880161006))    -- "음~! 이런 무대 위에서 함께 추지 않을래!?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161007))     -- "앗! 준비했네!\n고마워! 어서 춰보자!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161008))     -- "어서 따라 해봐~!\n이렇게 추는 거야~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880161009))    -- "어때? 나의 소울이 느껴지니?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(202), 612539)    

        
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161010))     -- "역시! 소문이 맞았어!\n내 춤을 한 번에 따라추다니~ 정말 남다른데?"
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161011))      -- "다음에 또 언제 볼 수 있을지 모르겠지만,\n또다시 널 만나러 올게!\n그때까지 잘 있어!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(202)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(202), 612539)       
   
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161002))      -- "쉿. 날 만난건 비밀이야~\n몰래 빠져나온 거라구.\n뭐 좀 물어보고 싶어서 말이야."
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161003))      -- "응? 누구냐고?.. 진심이야?\n나를 정말 모른다고? 하하....\n댄스빌에 날 모르는 사람은 거의 없을 텐데.."
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161004))      -- "음... 그래. 뭐.. 모르면 모르는 대로 괜찮아.\n더 유명해질 수 있도록 노력해야겠지!\n그래서 말인데.. 지금 내 춤 어때? "
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161005))      -- "뛰어난 춤꾼이 있다고 해서 찾아왔는데~\n네가 한번 춰보고, 느낌을 말해주지 않을래?\n나의 춤에 대한 평가를 듣고 싶어!"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612539, 0)
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161008))    -- "어서 따라 해봐~!\n이렇게 추는 거야~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880161009))    -- "어때? 나의 소울이 느껴지니?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001", STR_QUEST_TEXT(880161012))     -- "무대 위에서 함께 추면 훨씬 멋질 거야~!"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(202, STR_NPC(202), "Characters/npc_itiz_gudi_001",  STR_QUEST_TEXT(880161013))    -- "앗!! 나 자주 올 수 있는 거 아닌데..!\n후회할껄!?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612539, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

