-- 귀여운 댄스 음악(880164)
-- version("0.31.00")

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(203))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(203))
        TownCharacterSetQuest(TownCharacterGetNPC(203))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(203)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(203))
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
        PushPopupTownNpcWithSelectBox(203)
    end

    if OnClickQuestTab(TownCharacterGetNPC(203)) then
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(203))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(203))
        TownCharacterSetQuest(TownCharacterGetNPC(203))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(203)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(203))
                DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
        PushPopupTownNpcWithSelectBox(203)
    end

    if OnClickQuestTab(TownCharacterGetNPC(203)) then
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(203))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(203))
        TownCharacterSetQuest(TownCharacterGetNPC(203))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(203)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(203))
              DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
        PushPopupTownNpcWithSelectBox(203)
    end

    if OnClickQuestTab(TownCharacterGetNPC(203)) then
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164001))    -- "... 네가 그 소문의 [nickname]?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(203)
        
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164002))   -- "지난번에 웬 남자아이가 찾아오지 않았니?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164003))  -- "그 애는 나와 같은 그룹에 있는 구디야.\n너를 만나고 와서, 엄청 흥분해서 연일 떠들더라.\n정말 뛰어난 실력을 가졌다고 칭찬이 자자하던걸?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164004))  -- "그런데 말이야. 정말 충격적이게도 네가 우리를\n모른다고 하던걸?! 그게 말이 돼!?\n어떻게 우릴 모를 수 있어?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164005))  -- "그래서 이번엔 내가 몰래 왔지. 친히 너에게\n우리 그룹 음악을 알려주기 위해서 말이야!\n정말 엄청난 영광으로 알라구!"
    end

    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164006))   -- "흠! 이런 거 좀 준비해봐~!\n내가 시간이 별로 없어서 말이야~!\n빨리 좀 부탁해!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
   SetCostumeCollectionNeeds()

    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164007))   -- "아 갖고 왔어?\n빨리 알려줄게. 가봐야 해서~"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164008))  -- "아직도 어떻게 우리 음악을 모를 수 있나\n정말 의아하지만.... 잘 들어~"
    RequireMusicFollowButton()

    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164009))   -- "어때? 정말 들으면 중독되지 않아?"

    GoSceneTown()
	SoundPlay(music_id)
    -- SoundPlayMusicData(629019)
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164010))   -- "우리를 모르다니 아직도 충격이야...\n이번 기회에 잘 알았길 바라.\n그럼 난 다음 스케줄이 있어서 이만~"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164011))   -- "미안하지만 난 시간이~ 별로 없어~\n바쁜 사람이라~~"
    GoTown()
end

if OnQuestGiveUp() then
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164012))  -- "!?!?! 어.. 어머.... 화.. 황당해라..!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(203)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164002))   -- "지난번에 웬 남자아이가 찾아오지 않았니?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164003))  -- "그 애는 나와 같은 그룹에 있는 구디야.\n너를 만나고 와서, 엄청 흥분해서 연일 떠들더라.\n정말 뛰어난 실력을 가졌다고 칭찬이 자자하던걸?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164004))  -- "그런데 말이야. 정말 충격적이게도 네가 우리를\n모른다고 하던걸?! 그게 말이 돼!?\n어떻게 우릴 모를 수 있어?"
        DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164005))  -- "그래서 이번엔 내가 몰래 왔지. 친히 너에게\n우리 그룹 음악을 알려주기 위해서 말이야!\n정말 엄청난 영광으로 알라구!"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164006))   -- "흠! 이런 거 좀 준비해봐~!\n내가 시간이 별로 없어서 말이야~!\n빨리 좀 부탁해!"
         
    end

    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164007))   -- "아 갖고 왔어?\n빨리 알려줄게. 가봐야 해서~"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164008))  -- "아직도 어떻게 우리 음악을 모를 수 있나\n정말 의아하지만.... 잘 들어~"
    RequireMusicFollowButton()
    
    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164009))   -- "어때? 정말 들으면 중독되지 않아?"
      
      Wait(0.5)

    DialogOpen(203, STR_NPC(203), "Characters/npc_itiz_belly_001", STR_QUEST_TEXT(880164010))   -- "우리를 모르다니 아직도 충격이야...\n이번 기회에 잘 알았길 바라.\n그럼 난 다음 스케줄이 있어서 이만~"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end





