-- 이목을 끄는 정열적인 춤(880184)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)   
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"
        
        PushPopupTownNpcWithSelectBox(135)
    end

    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)           
        
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)           
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"

        PushPopupTownNpcWithSelectBox(135)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)           
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"
    end    
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(135))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(135))
        TownCharacterSetQuest(TownCharacterGetNPC(135))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(135)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(135))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)           
        
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"

        PushPopupTownNpcWithSelectBox(135)
    end

    if OnClickQuestTab(TownCharacterGetNPC(135)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)             
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184001))     -- "응? 무슨 일이죠?\n난 지금 뮤비 촬영하러 가야 해서 바쁜데~!"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(135)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)   
    
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184002))      -- "내 춤이 재미있어 보인다구요?\n훗, 나에게 끌리는 것은 당연한 것이니,\n뭐 놀랍지도 않네요!"
        DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184003))      -- "뭐. 정 궁금하면 알려줄까요?\n잘 따라 할 수 있겠어요?"
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)           
    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880184004))    -- "이 정도 길이의 춤을 출 건데, 괜찮죠?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184005))     -- "훗, 좋아요 그럼!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184006))     -- "조금 어렵겠지만~\n어쩔 수 없어요~ 내공이 다를 테니!\n한번 해보세요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880184007))    -- "이, 이런... 오랫동안 연습한 춤을\n단번에 따라 하다니..!\n자... 잘하시네요~~~"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)       
        
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184008))     -- "아! 그래~ 내 춤이 널리 알려지는 것도 좋지!!\n꼭 이 춤을 활용해서 뮤비를 찍어줘요!~\n내 이름도 꼭 뮤비의 태그로 달아주고요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184009))     -- "그럼 나는 바빠서 이만~~"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(135)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(135), 612596)        
   
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184010))     -- "내 춤이 재밌어서 불렀다구요?\n훗, 내 춤에 끌린 것은 당연한 것이니,\n뭐 놀랍지도 않네요!"
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184003))      -- "뭐. 정 궁금하면 알려줄까요?\n잘 따라 할 수 있겠어요?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612596, 0)
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184005))    -- "훗, 좋아요 그럼!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880184007))    -- "이, 이런... 오랫동안 연습한 춤을\n단번에 따라 하다니..!\n자... 잘하시네요~~~"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(135, STR_NPC(135), "Characters/npc_019", STR_QUEST_TEXT(880184011))     -- "준비도 안되었는데 어떻게 배우겠다는 건지~?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(135, STR_NPC(135), "Characters/npc_019",  STR_QUEST_TEXT(880184012))   -- "아이 정말! 바쁜데 붙잡더니....\n그럼 이만~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612596, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

