-- 황소 처럼 걷기(880192)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."
        
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."

        PushPopupTownNpcWithSelectBox(129)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."

        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192001))     -- "지난번에 이어, 새로운 탈춤 동작을 생각해봤다네."
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
		
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192002))      -- "지난번 고개 끄덕이는 동작 기억하나?\n그 동작에 어울리는 다음 동작을 생각해봤다네!"
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192003))      -- "이번에는 다리를 들어보는 걸세!\n성큼~! 성큼~!\n마치 황소처럼 걷는 것이지!"
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192004))            -- "이번에도 한번 해보지 않겠나?"
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880192005))    -- "이번에는 탈과 어울리는 의상을\n제대로 갖춰 입도록 해보지!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202291)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)     
        
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192006))     -- "음! 탈과 잘 어울리는구먼!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192007))     -- "내 이 동작에 이름을 붙여보자면..\n'황소걸음' 일세!\n한번 걸어보게나!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880192008))    -- "정말 멋지지 않나?\n고개와 다리를 사용하여 이렇게\n멋진 춤을 만들 수 있다니."
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(129), 612509)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202291)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)       
        
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192009))     -- "허허, 탈춤을 잘 익히는\n자네를 보니 참 뿌듯하구먼.\n그럼 다음에 또 봅세."
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(129)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192002))      -- "지난번 고개 끄덕이는 동작 기억하나?\n그 동작에 어울리는 다음 동작을 생각해봤다네!"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192003))      -- "이번에는 다리를 들어보는 걸세!\n성큼~! 성큼~!\n마치 황소처럼 걷는 것이지!"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192004))          -- "이번에도 한번 해보지 않겠나?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612509, 0)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192007))      -- "내 이 동작에 이름을 붙여보자면..\n'황소걸음' 일세!\n한번 걸어보게나!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880192008))    -- "정말 멋지지 않나?\n고개와 다리를 사용하여 이렇게\n멋진 춤을 만들 수 있다니."
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880192010))     -- "잠깐..\n탈과 어울리는 의상을 보고 싶다네..\n기다릴 테니 구해주시게나."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880192011))    -- "어려울 것 같지 않네만..\n도전 정신을 갖게나, 젊은이."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612509, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
