-- 고이 접어 나빌레라(880193)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"
        
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"

        PushPopupTownNpcWithSelectBox(129)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"

        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193001))     -- "드디어 완성했네! 완성했다고!\n마지막 탈춤 동작 말일세!"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193002))      -- "지난번엔 다리를 사용했으니,\n이번에는 팔과 손이라네!\n팔을 공중에서 흥겹게 흔들어 보는 것이지!"
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193003))      -- "어디 보자... 손에 무언가 착용하고 춤을 추면\n동작이 더 커지고 훨씬 더 재밌어 질것 같지 않나!?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880193004))    -- "오~ 그래, 이걸 착용하면 되겠군!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205150)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202291)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)      
        
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193005))     -- "잘 준비했군!\n일단은, 손동작부터 자세히 익혀봄세!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193006))     -- "흥겨우면서도 절제된 손동작을 해보시게나~!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880193007))    -- "아주 좋구먼!!\n손에 착용한 걸 보면 분명 더 재미있을 걸세!!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(129), 612511)      
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205150)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202291)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 203062)         
        
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193008))     -- "자아~ 마지막 탈춤 동작의 완성일세!\n어떤가, 정말 예술성이 뛰어난 춤이지 않은가?"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193009))    -- "자네, 내가 이전에 알려준 동작들을 기억하고 있겠지?\n모든 동작을 한번 이어서 춤춰보게!\n완성도 높은 탈춤이 될 테니까 말일세 허허!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193010))     -- "준비하라고 한 게 아직 없는 것 같네만.."
    GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(129)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193002))      -- "지난번엔 다리를 사용했으니,\n이번에는 팔과 손이라네!\n팔을 공중에서 흥겹게 흔들어 보는 것이지!"
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193003))      -- "어디 보자... 손에 무언가 착용하고 춤을 추면\n동작이 더 커지고 훨씬 더 재밌어 질것 같지 않나!?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612511, 0)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880193006))      -- "흥겨우면서도 절제된 손동작을 해보시게나~!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880193011))    -- "음.. 내가 알려줄 수 있는 탈춤의\n마지막 단계였다만..\n혼자서도 자신이 있나 보구먼.. 허허"
    SetCollectionData()
    
    PopScene()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(129, STR_NPC(129), "Characters/npc_011",  STR_QUEST_TEXT(880193011))   -- "음.. 내가 알려줄 수 있는 탈춤의\n마지막 단계였다만..\n혼자서도 자신이 있나 보구먼.. 허허"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612511, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
