-- 탈춤에 어울리는 장단(880194)
-- version("0.31.00")

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
    end

elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
                DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
              DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
    end

elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(129))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(129))
        TownCharacterSetQuest(TownCharacterGetNPC(129))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(129)) then
        PreLoad()
        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(129))
              DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
        PushPopupTownNpcWithSelectBox(129)
    end

    if OnClickQuestTab(TownCharacterGetNPC(129)) then
               DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194001))    -- "음.. 아무래도 말이야, 탈춤에 어울리는\n음악이 필요할 것 같단 말이지..\n그래! 장단 말일세!"
    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(129)
        
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194002))   -- "탈춤과 어울리는 장단이 있다면\n훨씬 더 좋을 것 같다네.\n자네의 의견을 듣고 싶은데 어떤가."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194003))  -- "이런 박자라면 어떨지...\n한번 봐주지 않겠나?"
    end

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194004))   -- "악기는.. 이렇게 있으면 될 것 같군."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    SetCostumeCollectionNeeds()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194005))   -- "오, 나 대신 준비해줘서 고맙네.\n어서 장단을 만들어 보세나."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194006))  -- "간단한 장단이어도 괜찮을 것 같네만."
    RequireMusicFollowButton()

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194007))   -- "오호! 들썩~ 들썩~\n절로 어깨춤이 춰지는군."

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629016)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194008))   -- "정말 흥겨운 장단이구먼.\n탈춤과도 잘 어울릴 것 같네.\n고맙네."

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194009))   -- "악기가 아직 준비가 되지 않은 것 같은데..\n꼭 준비해줬으면 싶네만.."
    GoTown()
end

if OnQuestGiveUp() then
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194010))  -- "음.. 무리한 부탁이었다면 미안하네."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(129)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194002))   -- "탈춤과 어울리는 장단이 있다면\n훨씬 더 좋을 것 같다네.\n자네의 의견을 듣고 싶은데 어떤가."
        DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194003))  -- "이런 박자라면 어떨지...\n한번 봐주지 않겠나?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194004))   -- "악기는.. 이렇게 있으면 될 것 같군."
         
    end

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194005))   -- "오, 나 대신 준비해줘서 고맙네.\n어서 장단을 만들어 보세나."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194006))  -- "간단한 장단이어도 괜찮을 것 같네만."
    RequireMusicFollowButton()
    
    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194007))   -- "오호! 들썩~ 들썩~\n절로 어깨춤이 춰지는군."
      
      Wait(0.5)

    DialogOpen(129, STR_NPC(129), "Characters/npc_011", STR_QUEST_TEXT(880194008))   -- "정말 흥겨운 장단이구먼.\n탈춤과도 잘 어울릴 것 같네.\n고맙네."

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end





