-- 곡예부리는 원숭이(880201)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(163))
        TownCharacterSetQuest(TownCharacterGetNPC(163))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(163)) then
        PreLoad()


        ScriptTownMoveToTradeShop(TownCharacterGetNPC(163), TownCharacterGetUser())
        SoundPlay(66) --=BGM=Theme_Tradeshop
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
        PushPopupTownNpcWithSelectBox(163)
    end

    if OnClickQuestTab(TownCharacterGetNPC(163)) then
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
    end

    if CheckIsOnQuest(810011) then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_04", "btn_shop_trade", "btn_shop_trade/iconNew", 52, 30)
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(163))
        TownCharacterSetQuest(TownCharacterGetNPC(163))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(163)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToTradeShop(TownCharacterGetNPC(163), TownCharacterGetUser())
        SoundPlay(66) --=BGM=Theme_Tradeshop
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
        PushPopupTownNpcWithSelectBox(163)
    end

    if OnClickQuestTab(TownCharacterGetNPC(163)) then
              DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
    end

    if CheckIsOnQuest(810011) then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_04", "btn_shop_trade", "btn_shop_trade/iconNew", 52, 30)
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(163))
        TownCharacterSetQuest(TownCharacterGetNPC(163))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(163)) then
        PreLoad()

        -- 유저가 오르카 옆으로 걸어감
        ScriptTownMoveToTradeShop(TownCharacterGetNPC(163), TownCharacterGetUser())
        SoundPlay(66) --=BGM=Theme_Tradeshop
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
        PushPopupTownNpcWithSelectBox(163)
    end

    if OnClickQuestTab(TownCharacterGetNPC(163)) then
               DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201001))  -- "이런저런 이야기를 들어보니\n자네가 음악과 춤에 대해 견식이 많다고 하던걸?\n내 부탁 좀 들어주겠나?"
    end

    if CheckIsOnQuest(810011) then
        UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_04", "btn_shop_trade", "btn_shop_trade/iconNew", 52, 30)
    end
end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(163)
        
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201002))   -- "내 친구 중에 전 세계를 떠돌아다니는 유명한\n서커스단의 단장이 있는데. 이번에 그 친구가\n내 상점에 놀러 왔다가, 선물을 주고 갔어!"
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201003))    -- "바로 저기에 있는 원숭이야! 정말 귀엽지 않나!\n그 친구 말로는 말도 잘 듣고, 재주가 많다더군!\n음악을 들으면 박자에 맞추어 심벌즈를 친다던가."
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201004))   -- "그래서 말인데..  내 귀여운 원숭이가\n신나게 심벌즈를 칠 수 있게 음악 하나\n만들어 주지 않겠어?"
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201005))  -- "원래 서커스에서 곡예를 부리던 아이였으니,\n이왕이면 서커스 음악이면 좋겠는데..\n의뢰비는 두둑이 줄 테니 걱정 말라고~"

    end

	DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201006))  -- "음~ 어디보자..\n이런 악기들이 필요할 것 같은데 말이야."
	PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201007))   -- "오오? 벌써 준비한거야? 빠른데?\n그럼 잘 부탁해!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201008))  -- "서커스 음악, 들어본 적은 있을 테지?"
    RequireMusicFollowButton()

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201009))   -- "오오! 좋아 좋아!\n마치 서커스 공연에 와있는 것만 같군!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629031)
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201010))     -- "정말 고마워!\n얼른 내 원숭이에게 들려줘야겠어~ 하하!"
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201011))     -- "널 위한 특별한 물건을 잔뜩 들여놓을 테니\n내 무역상에 자주 오라구~!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201012))   -- "음? 괜찮아. 나는 인내심이 많.. 으니. 하하."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201013))  -- "이런...\n포기는 네 명성에 어울리지 않다고\n생각하는데.. 실망이 크군."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(163)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201002))   -- "내 친구 중에 전 세계를 떠돌아다니는 유명한\n서커스단의 단장이 있는데. 이번에 그 친구가\n내 상점에 놀러 왔다가, 선물을 주고 갔어!"
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201003))    -- "바로 저기에 있는 원숭이야! 정말 귀엽지 않나!\n그 친구 말로는 말도 잘 듣고, 재주가 많다더군!\n음악을 들으면 박자에 맞추어 심벌즈를 친다던가."
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201004))   -- "그래서 말인데..  내 귀여운 원숭이가\n신나게 심벌즈를 칠 수 있게 음악 하나\n만들어 주지 않겠어?"
        DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201005))  -- "원래 서커스에서 곡예를 부리던 아이였으니,\n이왕이면 서커스 음악이면 좋겠는데..\n의뢰비는 두둑이 줄 테니 걱정 말라고~"
        
    --[[
    if CheckQuestStart() then
    else
  DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201006))  -- "음~ 어디보자..\n이런 악기들이 필요할 것 같은데 말이야."
         
    end

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201007))   -- "오오? 벌써 준비한거야? 빠른데?\n그럼 잘 부탁해!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201008))  -- "서커스 음악, 들어본 적은 있을 테지?"
    RequireMusicFollowButton()

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201009))   -- "오오! 좋아 좋아!\n마치 서커스 공연에 와있는 것만 같군!"
      
      Wait(0.5)

    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201010))     -- "정말 고마워!\n얼른 내 원숭이에게 들려줘야겠어~ 하하!"
    DialogOpen(163, STR_NPC(163), "Characters/npc_shop_venturer_001", STR_QUEST_TEXT(880201011))     -- "널 위한 특별한 물건을 잔뜩 들여놓을 테니\n내 무역상에 자주 오라구~!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end





