-- 접시 받치기 곡예(880204)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterSetQuestIcon(TownCharacterGetNPC(156))
        TownCharacterSetQuest(TownCharacterGetNPC(156))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(156)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(156))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"
        
        PushPopupTownNpcWithSelectBox(156)
    end

    if OnClickQuestTab(TownCharacterGetNPC(156)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterSetQuestIcon(TownCharacterGetNPC(156))
        TownCharacterSetQuest(TownCharacterGetNPC(156))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(156)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(156))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"

        PushPopupTownNpcWithSelectBox(156)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(156)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterSetQuestIcon(TownCharacterGetNPC(156))
        TownCharacterSetQuest(TownCharacterGetNPC(156))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(156)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(156))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"

        PushPopupTownNpcWithSelectBox(156)
    end

    if OnClickQuestTab(TownCharacterGetNPC(156)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204001))     -- "음.. 춤이나 음악의 제작을 부탁하면\n들어주신다죠..?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(156)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204002))   -- "아, [nickname]님... 안녕하세요?\n부탁이 있는데.. 들어주시겠어요?"
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204003))      -- "이번에.... 광장에서 어린아이들을 위한\n이벤트가 열리는데.... \n제가 피에로 분장을... 하게 되었지 뭐예요....... "
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204004))            -- "근데...\n어떻게 해야 할지 모르겠어요...\n피에로는 갖가지 묘기를 선보이잖아요?.."
        DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204005))            -- "분명히 아이들이 뭔가를 해보라고 할 것 같은데..\n간단하게 접시라도 돌려보고 싶은데, 감이 안 와요..\n시범을 좀 보여주시겠어요?..."
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001",  STR_QUEST_TEXT(880204006))    -- "죄송하지만...\n접시 준비도 좀.. 부탁드릴게요..."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205157)    
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204007))     -- "앗... 준비해주셨군요..!\n감사합니다.."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204008))     -- "두 눈을 크게 뜨고..!!\n잘 보고 있을게요..!!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001",  STR_QUEST_TEXT(880204009))    -- "앗..! 우와..!!\n이렇게 하는 거군요...!!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205157)   
        
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204010))     -- "정말 감사합니다 [nickname]님...\n제 부탁을 들어주시다니...\n정말 친절하시네요... 그럼 또 봬요~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(156)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204002))   -- "아, [nickname]님... 안녕하세요?\n부탁이 있는데.. 들어주시겠어요?"
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204003))      -- "이번에.... 광장에서 어린아이들을 위한\n이벤트가 열리는데.... \n제가 피에로 분장을... 하게 되었지 뭐예요....... "
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204004))            -- "근데...\n어떻게 해야 할지 모르겠어요...\n피에로는 갖가지 묘기를 선보이잖아요?.."
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204005))          -- "분명히 아이들이 뭔가를 해보라고 할 것 같은데..\n간단하게 접시라도 돌려보고 싶은데, 감이 안 와요..\n시범을 좀 보여주시겠어요?..."
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612648, 0)
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204008))      -- "두 눈을 크게 뜨고..!!\n잘 보고 있을게요..!!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001",  STR_QUEST_TEXT(880204009))    -- "앗..! 우와..!!\n이렇게 하는 거군요...!!"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001", STR_QUEST_TEXT(880204011))     -- "접시가 없다면...\n보여주시기 힘들 것 같은데...."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(156, STR_NPC(156), "Characters/npc_manager_square_001",  STR_QUEST_TEXT(880204012))    -- "아.. 무리한 부탁을 한 것 같네요..\n죄송해요..!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612648, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

