-- 휴양지 노래(880212)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()


        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212001))    -- "아~ 무기력해라..\n어디론가 좀 갔다오면 괜찮아지려나.."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(146)
        
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212002))   -- "훌쩍 떠나서 바닷가에서\n파도소리를 들으며 여유롭게\n낮잠 자고 싶네요.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212003))   -- "해변가에서 모닥불을 피워놓는 것도\n좋을 것 같구요..\n그냥 좀 푹~ 쉬고 싶달까..."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212004))   -- "하지만 지금 당장 가게를 비울 수는 없으니\n대신 휴양지 분위기의 음악만이라도 듣고 싶은데.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212005))    -- "저... [nickname]님~\n혹시 저를 위해 기분 전환할 작곡을 좀 해주시겠어요?"
    end

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212006))    -- "노래를 만들 악기가 필요하겠네요..\n아, 그리고 아까 말씀드린 것처럼\n모닥불도 있으면 더 분위기가 살 것 같아요~"
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212007))   -- "오.. 준비하셨네요.."

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212008))  -- "제가 약간 기대를 해도 좋을까요?"
    RequireMusicFollowButton()

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212009))   -- "음~~ 좋아라~\n휴양지의 분위기가 느껴지네요~"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629036)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212010))     -- "무기력한 일상이었는데,\n잠시나마 활력이 생긴 것 같네요.\n고마워요, [nickname] 님."

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212011))    -- "준비되실 때까지 기다려볼게요~"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212012))  -- "아, 바쁘시다구요?\n네.. 그럼 다음에 또 얘기해요~\n하아~.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end


-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(146)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212002))   -- "훌쩍 떠나서 바닷가에서\n파도소리를 들으며 여유롭게\n낮잠 자고 싶네요.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212003))   -- "해변가에서 모닥불을 피워놓는 것도\n좋을 것 같구요..\n그냥 좀 푹~ 쉬고 싶달까..."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212004))   -- "하지만 지금 당장 가게를 비울 수는 없으니\n대신 휴양지 분위기의 음악만이라도 듣고 싶은데.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212005))    -- "저... [nickname]님~\n혹시 저를 위해 기분 전환할 작곡을 좀 해주시겠어요?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212006))    -- "노래를 만들 악기가 필요하겠네요..\n아, 그리고 아까 말씀드린 것처럼\n모닥불도 있으면 더 분위기가 살 것 같아요~"
         
    end

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212007))   -- "오.. 준비하셨네요.."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212008))  -- "제가 약간 기대를 해도 좋을까요?"
    RequireMusicFollowButton()

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212009))   -- "음~~ 좋아라~\n휴양지의 분위기가 느껴지네요~"
      
      Wait(0.5)

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880212010))     -- "무기력한 일상이었는데,\n잠시나마 활력이 생긴 것 같네요.\n고마워요, [nickname] 님."

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end




