-- 춤에 대한 열정(880222)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then

    if OnTownRefresh() then
        
        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"
        
        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    

        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"
        
    end
    
    
elseif CheckQuestRunning() then
    
    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))
        
    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"

        PushPopupTownNpcWithSelectBox(153)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"

    end
    
elseif CheckQuestComplete() then

    if OnTownRefresh() then

        TownCharacterRoamInAchademy(TownCharacterAddNPC(153))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(153))
        TownCharacterSetQuest(TownCharacterGetNPC(153))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(153)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(153))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"

        PushPopupTownNpcWithSelectBox(153)
    end

    if OnClickQuestTab(TownCharacterGetNPC(153)) then
    
     
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222001))    -- "춤에 대한 열정은 저를 따라올 사람이 없을 거예요!"


    end
    
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(153)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222002))      -- "항상 넘치는 열정을 주체할 수 없죠!\n이런 열정을 가득 담아 빠른 리듬에\n열정적으로 몸을 맡기는 춤을 추려구요!"
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222003))      -- " '카탁'을 춰서 뮤직비디오에 담아\n모든 사람들에게 나를 홍보하겠어요!"       
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
	DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880222004))    -- "카탁을 추려면 이 정도는 필요하죠!"
    PushPopupCollectionNeed()
	
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222005))     -- "준비됐군요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222006))     -- "열정을 가득 담아 춰보자구요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880222007))    -- "역시~ 열정이 넘치시는군요!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(153), 612548)   
        
        DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222008))     -- "헤~ 역시 [nickname]님의 열정도 대단하네요.\n그럼 다음에 또 봐요~!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(153)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222002))      -- "항상 넘치는 열정을 주체할 수 없죠!\n이런 열정을 가득 담아 빠른 리듬에\n열정적으로 몸을 맡기는 춤을 추려구요!"
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222003))      -- " '카탁'을 춰서 뮤직비디오에 담아\n모든 사람들에게 나를 홍보하겠어요!"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612548, 0)
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222006))     -- "열정을 가득 담아 춰보자구요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880222007))    -- "역시~ 열정이 넘치시는군요!"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(153, STR_NPC(153), "Characters/npc_014", STR_QUEST_TEXT(880222009))     -- "잠~깐! 준비가 안됐네요?\n열정을 좀 더 충전해보세요~"
    GoTown()
    
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(153, STR_NPC(153), "Characters/npc_014",  STR_QUEST_TEXT(880222010))    -- "제가 [nickname]님 보다 좀 더\n열정이 많은 것 같네요~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612548, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
