-- 로봇 춤(880232)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"
        
        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"

        PushPopupTownNpcWithSelectBox(112)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(112))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(112))
        TownCharacterSetQuest(TownCharacterGetNPC(112))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(112)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(112))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"

        PushPopupTownNpcWithSelectBox(112)
    end

    if OnClickQuestTab(TownCharacterGetNPC(112)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232001))     -- "제가 장기자랑에 나가게 됐어요!!\n음.. 근데 춤을 춰야 하는데 혼자서\n연습하기 너무 힘드네요... 도와주세요!"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(112)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232002))     -- "특이하고 기발한 춤을 추고 싶은데,\n잘 떠오르지 않아서요..!\n[nickname]님께서 도와주시면 안 될까요?"
        DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232003))     -- "음.. 아! 그래~!\n로봇 춤은 어떨까요?\n정말 멋질 것 같아요!"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(112, STR_NPC(112), "Characters/npc_006",  STR_QUEST_TEXT(880232004))    -- "이런 게 있으면 어때요?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201206)    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232005))     -- "헤헤! 멋져요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232006))     -- "저도 열심히 따라 해볼게요!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(112, STR_NPC(112), "Characters/npc_006",  STR_QUEST_TEXT(880232007))    -- "우와! 정말 로봇 같은데요!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(112), "copy")    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 201206)
       
        
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232008))  -- "삐리리릿.  삐리릿!\n정말 기발한 것 같아요!\n고마워요 [nickname]님!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(112)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232002))     -- "특이하고 기발한 춤을 추고 싶은데,\n잘 떠오르지 않아서요..!\n[nickname]님께서 도와주시면 안 될까요?"
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232003))     -- "음.. 아! 그래~!\n로봇 춤은 어떨까요?\n정말 멋질 것 같아요!"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612637, 0)
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232006))     -- "저도 열심히 따라 해볼게요!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(112, STR_NPC(112), "Characters/npc_006",  STR_QUEST_TEXT(880232007))    -- "우와! 정말 로봇 같은데요!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(112, STR_NPC(112), "Characters/npc_006", STR_QUEST_TEXT(880232009))     -- "으잉.. 준비물이 있어야 해요.."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(112, STR_NPC(112), "Characters/npc_006",  STR_QUEST_TEXT(880232010))    -- "앗. 이런..!!\n[nickname]님이 도와주셔야 하는데..."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612637, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

