-- 단체 걸그룹 춤(880233)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"
        
        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"

        PushPopupTownNpcWithSelectBox(126)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(126))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(126))
        TownCharacterSetQuest(TownCharacterGetNPC(126))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(126)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(126))
        
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"

        PushPopupTownNpcWithSelectBox(126)
    end

    if OnClickQuestTab(TownCharacterGetNPC(126)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233001))     -- "이번 장기자랑에서 단체로 춤을\n추기로 했어요 후훗!\n무슨 춤이 예쁠까?"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(126)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233002))     -- "장기자랑하면 걸그룹 춤이죠~!\n여자들끼리 예쁘게 춤 춰보려구요!\n아~! 아이돌 그룹 '아이티즈' 의 춤을 춰볼까~?"
        DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233003))     -- "자! 어서 같이 춰보죠!"    
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880233004))    -- "잠깐만~\n단체 의상은 맞춰야죠!\n저랑 같은 옷을 입어요~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202297)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202297)            
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233005))     -- "와~ 똑같은 의상을 입었네요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233006))     -- "동작을 알려줄게요. 잘 봐요~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880233007))    -- "어때요?\n여러 명이 함께 추면 더 근사하겠죠?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(126), 612622)     
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202297)
    TownCharacterWearClothes(TownCharacterGetNPC(126), 202297)               
        
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233008))     -- "헤헤, 같이 추니 춤출 맛 나네요!\n이 맛에 장기 자랑하는 거지~\n고마워요 [nickname]님!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(126)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233002))     -- "장기자랑하면 걸그룹 춤이죠~!\n여자들끼리 예쁘게 춤 춰보려구요!\n아~! 아이돌 그룹 '아이티즈' 의 춤을 춰볼까~?"
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233003))     -- "자! 어서 같이 춰보죠!"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612622, 0)
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233006))     -- "동작을 알려줄게요. 잘 봐요~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880233007))    -- "어때요?\n여러 명이 함께 추면 더 근사하겠죠?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(126, STR_NPC(126), "Characters/npc_007", STR_QUEST_TEXT(880233009))     -- "이번 장기 자랑에서는 단체로\n춤을 출꺼기 때문에,\n같은 옷을 입는 게 좋을 것 같아요~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(126, STR_NPC(126), "Characters/npc_007",  STR_QUEST_TEXT(880233010))    -- "응!?\n나랑 춤추는 게 싫은 건가요?!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612622, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
