-- 개성이 담긴 춤(880241)
-- version("0.51.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"
        
        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"

        PushPopupTownNpcWithSelectBox(145)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(145))
        TownCharacterSetQuest(TownCharacterGetNPC(145))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(145)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(145))

        SoundPlay(72) --=BGM=Theme_Hairshop
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"

        PushPopupTownNpcWithSelectBox(145)
    end

    if OnClickQuestTab(TownCharacterGetNPC(145)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241001))     -- "듸자~인엔 스피릿!!\n혼을 담아야지! 머리부터 발끝까지!\n춤도 마찬가지야~~"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(145)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
		DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241002))     -- "영혼 없이 춤을 추는 사람들이 있는데 말이야~\n노~노~ 그런 개성 없는 춤보다,\n나만의 색! 나만의 개성을 뽐내야 한다고 생각해~ "
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241003))     -- "나는 언제나, 항상, 나만의 개성을\n담고자 노력한다고~ 내 머리 모양이\n바로 그 개성이 드러난 표현이랄까!"
     DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241004))       -- "춤도 말이야, 잘 추든지 못 추든지 그런 게 중요하다기 보다,\n'나' 자체에 집중해서 내가 뭘 잘 출 수 있는지 생각하고\n그걸 내 트레이드 마크로 만들어 내야 하는 거지~"
        DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241005))   -- "호호, 내가 너무 설교를 했나? 미안 자기.\n그나저나 자기의 개성이 담긴 춤을 보고 싶은데.\n한번 보여주지 않을래?"
    end

	TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001",  STR_QUEST_TEXT(880241006))      -- "이 정도 길이면 되려나~괜찮지~?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241007))     -- "오우 좋아~ 언제나 준비되어있구나~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241008))     -- "음~ 좋아~\n처음 느낌 좋고~~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001",  STR_QUEST_TEXT(880241009))    -- "오 마이갓~!\n정말 뚜~렷한! 개성인 걸?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
        
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241010))  -- "자기는 역시 뭔가 남달라~!\n나중에 우리 미용실에서 오면 더욱더\n자기의 개성을 뽐낼 수 있도록 내가 도와줄게~"
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(145)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241002))     -- "영혼 없이 춤을 추는 사람들이 있는데 말이야~\n노~노~ 그런 개성 없는 춤보다,\n나만의 색! 나만의 개성을 뽐내야 한다고 생각해~ "
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241003))     -- "나는 언제나, 항상, 나만의 개성을\n담고자 노력한다고~ 내 머리 모양이\n바로 그 개성이 드러난 표현이랄까!"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241004))       -- "춤도 말이야, 잘 추든지 못 추든지 그런 게 중요하다기 보다,\n'나' 자체에 집중해서 내가 뭘 잘 출 수 있는지 생각하고\n그걸 내 트레이드 마크로 만들어 내야 하는 거지~"
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241005))   -- "호호, 내가 너무 설교를 했나? 미안 자기.\n그나저나 자기의 개성이 담긴 춤을 보고 싶은데.\n한번 보여주지 않을래?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612628, 0)
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241008))     -- "음~ 좋아~\n처음 느낌 좋고~~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001",  STR_QUEST_TEXT(880241009))    -- "오 마이갓~!\n정말 뚜~렷한! 개성인 걸?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001", STR_QUEST_TEXT(880241011))     -- "흐음~?\n아직 개성을 뽐낼 준비가 되지 않은 것 같은데?"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(145, STR_NPC(145), "Characters/npc_shop_beauty_001",  STR_QUEST_TEXT(880241012))    -- "에엑!? 실망이야 자기~!"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612628, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
