-- 의상에서 느끼는 영감(880242)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."
        
        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
         ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(68) --=BGM=Theme_Clothshop
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."

        PushPopupTownNpcWithSelectBox(146)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(146))
        TownCharacterSetQuest(TownCharacterGetNPC(146))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(146)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
         ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(68) --=BGM=Theme_Clothshop
        
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."

        PushPopupTownNpcWithSelectBox(146)
    end

    if OnClickQuestTab(TownCharacterGetNPC(146)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242001))     -- "개개인의 잠재된 영감을 불러일으킬만한\n의상을 들이는 건 쉬운 게 아니죠.."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(146)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242002))     -- "디자이너의 혼이 담긴 의상은 멀리서 보아도 눈에 띈답니다.\n그런 옷으로 하여금 어떤 영감을 받을 수도 있기도 하고.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242003))     -- "뭐... 멋진 일이죠. 내가 만든 무언가가, 다른 사람에게\n또 다른 무언가를 창조해내는 영감을 준다는 것이.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242004))     -- "그런 옷을 찾고 셀렉 하는 과정이 귀찮지만~\n제 가게의 옷을 좋아해 주는 손님들을 볼 때면\n뿌듯함을 느낄 때도 있어요.."
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242005))     -- "음.. 말이 길어졌네요.\n이번에 가게에 들어온 특별한 의상이 있는데,\n그 의상과 어울리는 춤을 좀 부탁해도 될까요?"
        DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242006))     -- "이 옷을 팔 때 어울리는 춤을 말하려 하는데\n제가 춤까지 생각하기는 좀 귀찮아서요.\n부탁 좀 해도 될까요?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880242007))   -- "바로 이 의상이랍니다.\n어때요, 특이하지 않나요?\n[nickname]님도 한번 입어보세요~"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202026)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242008))     -- "음, 꼭 맞는걸요?"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242009))     -- "과연 어떤 춤이 만들어질까~?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880242010))    -- "오~ 그럴싸한데요?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202026)   
        
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242011))   -- "제 부탁을 들어주셔서 고마워요~\n괜찮은 춤이네요~\n그런데 어떻게 설명해야 하나.. 하아.."
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(146)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242002))     -- "디자이너의 혼이 담긴 의상은 멀리서 보아도 눈에 띈답니다.\n그런 옷으로 하여금 어떤 영감을 받을 수도 있기도 하고.."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242003))     -- "뭐... 멋진 일이죠. 내가 만든 무언가가, 다른 사람에게\n또 다른 무언가를 창조해내는 영감을 준다는 것이.."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242004))     -- "그런 옷을 찾고 셀렉 하는 과정이 귀찮지만~\n제 가게의 옷을 좋아해 주는 손님들을 볼 때면\n뿌듯함을 느낄 때도 있어요.."
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242005))     -- "음.. 말이 길어졌네요.\n이번에 가게에 들어온 특별한 의상이 있는데,\n그 의상과 어울리는 춤을 좀 부탁해도 될까요?"
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242006))     -- "이 옷을 팔 때 어울리는 춤을 말하려 하는데\n제가 춤까지 생각하기는 좀 귀찮아서요.\n부탁 좀 해도 될까요?"
 
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612629, 0)
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242009))     -- "과연 어떤 춤이 만들어질까~?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880242010))    -- "오~ 그럴싸한데요?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001", STR_QUEST_TEXT(880242012))     -- "직접 입어 봐야 어울리는 춤을 만들죠~\n한번 입어보세요."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(146, STR_NPC(146), "Characters/npc_shop_fashion_001",  STR_QUEST_TEXT(880242013))    -- "아.. 이 의상이 취향에 안 맞나요?\n알겠어요, 어쩔 수 없죠~"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612629, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

