-- 혼이 담긴 비트(880244)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()


        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
              DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then

        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(148))
        TownCharacterSetQuest(TownCharacterGetNPC(148))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(148)) then
        PreLoad()

        -- 유저가 신입요원 옆으로 걸어감
        ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
        SoundPlay(30) --=BGM=Character_DJ
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
        PushPopupTownNpcWithSelectBox(148)
    end

    if OnClickQuestTab(TownCharacterGetNPC(148)) then
               DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244001))    -- "요! 내 혼을 담은 새로운 비트,\n이것은 새로운 히트."
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(148)
        
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244002))   -- "어제 밤새도록 작곡한 음악,\n그동안 만든 비트와 좀 달라"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244003))  -- "나의 혼을 담은 비트에 모든 걸 걸어\n네 마음속에 내 비트를 새겨"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244004))  -- "헤이, 들어보고 싶어?\n그럼 소리쳐, 지금 당장 듣고 싶어!"

    end

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244005))   -- "요, 좋아. 하지만 브로.\n이걸 가져오도록."
    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244006))   -- "예~ 기다리고 있었어 브로~!\n렛츠 고~!"

    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244007))  -- "내가 제작한 개성 넘치는 비트\n이제 네가 더할 핫 소스!\n만들어 내. 더 그레이트 비트~!"
    RequireMusicFollowButton()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244008))   -- "요 브라더~!\n나이스 워크!"

    GoSceneTown()
    SoundPlay(music_id)
    -- SoundPlayMusicData(629020)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244009))   -- "요~! 들려줘 너의 느낌!\n정말 완벽하다고 느끼지!?"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244010))   -- "이건 나의 부탁에 대한 보답!\n고마워 브로!"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244011))   -- "음~ 롸잇 히어.\n기다리고 있겠어."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244012))  -- "난 얘기했지, 새로운 내 비트에 대해.\n하지만 넌 얘기하지. 지금은 못해."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(148)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244002))   -- "어제 밤새도록 작곡한 음악,\n그동안 만든 비트와 좀 달라"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244003))  -- "나의 혼을 담은 비트에 모든 걸 걸어\n네 마음속에 내 비트를 새겨"
        DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244004))  -- "헤이, 들어보고 싶어?\n그럼 소리쳐, 지금 당장 듣고 싶어!"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244005))   -- "요, 좋아. 하지만 브로.\n이걸 가져오도록."
         
    end

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244006))   -- "예~ 기다리고 있었어 브로~!\n렛츠 고~!"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244007))  -- "내가 제작한 개성 넘치는 비트\n이제 네가 더할 핫 소스!\n만들어 내. 더 그레이트 비트~!"
    RequireMusicFollowButton()

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244008))   -- "요 브라더~!\n나이스 워크!"

      
      Wait(0.5)

    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244009))   -- "요~! 들려줘 너의 느낌!\n정말 완벽하다고 느끼지!?"
    DialogOpen(148, STR_NPC(148), "Characters/npc_club_dj_001", STR_QUEST_TEXT(880244010))   -- "이건 나의 부탁에 대한 보답!\n고마워 브로!"

    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end




