-- 할머니의 사랑(880253)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."
        
        PushPopupTownNpcWithSelectBox(114)
    end

    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."

        PushPopupTownNpcWithSelectBox(114)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(114))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(114))
        TownCharacterSetQuest(TownCharacterGetNPC(114))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(114)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(114))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."

        PushPopupTownNpcWithSelectBox(114)
    end

    if OnClickQuestTab(TownCharacterGetNPC(114)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253001))     -- "에구 우리 손녀가 말이지..\n어느새 다 자라서 저렇게 춤도 추고..\n내가 춤을 하나 가르쳐 주고 싶은데..."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(114)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253002))     -- "자네 덕분에 요새 우리 손녀가~\n기가  아주 팔팔~! 해져선 말이야~"
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253003))     -- "뮤직비디오를 신나게 찍으러 다닌다네.\n얼마나 보기 좋은지..."
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253004))     -- "그래서 이 할미가 더 유명해지라고~\n왕년에 팔팔했던 시절에 췄던 춤을 알려주고 싶은데 말이지.."
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253005))    -- "늙은이가 이제 와서 춤을 기깔나게 추려니\n영 몸이 안 따라주네 허허.."
        DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253006))      -- "내가 생각한 춤을, [nickname]가 나대신\n한번 춰줘서, 괜찮은 지 어떤지 한번\n보여줄 수 있을까?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(114, STR_NPC(114), "Characters/npc_008",  STR_QUEST_TEXT(880253007))    -- "아이구, 고맙네 고마워..\n어디보자아..\n이게 필요했던 것 같은데.."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253008))     -- "어이구~ 준비도 빨리했네~!\n역시 젊어서 빠릿 빠릿 하구먼~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253009))     -- "내가 말한 춤은 이거여~"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(114, STR_NPC(114), "Characters/npc_008",  STR_QUEST_TEXT(880253010))    -- "어뗘~ 손주가 좋아할 것 같남?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(114), 612630)    
        
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253011))  -- "고맙네. 고마워.\n먼저 우리 손녀 뮤비에\n이 할미가 별점 다섯 개 주러 가야지.."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253012))  -- "이건 이 늙은이가 주는 보상이여..\n받아두게~ 고마워 젊은 양반~"
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(114)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")

    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253003))     -- "뮤직비디오를 신나게 찍으러 다닌다네.\n얼마나 보기 좋은지..."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253004))     -- "그래서 이 할미가 더 유명해지라고~\n왕년에 팔팔했던 시절에 췄던 춤을 알려주고 싶은데 말이지.."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253005))    -- "늙은이가 이제 와서 춤을 기깔나게 추려니\n영 몸이 안 따라주네 허허.."
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253006))      -- "내가 생각한 춤을, [nickname]가 나대신\n한번 춰줘서, 괜찮은 지 어떤지 한번\n보여줄 수 있을까?"
    
    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612630, 0)
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253009))     -- "내가 말한 춤은 이거여~"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008",  STR_QUEST_TEXT(880253010))    -- "어뗘~ 손주가 좋아할 것 같남?"
    SetCollectionData()
    
    PopScene()
end

if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(114, STR_NPC(114), "Characters/npc_008", STR_QUEST_TEXT(880253013))     -- "으잉? 아직 준비가 안된 것 같구먼~"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    
    DialogOpen(114, STR_NPC(114), "Characters/npc_008",  STR_QUEST_TEXT(880253014))    -- "으잉? 그려~ 지금 안된다면 어쩔 수 없지.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612630, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
