-- 기타와 여유(880262)
-- version("0.49.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"
        
        PushPopupTownNpcWithSelectBox(164)
        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end

    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"

        PushPopupTownNpcWithSelectBox(164)

        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        -- 고정 NPC 는 추가 및 위치 지정 금지
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"

        PushPopupTownNpcWithSelectBox(164)

        if CheckIsOnQuest(810010) then
            UIAddNewIconAtWithCCB("UI_common/ui_btn2_012_07", "btn_shop_instr", "btn_shop_instr/iconNew", 52, 30)
        end

    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262001))     -- "한가한 시간에는\n홀로 기타 치는 걸 좋아합니다.\n#여유 #감성"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262002))      -- "저는 사실 광장에 가는 것을 굉장히 즐깁니다.\n(바빠서 잘 못 가지만..)"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262003))       -- "해 질 녘부터 밤까지.. 방해받지 않는 곳에서\n돗자리를 깔고 기타를 치며\n감성적인 곡을 만드는 걸 즐기죠."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262004))     -- "[nickname]씨는 기타를 칠 줄 아나요?\n#궁금"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262005))     -- "이럴 수가!\n기타 치는 자세도 모르다니!\n어서 나의 자세를 보고 참고하세요."
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001",  STR_QUEST_TEXT(880262006))    -- "기타는 메고 있어야 합니다."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202293)    

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262007))     -- "기타를 가져오셨군요."
    
    RequireSceneDanceCorrection()
    
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262008))     -- "잘 따라 하시면 됩니다."
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001",  STR_QUEST_TEXT(880262009))    -- "좋네요. 괜찮은 자세입니다."
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202293)   
        
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262010))  -- "어떤가요.\n#뿌듯"
   
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(164)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262002))      -- "저는 사실 광장에 가는 것을 굉장히 즐깁니다.\n(바빠서 잘 못 가지만..)"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262003))       -- "해 질 녘부터 밤까지.. 방해받지 않는 곳에서\n돗자리를 깔고 기타를 치며\n감성적인 곡을 만드는 걸 즐기죠."
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262004))     -- "[nickname]씨는 기타를 칠 줄 아나요?\n#궁금"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262005))     -- "이럴 수가!\n기타 치는 자세도 모르다니!\n어서 나의 자세를 보고 참고하세요."

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612559, 0)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262008))     -- "잘 따라 하시면 됩니다."

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001",  STR_QUEST_TEXT(880262009))    -- "좋네요. 괜찮은 자세입니다."
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880262011))     -- "기타가 없으면 곤란합니다만."
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001",  STR_QUEST_TEXT(880262012))    -- "가끔은 자신의 감성을 표현해보는 건 어떨까요.\n#실망"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612559, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

