-- 사랑의총알(뱅뱅뱅)(880273)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"
        
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"

        PushPopupTownNpcWithSelectBox(150)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"

        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273001))     -- "[nickname]님!\n이성의 마음을 훔치는 법을 알았어요!\n [nickname]님도 궁금하죠!?"
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(150)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        TownCharacterSetDanceIdle(TownCharacterAddNPC(150), 612552)   
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273002))     -- "빵야 빵야!\n사랑의 총알을 쏴보면 어떨까요!?"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273003))     -- "내 사랑의 총에 맞는다면 한 번에 저한테 넘어오겠죠?"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273004))     -- "같이 한번 총알을 쏴보실래요?\n빵야~ 하고 쏴보는 거예요~ 헤헤"
	end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(150), 612552)       
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880273005))    -- "예쁜 옷도 입어보자구요~!"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202320)
     TownCharacterWearClothes(TownCharacterGetNPC(150), 202320)          
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273006))     -- "그래요! 바로 이거예요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273007))     -- "빵야! 빵야!\n사랑의 총알을 마구 쏴보자구요~!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880273008))    -- "오~ 잘 쏘시는데요!?"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(150), 612552)   
    TownCharacterWearClothes(TownCharacterGetNPC(1), 202320)   
    TownCharacterWearClothes(TownCharacterGetNPC(150), 202320)   
        
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273009))  -- "윽~! [nickname]님!\n저 방금 [nickname]님 총알에 심장을\n관통당했어요!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273010))        -- "헤헤, 누구든 넘어올 것 같아요!\n어때요! 제 마음 훔치는 법?\n이제 모두 저한테 마음을 뺏기겠죠?"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(150)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273002))     -- "빵야 빵야!\n사랑의 총알을 쏴보면 어떨까요!?"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273003))     -- "내 사랑의 총에 맞는다면 한 번에 저한테 넘어오겠죠?"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273004))     -- "같이 한번 총알을 쏴보실래요?\n빵야~ 하고 쏴보는 거예요~ 헤헤"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612552, 0)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273007))     -- "빵야! 빵야!\n사랑의 총알을 마구 쏴보자구요~!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880273008))    -- "오~ 잘 쏘시는데요!?"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880273011))     -- "음? 아직 마음의 준비가 안되셨다구요?"
    GoTown()
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880273012))    -- "이성의 마음에 관심이 없다니!\n어떻게 그럴 수 있죠~!?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612552, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

