-- 쪼아 춤(880274)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"
        
        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
       
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"

        PushPopupTownNpcWithSelectBox(150)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(150))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(150))
        TownCharacterSetQuest(TownCharacterGetNPC(150))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(150)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(150))
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"

        PushPopupTownNpcWithSelectBox(150)
    end

    if OnClickQuestTab(TownCharacterGetNPC(150)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274001))     -- "[nickname]님! 제가 좀 연구해 봤는데요..!!\n이성에게 인기가 많으려면..\n귀여워야 하는 것 같아요!"
    end
end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(150)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274002))     -- "음, 제가 고민을 좀 해보았죠...\n이성을 뛰어넘어 동성까지 포섭할만한\n진정한 인기란 무엇인가!"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274003))     -- "그래서 귀여운 춤을 만들어 봤어요!\n남녀 누구나 귀여운 걸 좋아하잖아요~"
        DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274004))     -- "긍정적인 이미지의 귀여운 춤이라면\n누구나 다 좋아하지 않을까요?"    
    end

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880274005))    -- "그럼 이런 걸 좀 준비해 보실래요~?"
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205159)
    TownCharacterWearClothes(TownCharacterGetNPC(150), 205159)            
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274006))     -- "역시, [nickname]님도 인기를 위해서라면\n준비해주실 줄 알았어요!"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274007))     -- "최대한 귀엽게 춰보는 거예요~!"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880274008))    -- "우와~! [nickname]님 정말 귀여워요!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterSetDanceIdle(TownCharacterAddNPC(150), 612643)
    TownCharacterWearClothes(TownCharacterGetNPC(1), 205159)   
        
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274009))  -- "이야~! 꽤나 인기를 끄시겠어요!\n너무 귀엽잖아요!~~"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274010))        -- "저한테 전수받은 스킬이라고 꼭!\n코멘트 해주셔야 해요~ 헤헤!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(150)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274002))     -- "음, 제가 고민을 좀 해보았죠...\n이성을 뛰어넘어 동성까지 포섭할만한\n진정한 인기란 무엇인가!"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274003))     -- "그래서 귀여운 춤을 만들어 봤어요!\n남녀 누구나 귀여운 걸 좋아하잖아요~"
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274004))     -- "긍정적인 이미지의 귀여운 춤이라면\n누구나 다 좋아하지 않을까요?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612643, 0)
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274007))     -- "최대한 귀엽게 춰보는 거예요~!"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880274008))    -- "우와~! [nickname]님 정말 귀여워요!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(150, STR_NPC(150), "Characters/npc_003", STR_QUEST_TEXT(880274011))     -- "인기를 위한 거라면!\n뭐든 준비가 필요하죠!"
    GoTown()
end

if OnQuestGiveUp() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(150, STR_NPC(150), "Characters/npc_003",  STR_QUEST_TEXT(880274012))    -- "엥?! 인기에 관심이 없으시다구요!?"
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612643, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end
