-- 행복한 댄스빌(880304)
-- version("0.31.00")

if HasLuaHeader == nil or HasLuaHeader() == true then
    require("Header")
end

if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end
    
    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
          
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."
        
        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."
    end
elseif CheckQuestRunning() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()
        
        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."

        PushPopupTownNpcWithSelectBox(101)
    end
    
    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInAchademy(TownCharacterAddNPC(101))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(101))
        TownCharacterSetQuest(TownCharacterGetNPC(101))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(101)) then
        PreLoad()

        -- 유저가 npc 옆으로 걸어감
        ScriptTownMoveToSide(TownCharacterGetNPC(101))
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
        
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."

        PushPopupTownNpcWithSelectBox(101)
    end

    if OnClickQuestTab(TownCharacterGetNPC(101)) then
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")  
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304001))     -- "댄스빌은 나의 전부지.\n댄스빌에 살고 있는 건 정말 행복한 일이라고\n진심으로 생각한다네."
    end
end

if OnClickQuestStart() then
    
    FullLoad() -- 리소스 로딩
      -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
    
    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(101)
        
        TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304002))     -- "매일 아침 눈을 뜨면, 오늘은 어떤 춤을 출지!\n또 어떤 음악을 듣게 될지, 항상 설렌다네..\n하하..  정말 행복한 삶이지!"
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880304003))     -- "그래서 말이야.. 내가 생각하는 이 행복함을\n춤으로 표현하고자 한다네. 말 그대로\n'행복함'을 표현한 춤이랄까.."
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304004))            -- "아직 어떤 춤을 출 지 안정했지만...\n혹시 자네가 추는 춤이 나에게\n영감을 줄 수 있지 않을까 해서 와봤다네. "
        DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304005))     -- "자네의 행복함을 나타내는 춤을 춰보지 않겠나?"
    end
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001",  STR_QUEST_TEXT(880304006))    -- "한.. 이 정도 길이의 춤으로\n표현해주면 좋겠네만..\n의상은 자네 마음대로 입어보시게."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304007))     -- "음. 기대되는군~"
    
    RequireSceneDanceCorrection()
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304008))     -- "기대해도 되겠나?"
      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004",  STR_QUEST_TEXT(880304009))    -- "자네.... 정말....\n그 누구보다 행복해 보이는군!"
    
    GoSceneTown()
        
    TownCharacterAction(TownCharacterGetNPC(1), "copy")
    TownCharacterAction(TownCharacterGetNPC(101), "copy")    
        
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_006", STR_QUEST_TEXT(880304010))     -- "행복함을 이렇게까지 표현이라니!\n정말 대단하군!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304011))     -- "영감이 마구 떠오르고 있다네!\n역시! 자네를 찾아오길 잘했어!\n고맙네!"
    
    Wait(0.5)
    ScenarioEndingShow()
    
    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
    
end

  -- 춤 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

      -- 퀘스트 배경음
	SoundPlay(9) --=BGM=Event_Quest_common
      -- 퀘스트 인트로
    ScenarioIntroShow(101)
    
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
   
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304002))     -- "매일 아침 눈을 뜨면, 오늘은 어떤 춤을 출지!\n또 어떤 음악을 듣게 될지, 항상 설렌다네..\n하하..  정말 행복한 삶이지!"
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_005", STR_QUEST_TEXT(880304003))     -- "그래서 말이야.. 내가 생각하는 이 행복함을\n춤으로 표현하고자 한다네. 말 그대로\n'행복함'을 표현한 춤이랄까.."
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304004))            -- "아직 어떤 춤을 출 지 안정했지만...\n혹시 자네가 추는 춤이 나에게\n영감을 줄 수 있지 않을까 해서 와봤다네. "
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_002", STR_QUEST_TEXT(880304005))     -- "자네의 행복함을 나타내는 춤을 춰보지 않겠나?"

    HideUpperUI("uiBtnSkip")
    RequireSceneDanceFollow(612661, 0)
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304008))      -- "기대해도 되겠나?"

      -- DescriptionBarShow("모든 프레임의 자세를 안내선과 같도록 교정하세요.")
    RequireDanceFollowButton()
      -- DescriptionBarHide()
    Wait(0.5)
    
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_004",  STR_QUEST_TEXT(880304009))     -- "자네.... 정말....\n그 누구보다 행복해 보이는군!"
    SetCollectionData()
    
    PopScene()
end


if OnClickCollectionQuestPopupClose() then
    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")
    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_001", STR_QUEST_TEXT(880304012))     -- "아직 이 정도 길이의 춤을 출 수 있지 않아 보이는군."
    GoTown()
end

if OnQuestGiveUp() then

    TownCharacterAction(TownCharacterGetNPC(1), "dance_01")    

    DialogOpen(101, STR_NPC(101), "Characters/npc_caba_007",  STR_QUEST_TEXT(880304013))    -- "이런. 나의 행복함을 자네와 함께\n나누고 싶었는데 말일세.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()
    
end

 -- 춤 편집 중 스킵 버튼을 눌렀을 때 (편집화면 시작멘트까지 스킵)
if OnClickCollectionStorySkipButton() then
    RequireSceneDanceFollow(612661, 0)
    DanceEdit()
    ScenarioEndingShow()
    PopScene()
end

