-- 멜로디에 비트 넣어보기(880312)
-- version("0.49.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))      -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))    -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))     -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))   -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()

        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))   -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312001))   -- "비트를 ‘잘’ 만들면 음악이 풍부해진다는 것을\n알고 있습니까?  #드럼 비트"
    end

end

if OnClickQuestStart() then
    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312002))   -- "똑같은 멜로디에 베이스 반주가 있냐, 없냐의 차이는\n같은 만두라도 속이 다르면 맛이 다르듯이,\n전혀 색다른 차이가 있죠. #갑자기 배고픔"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312003))          -- "마침 멜로디에 드럼 비트를 추가하려던 참입니다.\n한번 어떻게 다른지 보실…?"
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312004))   -- "이것들이 필요합니다."
    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then
    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312005))   -- "준비가 되었군요. #박수"

local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312006))  -- "저기 제가 미리 만든 멜로디가 있습니다.\n멜로디 만으로도 꽤 괜찮지 않..?"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312007))      -- "비트를 넣었을 때의 차이를 비교해봐야 하니..\n어서 드럼을 넣어봅시다."
    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312008))   -- "어때요. 제가 말한 차이를 알겠죠?\n(모르면 큰일인데…)"

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    --SoundPlayMusicData(629082) 

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312009))  -- "[nickname] 씨는 어느 쪽이 더 좋습니까?\n#멜로디 #비트가 있는 멜로디 #취향 존중"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312010))  -- "같은 멜로디에 다른 비트를 넣어보면\n여러 가지 곡을 만들 수 있을 겁니다. "

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312011))  -- "앗.. 아직 없습니다. #준비물"
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312012))   -- "어쩔 수 없군요. #다음 기회에.."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end




-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312002))   -- "똑같은 멜로디에 베이스 반주가 있냐, 없냐의 차이는\n같은 만두라도 속이 다르면 맛이 다르듯이,\n전혀 색다른 차이가 있죠. #갑자기 배고픔"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312003))          -- "마침 멜로디에 드럼 비트를 추가하려던 참입니다.\n한번 어떻게 다른지 보실…?"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312004))   -- "이것들이 필요합니다."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312005))   -- "준비가 되었군요. #박수"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312006))  -- "저기 제가 미리 만든 멜로디가 있습니다.\n멜로디 만으로도 꽤 괜찮지 않..?"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312007))      -- "비트를 넣었을 때의 차이를 비교해봐야 하니..\n어서 드럼을 넣어봅시다."
    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312008))   -- "어때요. 제가 말한 차이를 알겠죠?\n(모르면 큰일인데…)"

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312009))  -- "[nickname] 씨는 어느 쪽이 더 좋습니까?\n#멜로디 #비트가 있는 멜로디 #취향 존중"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880312010))  -- "같은 멜로디에 다른 비트를 넣어보면\n여러 가지 곡을 만들 수 있을 겁니다. "


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


