-- 비트에 어울리는 멜로디 제작하기(880314)
-- version("0.31.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))      -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
        PushPopupTownNpcWithSelectBox(164)
        SoundPlay(69) --=BGM=Theme_Instrumentshop
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))    -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))     -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
        PushPopupTownNpcWithSelectBox(164)
        SoundPlay(69) --=BGM=Theme_Instrumentshop
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))   -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))   -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
        PushPopupTownNpcWithSelectBox(164)
        SoundPlay(69) --=BGM=Theme_Instrumentshop
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314001))   -- "또 왔군요. #환영\n비트를 만들었는데 한번 들어보지 않으실..?"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314002))   -- "만들어둔 드럼 비트가 있는데 어울리는 멜로디가 딱히\n떠오르질 않네요. #멜로디 고갈\n[nickname]씨는 혹시 좋은 멜로디를 아나요?"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314003))   -- "듣고 괜찮으면 멜로디를 추가해주지 않겠습니까? #기대"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314004))           -- "뭐.. 팁을 드리자면 멜로디를 만드는 가장 쉬운 방법은..\n어디서 들어본 음을 재현해보는 것이 가장 쉽죠.\n#모방은 창조의 어머니  #표절 주의"
        
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314005))   -- "이런 소리를 내는 악기로 멜로디를 한번 만들어보세요."

    PushPopupCollectionNeed()
end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314006))   -- "악기를 구해왔군요."

local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314007))  -- "제법 괜찮은 비트 아닙니까 #뿌듯"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314008))      -- "그럼 이제 어울리는 멜로디를 “자유롭게” 추가해주세요."

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314009))   -- "좋네요."

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629084)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314010))  -- "좋은 곡이 탄생한 것 같아 기분이 좋군요.\n덕분입니다. #짝짝짝"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314011))  -- "아직 필요한 악기가 없습니다."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314012))   -- "... 알겠..."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314002))   -- "만들어둔 드럼 비트가 있는데 어울리는 멜로디가 딱히\n떠오르질 않네요. #멜로디 고갈\n[nickname]씨는 혹시 좋은 멜로디를 아나요?"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314003))   -- "듣고 괜찮으면 멜로디를 추가해주지 않겠습니까? #기대"
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314004))           -- "뭐.. 팁을 드리자면 멜로디를 만드는 가장 쉬운 방법은..\n어디서 들어본 음을 재현해보는 것이 가장 쉽죠.\n#모방은 창조의 어머니  #표절 주의"
        
    --[[
    if CheckQuestStart() then
    else
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314005))   -- "이런 소리를 내는 악기로 멜로디를 한번 만들어보세요."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314006))   -- "악기를 구해왔군요."
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314007))  -- "제법 괜찮은 비트 아닙니까 #뿌듯"
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314008))      -- "그럼 이제 어울리는 멜로디를 “자유롭게” 추가해주세요."

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314009))   -- "좋네요."

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880314010))  -- "좋은 곡이 탄생한 것 같아 기분이 좋군요.\n덕분입니다. #짝짝짝"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end
