-- 리드 소리 제작하기(880323)
-- version("0.50.00")

if CheckQuestAppear() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))      -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))    -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
    end

elseif CheckQuestRunning() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))     -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))   -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
    end

elseif CheckQuestComplete() then

    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(164))
        TownCharacterSetQuest(TownCharacterGetNPC(164))

    end

    if OnTownCharacterClick(TownCharacterGetNPC(164)) then
        PreLoad()
        ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
        SoundPlay(69) --=BGM=Theme_Instrumentshop
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))   -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
        PushPopupTownNpcWithSelectBox(164)
    end

    if OnClickQuestTab(TownCharacterGetNPC(164)) then
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323001))   -- "리드 악기가 뭔지 알죠?\n(혹시 모릅..?)"
    end

end

if OnClickQuestStart() then

    FullLoad() -- 리소스 로딩
    -- UnlockQuestContents() -- 퀘스트 진행 시 필요한 기능들을 오픈

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    if IsDialogSkipQuest() == false then
        -- 퀘스트 인트로
        ScenarioIntroShow(164)
        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323002))   -- "음악의 멜로디를 리드하는 악기를 리드 악기라고 부릅니다."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323003))   -- "기타, 피아노 와 같은 악기들이 음악의 코드와\n분위기를 이끌어주기(리드하기) 때문에\n주로 음악의 컨셉과 스타일을 책임지죠."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323004))         -- "물론 다양한 여러 악기들이 멜로디 악기가 될 수 있죠.\n그중에 가장 익숙한 악기들을 대표적인 예로 들어봤습니다.\n[nickname]씨는 무슨 악기를 주로 사용하는지 궁금하군요."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323005))   -- "리드 악기를 사용하지 않은 음악이 있는데,\n[nickname]씨의 취향대로 그 채널을 채워보지 않겠? #기대"
        
    end


        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323006))   -- "리드 악기는 [nickname]님이 아무거나 자유롭게 준비해보세요."


    PushPopupCollectionNeed()

end

if OnClickCollectionQuestPopupOk() then

    SetCostumeCollectionNeeds()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323007))   -- "왔군요.\n리드악기로 무슨 악기를 준비하셨는지 기대가 됩니다.\n#궁금"

local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323008))  -- "어떤 리드 멜로디가 나올지 정말 기대되는군요."

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323009))   -- "음.. 이 악기를 사용했군요.\n좋습니다.\n제가 만든 다른 채널과 잘 어울리군요."

    GoSceneTown()
    SoundPlay(35) -- =BGM=Theme_Town
    -- SoundPlayMusicData(629015)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323010))  -- "고생했습니다.\n(원한다면 다음에 다른 악기로 편집을 해 보는 것도 추천..)"

    Wait(0.5)
    ScenarioEndingShow()

    QuestStart()
    QuestComplete()
    QuestReward()
    PushPopupCollectionReward()
    RestoreUserConstume()
    -- GoTown()
end

if OnClickCollectionQuestPopupClose() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323011))    -- "아직 리드 악기를 뭘로 할지 정하지 못했군요.\n천천히 정해보세요."
    GoTown()

end

if OnQuestGiveUp() then

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323012))   -- "이런.. 포기하는 겁니까."
    SendProtocolQuestGiveUp()
    GoTown()
    RestoreUserConstume()

end



-- 음악 편집
if OnClickCollectionEdit() then

    FullLoad() -- 리소스 로딩

    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common

    -- 퀘스트 인트로
    ScenarioIntroShow(164)

    -- 스킵 버튼 활성화
    AddQuestSkipButton()

        
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323002))   -- "음악의 멜로디를 리드하는 악기를 리드 악기라고 부릅니다."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323003))   -- "기타, 피아노 와 같은 악기들이 음악의 코드와\n분위기를 이끌어주기(리드하기) 때문에\n주로 음악의 컨셉과 스타일을 책임지죠."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323004))         -- "물론 다양한 여러 악기들이 멜로디 악기가 될 수 있죠.\n그중에 가장 익숙한 악기들을 대표적인 예로 들어봤습니다.\n[nickname]씨는 무슨 악기를 주로 사용하는지 궁금하군요."
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323005))   -- "리드 악기를 사용하지 않은 음악이 있는데,\n[nickname]씨의 취향대로 그 채널을 채워보지 않겠? #기대"
        
    --[[
    if CheckQuestStart() then
    else
        DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323006))   -- "리드 악기는 [nickname]님이 아무거나 자유롭게 준비해보세요."
         
    end

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323007))   -- "왔군요.\n리드악기로 무슨 악기를 준비하셨는지 기대가 됩니다.\n#궁금"
    ]]--


    local music_id = GetCollecctionQuestMusicID()

    SoundLoadMusicData(music_id)
    RequireSceneMusicTrackListFollow(music_id)
    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323008))  -- "어떤 리드 멜로디가 나올지 정말 기대되는군요."

    RequireMusicFollowButton()

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323009))   -- "음.. 이 악기를 사용했군요.\n좋습니다.\n제가 만든 다른 채널과 잘 어울리군요."

      
      Wait(0.5)

    DialogOpen(164, STR_NPC(164), "Characters/npc_shop_instrument_001", STR_QUEST_TEXT(880323010))  -- "고생했습니다.\n(원한다면 다음에 다른 악기로 편집을 해 보는 것도 추천..)"


    SetCollectionData()

    ScenarioEndingShow()
    PopScene()
end


