
-- 아르바이트를 시작하면 카페 유니폼을 착용하고 카페 안을 돌아다니며 춤을 춤
-- 식탁 앞에서는 뒤로 돌아 정리하는 듯 한 액션 가미

local function WearDefault()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202706)
end

local function WearWithFood()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202706)
    Character_Wear("dancer", 205712)
end

local function WearWithRag()
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202706)
    Character_Wear("dancer", 205715)
end

if OnArbeit() then
    -- 카페 바깥 테이블
    SetItem("table", 10020506)
    
    x_cafe = -41 -- 17
    y_cafe = 45 -- 31
    
    l_cafe = x_cafe-4
    r_cafe = x_cafe+6
    b_cafe = y_cafe-4
    t_cafe = y_cafe+6

    -- 음식
    SetAnimationByTownObjectID("food_ani", 10020510) -- 카페 아르바이트 컵

    WearDefault()
    Character_RoamIn("dancer", l_cafe, r_cafe, b_cafe, t_cafe)

    SetCharacter("client_1", 350)
    Item_SetCharacterFront("table", "client_1", 0)
    Character_ActionID_Offset("client_1", 612222)

    SetCharacter("client_2", 351)
    Item_SetCharacterFront("table", "client_2", 0)
    Character_ActionID_Offset("client_2", 612223)

    -- 반복
    while 1 do
        -- 카운터 근처로 이동
        Character_WaitMoveTo("dancer", (x_cafe+2)*40, (y_cafe+2)*40)

        -- 음식을 들려주자
        WearWithFood()

        -- 카페 돌아다님, 음식 든 자세
        Character_SetIdleAction("dancer", 612201)
        Character_SetRoamingAction("dancer", 612194, 612200)
        Character_RoamIn("dancer", l_cafe, r_cafe, b_cafe, t_cafe)
        Wait(1)

        -- 식탁 근처로 이동
        Character_WaitMoveTo("dancer", (x_cafe-1)*40, (y_cafe-3)*40)

        -- 음식 놓기
        Item_SetCharacterBack("table", "dancer", 0)
        Character_LeftArmToFront("dancer", "table")
        Character_ActionID_Offset("dancer", 612197)
        Wait(1)
        WearDefault()
        Item_SetAniFront("table", "food_ani")
        Animation_Play("food_ani")
        Animation_SetPos("food_ani", 87, 20)
        Item_UnsetCharacter("table", "dancer")
        Character_ArmsToBack("dancer")

        -- 카페 돌아다님
        Character_SetRoamingAction("dancer", 612065, 0)
        Character_RoamIn("dancer", l_cafe, r_cafe, b_cafe, t_cafe)
        Wait(12)

        -- 식탁 근처로 이동
        Character_WaitMoveTo("dancer", (x_cafe-1)*40, (y_cafe-3)*40)

        -- 음식 제거
        Item_SetCharacterBack("table", "dancer", 0)
        Character_LeftArmToFront("dancer", "table")
        Character_RightArmToFront("dancer", "table")
        Character_ActionID_Offset("dancer", 612202)
        Wait(1)
        Item_UnsetCharacter("table", "dancer")
        Character_ArmsToBack("dancer")
        Item_UnsetAni("table", "food_ani")

        -- 테이블 닦기
        Item_SetCharacterBack("table", "dancer", 0)
        WearWithRag()
        Character_LeftArmToFront("dancer", "table")
        Character_RightArmToFront("dancer", "table")
        Character_ActionID_Offset("dancer", 612083)
        Wait(5)
        Item_UnsetCharacter("table", "dancer")
        Character_ArmsToBack("dancer")
    end
end
