
-- 아르바이트를 시작하면 광장 내 임의의 장소에서 춤을 춤
-- 원래 입고 있던 의상 그대로
if OnArbeit() then
    -- 광장 기준 위치
    x = 0 -5*40;
    y = 33*40 +4*40;

    -- 사운드바1
    SetAnimationByTownObjectID("sound_bar_1", 10020908)
    Animation_SetPos("sound_bar_1", x+0, y+120)
    Animation_SetAsTownObject("sound_bar_1")

    -- 사운드바2
    SetAnimationByTownObjectID("sound_bar_2", 10020908)
    Animation_SetPos("sound_bar_2", x+360, y+120)
    Animation_SetAsTownObject("sound_bar_2")

    -- 마이크1
    SetAnimationByTownObjectID("mic_1", 10020905)
    Animation_SetPos("mic_1", x+40, y+80)
    Animation_SetAsTownObject("mic_1")

    -- 마이크2
    SetAnimationByTownObjectID("mic_2", 10020906)
    Animation_SetPos("mic_2", x+360, y+0)
    Animation_SetAsTownObject("mic_2")

    -- 마이크3
    SetAnimationByTownObjectID("mic_3", 10020907)
    Animation_SetPos("mic_3", x+240, y+40)
    Animation_SetAsTownObject("mic_3")

    -- 보라색천
    SetAnimationByTownObjectID("stage", 10020900)
    Animation_SetPos("stage", x+40, y+0)
    Animation_SetAsTownLugs("stage")

    -- 피아노
    SetAnimationByTownObjectID("piano", 10020909)
    Animation_SetPos("piano", x+100, y+80)
    Animation_SetAsTownObject("piano")

    -- 기타동전통
    SetAnimationByTownObjectID("moneybag", 10020910)
    Animation_SetPos("moneybag", x+80, y+0)
    Animation_SetAsTownObject("moneybag")

    -- 비둘기
    SetAnimationByTownObjectID("dove_1", 10020901)
    Animation_SetPos("dove_1", x-80, y-360)
    Animation_SetAsTownObject("dove_1")

    SetAnimationByTownObjectID("dove_2", 10020902)
    Animation_SetPos("dove_2", x+0, y-240)
    Animation_SetAsTownObject("dove_2")

    SetAnimationByTownObjectID("dove_3", 10020903)
    Animation_SetPos("dove_3", x+360, y-320)
    Animation_SetAsTownObject("dove_3")

    -- 기타
    SetAnimationByTownObjectID("guitar", 10020904)
    Animation_SetPos("guitar", x+280, y+25)
    Animation_SetAsTownObject("guitar");


    -- 문하생
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 202708) -- 옷
    Character_Wear("dancer", 201706) -- 모자
    Character_StandAt("dancer", x+240, y+80)
    Character_LeftArmToFront("dancer", "mic_3")
    Character_RightArmToFront("dancer", "mic_3")
    Animation_SetCharacterBack("mic_3", "dancer")
    Character_ActionID("dancer", 612191) -- 춤

    -- NPC
    SetCharacter("townsquare_alba_1", 339)
    Character_StandAt("townsquare_alba_1", x+120, y+80)
    Animation_SetCharacterBack("piano", "townsquare_alba_1")
    Character_LeftArmToFront("townsquare_alba_1", "piano")
    Character_RightArmToFront("townsquare_alba_1", "piano")
    Character_ActionID("townsquare_alba_1", 612183)

    SetCharacter("townsquare_alba_2", 340)
    Character_StandAt("townsquare_alba_2", x+320, y+40)
    Animation_SetCharacterBack("guitar", "townsquare_alba_2");
    Character_LeftArmToFront("townsquare_alba_2", "guitar")
    Character_ActionID("townsquare_alba_2", 612190)

    SetCharacter("townsquare_gallery_1", 341)
    Character_StandAt("townsquare_gallery_1", x+0, y-80)

    SetCharacter("townsquare_gallery_2", 342)
    Character_StandAt("townsquare_gallery_2", x+40, y-120)

    SetCharacter("townsquare_gallery_3", 343)
    Character_StandAt("townsquare_gallery_3", x-40, y-200)

    SetCharacter("townsquare_gallery_4", 344)
    Character_StandAt("townsquare_gallery_4", x+320, y-120)

    SetCharacter("townsquare_gallery_5", 345)
    Character_StandAt("townsquare_gallery_5", x+400, y-80)

    WaitFinish()
end
