
-- 1000005	홍보 - 옷 가게
-- 1000006	홍보 - 미용실
-- 1000007	홍보 – 인테리어
-- 해당 시설 홍보용 입간판이 옆에 등장
-- 해당 시설의 홍보용 의상을 착용
-- 해당 시설 입구 옆에서 춤을 춤

if OnArbeit() then
    SetAnimationByTownObjectID("ani_left", 10020215)
    SetAnimationByTownObjectID("ani_center", 10020216)
    SetAnimationByTownObjectID("ani_right", 10020217)

    SetItem("stage_left", 10020215)
    SetItem("stage_center", 10020216)
    SetItem("stage_right", 10020217)

    SetCharacter("worker1", 328)
    SetCharacter("worker2", 329)

    Item_SetCharacterFront("stage_left", "worker1", 0)
    Item_SetCharacterFront("stage_center", "dancer", 0)
    Item_SetCharacterFront("stage_right", "worker2", 0)

    Item_SetAniBack("stage_left", "ani_left")
    Item_SetAniBack("stage_center", "ani_center")
    Item_SetAniBack("stage_right", "ani_right")

    -- 해당 시설의 홍보용 의상을 착용
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 201703)
    Character_Wear("dancer", 202703)
    Character_Wear("dancer", 205704)

    -- 스테이지 위에서춤을춤
    Character_StandAt("worker1", 40, 0)
    Character_StandAt("dancer", 40, 0)
    Character_StandAt("worker2", 40, 0)

    Character_Action("worker1", "옷상점홍보02")
    Character_ActionID("dancer", 612176)
    Character_Action("worker2", "옷상점홍보03")

    WaitFinish()
end
