
-- 1000005	홍보 - 옷 가게
-- 1000006	홍보 - 미용실
-- 1000007	홍보 – 인테리어
-- 해당 시설 홍보용 입간판이 옆에 등장
-- 해당 시설의 홍보용 의상을 착용
-- 해당 시설 입구 옆에서 춤을 춤

if OnArbeit() then
    SetItem("shop", 10020400)
    SetItem("shop_wheel", 10020419)

    Item_Hide("shop_wheel")
    wheel_x = Item_GetX("shop_wheel")
    wheel_y = Item_GetY("shop_wheel")

    SetAnimationByTownObjectID("ani_wheel", 10020419)
    Item_SetAniFront("shop_wheel", "ani_wheel")

    SetCharacter("worker1", 330)
    SetCharacter("worker2", 331)
    SetCharacter("worker3", 332)

    -- 해당 시설의 홍보용 의상을 착용
    Character_UnwearClothesAll("dancer")
    Character_Wear("dancer", 201702)
    Character_Wear("dancer", 202702)

    -- 춤을 춤
    x = Item_GetX("shop");
    y = Item_GetY("shop")+40;
    Character_StandAt("worker1", x-40, y-120)
    Character_StandAt("worker2", x+40, y-120)
    Character_StandAt("worker3", x+120, y-120)
    Character_StandAt("dancer", x+352, y-80)

    Character_ActionID("worker1", 612036)
    Character_ActionID("worker2", 612057)
    Character_ActionID("worker3", 612041)

    -- 회전판 애니메이션 맞춰서 동작
    while 1 do
        Animation_Play("ani_wheel")
        Character_ActionID("dancer", 612178)
        Wait(7)
    end

    WaitFinish()
end
