
local function ScriptHireDialog(npc_id)
    hire_count = GetClubDancerHireCount(npc_id)
    if hire_count == 0 then
        DialogOpen(npc_id_clicked, STR_NPC(npc_id_clicked), STR_NPC_IMG(npc_id_clicked, 1), STR_FOLLOWER_DIALOG(npc_id_clicked, 610))
    else
        DialogOpen(npc_id_clicked, STR_NPC(npc_id_clicked), STR_NPC_IMG(npc_id_clicked, 1), STR_FOLLOWER_DIALOG(npc_id_clicked, 620))
    end
end

if OnTownRefresh() then
    dancer_id = GetInteger("dancer_id")
    TownCharacterRoamInClub(TownCharacterAddNPC(dancer_id))
    TownCharacterSetAsClub(TownCharacterGetNPC(dancer_id))
end

if OnTownAnyCharacterClick() then
    npc_id_clicked = GetInteger("npc_id_clicked")
    PushPopupTownClubDancer(npc_id_clicked)
    ScriptTownZoomInCharacter(TownCharacterGetNPC(npc_id_clicked))
    ScriptHireDialog(npc_id_clicked)
end

if OnTownDancerHire() then
    npc_id = GetInteger("dancer_id_hired")
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 630))
    GoTown()
end
