
if OnTownRefresh() then

    if CheckHasDanceGameQuest() and CheckUnlock(520030) then
        npc_id = GetInteger("npc_id_quest")

        -- 아카데미 입구(우체통 옆)에 등장
        TownCharacterStandAt(TownCharacterAddNPC(npc_id), -240, 0)
        TownCharacterSetIcon(TownCharacterGetNPC(npc_id), "Quest_Challenger_Appear")

    end
end


if OnTownAnyCharacterClick() then

    npc_id = GetInteger("npc_id_clicked")
    quest_id = GetInteger("quest_id")

    ScriptTownZoomInCharacter(TownCharacterGetNPC(npc_id))

    PushPopupTownNpcWithSelectBox(npc_id)

    if CheckDanceGameQuestIsFirst() then
        if npc_id == 901 or npc_id == 902 or npc_id == 904 or npc_id == 905 or npc_id == 908 or npc_id == 909 or npc_id == 910 then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 10))
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 11))
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 12))
        else
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 10))
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 11))
        end
    else
        DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 20))
    end
end


if OnDanceGameButtonClick() then

    if CheckHasDanceGameQuest() then

        npc_id = GetInteger("npc_id_quest")
        quest_id = GetInteger("quest_id")

        PushSceneMiniGameDanceQuest(quest_id)
        UIHide("uiScore")
        UIHide("btnBack")
        SceneMiniGameDanceHideNPC()
        SceneMiniGameDanceHideFollower()
        SceneMiniGameDanceHideUser()

        SceneMiniGameDanceAppearNPC()
        SceneMiniGameDanceAppearUser()
        Wait(2)

        if CheckDanceGameQuestIsFirst() then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 30))
        else
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 40))
        end

        SceneMiniGameDanceAppearFollower()
        Wait(2)

        RequireSceneMiniGameDanceFinish()
        Wait(2)
        if RequireCheckResult("Success") then
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 60))
        else
            DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_CHALLENGER_DIALOG(npc_id, 50))
        end

        Wait(1)

        if CheckDanceGameQuestIsDummy() then
            DummyDanceGameQuestEnd()
            PopScene()
        else
            SendProtocolCompleteDanceGameQuest()
            GoTown()
        end

    else
        GoTown()

    end
end
