-- 문
-- version("0.19.00")

if OnCreate() then
    local door_id = GetInteger("door_id")
    local door_open_id = GetInteger("door_open_id")
    local door_close_id = GetInteger("door_close_id")
    
    SetAnimationByTownObjectID("door", door_id)
    SetAnimationByTownObjectID("door_open", door_open_id)
    SetAnimationByTownObjectID("door_close", door_close_id)
    
    Item_Hide("self")
    -- 기본 애니메이션
    while 1 do
        Item_SetAniFront("self", "door")

        -- 캐릭터가 진입
        Item_WaitCharacterIn("self")
        Item_UnsetAni("self", "door")
        -- 문 열리는 애니메이션
        Item_SetAniFront("self", "door_open")
        Animation_Play("door_open")
        Animation_WaitFinish("door_open")

        -- 캐릭터가 나감
        Item_WaitCharacterOut("self")
        -- 문 닫히는 애니메이션
        Item_UnsetAni("self", "door_open")
        Item_SetAniFront("self", "door_close")
        Animation_Play("door_close")
        Animation_WaitFinish("door_close")

        -- 다시 기본 애니메이션
        Item_UnsetAni("self", "door_close")
    end
end
