if OnTownRefresh() then
    -- 컴투스
    -- TownCharacterRoamInTown(TownCharacterAddNPCOtherTown(201), -50, 50)

    -- 우체부
    -- TownCharacterStandAt(TownCharacterAddNPCOtherTown(104), -6*40, -1*40)

    -- 가디, 댄스게이트 주변
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(121), 2*40, 74*40)

    -- 명예 상인
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(149), 14*40, 43*40) -- 560, 1720
    TownCharacterHide(TownCharacterGetNPCOtherTown(0, 149))

    -- 재야의 춤선생
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(158), -10*40, 48*40) -- -400, 1920

    -- 인테리어 샵 주인
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(144), -34*40, 14*40)

    -- 미용실 원장
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(145), 14*40, 15*40)

    -- 옷가게 주인
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(146), -15*40, 15*40)
    if CheckOtherTownDressShopOpen() then
        TownCharacterSetIcon(TownCharacterGetNPCOtherTown(0, 146), "DRESS_SHOP_OTHER")
    end

    -- 환전상
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(147), -21*40, 33*40)
    
    -- 무역상
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(163), 16*40, 32*40) -- 640, 1280
    
    -- 악기상
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(164), 36*40, 32*40) -- 1440, 1280

    -- 클럽 DJ
    TownCharacterStandAt(TownCharacterAddNPCOtherTown(148), 32*40, 20*40)

    -- 카페 주인
    if PartTimeIsOpenedOtherTown(1000001) then
        TownCharacterStandAt(TownCharacterAddNPCOtherTown(154), -41*40, 45*40) -- -1640, 1800
    end

    -- 레스토랑 주인
    if PartTimeIsOpenedOtherTown(1000003) then
        TownCharacterStandAt(TownCharacterAddNPCOtherTown(155), -20*40, 46*40) -- -800, 1840
    end

    -- 광장 관리인은 분수 옆에 위치 156
    if PartTimeIsOpenedOtherTown(1000002) then
        TownCharacterStandAt(TownCharacterAddNPCOtherTown(156), 5*40, 33*40)
    end

    -- 야외 무대 관리인은 무대 옆에 위치 157
    if PartTimeIsOpenedOtherTown(1000008) then
        -- TownCharacterRoamIn(TownCharacterAddNPCOtherTown(157), 0-12, 0+12, 33-12, 33+12)
        TownCharacterStandAt(TownCharacterAddNPCOtherTown(157), 29*40, 41*40) -- 1160, 1640
    end

end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 121)) then
    PreLoad()
    ScriptOtherTownMoveToSide(TownCharacterGetNPCOtherTown(0, 121))

    PushPopupTownNpc(121)
    npc_id = 121
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

--[[
if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 149)) then
    PreLoad()
    ScriptOtherTownMoveToSide(TownCharacterGetNPCOtherTown(0, 149))

    PushPopupTownNpc(149)
    npc_id = 149
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end
--]]

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 144)) then
    PreLoad()
    ScriptTownMoveToInterior(TownCharacterGetNPCOtherTown(0, 144), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(67) --=BGM=Theme_Interiorshop
    PushPopupTownNpc(144)
    npc_id = 144
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 145)) then
    PreLoad()
    ScriptTownMoveToBeauty(TownCharacterGetNPCOtherTown(0, 145), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(72) --=BGM=Theme_Hairshop
    PushPopupTownNpc(145)
    npc_id = 145
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 146)) then
    PreLoad()
    ScriptTownMoveToDress(TownCharacterGetNPCOtherTown(0, 146), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(68) --=BGM=Theme_Clothshop
    PushPopupTownDress(146)
    npc_id = 146
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 147)) then
    PreLoad()
    ScriptTownMoveToExchange(TownCharacterGetNPCOtherTown(0, 147), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(70) --=BGM=Theme_Bank
    PushPopupTownNpc(147)
    npc_id = 147
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 148)) then
    PreLoad()
    ScriptTownMoveToClub(TownCharacterGetNPCOtherTown(0, 148), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(30) --=BGM=Character_DJ

    PushPopupTownNpc(148)
    npc_id = 148
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 154)) then
    PreLoad()
    ScriptTownMoveToCafe(TownCharacterGetNPCOtherTown(0, 154), TownCharacterGetUserOtherTown())

    PushPopupTownNpc(154)
    npc_id = 154
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 156)) then
    npc_id = 156
    PreLoad()
    ScriptOtherTownMoveToSide(TownCharacterGetNPCOtherTown(0, npc_id))

    PushPopupTownNpc(npc_id)
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 157)) then
    npc_id = 157
    PreLoad()
    ScriptOtherTownMoveToSide(TownCharacterGetNPCOtherTown(0, npc_id))

    PushPopupTownNpc(npc_id)
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 158)) then
    npc_id = 158
    PreLoad()
    ScriptOtherTownMoveToSide(TownCharacterGetNPCOtherTown(0, npc_id))
    SoundPlayWithLock(71) --=BGM=Character_Dancemasterbgm
    PushPopupTownNpc(npc_id)
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 155)) then
    PreLoad()
    ScriptTownMoveToRestaurant(TownCharacterGetNPCOtherTown(0, 155), TownCharacterGetUserOtherTown())

    PushPopupTownNpc(155)
    npc_id = 155
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 163)) then
    PreLoad()
    ScriptTownMoveToTradeShop(TownCharacterGetNPCOtherTown(0, 163), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(66) --=BGM=Theme_Tradeshop
    PushPopupTownNpc(163)
    npc_id = 163
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end

if OnOtherTownCharacterClick(TownCharacterGetNPCOtherTown(0, 164)) then
    PreLoad()
    ScriptOtherTownMoveToInstrumentShop(TownCharacterGetNPCOtherTown(0, 164), TownCharacterGetUserOtherTown())
    SoundPlayWithLock(69) --=BGM=Theme_Instrumentshop
    PushPopupTownNpc(164)
    npc_id = 164
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_NPC_DIALOG(npc_id, 501))
end


if OnTownUserClick() then
    PreLoad()
    uid = GetUserID()
    npc_id = GetCharacterID()
    ScriptTownZoomInCharacter(TownCharacterGetUserOtherTown())
    PushPopupTownUser(npc_id)
end

if OnOtherTownDancerClick() then
    uid = GetUserID()
    npc_id = GetCharacterID()
    ScriptTownZoomInCharacter(TownCharacterGetNPCOtherTown(uid, npc_id))
    PushPopupTownNpc(npc_id)
    DialogOpen(npc_id, STR_NPC(npc_id), STR_NPC_IMG(npc_id, 1), STR_FOLLOWER_DIALOG(npc_id, 1510))
end


