if OnTownRefresh() then
    -- 컴투스
    -- TownCharacterRoamInTown(TownCharacterAddNPC(201), -50, 50)

    -- 우체부
    -- TownCharacterStandAt(TownCharacterAddNPC(104), -6*40, -1*40)

    -- 가디, 댄스게이트 주변
    TownCharacterStandAt(TownCharacterAddNPC(121), 2*40, 74*40)

--[[
-- 신현우 : http://redmine.com2us.com/issues/24957 이 이슈로 등장코드도 함꼐 주석 잡아둡니다.
    -- 명예 상인 560 1720
    TownCharacterStandAt(TownCharacterAddNPC(149), 14*40, 43*40) -- 560, 1720
    if not CheckUnlock(520302) then
        TownCharacterHide(TownCharacterGetNPC(149))
    end
--]]
    -- 신현우 : 케릭터를 추가하지 않으면 명예 상인이 있던 자리의 구조물들이 그대로 출력되는 문제 떄문에
    --        지현 차석님이 확인하신 부분에 맞춰서 TownCharacterAddNPC()하고 TownCharacterHide()하는 방향으로 수정합니다.
    --        http://redmine.com2us.com/issues/24957 이 일감의 상황은 520302이 언락된 유저의 경우 숨김처리가 안된 것 같습니다.
    TownCharacterStandAt(TownCharacterAddNPC(149), 14*40, 43*40) -- 560, 1720
    TownCharacterHide(TownCharacterGetNPC(149))

    -- 인테리어 샵 주인
    TownCharacterStandAt(TownCharacterAddNPC(144), -34*40, 14*40)

    -- 미용실 원장
    TownCharacterStandAt(TownCharacterAddNPC(145), 14*40, 15*40)

    -- 옷 가게 주인
    TownCharacterStandAt(TownCharacterAddNPC(146), -15*40, 15*40)
    
    -- 환전상
    TownCharacterStandAt(TownCharacterAddNPC(147), -21*40, 33*40)

    -- 무역상
    TownCharacterStandAt(TownCharacterAddNPC(163), 16*40, 32*40) -- 640, 1280

    -- 악기상
    TownCharacterStandAt(TownCharacterAddNPC(164), 36*40, 32*40) -- 1440, 1280

    -- 클럽 DJ
    TownCharacterStandAt(TownCharacterAddNPC(148), 32*40, 20*40)

    -- 카페 주인
    if PartTimeIsOpened(1000001) then
        TownCharacterStandAt(TownCharacterAddNPC(154), -41*40, 45*40) -- -1640, 1800
    end

    -- 레스토랑 주인
    if PartTimeIsOpened(1000003) then
        TownCharacterStandAt(TownCharacterAddNPC(155), -20*40, 46*40) -- -800, 1840
    end

    -- 광장 관리인은 분수 옆에 위치 156
    if PartTimeIsOpened(1000002) then
        TownCharacterStandAt(TownCharacterAddNPC(156), 5*40, 33*40)
    end

    -- 야외 무대 관리인은 무대 옆에 위치 157
    if PartTimeIsOpened(1000008) then
        -- TownCharacterRoamIn(TownCharacterAddNPC(157), 0-12, 0+12, 33-12, 33+12)
        TownCharacterStandAt(TownCharacterAddNPC(157), 29*40, 41*40) -- 1160, 1640
    end

    -- 재야의 춤선생
    TownCharacterStandAt(TownCharacterAddNPC(158), -10*40, 48*40) -- -400, 1920
    if not CheckUnlock(520301) then
        TownCharacterHide(TownCharacterGetNPC(158))
    end

end

if OnTownCharacterClick(TownCharacterGetNPC(121)) then
    PreLoad()
    ScriptTownMoveToSide(TownCharacterGetNPC(121))

    PushPopupTownGadi(121)
    ScriptNPCCommonDialog(121)
    TownAutoZoomOut()    
end

--[[
if OnTownCharacterClick(TownCharacterGetNPC(149)) then
    PreLoad()
    ScriptTownMoveToSide(TownCharacterGetNPC(149))

    PushPopupTownHonorShop(149)
    ScriptNPCCommonDialog(149)
    TownAutoZoomOut()
end
--]]

if OnTownCharacterClick(TownCharacterGetNPC(144)) then
    PreLoad()
    ScriptTownMoveToInterior(TownCharacterGetNPC(144), TownCharacterGetUser())
    SoundPlayWithLock(67) --=BGM=Theme_Interiorshop
    PushPopupTownInterior(144)
    TownCameraZoomIn(TownCharacterGetNPC(144), 40, 50, 2)
    ScriptNPCCommonDialog(144)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(145)) then
    PreLoad()
    ScriptTownMoveToBeauty(TownCharacterGetNPC(145), TownCharacterGetUser())
    SoundPlayWithLock(72) --=BGM=Theme_Hairshop
    TownCameraZoomIn(TownCharacterGetNPC(145), 40, 50, 2)
    ScriptNPCCommonDialog(145)
    PushPopupTownBeauty(145)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(146)) then
    PreLoad()
    ScriptTownMoveToDress(TownCharacterGetNPC(146), TownCharacterGetUser())
    SoundPlayWithLock(68) --=BGM=Theme_Clothshop
    PushPopupTownDress(146)
    TownCameraZoomIn(TownCharacterGetNPC(146), -40, 50, 2)

    ScriptNPCDialogCollectionNeeds(146)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(147)) then
    PreLoad()
    ScriptTownMoveToExchange(TownCharacterGetNPC(147), TownCharacterGetUser())
    SoundPlayWithLock(70) --=BGM=Theme_Bank
    PushPopupTownExchanger(147)
    TownCameraZoomIn(TownCharacterGetNPC(147), 0, 0, 1.5)
    ScriptNPCCommonDialog(147)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(148)) then
    PreLoad()
    ScriptTownMoveToClub(TownCharacterGetNPC(148), TownCharacterGetUser())
    SoundPlayWithLock(30) --=BGM=Character_DJ

    PushPopupTownClub(148)
    TownCameraZoomIn(TownCharacterGetNPC(148), 0, 0, 1.5)
    ScriptNPCCommonDialog(148)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(154)) then
    PreLoad()
    ScriptTownMoveToCafe(TownCharacterGetNPC(154), TownCharacterGetUser())

    PushPopupTownNpc(154)
    TownCameraZoomIn(TownCharacterGetNPC(154), 0, 0, 1.5)
    ScriptNPCCommonDialog(154)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(155)) then
    PreLoad()
    ScriptTownMoveToRestaurant(TownCharacterGetNPC(155), TownCharacterGetUser())

    PushPopupTownNpc(155)
    TownCameraZoomIn(TownCharacterGetNPC(155), 0, 0, 1.5)
    ScriptNPCCommonDialog(155)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(156)) then
    npc_id = 156
    PreLoad()
    ScriptTownMoveToSide(TownCharacterGetNPC(npc_id))

    PushPopupTownNpc(npc_id)
    ScriptNPCCommonDialog(npc_id)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(157)) then
    npc_id = 157
    PreLoad()
    ScriptTownMoveToSide(TownCharacterGetNPC(npc_id))

    PushPopupTownNpc(npc_id)
    ScriptNPCCommonDialog(npc_id)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(158)) then
    PreLoad()
    ScriptTownMoveToSide(TownCharacterGetNPC(158))
    SoundPlayWithLock(71) --=BGM=Character_Dancemasterbgm
    PushPopupTownDancingMaster(158)
    ScriptNPCCommonDialog(158)
    TownAutoZoomOut()
end

if OnTownCharacterClick(TownCharacterGetNPC(163)) then
    PreLoad()
    ScriptTownMoveToTradeShop(TownCharacterGetNPC(163), TownCharacterGetUser())
    SoundPlayWithLock(66) --=BGM=Theme_Tradeshop

    PushPopupTownTradeShop(163)
    TownCameraZoomIn(TownCharacterGetNPC(163), 0, 0, 1.5)
    ScriptNPCCommonDialog(163)
    TownAutoZoomOut()
end

-- 악기 상점
if OnTownCharacterClick(TownCharacterGetNPC(164)) then
    PreLoad()
    ScriptTownMoveToInstrumentShop(TownCharacterGetNPC(164), TownCharacterGetUser())
    SoundPlayWithLock(69) --=BGM=Theme_Instrumentshop
    PushPopupTownInstShop(164)
    TownCameraZoomIn(TownCharacterGetNPC(164), 0, 0, 1.5)
    ScriptNPCCommonDialog(164)
    TownAutoZoomOut()
end

if OnTownUserClick() then
    PreLoad()
    npc_id = GetInteger("npc_id_clicked")
    ScriptTownZoomInCharacter(TownCharacterGetNPC(npc_id))
    PushPopupTownUser(npc_id)
  --  TownAutoZoomOut()
end

-- 마을에 돌아다니는 타유저와 대화
if OnTownOtherUserClick() then
    PreLoad()
    user_id = GetInteger("user_id_clicked")

    chr_type = GetInteger("character_type") -- 스타/팬/기타(인기유저)
    name = GetString("user_nickname")

    -- Zoom In
    TownCharacterHideAll()
    TownCharacterShow(TownCharacterGetOtherUser(user_id))
    TownCharacterStand(TownCharacterGetOtherUser(user_id))
    TownCameraZoomIn(TownCharacterGetOtherUser(user_id), 0, 63, 2.4)
    Wait(1)

    -- npc_id 2는 타유저
    if CheckCharacterType(chr_type, 16) then  --TownCharacterType_Star = 0x01<<4
        DialogOpen(2, name, "", STR_SCRIPT(305001)) -- "반갑습니다! 전 [유저의 닉네임] 님의 스타인 [타유저의 닉네임] 입니다!"
    elseif CheckCharacterType(chr_type, 32) then --TownCharacterType_Fan = 0x01<<5
        DialogOpen(2, name, "", STR_SCRIPT(305002)) -- "반갑습니다! 전 [유저의 닉네임] 님의 팬인 [타유저의 닉네임] 입니다!"
    else
        DialogOpen(2, name, "", STR_SCRIPT(305003)) -- "반갑습니다! 전 [타유저의 닉네임] 입니다!"
    end

    PushPopupTownOtherUser(user_id, 2)
end

if OnHonorItemBuyComplete() then
    PreLoad()
    ScriptTownZoomInCharacter(TownCharacterGetNPC(149))
    DialogOpen(149, STR_NPC(149), STR_NPC_IMG(149, 1), STR_SCRIPT(305004)) -- "이 물건을 쓸 자격이 충분하십니다.\n후훗, 다음에 또 찾아주시길."
    GoTown()
end

if OnClickCollectionQuestPopupItem() then

    req_type = GetInteger("req_type")
    if req_type == 10035 then -- 옷가게 진입
        count_try = CollectionNeedsGetTryCount() -- 준비물이 있으면 5, 아이템이 나왔는데 살수 있으면 -1, 이미 팔렸으면 -2
        if count_try < 5 and count_try ~= -1 then
            DialogOpen(146, STR_NPC(146), STR_NPC_IMG(146, 1), STR_SCRIPT(305005)) -- "음~ 지금은 찾으시는 준비물이 없네요!\n무료로 교체할 수 있는 시간에 다시 오시거나,\n지금 바로 새로 고침 버튼을 눌러 다음 상품들을 확인해보세요~") --
        end
    end

end
