-- 빨래 도둑
local function UnlockQuestContents()
    UnlockStartQuestMode()
    UnlockContents(520001)  -- 춤 관련 기능을 열어줌
    UnlockContents(520002)  -- 아카데미 관련 기능을 열어줌
    UnlockContents(520003)  -- 음악 관련 기능을 열어줌
    UnlockContents(520004)  -- 인테리어 샵 관련 기능을 열어줌
    UnlockContents(520005)  -- 춤/음악 교습 관련 기능을 열어줌
    UnlockContents(520007)  -- 댄스비전 관련 기능을 열어줌
    UnlockContents(520008)  -- 스타/팬 관리 기능을 열어줌
    UnlockContents(520009)  -- 장애물 제거 관련 기능을 열어줌
    UnlockContents(520010)  -- 춤/음악 배우기 관련 기능을 열어줌
    UnlockContents(520011)  -- 뮤비 촬영/뮤비 목록 기능을 열어줌
    UnlockContents(520012)  -- 춤꾼 영입 기능을 열어줌
    UnlockContents(520013)  -- 군무 제작 기능을 열어줌
    UnlockContents(520015)  -- 명예 상점 기능을 열어줌
    UnlockContents(520016)  -- NPC호감도 관리 기능을 열어줌
end

local function foundSuspicuosMan()
    SceneTownSetStateEmpty()

    ScriptTownMoveToSide(TownCharacterGetNPC(120))
    DialogOpen(120, "남다른 취향의 남자", "", "저한테 뭐 볼일이라도...")
    DialogOpen(120, "남다른 취향의 남자", "", "아, 이 옷이요? 저한테 딱 어울리죠? 이 옷을 처음 본 순간부터 내 꺼다 싶었죠!")
    DialogOpen(120, "남다른 취향의 남자", "", "그리고 마침내 손에 넣고 말았어요!")
    TownCharacterSetEmot(TownCharacterGetNPC(120), "Characters/Emoticon_heart")
    DialogOpen(120, "남다른 취향의 남자", "", "지금 이 순간 전 세상을 다 가진 것이나 다름없답니다!")
    DialogOpen(119, "옆 동네 아주머니", "", "사람이란 가장 행복한 순간에 위기가 찾아오는 법이지!")
    TownCharacterSetEmot(TownCharacterGetNPC(120), "Characters/Emoticon_exclamation")

    TownCharacterStandAtCharacter(TownCharacterAddNPC(119), TownCharacterGetNPC(120), -12*40, 0*40)
    Wait(0.5)
    TownCameraZoomIn(TownCharacterGetNPC(119), -40, 50, 1.3)
    TownCharacterRunToCharacter(TownCharacterGetNPC(119),TownCharacterGetNPC( 120), -4*40, 0*40)

    DialogOpen(120, "남다른 취향의 남자", "", "히익! 여기까지 따라오다니!")
    DialogOpen(119, "옆 동네 아주머니", "", "이제야 잡았다, 이 파렴치한 빨래 도둑!") 
    DialogOpen(119, "옆 동네 아주머니", "", "감히 내 몸에 맞춘 듯 어울리는 그 옷을 가져가다니, 각오는 되어있겠지?") 
    DialogOpen(120, "남다른 취향의 남자", "", "이 옷이 절규하고 있었어! 당신에게서 구해달라고! 내 몸에 입혀지고 싶다고!")
    TownCharacterSetEmot(TownCharacterGetNPC(119), "Characters/Emoticon_angry")
    DialogOpen(119, "옆 동네 아주머니", "", "이런 돼먹지 못 한...!") 

    TownCharacterRunToCharacter(TownCharacterGetNPC(119),TownCharacterGetNPC( 120), 1*40, 0)
    Wait(1.5)
    TownCharacterUnwearClothes(TownCharacterGetNPC(120), 202012)
    TownCharacterWearClothes(TownCharacterGetNPC(119), 202012)

    DialogOpen(119, "옆 동네 아주머니", "", "히야아아압!!")
    TownCameraZoomIn(TownCharacterGetNPC(119), 0, 0, 2.0)
    TownCharacterAction(TownCharacterGetNPC(119), "kick")
    Wait(0.6)
    AnimationAdd("kick", "UI/Event_kick")
    AnimationSetPos("kick", 0, 0)
    AnimationPlay("kick")
    Wait(0.1)
    AnimationRemove("kick")
    TownCharacterAction(TownCharacterGetNPC(120), "fly0_1")
    TownCharacterFlyTo(TownCharacterGetNPC(120), -500, -0);
    TownCharacterAction(TownCharacterGetNPC(119), "dance_01")
    Wait(1.5)
    TownCharacterHide(TownCharacterGetNPC(120))
    DialogOpen(119, "옆 동네 아주머니", "", "아휴, 속이 다 후련하다! 용케 찾아줬네! 고마워~")
    DialogOpen(119, "옆 동네 아주머니", "", "간만에 옷도 차려입었으니 바깥양반이랑 데이트나 해야겠다~")



    -- 독백, 퀘스트 완료
   -- MonologOpen("")
   Wait(1)
   ScenarioEndingShow() -- "[빨래 도둑] 퀘스트 완료"

    -- 퀘스트 시작/완료/보상
   QuestStart()
   QuestComplete()
   QuestReward()

   GoTown()
end

if OnClickQuestStart() then
    QuestContinue()
end

-- 퀘스트 NPC가 돌아다니고 있다.
if CheckQuestAppear() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
        PushPopupTownNpcWithSelectBox(119)
        DialogOpen(119, "옆 동네 아주머니", "", "분명히 여기 어디로 도망쳤는데...")
    end
elseif CheckQuestRunning() then
    --quest 진행 중
    if OnTownRefresh() then
        TownCharacterStandAt(TownCharacterAddNPC(120), 24*40, 50*40)
        TownCharacterSetQuestIcon(TownCharacterGetNPC(120))
    end
    if OnTownCharacterClick(TownCharacterGetNPC(120)) then
        foundSuspicuosMan()
    end
elseif CheckQuestComplete() then
    if OnTownRefresh() then
        TownCharacterRoamInTown(TownCharacterAddNPC(119))
        TownCharacterSetQuestIcon(TownCharacterGetNPC(119))
    end

    if OnTownCharacterClick(TownCharacterGetNPC(119)) then
        ScriptTownMoveToSide(TownCharacterGetNPC(119))
        PushPopupTownNpcWithSelectBox(119)
        DialogOpen(119, "옆 동네 아주머니", "", "분명히 여기 어디로 도망쳤는데...")
    end
end

-- 퀘스트 다시하기
if OnQuestReplay() then
    TownCharacterRoamInTown(TownCharacterAddNPC(119))
    TownCharacterSetQuestIcon(TownCharacterGetNPC(119))

    ScriptTownMoveToSide(TownCharacterGetNPC(119))
    PushPopupTownNpcWithSelectBox(119)
    DialogOpen(119, "옆 동네 아주머니", "", "분명히 여기 어디로 도망쳤는데...")
end


if OnQuestContinue() then
    UnlockQuestContents()

    -- 마을 UI 감추기
    SceneTownSetStateEmpty()
    -- 퀘스트 배경음
    SoundPlay(9) --=BGM=Event_Quest_common
    -- 퀘스트 인트로
    ScenarioIntroShow(119)

    DialogOpen(119, "옆 동네 아주머니", "", "아니, 글쎄, 내 이야기 좀 들어봐.")
    DialogOpen(119, "옆 동네 아주머니", "", "요즘 세상에도 빨래를 훔쳐가는 도둑이 있더라니까, 글쎄?")
    DialogOpen(119, "옆 동네 아주머니", "", "그것도 나에게 환상적으로 잘 어울려서 제일 아끼던 심플 누드톤 원피스를!")
    DialogOpen(119, "옆 동네 아주머니", "", "용하게도 그 놈을 현장에서 발견하지 않았겠어, 내가?")
    DialogOpen(119, "옆 동네 아주머니", "", "그런데 이놈이 다람쥐 마냥 재빠르지 뭐야.")
    DialogOpen(119, "옆 동네 아주머니", "", "하지만 그놈은 몰랐겠지. 내가 소싯적에 육상 선수였다는 사실을.")
    DialogOpen(119, "옆 동네 아주머니", "", "치열한 추격전 끝에 이 마을까지 오기는 했는데...")
    DialogOpen(119, "옆 동네 아주머니", "", "여긴 사람이 많아서 어디 있는지 도통 찾을 수가 없네...")
    DialogOpen(119, "옆 동네 아주머니", "", "이 마을 사람이니까 고 도둑놈 잡는 거 좀 도와줄 수 있지?")
    PushPopupClothesShow(202012);
    DialogOpen(119, "옆 동네 아주머니", "", "요런 옷을 입은 놈 중 하나가 범인일 거야.")

    
    TownCharacterStandAt(TownCharacterAddNPC(120), 24*40, 50*40)
    TownCharacterSetQuestIcon(TownCharacterGetNPC(120))
    
    GoTown()
-- 정식에서는 수정 필요
    Wait(2)
    foundSuspicuosMan()
end
